/*
 $Id: FileReadProgress.cpp,v 1.3 2002/05/01 03:33:20 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// FileReadProgress.cpp : implementation file
//

#include "stdafx.h"
#include "AMPatch.h"
#include "FileReadProgress.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileReadProgress dialog


CFileReadProgress::CFileReadProgress(CWnd* pParent /*=NULL*/)
	: CDialog(CFileReadProgress::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFileReadProgress)
	//}}AFX_DATA_INIT
	m_iUpper = 100;
	m_iLower = 0;
	m_iPos = 0;
	m_cBkg = GetSysColor(COLOR_3DFACE);
	m_cFgd = 0x00800000;
	NONCLIENTMETRICS met;
	memset(&met, 0, sizeof(met));
	met.cbSize = sizeof(met);
	SystemParametersInfo(SPI_GETNONCLIENTMETRICS, met.cbSize, (void *) &met, 0);
	m_csFontName.Format("%s", met.lfStatusFont.lfFaceName);
}


void CFileReadProgress::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFileReadProgress)
	DDX_Control(pDX, IDC_PROGBAR, m_csProgBar);
	DDX_Control(pDX, IDC_STATUS_MESSAGE, m_csMessage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFileReadProgress, CDialog)
	//{{AFX_MSG_MAP(CFileReadProgress)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileReadProgress message handlers

void CFileReadProgress::Update()
{
	if ( m_iUpper == m_iLower )
		return;
	CDC * pDC = this->m_csProgBar.GetDC();

	pDC->SetTextAlign(TA_CENTER);
	CString csPercent;
	csPercent.Format("%ld%%", ( (m_iPos * 100) / (m_iUpper - m_iLower)) );

	CRect rect;
	m_csProgBar.GetClientRect(&rect);
	CRgn clip, clip2;
	COLORREF oldBkg, oldText;
	oldBkg = pDC->SetBkColor(m_cFgd);
	oldText = pDC->SetTextColor(m_cBkg);
	CBrush * pFore = new CBrush(m_cFgd);
	CBrush * pBack = new CBrush(m_cBkg);
	CFont * pFont = new CFont();
	pFont->CreateFont(15, 0, 0, 0, 600, 0, 0, 0, 0, OUT_TT_PRECIS, CLIP_TT_ALWAYS, PROOF_QUALITY, DEFAULT_PITCH, m_csFontName);
	CFont * pOldFont = pDC->SelectObject(pFont);
	int right = rect.left + ( rect.Width() * m_iPos / (m_iUpper - m_iLower) );
	clip.CreateRectRgn(rect.left, rect.top, right, rect.bottom);
	pDC->SelectClipRgn(&clip);
	pDC->FillRect(rect, pFore);
	pDC->ExtTextOut( ((rect.right - rect.left) / 2), rect.top - 1, ETO_CLIPPED, &rect, csPercent, NULL);
	clip2.CreateRectRgn(right, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&clip2);
	pDC->FillRect(rect, pBack);
	pDC->SetBkColor(m_cBkg);
	pDC->SetTextColor(m_cFgd);
	pDC->ExtTextOut( ((rect.right - rect.left) / 2), rect.top - 1, ETO_CLIPPED, &rect, csPercent, NULL);
	pDC->SelectObject(pOldFont);
	delete pFore;
	delete pBack;
	delete pFont;
	pDC->SetBkColor(oldBkg);
	pDC->SetTextColor(oldText);
	m_csProgBar.ReleaseDC(pDC);
}

void CFileReadProgress::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	Update();	
	// Do not call CDialog::OnPaint() for painting messages
}
