// AdditionalSettingsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "AdditionalSettingsDlg.h"
#include "RemoteProfileDlg.h"
#include <windowsx.h>  // required for GET_X_LPARAM, GET_Y_LPARAM)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAdditionalSettingsDlg dialog


CAdditionalSettingsDlg::CAdditionalSettingsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAdditionalSettingsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAdditionalSettingsDlg)
	m_b3DRoomView = FALSE;
	m_bDisplayItems = FALSE;
	m_bAlwaysOnTop = FALSE;
	m_bShowRadarMap = FALSE;
	m_bScaleItems = FALSE;
	m_bShowChars = FALSE;
	m_bShowSpawns = FALSE;
	m_bSpawnMessage = FALSE;
	m_bStartLauncher = FALSE;
	m_bSysClose = FALSE;
	m_bAllowMultiple = FALSE;
	m_bGodClient = FALSE;
	//}}AFX_DATA_INIT

	m_hFolderIcon = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_FOLDER));
	m_hDocIcon = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DOC));

	m_ilIcons.Create(16, 16, ILC_MASK, 0, 1);
	m_iFolderIndex = m_ilIcons.Add(m_hFolderIcon);
	m_iDocIndex = m_ilIcons.Add(m_hDocIcon);

	m_iCurProfileSel = -1;
}


void CAdditionalSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdditionalSettingsDlg)
	DDX_Control(pDX, IDC_AS_CLIENTBROWSE, m_cbClientBrowse);
	DDX_Control(pDX, IDC_AS_USESAMEPATHASCLIENT, m_cbMulPathFromClient);
	DDX_Control(pDX, IDC_AS_PROFILES, m_clbProfiles);
	DDX_Control(pDX, IDC_AS_NEWPROFILE, m_cbNewProfile);
	DDX_Control(pDX, IDC_AS_MULBROWSE, m_cbMulBrowse);
	DDX_Control(pDX, IDC_AS_EDITPROFILE, m_cbEditProfile);
	DDX_Control(pDX, IDC_AS_DELETEPROFILE, m_cbDeleteProfile);
	DDX_Control(pDX, IDC_AS_DEFUALTMULPATH, m_csDefaultMulPath);
	DDX_Control(pDX, IDC_AS_DEFUALTCLIENT, m_csDefaultClient);
	DDX_Control(pDX, IDC_AS_CUSTOMMULS, m_clcMuls);
	DDX_Control(pDX, IDC_AS_AVAILABLESCRIPTS, m_ctcScripts);
	DDX_Check(pDX, IDC_AS_3DROOMVIEW, m_b3DRoomView);
	DDX_Check(pDX, IDC_AS_DISPLAYITEMS, m_bDisplayItems);
	DDX_Check(pDX, IDC_AS_ONTOP, m_bAlwaysOnTop);
	DDX_Check(pDX, IDC_AS_RADAR, m_bShowRadarMap);
	DDX_Check(pDX, IDC_AS_SCALE, m_bScaleItems);
	DDX_Check(pDX, IDC_AS_SHOWCHARS, m_bShowChars);
	DDX_Check(pDX, IDC_AS_SHOWSPAWNS, m_bShowSpawns);
	DDX_Check(pDX, IDC_AS_SPAWNMSG, m_bSpawnMessage);
	DDX_Check(pDX, IDC_AS_STARTLAUNCHER, m_bStartLauncher);
	DDX_Check(pDX, IDC_AS_SYSCLOSE, m_bSysClose);
	DDX_Check(pDX, IDC_AS_ALLOWMULTIPLE, m_bAllowMultiple);
	DDX_Check(pDX, IDC_AS_GODCLIENT, m_bGodClient);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAdditionalSettingsDlg, CDialog)
	//{{AFX_MSG_MAP(CAdditionalSettingsDlg)
	ON_LBN_SELCHANGE(IDC_AS_PROFILES, OnSelchangeAsProfiles)
	ON_BN_CLICKED(IDC_AS_NEWPROFILE, OnAsNewprofile)
	ON_BN_CLICKED(IDC_AS_EDITPROFILE, OnAsEditprofile)
	ON_BN_CLICKED(IDC_AS_DELETEPROFILE, OnAsDeleteprofile)
	ON_BN_CLICKED(IDC_AS_MULBROWSE, OnAsMulbrowse)
	ON_BN_CLICKED(IDC_AS_CLIENTBROWSE, OnAsClientbrowse)
	ON_NOTIFY(NM_RCLICK, IDC_AS_CUSTOMMULS, OnChangeCustommuls)
	ON_BN_CLICKED(IDC_AS_USESAMEPATHASCLIENT, OnAsUsesamepathasclient)
	ON_BN_CLICKED(IDC_AS_3DROOMVIEW, OnAs3droomview)
	ON_BN_CLICKED(IDC_AS_ALLOWMULTIPLE, OnAsAllowmultiple)
	ON_BN_CLICKED(IDC_AS_DISPLAYITEMS, OnAsDisplayitems)
	ON_BN_CLICKED(IDC_AS_ONTOP, OnAsOntop)
	ON_BN_CLICKED(IDC_AS_RADAR, OnAsRadar)
	ON_BN_CLICKED(IDC_AS_SCALE, OnAsScale)
	ON_BN_CLICKED(IDC_AS_SHOWCHARS, OnAsShowchars)
	ON_BN_CLICKED(IDC_AS_SHOWSPAWNS, OnAsShowspawns)
	ON_BN_CLICKED(IDC_AS_SPAWNMSG, OnAsSpawnmsg)
	ON_BN_CLICKED(IDC_AS_STARTLAUNCHER, OnAsStartlauncher)
	ON_BN_CLICKED(IDC_AS_SYSCLOSE, OnAsSysclose)
	ON_BN_CLICKED(IDC_AS_GODCLIENT, OnAsGodclient)
	ON_NOTIFY(NM_CLICK, IDC_AS_AVAILABLESCRIPTS, OnClickAsAvailablescripts)
	ON_MESSAGE(WM_APP, OnTvCheckbox)
	ON_NOTIFY(NM_DBLCLK, IDC_AS_CUSTOMMULS, OnChangeCustommuls)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdditionalSettingsDlg message handlers

BOOL CAdditionalSettingsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_bSpawnMessage = (BOOL) Main->m_dwSpawnMessage;
	m_bStartLauncher = (BOOL) Main->m_dwStartLauncher;
	m_bDisplayItems = (BOOL) Main->m_dwDrawItems;
	m_bShowChars = (BOOL) Main->m_dwDrawChars;
	m_b3DRoomView = (BOOL) Main->m_dw3DRoomView;
	m_bScaleItems = (BOOL) Main->m_dwScaleItems;
	m_bAlwaysOnTop = (BOOL) Main->m_dwAlwaysOnTop;
	m_bShowRadarMap = (BOOL) Main->m_dwShowRadar;
	m_bShowSpawns = (BOOL) Main->m_dwShowSpawnpoints;
	m_bSysClose = (BOOL) Main->m_dwSysClose;
	m_bAllowMultiple = (BOOL) Main->m_dwAllowMultiple;
	m_bGodClient = (BOOL) Main->m_dwGodClient;

	CString csText;
	csText.Format("%s%s", csUOPath, csUOExe);
	m_csDefaultClient.SetWindowText(csText);
	m_csDefaultMulPath.SetWindowText(Main->GetRegistryString("MulPath", csUOPath));

	// List the mulfiles
	m_clcMuls.InsertColumn(0, "Mulfile", LVCFMT_LEFT, 75, 0);
	m_clcMuls.InsertColumn(1, "Custom Filename", LVCFMT_LEFT, 255, 1);

	int iIndex = 0;
	iIndex = m_clcMuls.InsertItem(0, "map0");
	m_clcMuls.SetItemData(iIndex, 0);
	iIndex = m_clcMuls.InsertItem(1, "staidx0");
	m_clcMuls.SetItemData(iIndex, 1);
	iIndex = m_clcMuls.InsertItem(2, "statics0");
	m_clcMuls.SetItemData(iIndex, 2);
	iIndex = m_clcMuls.InsertItem(3, "artidx");
	m_clcMuls.SetItemData(iIndex, 3);
	iIndex = m_clcMuls.InsertItem(4, "art");
	m_clcMuls.SetItemData(iIndex, 4);
	iIndex = m_clcMuls.InsertItem(5, "animidx");
	m_clcMuls.SetItemData(iIndex, 5);
	iIndex = m_clcMuls.InsertItem(6, "anim");
	m_clcMuls.SetItemData(iIndex, 6);
	iIndex = m_clcMuls.InsertItem(7, "soundidx");
	m_clcMuls.SetItemData(iIndex, 7);
	iIndex = m_clcMuls.InsertItem(8, "sound");
	m_clcMuls.SetItemData(iIndex, 8);
	iIndex = m_clcMuls.InsertItem(9, "texidx");
	m_clcMuls.SetItemData(iIndex, 9);
	iIndex = m_clcMuls.InsertItem(10, "texmaps");
	m_clcMuls.SetItemData(iIndex, 10);
	iIndex = m_clcMuls.InsertItem(11, "gumpidx");
	m_clcMuls.SetItemData(iIndex, 11);
	iIndex = m_clcMuls.InsertItem(12, "gumpart");
	m_clcMuls.SetItemData(iIndex, 12);
	iIndex = m_clcMuls.InsertItem(13, "multiidx");
	m_clcMuls.SetItemData(iIndex, 13);
	iIndex = m_clcMuls.InsertItem(14, "multi");
	m_clcMuls.SetItemData(iIndex, 14);
	iIndex = m_clcMuls.InsertItem(15, "skillsidx");
	m_clcMuls.SetItemData(iIndex, 15);
	iIndex = m_clcMuls.InsertItem(16, "skills");
	m_clcMuls.SetItemData(iIndex, 16);
	iIndex = m_clcMuls.InsertItem(17, "lightidx");
	m_clcMuls.SetItemData(iIndex, 17);
	iIndex = m_clcMuls.InsertItem(18, "light");
	m_clcMuls.SetItemData(iIndex, 18);
	iIndex = m_clcMuls.InsertItem(30, "tiledata");
	m_clcMuls.SetItemData(iIndex, 30);
	iIndex = m_clcMuls.InsertItem(31, "animdata");
	m_clcMuls.SetItemData(iIndex, 31);
	iIndex = m_clcMuls.InsertItem(32, "hues");
	m_clcMuls.SetItemData(iIndex, 32);
	iIndex = m_clcMuls.InsertItem(33, "animinfo");
	m_clcMuls.SetItemData(iIndex, 33);
	iIndex = m_clcMuls.InsertItem(34, "fonts");
	m_clcMuls.SetItemData(iIndex, 34);
	iIndex = m_clcMuls.InsertItem(35, "radarcol");
	m_clcMuls.SetItemData(iIndex, 35);
	iIndex = m_clcMuls.InsertItem(36, "verdata");
	m_clcMuls.SetItemData(iIndex, 36);
	iIndex = m_clcMuls.InsertItem(37, "map2");
	m_clcMuls.SetItemData(iIndex, 37);
	iIndex = m_clcMuls.InsertItem(38, "staidx2");
	m_clcMuls.SetItemData(iIndex, 38);
	iIndex = m_clcMuls.InsertItem(39, "statics2");
	m_clcMuls.SetItemData(iIndex, 39);
	iIndex = m_clcMuls.InsertItem(40, "anim2");
	m_clcMuls.SetItemData(iIndex, 40);
	iIndex = m_clcMuls.InsertItem(41, "animidx2");
	m_clcMuls.SetItemData(iIndex, 41);

	for ( int i = 0; i < 42; i++ )
	{
		// Get the custom mul entries out of the registry
		CString csRegVal;
		csRegVal.Format("Mul%ld", i);
		CString csPath = Main->GetRegistryString(csRegVal);
		if ( csPath != "" )
		{
			for ( int j = 0; j < m_clcMuls.GetItemCount(); j++ )
			{
				if ( m_clcMuls.GetItemData(j) == (DWORD) i )
					m_clcMuls.SetItemText(j, 1, csPath);
			}
		}
	}

	// Are there any local profiles in the registry?
	HKEY hKey;
	LONG lStatus;
	iIndex = 0;
	lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Local Profiles", 0, KEY_ALL_ACCESS, &hKey);
	if ( lStatus == ERROR_SUCCESS )
	{
		while (lStatus == ERROR_SUCCESS)
		{
			char szBuffer[MAX_PATH];
			DWORD dwSize = sizeof(szBuffer);
			lStatus = RegEnumKeyEx(hKey, iIndex, &szBuffer[0], &dwSize, 0, NULL, NULL, NULL);
			if (lStatus == ERROR_SUCCESS)
			{
				CString csProfile;
				csProfile.Format("Local: %s", szBuffer);
				this->m_clbProfiles.AddString(csProfile);
			}
			iIndex++;
		}
		RegCloseKey(hKey);
	}

	// Are there any remote profiles in the registry?
	lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Remote Profiles", 0, KEY_ALL_ACCESS, &hKey);
	iIndex = 0;
	if ( lStatus == ERROR_SUCCESS )
	{
		while (lStatus == ERROR_SUCCESS)
		{
			char szBuffer[MAX_PATH];
			DWORD dwSize = sizeof(szBuffer);
			lStatus = RegEnumKeyEx(hKey, iIndex, &szBuffer[0], &dwSize, 0, NULL, NULL, NULL);
			if (lStatus == ERROR_SUCCESS)
			{
				CString csProfile;
				csProfile.Format("Remote: %s", szBuffer);
				this->m_clbProfiles.AddString(csProfile);
			}
			iIndex++;
		}
		RegCloseKey(hKey);
	}

	UpdateData(FALSE);

	m_ctcScripts.SetImageList(&m_ilIcons, TVSIL_NORMAL);

	return TRUE;  
}

void CAdditionalSettingsDlg::OnSelchangeAsProfiles() 
{
	int iSel = this->m_clbProfiles.GetCurSel();
	if ( m_iCurProfileSel != -1 && m_iCurProfileSel != iSel )
		UpdateProfile();
	m_iCurProfileSel = iSel;
	if ( iSel == -1 )
	{
		this->m_cbDeleteProfile.EnableWindow(FALSE);
		this->m_cbEditProfile.EnableWindow(FALSE);
		this->m_ctcScripts.DeleteAllItems();
		return;
	}
	this->m_cbDeleteProfile.EnableWindow(TRUE);
	this->m_cbEditProfile.EnableWindow(TRUE);
	m_ctcScripts.DeleteAllItems();
	
	// Populate the tree control with the scripts available to this profile
	CString csProfile;
	m_clbProfiles.GetText(iSel, csProfile);
	if (csProfile.Find("Local:") == 0 )
	{
		// Local profile
		// Find the root directory of this profile
		CString csKey = _T("SOFTWARE\\Menasoft\\GM Tools\\Local Profiles\\") + _T(csProfile.Mid(7));
		CString csRoot = Main->GetRegistryString("Root Directory", "", HKEY_LOCAL_MACHINE, csKey);
		CStringArray csaSelectedScripts;
		Main->GetRegistryMultiSz("Selected Scripts", &csaSelectedScripts, HKEY_LOCAL_MACHINE, csKey);
		// Make a node in the tree control for this directory
		HTREEITEM hRoot = m_ctcScripts.InsertItem(csRoot);
		ParseDirectory(LPCTSTR(csRoot), hRoot, &csaSelectedScripts);
	}
	else
	{
		// Remote profile
		CString csKey = _T("SOFTWARE\\Menasoft\\GM Tools\\Remote Profiles\\") + _T(csProfile.Mid(8));
		CRemoteConnection remote(csProfile.Mid(8));
		CStringArray csaSelectedScripts;
		Main->GetRegistryMultiSz("Selected Scripts", &csaSelectedScripts, HKEY_LOCAL_MACHINE, csKey);
		HTREEITEM hRoot = m_ctcScripts.InsertItem("");
		ParseRemoteDirectory("." , hRoot, &csaSelectedScripts, &remote);
	}
}

void CAdditionalSettingsDlg::OnAsNewprofile() 
{
	CRemoteProfileDlg dlg;
	if ( dlg.DoModal() != IDOK )
		return;
	CString csKey, csRmtPwd, csPwd;
	csPwd = Encrypt(dlg.m_csPwd);
	int iTimeout = atoi(dlg.m_csReceiveTimeout);
	int iRemoteSpawns = dlg.m_bRemoteSpawns ? 1 : 0;
	if ( iTimeout < 1000 )
		iTimeout = 1000;
	switch ( dlg.m_iProfile )
	{
	case 0:
		{
			csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Local Profiles\\%s", dlg.m_csName);

			Main->PutRegistryString("Username", dlg.m_csUsername, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Password", csPwd, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("HoGPort", dlg.m_csHogPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("ServerIP", dlg.m_csIP, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Port", dlg.m_csTusPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Root Directory", dlg.m_csBaseDir, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryDword("ReceiveTimeout", (DWORD) iTimeout, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryDword("Read Remote Spawnpoints", (DWORD) iRemoteSpawns, HKEY_LOCAL_MACHINE, csKey);
		}
		break;
	case 1:
		{
			csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Remote Profiles\\%s", dlg.m_csName);

			Main->PutRegistryString("Username", dlg.m_csUsername, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Password", csPwd, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("ServerIP", dlg.m_csIP, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("HoGPort", dlg.m_csHogPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("TUSPort", dlg.m_csTusPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryDword("ReceiveTimeout", (DWORD) iTimeout, HKEY_LOCAL_MACHINE, csKey);
		}
		break;

	}
	CString csProfile;
	csProfile.Format("%s: %s", dlg.m_iProfile == 0 ? "Local" : "Remote", dlg.m_csName);
	this->m_clbProfiles.AddString(csProfile);
	this->m_clbProfiles.SelectString(-1, csProfile);	
}

void CAdditionalSettingsDlg::OnAsEditprofile() 
{
	int iSel = this->m_clbProfiles.GetCurSel();
	if ( iSel == -1 )
		return;
	CString csProfile;
	m_clbProfiles.GetText(iSel, csProfile);
	CRemoteProfileDlg dlg;
	if ( csProfile.Find("Remote:") == 0 )
	{
		dlg.m_csName = csProfile.Mid(8);
		dlg.m_csHogPort = Main->m_csAxissvrPort;
		dlg.m_csIP = Main->m_csServerIP;
		dlg.m_csPwd = Main->m_csPassword;
		dlg.m_csTusPort = Main->m_csSpherePort;
		dlg.m_csUsername = Main->m_csUserID;
		dlg.m_csReceiveTimeout.Format("%ld", Main->m_iReceiveTimeout);
		dlg.m_iProfile = 1;
	}
	else
	{
		dlg.m_csName = csProfile.Mid(7);
		dlg.m_csHogPort = Main->m_csAxissvrPort;
		dlg.m_csIP = Main->m_csServerIP;
		dlg.m_csPwd = Main->m_csPassword;
		dlg.m_csTusPort = Main->m_csSpherePort;
		dlg.m_csUsername = Main->m_csUserID;
		dlg.m_csReceiveTimeout.Format("%ld", Main->m_iReceiveTimeout);
		dlg.m_csBaseDir = Main->m_csRootDirectory;
		dlg.m_bRemoteSpawns = Main->m_dwRemoteSpawns ? true : false;
		dlg.m_iProfile = 0;
	}

	if ( dlg.DoModal() != IDOK )
		return;
	int iRemoteSpawns = dlg.m_bRemoteSpawns ? 1 : 0;
	int iTimeout = atoi(dlg.m_csReceiveTimeout);
	if ( iTimeout < 1000 )
		iTimeout = 1000;

	CString csKey, csRmtPwd, csPwd;
	csPwd = Encrypt(dlg.m_csPwd);

	switch ( dlg.m_iProfile )
	{
	case 0:
		{
			csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Local Profiles\\%s", dlg.m_csName);

			Main->PutRegistryString("Username", dlg.m_csUsername, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Password", csPwd, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("HoGPort", dlg.m_csHogPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("ServerIP", dlg.m_csIP, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Port", dlg.m_csTusPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Root Directory", dlg.m_csBaseDir, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryDword("ReceiveTimeout", (DWORD) iTimeout, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryDword("Read Remote Spawns", (DWORD) iRemoteSpawns, HKEY_LOCAL_MACHINE, csKey);
		}
		break;
	case 1:
		{
			csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Remote Profiles\\%s", dlg.m_csName);

			Main->PutRegistryString("Username", dlg.m_csUsername, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Password", csPwd, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("ServerIP", dlg.m_csIP, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("HoGPort", dlg.m_csHogPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("TUSPort", dlg.m_csTusPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryDword("ReceiveTimeout", (DWORD) iTimeout, HKEY_LOCAL_MACHINE, csKey);
		}
		break;
	}	
}

void CAdditionalSettingsDlg::OnAsDeleteprofile() 
{
	int iSel = this->m_clbProfiles.GetCurSel();
	if ( iSel == -1 )
		return;
	CString csKey;
	csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Remote Profiles\\%s", Main->GetProfileString());
	Main->DeleteRegistryKey(csKey);
	this->m_clbProfiles.DeleteString( iSel );
	Main->m_csUserID = "";
	Main->m_csPassword = "";
	Main->m_csSpherePort = "";
	Main->m_csAxissvrPort = "";
	Main->m_csServerIP = "";
	Main->GetProfileString() = "";
	Main->m_iReceiveTimeout = 60000;
	Main->m_dwRemoteSpawns = 0;
}

void CAdditionalSettingsDlg::OnAsMulbrowse() 
{
	CFileDialog dlg(TRUE, "exe", "map0.mul", 0, "Ultima Online client files (*.mul)|*.mul|All files (*.*)|*.*||");
	if ( dlg.DoModal() == IDOK )
	{
		CString csPath = dlg.GetPathName();
		csPath.SetAt(csPath.ReverseFind('\\'), 0x00);
		Main->PutRegistryString("MulPath", csPath);
		m_csDefaultMulPath.SetWindowText(csPath);
	}
}

void CAdditionalSettingsDlg::OnAsClientbrowse() 
{
	CFileDialog dlg(TRUE, "exe", "client.exe", 0, "Application files (*.exe)|*.exe|All files (*.*)|*.*||");
	if ( dlg.DoModal() == IDOK )
	{
		csUOExe = dlg.GetPathName();
		Main->PutRegistryString("Default client", dlg.GetPathName());
		m_csDefaultClient.SetWindowText(csUOExe);
		if ( m_cbMulPathFromClient.GetCheck() )
		{
			CString csPath = csUOExe;
			csPath.SetAt(csUOExe.ReverseFind('\\'), 0x00);
			m_csDefaultMulPath.SetWindowText(csPath);
		}
	}
}

void CAdditionalSettingsDlg::ParseDirectory(LPCTSTR pszPath, HTREEITEM hNode, CStringArray *pSelections)
{
		WIN32_FIND_DATA findData;
		memset(&findData, 0x00, sizeof(findData));
		CString csTestFile;
		csTestFile.Format("%s\\*", pszPath);
		HANDLE hSearch = FindFirstFile(csTestFile, &findData);
		if ( hSearch != INVALID_HANDLE_VALUE )
		{
			BOOL bStatus = TRUE;
			while (bStatus)
			{
				if ( findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
				{
					// Recurse this
					if ( strcmp(findData.cFileName, "..") == 0 || strcmp(findData.cFileName, ".") == 0 )
					{
						// Ignore this one
					}
					else
					{
						HTREEITEM hBranch = m_ctcScripts.InsertItem(findData.cFileName, m_iFolderIndex, m_iFolderIndex, hNode);
						CString csNewPath;
						csNewPath.Format("%s\\%s", pszPath, findData.cFileName);
						ParseDirectory(csNewPath, hBranch, pSelections);
					}
				}
				else
				{
					CString csFileName = _T(findData.cFileName);
					if ( csFileName.Right(4).CompareNoCase(".scp") == 0)
					{
						CString csFullPath;
						csFullPath.Format("%s\\%s", pszPath, findData.cFileName);
						HTREEITEM hNewItem = m_ctcScripts.InsertItem(findData.cFileName, m_iDocIndex, m_iDocIndex, hNode);
						if ( IsSelected(pSelections, csFullPath ) )
							m_ctcScripts.SetCheck(hNewItem);

					}
				}
				bStatus = FindNextFile(hSearch, &findData);
			}
			FindClose(hSearch);
		}
}

void CAdditionalSettingsDlg::ParseRemoteDirectory(LPCTSTR pszPath, HTREEITEM hNode, CStringArray * pSelections, CRemoteConnection * pRemote)
{
	CStringArray csaFiles, csaDirectories;
	pRemote->GetDirectory(pszPath, &csaFiles, &csaDirectories);
	int i;
	for ( i = 0; i <= csaDirectories.GetUpperBound(); i++ )
	{
		if ( csaDirectories.GetAt(i) == "." || csaDirectories.GetAt(i) == ".." )
			continue;
		HTREEITEM hBranch = m_ctcScripts.InsertItem(csaDirectories.GetAt(i), m_iFolderIndex, m_iFolderIndex, hNode);
		CString csNewPath;
		csNewPath.Format("%s\\%s", pszPath, csaDirectories.GetAt(i));
		if ( csNewPath.Find(".\\") == 0 ) 
			csNewPath = csNewPath.Mid(2);
		ParseRemoteDirectory(csNewPath, hBranch, pSelections, pRemote);
	}
	for ( i = 0; i <= csaFiles.GetUpperBound(); i++ )
	{
		if ( csaFiles.GetAt(i).Right(4).CompareNoCase(".scp") == 0 )
		{
			CString csFullPath;
			csFullPath.Format("%s\\%s", pszPath, csaFiles.GetAt(i));
			if ( csFullPath.Find(".\\") == 0  )
				csFullPath = csFullPath.Mid(2);
			HTREEITEM hNewItem = m_ctcScripts.InsertItem(csaFiles.GetAt(i), m_iDocIndex, m_iDocIndex, hNode);
			if ( IsSelected(pSelections, csFullPath) )
				m_ctcScripts.SetCheck(hNewItem);
		}
	}
}

void CAdditionalSettingsDlg::UpdateProfile()
{
	if ( m_iCurProfileSel == -1 )
		return;
	CString csProfile;
	this->m_clbProfiles.GetText(m_iCurProfileSel, csProfile);
	CStringArray aSelectedScripts;
	HTREEITEM hRoot = m_ctcScripts.GetRootItem();
	CString csRootDir = m_ctcScripts.GetItemText(hRoot);
	GetSelections(hRoot, csRootDir, &aSelectedScripts);

	CString csProfileKey;
	if (csProfile.Find("Local:") == 0 )
	{
		// Local profile
		csProfileKey = _T("SOFTWARE\\Menasoft\\GM Tools\\Local Profiles\\") + _T(csProfile.Mid(7));
	}
	else
	{
		// Remote profile
		csProfileKey = _T("SOFTWARE\\Menasoft\\GM Tools\\Remote Profiles\\") + _T(csProfile.Mid(8));
	}
	Main->PutRegistryMultiSz("Selected Scripts", &aSelectedScripts, HKEY_LOCAL_MACHINE, csProfileKey);		
}

void CAdditionalSettingsDlg::GetSelections(HTREEITEM hNode, CString csRootDir, CStringArray *pSelections)
{
	HTREEITEM hChild = m_ctcScripts.GetNextItem(hNode, TVGN_CHILD);
	while (hChild != NULL )
	{
		CString csPath;
		if ( csRootDir != "" )
			csPath = csRootDir + _T("\\") + m_ctcScripts.GetItemText(hChild);
		else
			csPath = m_ctcScripts.GetItemText(hChild);
		if ( m_ctcScripts.ItemHasChildren(hChild) )
			GetSelections(hChild, csPath, pSelections);
		else
		{
			// This is a script file
			if ( m_ctcScripts.GetCheck(hChild) )
				pSelections->Add(csPath);
		}
		hChild = m_ctcScripts.GetNextItem(hChild, TVGN_NEXT);
	}
}

bool CAdditionalSettingsDlg::IsSelected(CStringArray * pSelections, CString csFile)
{
	for ( int i = 0; i <= pSelections->GetUpperBound(); i++ )
	{
		if ( csFile == pSelections->GetAt(i) )
			return true;
	}
	return false;
}

void CAdditionalSettingsDlg::OnOK() 
{
	UpdateProfile();	
	CDialog::OnOK();
}

void CAdditionalSettingsDlg::OnChangeCustommuls(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
	// Get the current selected mul and the specified file
	POSITION pos = m_clcMuls.GetFirstSelectedItemPosition();
	if ( pos == NULL )
		return;
	int iSel = m_clcMuls.GetNextSelectedItem(pos);
	CString csMul, csPath, csFile;
	csMul = m_clcMuls.GetItemText(iSel, 0);
	csPath = m_clcMuls.GetItemText(iSel, 1);
	if ( csPath.Find("\\") != -1 )
		csFile = csPath.Mid(csPath.ReverseFind('\\') + 1);
	else
		csFile = csPath;
	// Pop up a file dialog to select the custom mul
	CFileDialog dlg(TRUE, "mul", csFile, 0, "Ultima Online Client files (*.mul; *.idx)|*.mul;*.idx|All Files (*.*)|*.*||");
	if ( dlg.DoModal() == IDOK )
	{
		csPath = dlg.GetPathName();
		m_clcMuls.SetItemText(iSel, 1, csPath);
		int iData = m_clcMuls.GetItemData(iSel);
		CString csRegVal;
		csRegVal.Format("Mul%ld", iData);
		Main->PutRegistryString(csRegVal, csPath);
	}
	// If the user cancelled, ask if we should use the default
	else
	{
		if ( AfxMessageBox("Should Axis use the default client file?", MB_YESNO, MB_ICONQUESTION) == IDYES )
		{
			m_clcMuls.SetItemText(iSel, 1, "");
			int iData = m_clcMuls.GetItemData(iSel);
			CString csRegVal;
			csRegVal.Format("Mul%ld", iData);
			Main->PutRegistryString(csRegVal, csPath);
		}
	}
		return;
}

void CAdditionalSettingsDlg::OnAsUsesamepathasclient() 
{
	if ( this->m_cbMulPathFromClient.GetCheck() )
	{
		CString csClientPath;
		m_csDefaultClient.GetWindowText(csClientPath);
		csClientPath.SetAt(csClientPath.ReverseFind('\\'), 0x00);
		m_csDefaultMulPath.SetWindowText(csClientPath);
		m_cbMulBrowse.EnableWindow(FALSE);
	}
	else
		m_cbMulBrowse.EnableWindow(TRUE);
}

void CAdditionalSettingsDlg::OnAs3droomview() 
{
	UpdateData();
	Main->PutRegistryDword("3DRoomView", m_b3DRoomView);
}

void CAdditionalSettingsDlg::OnAsAllowmultiple() 
{
	UpdateData();
	Main->PutRegistryDword("AllowMultipleInstances", m_bAllowMultiple);
}

void CAdditionalSettingsDlg::OnAsDisplayitems() 
{
	UpdateData();
	Main->PutRegistryDword("DrawItems", m_bDisplayItems);	
}

void CAdditionalSettingsDlg::OnAsOntop() 
{
	UpdateData();
	Main->PutRegistryDword("AlwaysOnTop", m_bAlwaysOnTop);	
}

void CAdditionalSettingsDlg::OnAsRadar() 
{
	UpdateData();
	Main->PutRegistryDword("ShowRadar", m_bShowRadarMap);	
}

void CAdditionalSettingsDlg::OnAsScale() 
{
	UpdateData();
	Main->PutRegistryDword("ScaleItems", m_bScaleItems);
}

void CAdditionalSettingsDlg::OnAsShowchars() 
{
	UpdateData();
	Main->PutRegistryDword("DrawChars", m_bShowChars);	
}

void CAdditionalSettingsDlg::OnAsShowspawns() 
{
	UpdateData();
	Main->PutRegistryDword("ShowSpawnpoints", m_bShowSpawns);	
}

void CAdditionalSettingsDlg::OnAsSpawnmsg() 
{
	UpdateData();
	Main->PutRegistryDword("SpawnMessage", m_bSpawnMessage);	
}

void CAdditionalSettingsDlg::OnAsStartlauncher() 
{
	UpdateData();
	Main->PutRegistryDword("StartLauncher", m_bStartLauncher);	
}

void CAdditionalSettingsDlg::OnAsSysclose() 
{
	UpdateData();
	Main->PutRegistryDword("SysClose", m_bSysClose);	
}

void CAdditionalSettingsDlg::OnAsGodclient() 
{
	UpdateData();
	Main->PutRegistryDword("GodClient", m_bGodClient);
}

void CAdditionalSettingsDlg::OnClickAsAvailablescripts(NMHDR* pNMHDR, LRESULT* pResult) 
{
	DWORD dw = GetMessagePos();                   // retrieve mouse cursor position when msg was sent
	CPoint p(GET_X_LPARAM(dw), GET_Y_LPARAM(dw)); // ..and put into point structure
	m_ctcScripts.ScreenToClient(&p);                    // make coords local to tree client area

	UINT htFlags = 0;
	HTREEITEM it = m_ctcScripts.HitTest(p, &htFlags);   // See where the click was on

	if (it != NULL && htFlags==TVHT_ONITEMSTATEICON)
	{   
		// the check box was hit.
		// we just post a message
		PostMessage(WM_APP, pNMHDR->idFrom, (LPARAM) it);
	}	
	*pResult = 0;
}

LRESULT CAdditionalSettingsDlg::OnTvCheckbox(WPARAM wp, LPARAM lp)
{
	// CTreeCtrl & tree = GetDlgItem(wp);  -- if we have multiple trees
	HTREEITEM hItem = (HTREEITEM) lp;
	int checked = (m_ctcScripts.GetItemState(hItem, TVIS_STATEIMAGEMASK) >> 12) - 1;

	CheckChildren(hItem, checked);
	
	return 0;
}

void CAdditionalSettingsDlg::CheckChildren(HTREEITEM hNode, int check)
{
	HTREEITEM hChild = m_ctcScripts.GetNextItem(hNode, TVGN_CHILD);
	while (hChild != NULL )
	{
		if ( m_ctcScripts.ItemHasChildren(hChild) )
			CheckChildren(hChild, check);
		m_ctcScripts.SetCheck(hChild, check);
		hChild = m_ctcScripts.GetNextItem(hChild, TVGN_NEXT);
	}
}