/*
 $Id: AxisLog.cpp,v 1.6 2002/07/17 19:10:56 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// AxisLog.cpp: implementation of the CAxisLog class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "drewsky.h"
#include "AxisLog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CAxisLog::CAxisLog()
{
#ifdef _AXIS
#define OLD_LOG "axis.log.old"
#define NEW_LOG "axis.log"
#else
#define OLD_LOG "spherescript.log.old"
#define NEW_LOG "spherescript.log"
#endif
	try
	{
		CFile::Remove(OLD_LOG);
	}
	catch (CFileException * e)
	{
		e->Delete();
	}
	try
	{
		CFile::Rename(NEW_LOG, OLD_LOG);
	}
	catch (CFileException * e)
	{
		e->Delete();
	}
	// Open a new log file
	m_pLog = fopen(NEW_LOG, "w");
}

CAxisLog::~CAxisLog()
{
	// Close the file
	Add("Axis is shutting down.");
	fclose(m_pLog);
}

void CAxisLog::Add(const char *format, ...)
{
	if ( m_pLog == NULL )
		return;
	time_t now;
	now = time(NULL);
	struct tm * lt = localtime(&now);
	fprintf( m_pLog, "%ld.%ld.%ld %02d:%02d:%02d ::", lt->tm_year + 1900, lt->tm_mon + 1, lt->tm_mday, lt->tm_hour, lt->tm_min, lt->tm_sec );
	CString csText;
	va_list args;
	va_start(args, format);
	csText.FormatV(format, args);
	vfprintf(m_pLog, format, args);
	va_end(args);
	fprintf(m_pLog, "\n");
	fflush(m_pLog);
	if ( Main->m_pcppAxisLogTab )
		Main->m_pcppAxisLogTab->AddText(csText);
}