/*
 $Id: CITEM.CPP,v 1.8 2002/11/17 04:25:27 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#include "stdafx.h"
#include "CItem.h"
#include "RemoteConnection.h"
#include "RemoteConsole.h"

//  Stuff for CItem

CItem::CItem()
{
	m_bType = TYPE_ITEM;
	this->m_bNoIndex = false;
	this->m_bCustom = false;
	this->m_bDyeable = false;
	this->m_bRepairable = false;
	this->m_byReqStr = 0;
	this->m_bySpell = 0;
	this->m_dwType = 0;
	this->m_csItemName = "";
	this->m_csDescription = "<unnamed>";
	this->m_csCategory = "<none>";
	this->m_csSubsection = "<none>";
	this->m_csSkill = "";
	this->m_csValue = "";
	this->m_csColor = "";
	this->m_fWeight = 0.0;
	this->m_iArmourBonus = 0;
	this->m_iCharges = 0;
	this->m_iSpeed = 0;
	this->m_wAttr = 0;
	this->m_csDupeItem = "";
	this->m_wItemBase = 0;
	this->m_dwMore1 = 0;
	this->m_dwMore2 = 0;
	this->m_iTimer = 0;
	this->m_bTwohands = false;
}

CCategory::CCategory()
{
	this->m_csName = "<none>";
}

CSubsection::CSubsection()
{
	this->m_csName = "<none>";
}

CDupeItem::~CDupeItem()
{

}

void CItem::Dupe(CItem *pDupe)
{
	if (pDupe == NULL)
		return;
	CString csCategory, csSubsection, csName, csValue;
	WORD wItemBase;
	csCategory = m_csCategory;
	csSubsection = m_csSubsection;
	csName = m_csDescription;
	csValue = m_csValue;
	wItemBase = m_wItemBase;
	Copy(pDupe);
	m_csCategory = csCategory;
	m_csSubsection = csSubsection;
	m_csDescription = csName;
	this->m_csValue = csValue;
	m_wItemBase = wItemBase;
	this->m_csDupeItem = pDupe->m_csValue;
	if ( this->m_csCategory == "<none>" )
		this->m_csCategory = pDupe->m_csCategory;
	if ( this->m_csSubsection == "<none>" )
		this->m_csSubsection = pDupe->m_csSubsection;
	if ( this->m_csDescription == "<unnamed>" )
		this->m_csDescription = pDupe->m_csDescription;
	if ( ! this->m_wItemBase )
		this->m_wItemBase = pDupe->m_wItemBase;
	this->m_csValue = csValue;
}

void CItem::Copy(CItem *pCopy)
{
	this->m_bCustom = pCopy->m_bCustom;
	this->m_bDyeable = pCopy->m_bDyeable;
	this->m_bNoIndex = pCopy->m_bNoIndex;
	this->m_bRepairable = pCopy->m_bRepairable;
	this->m_byReqStr = pCopy->m_byReqStr;
	this->m_bySpell = pCopy->m_bySpell;
	this->m_csaOthers.Copy(pCopy->m_csaOthers);
	this->m_csaTriggers.Copy(pCopy->m_csaTriggers);
	this->m_csCategory = pCopy->m_csCategory;
	this->m_csDescription = pCopy->m_csDescription;
	this->m_csSubsection = pCopy->m_csSubsection;
	this->m_csValue = pCopy->m_csValue;
	this->m_csColor = pCopy->m_csColor;
	this->m_csDef = pCopy->m_csDef;
	this->m_csDupeList = pCopy->m_csDupeList;
	this->m_csItemName = pCopy->m_csItemName;
	this->m_dwMore1 = pCopy->m_dwMore1;
	this->m_dwMore2 = pCopy->m_dwMore2;
	this->m_csSkill = pCopy->m_csSkill;
	this->m_dwType = pCopy->m_dwType;
	this->m_fWeight = pCopy->m_fWeight;
	this->m_iArmourBonus = pCopy->m_iArmourBonus;
	this->m_irArmour.Copy(&(pCopy->m_irArmour));
	this->m_irBuyValue.Copy(&(pCopy->m_irBuyValue));
	this->m_iCharges = pCopy->m_iCharges;
	this->m_irDamage.Copy(&(pCopy->m_irDamage));
	this->m_irHitPoints.Copy(&(pCopy->m_irHitPoints));
	this->m_irSellValue.Copy(&(pCopy->m_irSellValue));
	this->m_iSpeed = pCopy->m_iSpeed;
	this->m_iTimer = pCopy->m_iTimer;
	this->m_wAttr = pCopy->m_wAttr;
	this->m_csDupeItem = pCopy->m_csDupeItem;
	this->m_wItemBase = pCopy->m_wItemBase;
	this->m_bTwohands = pCopy->m_bTwohands;
	this->m_csMaterial = pCopy->m_csMaterial;
	this->m_csMultiregion = pCopy->m_csMultiregion;
	this->m_csaComponents.Copy(pCopy->m_csaComponents);
}

bool CItem::Save(CString csFileRoot)
{
#ifdef _AXIS
	CString csFileName, csTmpFileName;
	if (Main->GetProfileType() == PROFILE_REMOTE)
		csFileRoot = "remoteaxis";
	csFileName.Format("%s.scp", csFileRoot);
	csTmpFileName.Format("%s.tmp", csFileRoot);
	CStdioFile csfInput;
	CStdioFile csfOutput;
	if (!csfInput.Open(csFileName, CFile::modeRead | CFile::modeCreate | CFile::modeNoTruncate | CFile::shareDenyWrite))
		return false;
	if (Main->GetProfileType() == PROFILE_REMOTE)
	{
		if (!csfOutput.Open(csTmpFileName, CFile::modeWrite | CFile::modeCreate | CFile::shareDenyWrite | CFile::typeBinary))
		{
			csfInput.Close();
			return false;
		}
	}
	else
	{
		if (!csfOutput.Open(csTmpFileName, CFile::modeWrite | CFile::modeCreate | CFile::shareDenyWrite))
		{
			csfInput.Close();
			return false;
		}
	}
	// We need to read the input file and search for the correct place to put this item
	// If the item is already there, we need to overwrite the existing one (except for certain things)
	// If the item isn't already there, we need to insert it in numerical order.
	CString csIn, csOut, endl;
	endl.Format("\n");

	BOOL bStatus = true;
	BOOL bItemWritten = false;
	while (bStatus)
	{
		bool bTagsHandled[23] = {false};
		// Read a line from the file...
		bStatus = csfInput.ReadString(csIn);
		// If it starts with a '[', it is the beginning of an item description
		if (!bStatus && !bItemWritten)
		{
			// We hit the end of the file and didn't find it...
			// Put this item at the end
			this->Write(csfOutput);
			bItemWritten = true;
			break;
		}
		if (csIn != "")
		{
			if ((csIn[0] == '[') && !bItemWritten)
			{
				// Get the item number
				CString csLine = csIn.Mid(1);
				csLine = csLine.SpanExcluding("]");
				DWORD dwThisItem = ahextoi(csLine);
				if (dwThisItem < ahextoi(this->m_csValue))
				{
					csfOutput.WriteString(csIn);
					csfOutput.WriteString(endl);
					continue;
				}
				if (dwThisItem == ahextoi(this->m_csValue))
				{
					// this is the item...we need to handle this one carefully
					Write(csfOutput);
					bItemWritten = true;
					csfOutput.WriteString("\n");
					while (bStatus)
					{
						bStatus = csfInput.ReadString(csIn);
						if (csIn == "")
							continue;
						if (csIn[0] == '[')
						{
							// We are into the next item now
							break;
						}
					}
				}
				if (dwThisItem > ahextoi(this->m_csValue) && !bItemWritten )
				{
					// Insert the new one
					this->Write(csfOutput);
					bItemWritten = true;
				}
			}
		}
		// otherwise, at this point, it's either a comment, or a tag in an item preceding the one we want, or we've already written the new item
		// so write the line to the new file
		if (bStatus)
		{
			csfOutput.WriteString(csIn);
			csfOutput.WriteString(endl);
		}
	}
	csfInput.Close();
	csfOutput.Close();
	if (Main->GetProfileType() == PROFILE_REMOTE)
	{
		CRemoteConnection crRemote;
		if (crRemote.IsValid())
		{
			//crRemote.SendCustomFile("grayitem2", csTmpFileName, this);
			//crRemote.GetCustomFile("grayitem2");
		}
	}
	if (Main->GetProfileType() == PROFILE_REMOTE)
	{
		CFile::Remove(csFileName);
		CFile::Remove(csTmpFileName);
	}
	else
	{
		CRemoteConsole * pConsole = Main->m_pRConsole;
		bool bDeleteConsole = false;
		if (pConsole == NULL)
		{
			pConsole = new (CRemoteConsole);
			bDeleteConsole = true;
		}
		pConsole->Pause();
		int i = 0;
		while (pConsole->m_bCommandPending)
		{
			i++;
			Sleep(50);
			if (i > 100)
				break;
		}
		ReplaceFiles(csTmpFileName, csFileName);
		pConsole->Resync();
		i = 0;
		while (pConsole->m_bCommandPending)
		{
			i++;
			Sleep(50);
			if (i > 100)
				break;
		}
		if (bDeleteConsole)
			delete pConsole;
	}
#endif
	return true;
}

bool CItem::WriteBasic(CStdioFile &csfOutput)
{
	if ( ! CSObject::Write(csfOutput) )
		return false;
	CString csLine;
	if ( this->m_wItemBase != 0 )
	{
		csLine.Format("ID=%05x\n", m_wItemBase);
		csfOutput.WriteString(csLine);
	}
	if ( this->m_csColor != "" )
	{
		csLine.Format("COLOR=%s\n", this->m_csColor);
		csfOutput.WriteString(csLine);
	}
	return true;
}

bool CItem::Write(CStdioFile &csfOutput)
{
	CString csVal;
	csVal.Format("[%s]\n", this->m_csValue);
	csfOutput.WriteString(csVal);
	for ( int i = 0; i < this->m_csaComments.GetSize(); i++ )
	{
		csfOutput.WriteString(m_csaComments.GetAt(i));
		csfOutput.WriteString("\n");
	}
	bool bTagsHandled[34] = {false};
	// Write this stuff out in a particular order.
	WriteTag("NAME", csfOutput, &bTagsHandled[0], "");
	WriteTag("DUPEITEM", csfOutput, &bTagsHandled[0], "");
	WriteTag("TYPE", csfOutput, &bTagsHandled[0], "");
	WriteTag("ID", csfOutput, &bTagsHandled[0], "");
	WriteTag("COLOR", csfOutput, &bTagsHandled[0], "");
	WriteTag("WEIGHT", csfOutput, &bTagsHandled[0], "");
	WriteTag("BUYVALUE", csfOutput, &bTagsHandled[0], "");
	WriteTag("SELLVALUE", csfOutput, &bTagsHandled[0], "");
	WriteTag("DYE", csfOutput, &bTagsHandled[0], "");
	WriteTag("REPAIR", csfOutput, &bTagsHandled[0], "");
	WriteTag("SKILL", csfOutput, &bTagsHandled[0], "");
	WriteTag("DAM", csfOutput, &bTagsHandled[0], "");
	WriteTag("ARMOR", csfOutput, &bTagsHandled[0], "");
	WriteTag("REQSTR", csfOutput, &bTagsHandled[0], "");
	WriteTag("SPEED", csfOutput, &bTagsHandled[0], "");
	WriteTag("HITPOINTS", csfOutput, &bTagsHandled[0], "");
	WriteTag("ATTR", csfOutput, &bTagsHandled[0], "");
	WriteTag("MOREP", csfOutput, &bTagsHandled[0], "");
	WriteTag("MORE", csfOutput, &bTagsHandled[0], "");
	WriteTag("MORE2", csfOutput, &bTagsHandled[0], "");
	WriteTag("DUPELIST", csfOutput, &bTagsHandled[0], "");
	WriteTag("DEFNAME", csfOutput, &bTagsHandled[0], "");
	WriteTag("TIMER", csfOutput, &bTagsHandled[0], "");
	WriteTag("TWOHANDS", csfOutput, &bTagsHandled[0], "");
	WriteTag("MULTIREGION", csfOutput, &bTagsHandled[0], "");
	WriteTag("COMPONENT", csfOutput, &bTagsHandled[0], "");
	WriteTag("MATERIAL", csfOutput, &bTagsHandled[0], "");

	for ( i = 0; i < this->m_csaOthers.GetSize(); i++ )
	{
		CString csText = this->m_csaOthers.GetAt(i);
		if ( csText != "" )
		{
			csfOutput.WriteString(this->m_csaOthers.GetAt(i));
			csfOutput.WriteString("\n");
		}
	}
	if (this->m_bNoIndex)
		csfOutput.WriteString("NOINDEX\n");
	else
	{
		WriteTag("CATEGORY", csfOutput, &bTagsHandled[0], "");
		WriteTag("SUBSECTION", csfOutput, &bTagsHandled[0], "");
		WriteTag("DESCRIPTION", csfOutput, &bTagsHandled[0], "");
	}
	if ( this->m_csaTriggers.GetSize() != 0 )
	{
		for ( int i = 0; i < this->m_csaTriggers.GetSize(); i++ )
		{
			csfOutput.WriteString(this->m_csaTriggers.GetAt(i));
			csfOutput.WriteString("\n");
		}
	}
	csfOutput.WriteString("\n");
	return true;
}

void CItem::WriteTag(CString csTag, CStdioFile &csfOutput, bool * bTagsHandled, CString csIn)
{
	CString csNewVal;
	CString endl = "\n";
	switch (FindTable(csTag, knownItemTags, 34))
	{
	case 0:
		bTagsHandled[0] = true;
		if (this->m_csItemName != "")
			csNewVal.Format("NAME=%s\n", this->m_csItemName);
		break;
	case 1:
		bTagsHandled[1] = true;
		if (this->m_bDyeable)
			csNewVal.Format("DYE=1\n");
		break;
	case 2:
		bTagsHandled[2] = true;
		if (this->m_bRepairable)
			csNewVal.Format("REPAIR=1\n");
		break;
	case 3:
		bTagsHandled[3] = true;
		if (this->m_byReqStr != 0)
			csNewVal.Format("REQSTR=%ld\n", this->m_byReqStr);
		break;
	case 4:
		bTagsHandled[4] = true;
		if (this->m_bySpell != 0 || this->m_iArmourBonus != 0 || this->m_iCharges != 0)
			csNewVal.Format("MOREP=%ld %ld %ld\n", this->m_bySpell, this->m_iArmourBonus, this->m_iCharges);
		break;
	case 5:
		bTagsHandled[5] = true;
		if (this->m_dwType != 0)
			csNewVal.Format("TYPE=%ld\n", this->m_dwType);
		break;
	case 6:
		bTagsHandled[6] = true;
		if (this->m_csCategory != "" && !this->m_bNoIndex)
			csNewVal.Format("CATEGORY=%s\n", this->m_csCategory);
		break;
	case 7:
		bTagsHandled[7] = true;
		if (this->m_csSubsection != "" && !this->m_bNoIndex)
			csNewVal.Format("SUBSECTION=%s\n", this->m_csSubsection);
		break;
	case 8:
		bTagsHandled[8] = true;
		if (this->m_csDescription != "" && !this->m_bNoIndex)
			csNewVal.Format("DESCRIPTION=%s\n", this->m_csDescription);
		break;
	case 9:
		bTagsHandled[9] = true;
		if (this->m_wItemBase != 0)
			csNewVal.Format("ID=%05x\n", this->m_wItemBase);
		break;
	case 10:
		bTagsHandled[10] = true;
		if (this->m_csColor != "")
			csNewVal.Format("COLOR=%s\n", this->m_csColor);
		break;
	case 11:
		bTagsHandled[11] = true;
		if (this->m_fWeight != 0)
		{
			if (this->m_fWeight == ((float) ((int) this->m_fWeight)) )
				csNewVal.Format("WEIGHT=%ld\n", (int) this->m_fWeight);
			else
				csNewVal.Format("WEIGHT=%-.1f\n", this->m_fWeight);
		}
		break;
	case 12:
		bTagsHandled[12] = true;
		if (this->m_irArmour.max != 0)
			csNewVal.Format("ARMOR=%s\n", m_irArmour.WriteRange());
		break;
	case 13:
		bTagsHandled[13] = true;
		if (this->m_irBuyValue.max != 0)
			csNewVal.Format("BUYVALUE=%s\n", m_irBuyValue.WriteRange());
		break;
	case 14:
		bTagsHandled[14] = true;
		if (this->m_irSellValue.max != 0)
			csNewVal.Format("SELLVALUE=%s\n", m_irSellValue.WriteRange());
		break;
	case 15:
	case 16:
		bTagsHandled[15] = true;
		bTagsHandled[16] = true;
		if (this->m_irDamage.max != 0)
			csNewVal.Format("DAM=%s\n", m_irDamage.WriteRange());
		break;
	case 17:
		bTagsHandled[17] = true;
		if (this->m_irHitPoints.max != 0)
			csNewVal.Format("HITPOINTS=%s\n", m_irHitPoints.WriteRange());
		break;
	case 18:
		bTagsHandled[18] = true;
		if (this->m_csDupeItem != "")
			csNewVal.Format("DUPEITEM=%s\n", this->m_csDupeItem);
		break;
	case 19:
		bTagsHandled[19] = true;
		if (this->m_wAttr != 0)
			csNewVal.Format("ATTR=%04x\n", this->m_wAttr);
		break;
	case 20:
		bTagsHandled[20] = true;
		if (this->m_iSpeed != 0)
			csNewVal.Format("SPEED=%ld\n", this->m_iSpeed);
		break;
	case 21:
		bTagsHandled[21] = true;
		if (this->m_csSkill != "")
			csNewVal.Format("SKILL=%s\n", this->m_csSkill);
		break;
	case 22:
	case 23:
		bTagsHandled[22] = true;
		bTagsHandled[23] = true;
		if ( this->m_dwMore1 )
			csNewVal.Format("MORE1=0%x\n", this->m_dwMore1);
		break;
	case 24:
		bTagsHandled[24] = true;
		if ( this->m_dwMore2 )
			csNewVal.Format("MORE2=0%x\n", this->m_dwMore2);
		break;
	case 25:
		bTagsHandled[25] = true;
		break;
	case 26:
		bTagsHandled[26] = true;
		if ( this->m_csDupeList != "" )
			csNewVal.Format("DUPELIST=%s\n", this->m_csDupeList);
		break;
	case 27:
		bTagsHandled[27] = true;
		if ( this->m_csDef != "" )
			csNewVal.Format("DEFNAME=%s\n", this->m_csDef);
		break;
	case 28:
		bTagsHandled[28] = true;
		if ( this->m_iTimer != 0)
			csNewVal.Format("TIMER=%ld\n", this->m_iTimer);
		break;
	case 29:
		break;
	case 30:
		bTagsHandled[30] = true;
		if ( this->m_bTwohands )
			csfOutput.WriteString("TWOHANDS=Y\n");
		break;
	case 31:
		bTagsHandled[31] = true;
		{
			for (int i = 0; i < this->m_csaComponents.GetSize(); i++)
			{
				CString csTmp = m_csaComponents.GetAt(i);
				if ( csTmp != "" )
				{
					csNewVal.Format("COMPONENT=%s\n", csTmp);
					csfOutput.WriteString(csNewVal);
				}
			}
			csNewVal = "";
		}
		break;
	case 32:
		bTagsHandled[32] = true;
		if ( this->m_csMultiregion != "" )
			csNewVal.Format("MULTIREGION=%s\n", m_csMultiregion);
		break;
	case 33:
		bTagsHandled[33] = true;
		if ( this->m_csMaterial != "" )
			csNewVal.Format("MATERIAL=%s\n", m_csMaterial);
		break;
	default:
		// Don't know this one...write it
		csfOutput.WriteString(csIn);
		csfOutput.WriteString(endl);
	}
	if ( csNewVal != "" )
		csfOutput.WriteString(csNewVal);
}

bool CItem::Read(CStdioFile &inFile)
{
	int iSize = sizeof(CItem);
	BOOL bStatus = true;
	CString csLine = "";
	bool bHasTriggers = false;
	while ((csLine.Find("[") != 0) && bStatus )
	{
		DWORD dwCur = inFile.GetPosition();
		bStatus = inFile.ReadString(csLine);
		if ( csLine.Find("[") == 0 )
		{
			inFile.Seek((LONG) (dwCur - inFile.GetPosition()), CFile::current);
			break;
		}
		csLine.TrimLeft();
		csLine.TrimRight();
		if ( csLine.Find("//") == 0 )
		{
			this->m_csaComments.Add(csLine);
			continue;
		}
		CString csUCLine = csLine;
		csUCLine.MakeUpper();
		CString csTag = csUCLine.SpanExcluding("=");
		CString csValue;
		if ( csLine.Find("=") != -1 )
			csValue = csLine.Mid(csLine.Find("=") + 1);
		else
			csValue = csLine;
		csValue.TrimLeft();
		csValue.TrimRight();
		csValue.Remove(0x0d);
		if ( bHasTriggers && csUCLine.Find("CATEGORY=") == -1 && csUCLine.Find("SUBSECTION=") == -1 && csUCLine.Find("DESCRIPTION=") == -1 )
			this->m_csaTriggers.Add(csLine);
		else
		{
			if ( csTag == "" )
				continue;
			switch(FindTable(csTag, knownItemTags, 34))
			{
			case 0:	// Name
				this->m_csItemName = csValue; break;
			case 1: // DYE
				this->m_bDyeable = (atoi(csValue) == 0 ? false : true ); break;
			case 2: // REPAIR
				this->m_bRepairable = (atoi(csValue) == 0 ? false : true ); break;
			case 3: // REQSTR
				this->m_byReqStr = (BYTE) atoi(csValue); break;
			case 4: // MOREP
				{
					int iFirstSpace = csValue.Find(" ");
					if ( iFirstSpace == -1 )
						iFirstSpace = csValue.Find(",");
					int iSecondSpace = csValue.ReverseFind(' ');
					if ( iSecondSpace == -1 )
						iSecondSpace = csValue.ReverseFind(',');
					if (iFirstSpace == iSecondSpace)
						continue;
					if ( (iFirstSpace == -1) || (iSecondSpace == -1))
						continue;
					this->m_bySpell = (BYTE) atoi(csValue.Left(iFirstSpace));
					this->m_iArmourBonus = atoi(csValue.Mid(iFirstSpace + 1, iSecondSpace - iFirstSpace ));
					this->m_iCharges = atoi(csValue.Right(csValue.GetLength() - iSecondSpace - 1));
				}
				break;
			case 5: // TYPE
				this->m_dwType = (DWORD) DefLookup(csValue); break;
			case 6: // CATEOGRY
				this->m_csCategory = csValue; break;
			case 7: // SUBSECTION
				this->m_csSubsection = csValue; break;
			case 8: // DESCRIPTION
				this->m_csDescription = csValue; break;
			case 9: // ID
				if ( IsDef(csValue) )
					this->m_wItemBase = (WORD) DefLookup(csValue);
				else
					this->m_wItemBase = (WORD) ahextoi(csValue);
				break;
			case 10: // COLOR
				this->m_csColor = csValue; break;
			case 11: // WEIGHT
				this->m_fWeight = (float) atof(csValue); break;
			case 12: // ARMOR
				this->m_irArmour.ReadRange(csValue);
				break;
			case 13: // BUYVALUE
				this->m_irBuyValue.ReadRange(csValue);
				break;
			case 14: // SELLVALUE
				this->m_irSellValue.ReadRange(csValue);
				break;
			case 15: // DAM
			case 16: // ATT
				this->m_irDamage.ReadRange(csValue);
				break;
			case 17: // HITPOINTS
				this->m_irHitPoints.ReadRange(csValue);
				break;
			case 18: // DUPEITEM
				this->m_csDupeItem = csValue;
				break;
			case 19: // ATTR
				this->m_wAttr = (WORD) ahextoi(csValue); break;
			case 20: // SPEED
				this->m_iSpeed = atoi(csValue); break;
			case 21: // SKILL
				this->m_csSkill = csValue; break;
			case 22: // MORE
			case 23: // MORE1
				this->m_dwMore1 = ahextoi(csValue); break;
			case 24: // MORE2
				this->m_dwMore2 = ahextoi(csValue); break;
			case 25: // ONTRIGGER
				this->m_csaTriggers.Add(csLine);
				bHasTriggers = true;
				break;
			case 26: // DUPELIST
				this->m_csDupeList = csValue; break;
			case 27: // DEFNAME
				this->m_csDef = csValue; break;
			case 28: // TIMER
				this->m_iTimer = atoi(csValue); break;
			case 29: // NOINDEX
				this->m_bNoIndex = true;
			case 30: // TWOHANDS
				this->m_bTwohands = (csValue.CompareNoCase("Y") == 0) ? true : false; break;
			case 31: // COMPONENT
				this->m_csaComponents.Add(csValue); break;
			case 32: // MULTIREGION
				this->m_csMultiregion = csValue; break;
			case 33: // MATERIAL
				this->m_csMaterial = csValue; break;
			default:
				if ( bHasTriggers )
					this->m_csaTriggers.Add(csLine);
				else
					this->m_csaOthers.Add(csLine);
			}
		}
	}
	return ( bStatus ? true : false );
}

CItem::~CItem()
{
	this->m_csaComponents.RemoveAll();
	this->m_csaOthers.RemoveAll();
	this->m_csaTriggers.RemoveAll();
	this->m_csaComments.RemoveAll();
}
