/*
 $Id: CNPC.H,v 1.4 2002/05/06 04:11:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#include "stdafx.h"
#include "common.h"

#ifndef __NPC_H_
#define __NPC_H_

enum SKILL_TYPE	// List of skill numbers (things that can be done at a given time)
{
	SKILL_NONE = -1,

	SKILL_ALCHEMY = 0,
	SKILL_ANATOMY,
	SKILL_ANIMALLORE,
	SKILL_ITEMID,
	SKILL_ARMSLORE,
	SKILL_PARRYING,
	SKILL_BEGGING,
	SKILL_BLACKSMITHING,
	SKILL_BOWCRAFT,
	SKILL_PEACEMAKING,
	SKILL_CAMPING,	// 10
	SKILL_CARPENTRY,
	SKILL_CARTOGRAPHY,
	SKILL_COOKING,
	SKILL_DETECTINGHIDDEN,
	SKILL_ENTICEMENT,
	SKILL_EVALINT,
	SKILL_HEALING,
	SKILL_FISHING,
	SKILL_FORENSICS,
	SKILL_HERDING,	// 20
	SKILL_HIDING,
	SKILL_PROVOCATION,
	SKILL_INSCRIPTION,
	SKILL_LOCKPICKING,
	SKILL_MAGERY,		// 25
	SKILL_MAGICRESISTANCE,
	SKILL_TACTICS,
	SKILL_SNOOPING,
	SKILL_MUSICIANSHIP,
	SKILL_POISONING,	// 30
	SKILL_ARCHERY,
	SKILL_SPIRITSPEAK,
	SKILL_STEALING,
	SKILL_TAILORING,
	SKILL_TAMING,
	SKILL_TASTEID,
	SKILL_TINKERING,
	SKILL_TRACKING,
	SKILL_VETERINARY,
	SKILL_SWORDSMANSHIP,	// 40
	SKILL_MACEFIGHTING,
	SKILL_FENCING,
	SKILL_WRESTLING,		// 43
	SKILL_LUMBERJACKING,
	SKILL_MINING,
	SKILL_MEDITATION,
	SKILL_Stealth,			// 47
	SKILL_RemoveTrap,		// 48
	SKILL_NECROMANCY,
	SKILL_QTY,	// 50

	// Actions a npc will perform. (no need to track skill level for these)
	NPCACT_FOLLOW_TARG = 100,	// 100 = following a char.
	NPCACT_STAY,			// 101
	NPCACT_GOTO,			// 102 = Go to a location x,y
	NPCACT_WANDER,			// 103 = Wander aimlessly.
	NPCACT_UNUSED,			// 104 = ??? Just wander around a central point.
	NPCACT_FLEE,			// 105 = Run away from target.
	NPCACT_TALK,			// 106 = Talking to my target.
	NPCACT_TALK_FOLLOW,		// 107 = 
	NPCACT_GUARD_TARG,		// 108 = Guard a targetted object.
	NPCACT_GO_HOME,			// 109 =
	NPCACT_GO_FETCH,		// 110 = Pick up a thing.
	NPCACT_BREATH,			// 111 = Using breath weapon.
	NPCACT_RIDDEN,			// 112 = Being ridden or shrunk as figurine.
	NPCACT_EATING,			// 113 = Animate the eating action.
	NPCACT_LOOTING,			// 114 = Looting a corpse.
	NPCACT_THROWING,		// 115 = Throwing a stone.
	NPCACT_GO_FOOD,			// 116 = walking to food.
	NPCACT_QTY,
};


class CNPC : public CSObject
{
public:
	bool m_bCustom;
	void WriteTag(CString csTag, CStdioFile &csfOutput, bool * bTagsHandled, CString csIn);
	bool Write(CStdioFile &csfOutput);
	bool WriteBasic(CStdioFile &csfOutput);
	bool Save(CString csFileRoot);
	void Copy(CNPC *ob);
	CNPCLootItem * m_pLastLootItem;
	CString m_csPreviousTag;
	CNPC();
	virtual ~CNPC();
	bool Read(CStdioFile &csfInput);
	void ReadTag(CString csLine);
	// 
	// Tag Values
	CString m_csAnim;
	CIntRange m_irAtt;
	CPtrList m_olBuyItems;
	CString m_csCan;
	CString m_csColor;
	CIntRange m_irDef;
	CIntRange m_irDex;
	CIntRange m_irFame;
	CString m_csFoodType;
	CString m_csIcon;
	WORD m_wID;
	CIntRange m_irInt;
	CPtrList m_olItems;
	CIntRange m_irKarma;
	CString m_csNPCName;
	CString m_csNPC;
	CString m_csResources;
	CPtrList m_olSellItems;
	CString m_csSound;
	WORD m_wSpeech;
	CIntRange m_irStr;
	int m_iDailyWage;
	bool m_bNoIndex;
	CStringArray m_saSpells;
	DWORD m_dwSpellsMore1;
	DWORD m_dwSpellsMore2;
	bool m_bHasSpellbook;
	CString m_csDesires;
	CStringArray m_csTSpeech;
	CStringArray m_csTEvents;
	CString m_csDefName;
	CString m_csNeed;
	CString m_csEvents;


	CIntRange m_irSkill[SKILL_QTY];
};

#endif