/*
 $Id: CScriptObjects.h,v 1.5 2002/11/12 21:29:14 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/


#ifdef _AXIS
#include "stdafx.h"
#include "drewsky.h"
#endif
#include "common.h"
#include "CItem.h"
#include "CNPC.h"
#include "tables.h"
#include "ConfigFile.h"

#ifndef _CSCRIPTOBJECTS_H_
#define _CSCRIPTOBJECTS_H_

static char * TriggerKeys [] =
{
	"PLOTITEM",
	"REGION",
	"TRIG",
};

class CScriptObjects
{
public:
	void LoadAll();
	void Unload();

	void UnloadNames();
	void ReloadNames();

	void UnloadTables();
	void ReloadTables();

	void UnloadNPCs();
	void ReloadNPCs();

	void UnloadItems();
	void ReloadItems();

	void UnloadTemplates();
	void ReloadTemplates();

	bool LoadFile(CString csFile);

	CScriptObjects();
	virtual ~CScriptObjects();
	void LoadItems();
	void LoadNPCs();
	void LoadDefs();
	void LoadTemplates();
	void LoadTables();
	void LoadMap();
	void LoadTriggers();
	void LoadLocations();
	void LoadNames();
	void LoadSpeechBlocks();

	bool SaveItems();
	bool SaveNPCs();
	bool SaveDefs();
	bool SaveTemplates();
	bool SaveTables();
	bool SaveMap();
	bool SaveTriggers();
	bool SaveLocations();
	bool SaveNames();
	bool SaveSpeechBlocks();

	void CategorizeNPCs();
	void CategorizeItems();
	void CategorizeLocations();
	void RecategorizeNPCs();
	void RecategorizeItems();
	void RecategorizeLocations();
	void RemoveNPCCategories();
	void RemoveItemCategories();
	void RemoveLocationCategories();
	void CleanCategories(CPtrList &olCategories);

#define TEMPLATE_INDEX_BASE 101500
#define TEMPLATE2_INDEX_BASE 500000

	CScriptArray m_aItems;
	CScriptArray m_aNPCs;
	CScriptArray m_aDefs;
	CScriptArray m_aTemplates;
	CScriptArray m_aTemplates2;
	CTables m_tables;
	CPtrList m_olAreas;
	CPtrList m_olRooms;
	CScriptArray m_aLocations;
	CScriptArray m_aNames;
	CScriptArray m_aWebpages;
	CScriptArray m_aSpeechBlocks;
	CScriptArray m_aRegionTrigs;
	CScriptArray m_aPlotTrigs;
	CScriptArray m_aTriggers;
	CConfigFile m_config;

	CPtrList m_olNPCs;
	CPtrList m_olItems;
	CPtrList m_olLocations;

	WORD m_wNextNPCID;
	WORD m_wNextItemID;
	DWORD m_dwNextTemplate;

	bool m_bNewFormat;
	int m_iICatSeq;
	int m_iNCatSeq;
	int m_iMCatSeq;
	static int m_iScriptSeq;

	class CRemoteConnection * m_pRemote;
	class CFileReadProgress * m_pDlg;
	void CreateProgressDialog();
	void DestroyProgressDialog();

protected:
	bool m_bDefsLoaded;
	bool m_bItemsLoaded;
	bool m_bNPCsLoaded;
	bool m_bTemplatesLoaded;
	bool m_bTablesLoaded;
	bool m_bMapLoaded;
	bool m_bTriggersLoaded;
	bool m_bLocationsLoaded;
	bool m_bNamesLoaded;
	bool m_bSpeechLoaded;
	bool m_bNPCsCategorized;
	bool m_bItemsCategorized;
	bool m_bLocationsCategorized;

	bool m_bDeleteDialog;
};

#endif // _CSCRIPTOBJECTS_H_

