/*
 $Id: ClientPatch.h,v 1.8 2002/05/01 03:33:09 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// ClientPatch.h: interface for the CClientPatch class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CLIENTPATCH_H__2ECEAB29_F812_4565_ADC2_17B808954382__INCLUDED_)
#define AFX_CLIENTPATCH_H__2ECEAB29_F812_4565_ADC2_17B808954382__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "UOMul.h"

#define CURRENT_PATCH_VERSION 0x01300000

#define ERROR_UNKNOWN_DATA_VERSION 7500
#define ERROR_UNKNOWN_CLIENT_FILE 7501
#define ERROR_BAD_DATA_LENGTH 7502
#define ERROR_BUFFER_TOO_SMALL 7503
#define ERROR_STATIC_SORT_FAILED 7504
#define ERROR_STATIC_PATCH_FAILED 7505

class CClientPatch  
{
public:
	void Clean();
	bool IsEmpty();
	CClientPatch();
	virtual ~CClientPatch();
	bool Read(CString csFilename);
	bool Write(CString csFilename);
	bool Apply();
	int GetError() { return m_dwError; };
	CString GetErrorString();
	bool Insert(BYTE bID, DWORD dwLength, BYTE * pData);
	DWORD GetDataBlockSize(BYTE bID);
	DWORD CopyDataBlock(BYTE bID, BYTE * pCopy, DWORD dwSize);
	void SetClientPath(CString csClientPath) { m_csClientPath = csClientPath; }

protected:
	bool SortStaticData(BYTE * pBuffer, DWORD dwSize);
	bool InsertStaticPatchObject(struct UOStaticPatchObject * pObject, BYTE * pDestBuffer, DWORD dwBufferSize);
	bool PatchStaticData(BYTE * pBuffer, DWORD dwSize, bool bVerdata = false);
	BYTE * PatchStaticAdd(BYTE * pBuffer, DWORD &dwSize, struct UOStaticPatchObject * pObject);
	BYTE * PatchStaticRemove(BYTE * pBuffer, DWORD &dwSize, struct UOStaticPatchObject * pObject);
	bool ConvertData();
	bool CompareObjects(BYTE * pOb1, BYTE * pOb2, DWORD dwSize);
	struct UOPatchBlockDescriptor * GetHeaderBlock(BYTE bID);

	int m_dwError;
	DWORD m_dwLoadVersion;
	DWORD m_dwHeaderSize;
	DWORD m_dwDataSize;
	BYTE * m_pHeader;
	BYTE * m_pData;
	CString m_csClientPath;
};

enum MulFiles
{
	MUL_Map0 = 0,
	MUL_StaIdx0,
	MUL_Statics0,
	MUL_ArtIdx,
	MUL_Art,
	MUL_AnimIdx,
	MUL_Anim,
	MUL_SoundIdx,
	MUL_Sound,
	MUL_TexIdx,
	MUL_Tex,	// 0x0A
	MUL_GumpIdx,
	MUL_Gump,
	MUL_MultiIdx,
	MUL_Multi,
	MUL_SkillIdx,
	MUL_Skill,	// 0x10
	MUL_Tiledata = 0x1e,
	MUL_Animdata = 0x1f,
};

#pragma pack(push, foo, 1)

struct UOPatchBlockDescriptor
{
	BYTE bFileID;
	DWORD dwOffset;
	DWORD dwLength;
};

struct UOStaticPatchObject
{
	DWORD dwBlockIndex;
	tUOStaticRec blockData;
	BYTE bFlags;
};

#pragma pack(pop, foo)

#endif // !defined(AFX_CLIENTPATCH_H__2ECEAB29_F812_4565_ADC2_17B808954382__INCLUDED_)
