/*
 $Id: CommandTab.cpp,v 1.3 2002/05/01 03:33:09 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// CommandTab.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "CommandTab.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCommandTab property page

IMPLEMENT_DYNCREATE(CCommandTab, CPropertyPage)

CCommandTab::CCommandTab() : CPropertyPage(CCommandTab::IDD)
{
	//{{AFX_DATA_INIT(CCommandTab)
	//}}AFX_DATA_INIT
}

CCommandTab::~CCommandTab()
{
}

void CCommandTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCommandTab)
	DDX_Control(pDX, IDC_ADD_CMD, m_cbAdd);
	DDX_Control(pDX, IDC_CHANGE_CMD, m_cbChange);
	DDX_Control(pDX, IDC_REMOVE_CMD, m_cbRemove);
	DDX_Control(pDX, IDC_CUSTOM_CMD_9, m_cbCmd9);
	DDX_Control(pDX, IDC_CUSTOM_CMD_8, m_cbCmd8);
	DDX_Control(pDX, IDC_CUSTOM_CMD_7, m_cbCmd7);
	DDX_Control(pDX, IDC_CUSTOM_CMD_6, m_cbCmd6);
	DDX_Control(pDX, IDC_CUSTOM_CMD_5, m_cbCmd5);
	DDX_Control(pDX, IDC_CUSTOM_CMD_4, m_cbCmd4);
	DDX_Control(pDX, IDC_CUSTOM_CMD_36, m_cbCmd36);
	DDX_Control(pDX, IDC_CUSTOM_CMD_35, m_cbCmd35);
	DDX_Control(pDX, IDC_CUSTOM_CMD_34, m_cbCmd34);
	DDX_Control(pDX, IDC_CUSTOM_CMD_33, m_cbCmd33);
	DDX_Control(pDX, IDC_CUSTOM_CMD_32, m_cbCmd32);
	DDX_Control(pDX, IDC_CUSTOM_CMD_31, m_cbCmd31);
	DDX_Control(pDX, IDC_CUSTOM_CMD_30, m_cbCmd30);
	DDX_Control(pDX, IDC_CUSTOM_CMD_3, m_cbCmd3);
	DDX_Control(pDX, IDC_CUSTOM_CMD_29, m_cbCmd29);
	DDX_Control(pDX, IDC_CUSTOM_CMD_28, m_cbCmd28);
	DDX_Control(pDX, IDC_CUSTOM_CMD_27, m_cbCmd27);
	DDX_Control(pDX, IDC_CUSTOM_CMD_26, m_cbCmd26);
	DDX_Control(pDX, IDC_CUSTOM_CMD_25, m_cbCmd25);
	DDX_Control(pDX, IDC_CUSTOM_CMD_24, m_cbCmd24);
	DDX_Control(pDX, IDC_CUSTOM_CMD_23, m_cbCmd23);
	DDX_Control(pDX, IDC_CUSTOM_CMD_22, m_cbCmd22);
	DDX_Control(pDX, IDC_CUSTOM_CMD_21, m_cbCmd21);
	DDX_Control(pDX, IDC_CUSTOM_CMD_20, m_cbCmd20);
	DDX_Control(pDX, IDC_CUSTOM_CMD_2, m_cbCmd2);
	DDX_Control(pDX, IDC_CUSTOM_CMD_19, m_cbCmd19);
	DDX_Control(pDX, IDC_CUSTOM_CMD_18, m_cbCmd18);
	DDX_Control(pDX, IDC_CUSTOM_CMD_17, m_cbCmd17);
	DDX_Control(pDX, IDC_CUSTOM_CMD_16, m_cbCmd16);
	DDX_Control(pDX, IDC_CUSTOM_CMD_15, m_cbCmd15);
	DDX_Control(pDX, IDC_CUSTOM_CMD_14, m_cbCmd14);
	DDX_Control(pDX, IDC_CUSTOM_CMD_13, m_cbCmd13);
	DDX_Control(pDX, IDC_CUSTOM_CMD_12, m_cbCmd12);
	DDX_Control(pDX, IDC_CUSTOM_CMD_11, m_cbCmd11);
	DDX_Control(pDX, IDC_CUSTOM_CMD_10, m_cbCmd10);
	DDX_Control(pDX, IDC_CUSTOM_CMD_1, m_cbCmd1);
	DDX_Control(pDX, IDC_COMMAND_CMD, m_ceCommand);
	DDX_Control(pDX, IDC_CAPTION_CMD, m_ceCaption);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCommandTab, CPropertyPage)
	//{{AFX_MSG_MAP(CCommandTab)
	ON_BN_CLICKED(IDC_ADD_CMD, OnAddCmd)
	ON_BN_CLICKED(IDC_CHANGE_CMD, OnChangeCmd)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_1, OnCustomCmd1)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_10, OnCustomCmd10)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_11, OnCustomCmd11)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_12, OnCustomCmd12)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_13, OnCustomCmd13)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_14, OnCustomCmd14)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_15, OnCustomCmd15)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_16, OnCustomCmd16)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_17, OnCustomCmd17)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_18, OnCustomCmd18)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_19, OnCustomCmd19)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_2, OnCustomCmd2)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_20, OnCustomCmd20)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_21, OnCustomCmd21)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_22, OnCustomCmd22)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_23, OnCustomCmd23)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_24, OnCustomCmd24)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_25, OnCustomCmd25)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_26, OnCustomCmd26)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_27, OnCustomCmd27)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_28, OnCustomCmd28)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_29, OnCustomCmd29)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_3, OnCustomCmd3)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_30, OnCustomCmd30)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_31, OnCustomCmd31)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_32, OnCustomCmd32)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_33, OnCustomCmd33)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_34, OnCustomCmd34)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_35, OnCustomCmd35)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_36, OnCustomCmd36)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_4, OnCustomCmd4)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_5, OnCustomCmd5)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_6, OnCustomCmd6)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_7, OnCustomCmd7)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_8, OnCustomCmd8)
	ON_BN_CLICKED(IDC_CUSTOM_CMD_9, OnCustomCmd9)
	ON_BN_CLICKED(IDC_REMOVE_CMD, OnRemoveCmd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCommandTab message handlers

void CCommandTab::OnAddCmd() 
{
	CString csCaption, csCommand;
	this->m_ceCaption.GetWindowText(csCaption);
	this->m_ceCommand.GetWindowText(csCommand);
	if ( csCaption == "" )
	{
		AfxMessageBox("Please enter a caption for the button", MB_OK | MB_ICONINFORMATION);
		return;
	}
	if ( csCommand == "" )
	{
		AfxMessageBox("Please enter a command for the button to execute", MB_OK | MB_ICONINFORMATION);
		return;
	}
	CommandAdd(csCaption, csCommand);
}

void CCommandTab::OnChangeCmd() 
{
	this->m_bEditButton = true;
	this->m_pMessageBox = new (CSpawnMessageDlg);
	m_pMessageBox->Create( IDD_SPAWNMESSAGE_DLG, (CWnd*) this );
	m_pMessageBox->m_csMessage = "Select the button to change";	
	m_pMessageBox->UpdateData(FALSE);
}

void CCommandTab::OnCustomCmd1() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd1.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd1.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(0));
}

void CCommandTab::OnCustomCmd10() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd10.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd10.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(9));
}

void CCommandTab::OnCustomCmd11() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd11.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd11.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(10));
}

void CCommandTab::OnCustomCmd12() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd12.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd12.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(11));
}

void CCommandTab::OnCustomCmd13() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd13.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd13.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(12));
}

void CCommandTab::OnCustomCmd14() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd14.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd14.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(13));
}

void CCommandTab::OnCustomCmd15() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd15.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd15.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(14));
}

void CCommandTab::OnCustomCmd16() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd16.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd16.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(15));
}

void CCommandTab::OnCustomCmd17() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd17.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd17.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(16));
}

void CCommandTab::OnCustomCmd18() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd18.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd18.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(17));
}

void CCommandTab::OnCustomCmd19() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd19.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd19.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(18));
}

void CCommandTab::OnCustomCmd2() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd2.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd2.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(1));
}

void CCommandTab::OnCustomCmd20() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd20.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd20.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(19));
}

void CCommandTab::OnCustomCmd21() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd21.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd21.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(20));
}

void CCommandTab::OnCustomCmd22() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd22.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd22.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(21));
}

void CCommandTab::OnCustomCmd23() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd23.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd23.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(22));
}

void CCommandTab::OnCustomCmd24() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd24.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd24.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(23));
}

void CCommandTab::OnCustomCmd25() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd25.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd25.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(24));
}

void CCommandTab::OnCustomCmd26() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd26.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd26.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(25));
}

void CCommandTab::OnCustomCmd27() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd27.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd27.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(26));
}

void CCommandTab::OnCustomCmd28() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd28.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd28.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(27));
}

void CCommandTab::OnCustomCmd29() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd29.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd29.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(28));
}

void CCommandTab::OnCustomCmd3() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd3.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd3.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(2));
}

void CCommandTab::OnCustomCmd30() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd30.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd30.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(29));
}

void CCommandTab::OnCustomCmd31() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd31.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd31.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(30));
}

void CCommandTab::OnCustomCmd32() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd32.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd32.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(31));
}

void CCommandTab::OnCustomCmd33() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd33.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd33.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(32));
}

void CCommandTab::OnCustomCmd34() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd34.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd34.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(33));
}

void CCommandTab::OnCustomCmd35() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd35.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd35.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(34));
}

void CCommandTab::OnCustomCmd36() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd36.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd36.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(35));
}

void CCommandTab::OnCustomCmd4() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd4.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd4.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(3));
}

void CCommandTab::OnCustomCmd5() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd5.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd5.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(4));
}

void CCommandTab::OnCustomCmd6() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd6.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd6.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(5));
}

void CCommandTab::OnCustomCmd7() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd7.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd7.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(6));
}

void CCommandTab::OnCustomCmd8() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd8.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd8.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(7));
}

void CCommandTab::OnCustomCmd9() 
{
	if ( this->m_bEditButton )
	{
		CString csOldCaption;
		this->m_cbCmd9.GetWindowText(csOldCaption);
		CommandChange(csOldCaption);
		return;
	}
	if ( this->m_bRemoveButton )
	{
		CString csCaption;
		this->m_cbCmd9.GetWindowText(csCaption);
		CommandRemove(csCaption);
		return;
	}
	SendToUO(this->m_csaCommands.GetAt(8));
}

void CCommandTab::OnRemoveCmd() 
{
	this->m_bRemoveButton = true;
	this->m_pMessageBox = new (CSpawnMessageDlg);
	m_pMessageBox->Create( IDD_SPAWNMESSAGE_DLG, (CWnd*) this );
	m_pMessageBox->m_csMessage = "Select the button to remove";	
	m_pMessageBox->UpdateData(FALSE);
}

void CCommandTab::CommandAdd(CString csCaption, CString csCommand)
{
	HKEY hKey;
	LONG lStatus;
	DWORD dwDisp;
	lStatus = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Commands", 0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
	if (lStatus == ERROR_SUCCESS)
	{
		lStatus = RegSetValueEx(hKey, csCaption, 0, REG_SZ, ((BYTE *) csCommand.GetBuffer(csCommand.GetLength())), csCommand.GetLength());
		if ( lStatus != ERROR_SUCCESS )
		{
			AfxMessageBox("An error occurred while saving the command to the registry", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		RegCloseKey(hKey);
	}
	UpdateButtons();
}

void CCommandTab::UpdateButtons()
{
	this->m_csaCommands.RemoveAll();
	this->m_csaCommands.SetSize(0);

	HKEY hKey;
	LONG lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Commands", 0, KEY_READ, &hKey);
	if (lStatus == ERROR_SUCCESS)
	{

		int iIndex = 0;
		int iCount = 0;
		while ( lStatus == ERROR_SUCCESS )
		{
			if ( iCount > 35 )
				break;
			DWORD dwType;
			char szValue[MAX_PATH];
			unsigned char szData[MAX_PATH];
			DWORD dwSize = sizeof(szValue);
			DWORD dwDataSize = sizeof(szData);

			lStatus = RegEnumValue( hKey, iIndex++, &szValue[0], &dwSize, 0, &dwType, &szData[0], &dwDataSize );
			if ( dwType != REG_SZ )
				continue;
			if ( lStatus != ERROR_SUCCESS )
				continue;
			switch (iCount)
			{
			case 0:
				this->m_cbCmd1.SetWindowText(szValue); this->m_cbCmd1.ShowWindow(SW_SHOW); break;
			case 1:
				this->m_cbCmd2.SetWindowText(szValue); this->m_cbCmd2.ShowWindow(SW_SHOW); break;
			case 2:
				this->m_cbCmd3.SetWindowText(szValue); this->m_cbCmd3.ShowWindow(SW_SHOW); break;
			case 3:
				this->m_cbCmd4.SetWindowText(szValue); this->m_cbCmd4.ShowWindow(SW_SHOW); break;
			case 4:
				this->m_cbCmd5.SetWindowText(szValue); this->m_cbCmd5.ShowWindow(SW_SHOW); break;
			case 5:
				this->m_cbCmd6.SetWindowText(szValue); this->m_cbCmd6.ShowWindow(SW_SHOW); break;
			case 6:
				this->m_cbCmd7.SetWindowText(szValue); this->m_cbCmd7.ShowWindow(SW_SHOW); break;
			case 7:
				this->m_cbCmd8.SetWindowText(szValue); this->m_cbCmd8.ShowWindow(SW_SHOW); break;
			case 8:
				this->m_cbCmd9.SetWindowText(szValue); this->m_cbCmd9.ShowWindow(SW_SHOW); break;
			case 9:
				this->m_cbCmd10.SetWindowText(szValue); this->m_cbCmd10.ShowWindow(SW_SHOW); break;
			case 10:
				this->m_cbCmd11.SetWindowText(szValue); this->m_cbCmd11.ShowWindow(SW_SHOW); break;
			case 11:
				this->m_cbCmd12.SetWindowText(szValue); this->m_cbCmd12.ShowWindow(SW_SHOW); break;
			case 12:
				this->m_cbCmd13.SetWindowText(szValue); this->m_cbCmd13.ShowWindow(SW_SHOW); break;
			case 13:
				this->m_cbCmd14.SetWindowText(szValue); this->m_cbCmd14.ShowWindow(SW_SHOW); break;
			case 14:
				this->m_cbCmd15.SetWindowText(szValue); this->m_cbCmd15.ShowWindow(SW_SHOW); break;
			case 15:
				this->m_cbCmd16.SetWindowText(szValue); this->m_cbCmd16.ShowWindow(SW_SHOW); break;
			case 16:
				this->m_cbCmd17.SetWindowText(szValue); this->m_cbCmd17.ShowWindow(SW_SHOW); break;
			case 17:
				this->m_cbCmd18.SetWindowText(szValue); this->m_cbCmd18.ShowWindow(SW_SHOW); break;
			case 18:
				this->m_cbCmd19.SetWindowText(szValue); this->m_cbCmd19.ShowWindow(SW_SHOW); break;
			case 19:
				this->m_cbCmd20.SetWindowText(szValue); this->m_cbCmd20.ShowWindow(SW_SHOW); break;
			case 20:
				this->m_cbCmd21.SetWindowText(szValue); this->m_cbCmd21.ShowWindow(SW_SHOW); break;
			case 21:
				this->m_cbCmd22.SetWindowText(szValue); this->m_cbCmd22.ShowWindow(SW_SHOW); break;
			case 22:
				this->m_cbCmd23.SetWindowText(szValue); this->m_cbCmd23.ShowWindow(SW_SHOW); break;
			case 23:
				this->m_cbCmd24.SetWindowText(szValue); this->m_cbCmd24.ShowWindow(SW_SHOW); break;
			case 24:
				this->m_cbCmd25.SetWindowText(szValue); this->m_cbCmd25.ShowWindow(SW_SHOW); break;
			case 25:
				this->m_cbCmd26.SetWindowText(szValue); this->m_cbCmd26.ShowWindow(SW_SHOW); break;
			case 26:
				this->m_cbCmd27.SetWindowText(szValue); this->m_cbCmd27.ShowWindow(SW_SHOW); break;
			case 27:
				this->m_cbCmd28.SetWindowText(szValue); this->m_cbCmd28.ShowWindow(SW_SHOW); break;
			case 28:
				this->m_cbCmd29.SetWindowText(szValue); this->m_cbCmd29.ShowWindow(SW_SHOW); break;
			case 29:
				this->m_cbCmd30.SetWindowText(szValue); this->m_cbCmd30.ShowWindow(SW_SHOW); break;
			case 30:
				this->m_cbCmd31.SetWindowText(szValue); this->m_cbCmd31.ShowWindow(SW_SHOW); break;
			case 31:
				this->m_cbCmd32.SetWindowText(szValue); this->m_cbCmd32.ShowWindow(SW_SHOW); break;
			case 32:
				this->m_cbCmd33.SetWindowText(szValue); this->m_cbCmd33.ShowWindow(SW_SHOW); break;
			case 33:
				this->m_cbCmd34.SetWindowText(szValue); this->m_cbCmd34.ShowWindow(SW_SHOW); break;
			case 34:
				this->m_cbCmd35.SetWindowText(szValue); this->m_cbCmd35.ShowWindow(SW_SHOW); break;
			case 35:
				this->m_cbCmd36.SetWindowText(szValue); this->m_cbCmd36.ShowWindow(SW_SHOW); break;
			}
			CString csCommand;
			csCommand.Format("%s", szData);
			this->m_csaCommands.SetAtGrow( iCount++, csCommand );

		}
		RegCloseKey(hKey);
	}

	// We need to hide the rest of the buttons
	for ( int i = this->m_csaCommands.GetSize(); i < 36; i++ )
	{
		switch (i)
		{
		case 0:
			this->m_cbCmd1.ShowWindow(SW_HIDE); break;
		case 1:
			this->m_cbCmd2.ShowWindow(SW_HIDE); break;
		case 2:
			this->m_cbCmd3.ShowWindow(SW_HIDE); break;
		case 3:
			this->m_cbCmd4.ShowWindow(SW_HIDE); break;
		case 4:
			this->m_cbCmd5.ShowWindow(SW_HIDE); break;
		case 5:
			 this->m_cbCmd6.ShowWindow(SW_HIDE); break;
		case 6:
			this->m_cbCmd7.ShowWindow(SW_HIDE); break;
		case 7:
			this->m_cbCmd8.ShowWindow(SW_HIDE); break;
		case 8:
			this->m_cbCmd9.ShowWindow(SW_HIDE); break;
		case 9:
			this->m_cbCmd10.ShowWindow(SW_HIDE); break;
		case 10:
			this->m_cbCmd11.ShowWindow(SW_HIDE); break;
		case 11:
			this->m_cbCmd12.ShowWindow(SW_HIDE); break;
		case 12:
			this->m_cbCmd13.ShowWindow(SW_HIDE); break;
		case 13:
			this->m_cbCmd14.ShowWindow(SW_HIDE); break;
		case 14:
			this->m_cbCmd15.ShowWindow(SW_HIDE); break;
		case 15:
			this->m_cbCmd16.ShowWindow(SW_HIDE); break;
		case 16:
			this->m_cbCmd17.ShowWindow(SW_HIDE); break;
		case 17:
			this->m_cbCmd18.ShowWindow(SW_HIDE); break;
		case 18:
			this->m_cbCmd19.ShowWindow(SW_HIDE); break;
		case 19:
			this->m_cbCmd20.ShowWindow(SW_HIDE); break;
		case 20:
			this->m_cbCmd21.ShowWindow(SW_HIDE); break;
		case 21:
			this->m_cbCmd22.ShowWindow(SW_HIDE); break;
		case 22:
			this->m_cbCmd23.ShowWindow(SW_HIDE); break;
		case 23:
			this->m_cbCmd24.ShowWindow(SW_HIDE); break;
		case 24:
			this->m_cbCmd25.ShowWindow(SW_HIDE); break;
		case 25:
			this->m_cbCmd26.ShowWindow(SW_HIDE); break;
		case 26:
			this->m_cbCmd27.ShowWindow(SW_HIDE); break;
		case 27:
			this->m_cbCmd28.ShowWindow(SW_HIDE); break;
		case 28:
			this->m_cbCmd29.ShowWindow(SW_HIDE); break;
		case 29:
			this->m_cbCmd30.ShowWindow(SW_HIDE); break;
		case 30:
			this->m_cbCmd31.ShowWindow(SW_HIDE); break;
		case 31:
			this->m_cbCmd32.ShowWindow(SW_HIDE); break;
		case 32:
			this->m_cbCmd33.ShowWindow(SW_HIDE); break;
		case 33:
			this->m_cbCmd34.ShowWindow(SW_HIDE); break;
		case 34:
			this->m_cbCmd35.ShowWindow(SW_HIDE); break;
		case 35:
			this->m_cbCmd36.ShowWindow(SW_HIDE); break;
		}
	}

}

BOOL CCommandTab::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	this->m_bEditButton = false;
	this->m_bRemoveButton = false;
	this->m_pMessageBox = NULL;
	UpdateButtons();	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCommandTab::CommandRemove(CString csCaption)
{
	this->m_pMessageBox->DestroyWindow();
	delete this->m_pMessageBox;
	this->m_pMessageBox = NULL;
	this->m_bRemoveButton = false;

	HKEY hKey;
	LONG lStatus;
	DWORD dwDisp;
	lStatus = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Commands", 0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
	if (lStatus == ERROR_SUCCESS)
	{
		lStatus = RegDeleteValue(hKey, csCaption);
		if ( lStatus != ERROR_SUCCESS )
		{
			AfxMessageBox("An error occurred while removing the command from the registry", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		RegCloseKey(hKey);
	}
	UpdateButtons();

}

void CCommandTab::CommandChange(CString csOldCaption)
{
	this->m_pMessageBox->DestroyWindow();
	delete this->m_pMessageBox;
	this->m_pMessageBox = NULL;
	this->m_bEditButton = false;

	CString csCaption, csCommand;
	this->m_ceCaption.GetWindowText(csCaption);
	this->m_ceCommand.GetWindowText(csCommand);

	HKEY hKey;
	LONG lStatus;
	DWORD dwDisp;
	lStatus = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Commands", 0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
	if (lStatus == ERROR_SUCCESS)
	{
		lStatus = RegDeleteValue(hKey, csOldCaption);
		if ( lStatus != ERROR_SUCCESS )
		{
			AfxMessageBox("An error occurred while removing the command from the registry", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		RegCloseKey(hKey);
	}

	CommandAdd( csCaption, csCommand );
}
