/*
 $Id: ConfigFile.h,v 1.3 2002/05/01 03:33:09 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// ConfigFile.h: interface for the CConfigFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONFIGFILE_H__A86664FB_0196_49F2_BF30_875D1807E093__INCLUDED_)
 #define AFX_CONFIGFILE_H__A86664FB_0196_49F2_BF30_875D1807E093__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define GRAY_MAIN_SERVER	"menace.ne.mediaone.net"
#define GRAY_GAME_SERVER
#define GRAY_LOG_SERVER
#define GRAY_URL			"www.sphereserver.com"	// default url.
#define TICK_PER_SEC 10
#define GRAY_CLIENT_VER 20000 // 1.25.37 = 12537 = default version.


enum SC_TYPE
{
	SC_ACCTFILES,			// m_sAcctBaseDir
	SC_ARRIVEDEPARTMSG, 
	SC_AUTONEWBIEKEYS,		// m_fAutoNewbieKeys
	SC_BACKUPLEVELS,				// m_iSaveBackupLevels
	SC_BANKMAXITEMS,
	SC_BANKMAXWEIGHT,
	SC_CHANGEFILES,			// m_sChangedBaseDir
	SC_CHARTAGS,					// m_fCharTags
	SC_CLIENTLINGER,
	SC_CLIENTMAX,			// m_nClientsMax
	SC_CLIENTS,
	SC_CLIENTVERSION,
	SC_CORPSENPCDECAY,
	SC_CORPSEPLAYERDECAY,
	SC_CRIMINALTIMER,		// m_iCriminalTimer
	SC_DEADSOCKETTIME,
	SC_DEBUGFLAGS,
	SC_DECAYTIMER,
	SC_DUNGEONLIGHT,
	SC_EQUIPPEDCAST,				// m_fEquippedCast
	SC_FILES,	//
	SC_FLIPDROPPEDITEMS,			// m_fFlipDroppedItems
	SC_FORCEGARBAGECOLLECT,		// m_fSaveGarbageCollect
	SC_FREEZERESTARTTIME,		// m_iFreezeRestartTime
	SC_GAMEMINUTELENGTH,			// m_iGameMinuteLength
	SC_GUARDLINGER,			// m_iGuardLingerTime
	SC_GUARDSINSTANTKILL,
	SC_GUESTS,
	SC_GUILDS,
	SC_HEARALL,
	SC_HELPINGCRIMINALSISACRIME,	// m_fHelpingCriminalsIsACrime
	SC_HITPOINTPERCENTONREZ, // m_iHitpointPercentOnRez
	SC_LIGHTDAY,			// m_iLightDay
	SC_LIGHTNIGHT,			// m_iLightNight
	SC_LOG,
	SC_LOGMASK,				// GetLogMask
	SC_LOOTINGISACRIME,		// m_fLootingIsACrime
	SC_MAGICUNLOCKDOOR,		// m_iMagicUnlockDoor
	SC_MAINLOGSERVER,		// m_fMainLogServer
	SC_MAPCACHETIME,
	SC_MAXBASESKILL,			// m_iMaxBaseSkill
	SC_MAXCHARSPERACCOUNT,	// m_iMaxCharsPerAccount
	SC_MAXCOMPLEXITY,			// m_iMaxComplexity
	SC_MINCHARDELETETIME,
	SC_MONSTERFEAR,			// m_fMonsterFear
	SC_MONSTERFIGHT,
	SC_MULFILE,
	SC_MULFILES,
	SC_MURDERDECAYTIME,		// m_iMurderDecayTime;
	SC_MURDERMINCOUNT,		// m_iMurderMinCount;		// amount of murders before we get title.
	SC_NOWEATHER,				// m_fNoWeather
	SC_NPCTRAINMAX,			// m_iTrainSkillMax
	SC_NPCTRAINPERCENT,			// m_iTrainSkillPercent
	SC_NTSERVICE,				// m_fUseNTService
	SC_PLAYERGHOSTSOUNDS,	// m_fPlayerGhostSounds
	SC_PLAYERNEUTRAL,		// m_iPlayerKarmaNeutral
	SC_POLLSERVERS,				// m_iPollServers
	SC_PROFILE,
	SC_RCLOCK,
	SC_REAGENTLOSSFAIL,			// m_fReagentLossFail
	SC_REAGENTSREQUIRED,
	SC_REGEN,
	SC_REGISTERSERVER,			// m_sRegisterServer
	SC_REQUIREEMAIL,		// m_fRequireEmail
	SC_RTIME,
	SC_RTIMETEXT,
	SC_RUNNINGPENALTY,		// m_iStamRunningPenalty
	SC_SAVEBACKGROUND,			// m_iSaveBackgroundTime
	SC_SAVEPERIOD,
	SC_SCPFILES,
	SC_SECTORSLEEP,				// m_iSectorSleepMask
	SC_SECURE,
	SC_SNOOPCRIMINAL,
	SC_SPEECHFILES,
	SC_STAMINALOSSATWEIGHT,	// m_iStaminaLossAtWeight
	SC_STATAVG,					// m_iAvgSumOfStats
	SC_STATCAP,					// m_iMaxSumOfStats
	SC_STATGUILDS,
	SC_TIME,
	SC_TIMEUP,
	SC_TOTALPOLLEDACCOUNTS,
	SC_TOTALPOLLEDCLIENTS,
	SC_TOTALPOLLEDSERVERS,
	SC_VENDORMAXSELL,			// m_iVendorMaxSell
	SC_VERBOSE,
	SC_VERSION,
	SC_WOPPLAYER,
	SC_WOPSTAFF,
	SC_WORLDSAVE,
	SC_QTY,
};

class CConfigFile  
{
public:
	CConfigFile();
	virtual ~CConfigFile();
	bool Read();
	bool Write();

	// Begin INI file options.
	bool m_fUseNTService;
	int  m_iPollServers;		// background polling of peer servers. (minutes)
	CString m_sRegisterServer;	// GRAY_MAIN_SERVER
	bool m_fMainLogServer;		// This is the main log server. Will list any server that polls.
	int  m_iMapCacheTime;		// Time in sec to keep unused map data.
	int	 m_iSectorSleepMask;	// The mask for how long sectors will sleep.

	CString m_sWorldBaseDir;	// "e:\graysvr\worldsave\" = world files go here.
	CString m_sAcctBaseDir;	// Where do the account files go/come from ?
	CString m_sSCPBaseDir;		// if we want to get *.SCP files from elsewhere.
	CString m_sSpeechBaseDir;	// Where do the speech script files go ?
	CString m_sChangedBaseDir;	// Take files from here and replace existing files.

	bool m_fSecure;     // Secure mode. (will trap exceptions)
	int  m_iFreezeRestartTime;	// # seconds before restarting.
#define DEBUGF_NPC_EMOTE		0x01
#define DEBUGF_ADVANCE_STATS	0x02
#define DEBUGF_MOTIVATION		0x04	// display motication level debug messages.
#define DEBUGF_WALKCODES		0x80	// try the new walk code checking stuff.
	WORD m_wDebugFlags;			// DEBUG In game effects to turn on and off.

	// Decay
	int  m_iDecay_Item;			// Base decay time in minutes.
	int  m_iDecay_CorpsePlayer;	// Time for a playercorpse to decay (mins).
	int  m_iDecay_CorpseNPC;	// Time for a NPC corpse to decay.

	// Save
	int  m_iSavePeriod;			// Minutes between saves.
	int  m_iSaveBackupLevels;	// How many backup levels.
	int  m_iSaveBackgroundTime;	// Speed of the background save in minutes.
	bool m_fSaveGarbageCollect;	// Always force a full garbage collection.
	bool m_fSaveInBackground;	// Do background save stuff.

	// Account
	bool m_fRequireEmail;		// Valid Email required to leave GUEST mode.
	int  m_iDeadSocketTimeMin;
	bool m_fArriveDepartMsg;    // General switch to turn on/off arrival/depart messages.
	int  m_nClientsMax;			// Maximum (FD_SETSIZE) open connections to server
	int  m_nGuestsMax;			// Allow guests who have no accounts ?
	int  m_iClientLingerTime;	// How long logged out clients linger in seconds.
	int  m_iMinCharDeleteTime;	// How old must a char be ? (minutes)
	int m_ClientVersion;		// GRAY_CLIENT_VER 12537
	int  m_iMaxCharsPerAccount;	// MAX_CHARS_PER_ACCT

	// Magic
	bool m_fReagentsRequired;
	bool m_fWordsOfPowerPlayer; // Words of Power for players
	bool m_fWordsOfPowerStaff;	// Words of Power for staff
	bool m_fEquippedCast;		// Allow casting while equipped.
	bool m_fReagentLossFail;	// ??? Lose reags when failed.
	int m_iMagicUnlockDoor;  // 1 in N chance of magic unlock working on doors -- 0 means never
	//ITEMID_TYPE m_iSpell_Teleport_Effect_Player;
	//SOUND_TYPE m_iSpell_Teleport_Sound_Player;
	//ITEMID_TYPE m_iSpell_Teleport_Effect_Staff;
	//SOUND_TYPE m_iSpell_Teleport_Sound_Staff;

	// In Game Effects
	int	 m_iLightDungeon;
	int  m_iLightDay;		// Outdoor light level.
	int  m_iLightNight;		// Outdoor light level.
	bool m_fMonsterFight;	// Will creatures fight amoung themselves.
	bool m_fMonsterFear;	// will they run away if hurt ?
	int	 m_iBankIMax;	// Maximum number of items allowed in bank.
	int  m_iBankWMax;	// Maximum weight in WEIGHT_UNITS stones allowed in bank.
	bool m_fGuardsInstantKill;	// Will guards kill instantly or follow normal combat rules?
	int  m_iSnoopCriminal;		// 1 in # chance of getting criminalflagged when succesfully snooping.
	int  m_iTrainSkillPercent;	// How much can NPC's train up to ?
	int	 m_iTrainSkillMax;
	bool m_fCharTags;			// Put [NPC] tags over chars.
	int  m_iVendorMaxSell;		// Max things a vendor will sell in one shot.
	int  m_iGameMinuteLength;	// Length of the game world minute in real world (TICK_PER_SEC) seconds.
	bool m_fFlipDroppedItems;	// Flip dropped items.
	bool m_fNoWeather;			// Turn off all weather.
	int  m_iMaxSumOfStats;		// Stat Cap
	int  m_iAvgSumOfStats;		// Stat Avg. decay can set in here.
	int  m_iMurderMinCount;		// amount of murders before we get title.
	int	 m_iMurderDecayTime;	// (minutes) Roll murder counts off this often.
	int  m_iMaxComplexity;		// How many chars per area.
	int	 m_iPlayerKarmaNeutral;	// How much bad karma makes a player neutral?
	int	 m_iPlayerKarmaEvil;
	int	 m_iGuardLingerTime;	// How long do guards linger about.
	int  m_iCriminalTimer;		// How many minutes are criminals flagged for?
	int  m_iHitpointPercentOnRez;// How many hitpoints do they get when they are rez'd?
	bool m_fLootingIsACrime;	// Looting a blue corpse is bad.
	bool m_fHelpingCriminalsIsACrime;// If I help (rez, heal, etc) a criminal, do I become one too?
	bool m_fPlayerGhostSounds;	// Do player ghosts make a ghostly sound?
	bool m_fAutoNewbieKeys;		// Are house and boat keys newbied automatically?
	int  m_iMaxBaseSkill;		// Maximum value for base skills at char creation
	int  m_iStamRunningPenalty;		// Weight penalty for running (+N% of max carry weight)
	int  m_iStaminaLossAtWeight;	// %Weight at which characters begin to lose stamina
	// End INI file options.

	CStringArray m_blockIP;
	CPtrArray m_servers;

};

class CServerDef
{
public:
	CServerDef();
	virtual ~CServerDef();
	bool Load(CStdioFile *psfInput);
	bool Write(CStdioFile *psfOutput);

	CString m_csName;
	CString m_csIP;
	unsigned int m_iPort;

};

#endif // !defined(AFX_CONFIGFILE_H__A86664FB_0196_49F2_BF30_875D1807E093__INCLUDED_)
