/*
 $Id: MISCTAB.H,v 1.12 2002/11/17 04:25:27 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * Modified by Adron 2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

/**********************************************************************
 * Changes:
 *  - 7 May 2002 - PiotrBanasik
 *    + The Underwear button that was removed from General tab
 *      was moved here
 * 
 **********************************************************************/


#if !defined(AFX_MISCTAB_H__DFB29CF9_D431_11D2_A613_004F4905E937__INCLUDED_)
#define AFX_MISCTAB_H__DFB29CF9_D431_11D2_A613_004F4905E937__INCLUDED_

#include "RemoteConsoleDlg.h"	// Added by ClassView
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// MiscTab.h : header file
//


/////////////////////////////////////////////////////////////////////////////
// CMiscTab dialog

class CMiscTab : public CPropertyPage
{
	DECLARE_DYNCREATE(CMiscTab)

// Construction
public:
	void Unload();
	bool m_bRemoteConsoleCreated;
	bool m_bRemoteConsoleVisible;
	CRemoteConsoleDlg m_rcDlg;
	void LoadScripts();
	CMiscTab();
	~CMiscTab();
	void HitConsole() { this->OnRconsole(); };

// Dialog Data
	//{{AFX_DATA(CMiscTab)
	enum { IDD = IDD_MISC_TAB };
	CComboBox	m_ccbYell;
	CComboBox	m_ccbGoCmd;
	CEdit	m_ceGoArgs;
	CEdit	m_ceNukeArg;
	CEdit	m_ceUID;
	CButton	m_cbRemoteConsole;
	CStatic	m_csSfxID;
	CComboBox	m_ccbSfxList;
	CStatic	m_csMusicID;
	CComboBox	m_ccbMusicList;
	CStatic	m_csSpellID;
	CComboBox	m_ccSpellList;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CMiscTab)
	public:
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void FillGoCmds();
	int m_iScriptSeq;
	// Generated message map functions
	//{{AFX_MSG(CMiscTab)
	afx_msg void OnCastSpell();
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeSpellList();
	afx_msg void OnPlaymidi();
	afx_msg void OnSelchangeMidiList();
	afx_msg void OnPlaySfx();
	afx_msg void OnSelchangeSfxList();
	afx_msg void OnYellit();
	afx_msg void OnSuicide();
	afx_msg void OnFollow();
	afx_msg void OnWeightfix();
	afx_msg void OnSetcriminal();
	afx_msg void OnSethungry();
	afx_msg void OnSplit();
	afx_msg void OnPrivshow();
	afx_msg void OnBark();
	afx_msg void OnAllshow();
	afx_msg void OnRconsole();
	afx_msg void OnNukechar();
	afx_msg void OnRoofing();
	afx_msg void OnStarttus();
	afx_msg void OnExportcats();
	afx_msg void OnUnderwear2();
	afx_msg void OnSendSfx();
	afx_msg void OnGouid();
	afx_msg void OnGocli();
	afx_msg void OnNukecmd();
	afx_msg void OnGo();
	afx_msg void OnGotype();
	afx_msg void OnDogocmd();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MISCTAB_H__DFB29CF9_D431_11D2_A613_004F4905E937__INCLUDED_)
