/*
 $Id: MacroDlg.cpp,v 1.4 2002/05/02 22:19:57 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// MacroDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "MacroDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMacroDlg dialog
IMPLEMENT_DYNCREATE(CMacroDlg, CPropertyPage)

CMacroDlg::CMacroDlg()	: CPropertyPage(CMacroDlg::IDD)
{
	m_pMacro = NULL;
	m_pSequence = NULL;
	//{{AFX_DATA_INIT(CMacroDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

}


void CMacroDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMacroDlg)
	DDX_Control(pDX, IDC_CANCEL_EDIT, m_cbCancel);
	DDX_Control(pDX, IDC_RUN_MACRO, m_cbRunMacro);
	DDX_Control(pDX, IDC_NEW_MACRO, m_cbNewMacro);
	DDX_Control(pDX, IDC_EDIT_MACRO, m_cbEditMacro);
	DDX_Control(pDX, IDC_DELETE_MACRO, m_cbDeleteMacro);
	DDX_Control(pDX, IDC_MACRO_ADD_TEXT, m_cbAddText);
	DDX_Control(pDX, IDC_MACRO_ADD_SLEEP, m_cbAddSleep);
	DDX_Control(pDX, IDC_MACRO_ADD_KEY, m_cbAddKey);
	DDX_Control(pDX, IDC_SAVE_MACRO, m_cbSave);
	DDX_Control(pDX, IDC_MACRO_NAME, m_ceMacroName);
	DDX_Control(pDX, IDC_REPEAT_MACRO, m_cbRepeat);
	DDX_Control(pDX, IDC_MACRO_LIST, m_clbMacros);
	DDX_Control(pDX, IDC_MACRO_KEY, m_ceKey);
	DDX_Control(pDX, IDC_MACRO_SLEEP, m_ceSleep);
	DDX_Control(pDX, IDC_MACRO_TEXT, m_ceText);
	DDX_Control(pDX, IDC_MACRO_CMD_LIST, m_clbCmdList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMacroDlg, CDialog)
	//{{AFX_MSG_MAP(CMacroDlg)
	ON_BN_CLICKED(IDC_MACRO_ADD_KEY, OnMacroAddKey)
	ON_BN_CLICKED(IDC_MACRO_ADD_TEXT, OnMacroAddText)
	ON_BN_CLICKED(IDC_EDIT_MACRO, OnEditMacro)
	ON_BN_CLICKED(IDC_DELETE_MACRO, OnDeleteMacro)
	ON_BN_CLICKED(IDC_RUN_MACRO, OnRunMacro)
	ON_BN_CLICKED(IDC_NEW_MACRO, OnNewMacro)
	ON_BN_CLICKED(IDC_MACRO_ADD_SLEEP, OnMacroAddSleep)
	ON_BN_CLICKED(IDC_SAVE_MACRO, OnSaveMacro)
	ON_LBN_SELCHANGE(IDC_MACRO_LIST, OnSelchangeMacroList)
	ON_BN_CLICKED(IDC_CANCEL_EDIT, OnCancelEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMacroDlg message handlers

void CMacroDlg::OnMacroAddKey() 
{
	int iSel = this->m_clbCmdList.AddString( m_pSequence->Format() );
	if ( iSel != -1 )
		this->m_clbCmdList.SetItemDataPtr( iSel, (void *) m_pSequence );
	this->m_ceKey.SetWindowText("");
	m_pSequence = NULL;
}

void CMacroDlg::OnMacroAddText() 
{
	CString csText;
	this->m_ceText.GetWindowText( csText );
	if ( csText == "" )
		return;
	CSequence * pSeq = new (CSequence);
	for ( int i = 0; i < csText.GetLength(); i++ )
	{
		CMessage * pMsg = new (CMessage);
		pMsg->m_dwMessage = WM_CHAR;
		pMsg->m_dwWParam = ( DWORD ) csText.GetAt( i );
		if ( pSeq->m_olMessages.IsEmpty() )
			pSeq->m_olMessages.AddHead( pMsg );
		else
			pSeq->m_olMessages.AddTail( pMsg );
	}
	CMessage * pMsg = new (CMessage);
	pMsg->m_dwMessage = WM_CHAR;
	pMsg->m_dwWParam = VK_RETURN;
	pSeq->m_olMessages.AddTail( pMsg );
	int iSel = this->m_clbCmdList.AddString( csText );
	this->m_clbCmdList.SetItemDataPtr( iSel, (void *) pSeq );
	this->m_ceText.SetWindowText("");
}

void CMacroDlg::OnEditMacro() 
{
	EnableEdits( true );
	EnableList( false );
}

void CMacroDlg::OnDeleteMacro() 
{
	CString csFullName, csName;
	int iSel = m_clbMacros.GetCurSel();
	if ( iSel != -1 )
	{
		m_clbMacros.GetText( iSel, csName );
		csFullName.Format("%s.mac", csName);
		CFile::Remove( csFullName );
		m_clbMacros.DeleteString( iSel );
		m_clbCmdList.ResetContent();
		m_clbMacros.SetSel( -1, FALSE );
	}

}

void CMacroDlg::OnRunMacro() 
{
	EnableEdits( m_bRun );
	EnableList( m_bRun );
	m_bRun = !m_bRun;
	if ( m_bRun == false )
	{
		// Stop it
		this->m_cbRunMacro.SetWindowText("Run");
	}
	else
	{
		// Start it
		this->m_cbRunMacro.SetWindowText("Stop");
		AfxBeginThread( &MacroThread, this );		
	}
}

void CMacroDlg::OnNewMacro() 
{
	this->m_ceMacroName.SetWindowText("");
	this->m_clbCmdList.ResetContent();
	EnableEdits( true );
	EnableList( false );
	if ( m_pMacro != NULL )
		delete m_pMacro;
	m_pMacro = new (CMacro);
}

void CMacroDlg::OnMacroAddSleep() 
{
	CString csSleep;
	this->m_ceSleep.GetWindowText( csSleep );
	CMessage * pMsg = new (CMessage);
	pMsg->m_dwMessage = WM_USER;
	pMsg->m_dwWParam = atoi(csSleep);
	CSequence * pSeq = new ( CSequence );
	pSeq->m_olMessages.AddHead( pMsg );

	int iSel = this->m_clbCmdList.AddString( pSeq->Format() );
	if ( iSel != -1 )
		this->m_clbCmdList.SetItemDataPtr( iSel, (void *) pSeq );
	this->m_ceSleep.SetWindowText("");
}

void CMacroDlg::OnSaveMacro() 
{
	for (int i = 0; i < this->m_clbCmdList.GetCount(); i++ )
	{
		CSequence * pSeq = (CSequence *) this->m_clbCmdList.GetItemDataPtr( i );
		if ( pSeq == NULL )
			continue;
		if ( m_pMacro->m_olSequences.IsEmpty() )
			m_pMacro->m_olSequences.AddHead( pSeq );
		else
			m_pMacro->m_olSequences.AddTail( pSeq );
	}
	CString csName, csFullName;
	this->m_ceMacroName.GetWindowText( csName );
	CFile cfFile;
	csFullName.Format("%s.mac", csName );
	cfFile.Open( csFullName, CFile::modeWrite | CFile::shareDenyNone | CFile::modeCreate | CFile::typeBinary );
	m_pMacro->Write( &cfFile );
	cfFile.Close();
	EnableEdits( false );
	EnableList( true );
	int iSel = m_clbMacros.FindStringExact( -1, csName );
	if (  iSel == -1 )
		iSel = m_clbMacros.AddString( csName );
	m_clbMacros.SetCurSel( iSel );
}

CMacroDlg::~CMacroDlg()
{
	if ( m_pMacro != NULL )
		delete m_pMacro;
	if ( m_pSequence != NULL)
		delete m_pSequence;
}

void CMacroDlg::LoadMacro(CString csName)
{
	CString csFullName;
	csFullName.Format("%s.mac", csName);
	CFile cfFile;
	cfFile.Open( csFullName, CFile::modeRead | CFile::shareDenyNone | CFile::typeBinary );
	m_clbCmdList.ResetContent();
	m_ceMacroName.SetWindowText( csName );
	if ( m_pMacro != NULL )
		delete m_pMacro;
	m_pMacro = new ( CMacro );
	m_pMacro->Read( & cfFile );
	cfFile.Close();
	
	POSITION pos = m_pMacro->m_olSequences.GetHeadPosition();
	while ( pos )
	{
		CSequence * pSeq = ( CSequence * ) m_pMacro->m_olSequences.GetNext( pos );
		if ( pSeq != NULL )
			this->m_clbCmdList.AddString( pSeq->Format() );
	}
}

CString CMacroDlg::CmdToString(CString csCmd)
{
	CString csOutput;
	CString csLF;
	csLF.Format("%c", 0x0a);

	if ( csCmd == "" )
		return csCmd;
	char ch = csCmd[0];
	switch ( ch )
	{
	case 0x01:
		csOutput.Format("<sleep>%s", csCmd.Mid(1) );
		break;
	case 0x02:
		csOutput.Format("<ctrl>%c", csCmd[1] );
		break;
	case 0x03:
		csOutput.Format("<alt>%c", csCmd[1] );
		break;
	case 0x04:
		csOutput.Format("<shift>%c", csCmd[1] );
		break;
	case 0x05:
		csOutput.Format("<ctrl><alt>%c", csCmd[1] );
		break;
	case 0x06:
		csOutput.Format("<ctrl><shift>%c", csCmd[1] );
		break;
	case 0x07:
		csOutput.Format("<alt><shift>%c", csCmd[1] );
		break;
	case 0x08:
		csOutput.Format("<ctrl><alt><shift>%c", csCmd[1] );
		break;
	default:
		csOutput = csCmd.SpanExcluding( csLF );
		break;
	}
	return csOutput;
}

BOOL CMacroDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Find all of the macro files in the directory.
	CFileFind fFind;
	BOOL bStatus = fFind.FindFile( "*.mac" );
	while (bStatus)
	{
		bStatus = fFind.FindNextFile();
		CString csName = fFind.GetFileName();
		csName = csName.Left( csName.GetLength() - 4 );
		this->m_clbMacros.AddString( csName );
	}
	this->EnableEdits( false );
	this->m_bRun = false;
	m_pMacro = NULL;
	m_pSequence = NULL;
	m_bText = false;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMacroDlg::OnSelchangeMacroList() 
{
	int iSel = m_clbMacros.GetCurSel();
	CString csName;
	if ( iSel != -1 )
	{
		m_clbMacros.GetText( iSel, csName );
		LoadMacro( csName );
	}
	else
	{
		m_clbCmdList.ResetContent();
		m_ceText.SetWindowText("");
	}
}

void CMacroDlg::EnableEdits(bool bEnable)
{
	this->m_clbCmdList.EnableWindow( bEnable );
	this->m_ceKey.EnableWindow( bEnable );
	this->m_ceMacroName.EnableWindow( bEnable );
	this->m_ceSleep.EnableWindow( bEnable );
	this->m_ceText.EnableWindow( bEnable );
	this->m_cbSave.EnableWindow( bEnable );
	this->m_cbAddKey.EnableWindow( bEnable );
	this->m_cbAddSleep.EnableWindow( bEnable );
	this->m_cbAddText.EnableWindow( bEnable );
	this->m_cbCancel.EnableWindow( bEnable );
}

void CMacroDlg::EnableList(bool bEnable)
{
	this->m_cbDeleteMacro.EnableWindow( bEnable );
	this->m_cbNewMacro.EnableWindow( bEnable );
	this->m_cbEditMacro.EnableWindow( bEnable );
	this->m_clbMacros.EnableWindow( bEnable );
	this->m_cbRepeat.EnableWindow( bEnable );
}

void CMacroDlg::OnCancelEdit() 
{
	this->OnSelchangeMacroList();
	EnableEdits( false );
	EnableList( true );
}

UINT MacroThread(LPVOID lpData)
{
	CMacroDlg * pMacroDlg = ( CMacroDlg * ) lpData;
	if ( pMacroDlg->m_pMacro == NULL )
		return 0;
	if ( pMacroDlg->m_pMacro->m_olSequences.IsEmpty() )
		return 0;
	while ( pMacroDlg->m_bRun )
	{
		POSITION pos = pMacroDlg->m_pMacro->m_olSequences.GetHeadPosition();
		while ( pos != NULL )
		{
			CSequence * pSeq = (CSequence *) pMacroDlg->m_pMacro->m_olSequences.GetNext(pos);
			if ( pSeq != NULL )
			{
				POSITION pos = pSeq->m_olRawMessages.GetHeadPosition();
				while ( pos != NULL )
				{
					CMessage * pMsg = (CMessage *) pSeq->m_olRawMessages.GetNext(pos);
					if ( pMsg != NULL )
					{
						if ( pMsg->m_dwMessage == WM_USER )
							Sleep( pMsg->m_dwWParam );
						else
							SendUOMsg( pMsg->m_dwMessage, pMsg->m_dwWParam, pMsg->m_dwLParam );
					}
					Sleep(10);
				}
			}
			Sleep(100);
		}
		if ( pMacroDlg->m_cbRepeat.GetCheck() == 0 )
			break;
	}
	pMacroDlg->m_bRun = false;
	pMacroDlg->m_cbRunMacro.SetWindowText("Run");
	pMacroDlg->EnableList( true );
	return 0;
}


BOOL CMacroDlg::PreTranslateMessage(MSG* pMsg) 
{
	// Find out which window has the input focus.
	if ( pMsg->hwnd == this->m_ceKey.GetSafeHwnd() )
	{
		// It's the single key window.
		switch( pMsg->message )
		{
		case WM_KEYDOWN:
		case WM_SYSKEYDOWN:
			{
				if ( ( m_pSequence != NULL && m_pSequence->Format() != "" )
				 || ( (char) pMsg->wParam == VK_DELETE || (char) pMsg->wParam == VK_BACK ) )
				{
					delete m_pSequence;
					this->m_ceKey.SetWindowText("");
					m_pSequence = NULL;
					if ( (char) pMsg->wParam == VK_BACK )
						return TRUE;
				}
			}
		case WM_KEYUP:
		case WM_SYSKEYUP:
		case WM_CHAR:
		case WM_SYSCHAR:
		case WM_SYSDEADCHAR:
		case WM_DEADCHAR:
		case WM_VKEYTOITEM:
		case WM_GETHOTKEY:
		case WM_HOTKEY:
		case WM_SETHOTKEY:
		case WM_CHARTOITEM:
			{
				CMessage * pRawMsg = new ( CMessage );
				pRawMsg->m_dwLParam = pMsg->lParam;
				pRawMsg->m_dwMessage = pMsg->message;
				pRawMsg->m_dwWParam = pMsg->wParam;
				if ( m_pSequence == NULL )
					m_pSequence = new ( CSequence );
				if ( m_pSequence->m_olRawMessages.IsEmpty() )
					m_pSequence->m_olRawMessages.AddHead( pRawMsg );
				else
					m_pSequence->m_olRawMessages.AddTail( pRawMsg );
				TranslateMessage( pMsg );
				CMessage * pTransMessage = new ( CMessage );
				pTransMessage->m_dwLParam = pMsg->lParam;
				pTransMessage->m_dwMessage = pMsg->message;
				pTransMessage->m_dwWParam = pMsg->wParam;
				if ( this->m_bText )
				{
					if ( m_pSequence != NULL )
						delete m_pSequence;
					m_pSequence = NULL;
					m_ceText.SetWindowText("");
					m_bText = false;
				}
				if ( m_pSequence->m_olMessages.IsEmpty() )
					m_pSequence->m_olMessages.AddHead( pTransMessage );
				else
					m_pSequence->m_olMessages.AddTail( pTransMessage );
				this->m_ceKey.SetWindowText( m_pSequence->Format() );
				return TRUE;
			}
			break;
		default:
			return CDialog::PreTranslateMessage(pMsg);
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}
