/*
 $Id: NameEditDlg.cpp,v 1.4 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// NameEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "NameEditDlg.h"
#include "AddValueDialog.h"
#include "RemoteConnection.h"
#include "FileReadProgress.h"
#include "RemoteConsole.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNameEditDlg dialog


CNameEditDlg::CNameEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNameEditDlg::IDD, pParent)
{
	this->m_pCurrentArray = NULL;
	//{{AFX_DATA_INIT(CNameEditDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CNameEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNameEditDlg)
	DDX_Control(pDX, IDOK, m_cbSave);
	DDX_Control(pDX, IDC_NAMELIST, m_clbNameList);
	DDX_Control(pDX, IDC_NAMEENTRY, m_ceNameEntry);
	DDX_Control(pDX, IDC_NAMEGROUPLIST, m_ccbGroupNames);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNameEditDlg, CDialog)
	//{{AFX_MSG_MAP(CNameEditDlg)
	ON_BN_CLICKED(IDC_ADDNAMEGROUP, OnAddnamegroup)
	ON_BN_CLICKED(IDC_INSERTNAME, OnInsertname)
	ON_BN_CLICKED(IDOK, OnOk)
	ON_WM_VKEYTOITEM()
	ON_CBN_SELCHANGE(IDC_NAMEGROUPLIST, OnSelchangeNamegrouplist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNameEditDlg message handlers

void CNameEditDlg::OnAddnamegroup() 
{
	CAddValueDialog dlg;
	dlg.m_csTitle = "Add New Group Name";
	bool bBadEntry = true;
	bool bNameExists = true;
	int rc = IDOK;
	while (rc == IDOK && (bBadEntry || bNameExists))
	{
		rc = dlg.DoModal();
		if (dlg.m_csValue.SpanExcluding(" #!@$%^&*()~`'+=[]{}:;<>?/\\|\"") != dlg.m_csValue)
			bBadEntry = true;
		else
			bBadEntry = false;
		CString csTest = dlg.m_csValue;
		csTest.MakeUpper();
		if (this->m_ccbGroupNames.FindStringExact(-1, csTest) != -1)
			bNameExists = true;
		else
			bNameExists = false;
		if (bBadEntry)
			AfxMessageBox("Invalid Character in the group name", MB_OK | MB_ICONEXCLAMATION);
		else if (bNameExists)
			AfxMessageBox("Group name already exists", MB_OK | MB_ICONEXCLAMATION);
	}
	if (rc == IDOK)
	{
		CString csValue = dlg.m_csValue;
		csValue.MakeUpper();
		CStringBlock * pBlock = new (CStringBlock);
		if ( pBlock )
		{
			pBlock->m_bIgnoreBlanks = true;
			pBlock->m_bIgnoreComments = true;
			pBlock->m_bStringsOnly = true;
			pBlock->m_bWriteStringCount = true;
			pBlock->m_csID = csValue;
			int index = this->m_ccbGroupNames.AddString(pBlock->m_csID);
			int entry = Main->m_pScripts->m_aNames.Add(pBlock);
			this->m_ccbGroupNames.SetItemData(index, entry);
			this->m_ccbGroupNames.SetCurSel(index);
			this->OnSelchangeNamegrouplist();
		}
	}
}

void CNameEditDlg::OnInsertname() 
{
	CString csNameGroup;
	int iSel = this->m_ccbGroupNames.GetCurSel();
	if ( iSel == -1 )
		return;
	iSel = this->m_ccbGroupNames.GetItemData(iSel);
	CString csName;
	this->m_ceNameEntry.GetWindowText(csName);
	csName.TrimLeft();
	csName.TrimRight();
	if (this->m_clbNameList.FindStringExact(-1, csName) == -1)
	{
		CStringBlock * pBlock = (CStringBlock *) Main->m_pScripts->m_aNames.GetAt(iSel);
		if ( ! pBlock )
			return;
		pBlock->Add(csName);
		this->m_clbNameList.AddString(csName);
	}
	else
	{
		CString csMessage;
		csMessage.Format("The name %s is already in the list", csName);
		AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
	}
	this->m_ceNameEntry.SetWindowText("");
}

void CNameEditDlg::OnOk() 
{
	CWaitCursor hourglass;
	Main->m_pScripts->SaveNames();
	CDialog::OnOK();
}

BOOL CNameEditDlg::OnInitDialog() 
{
	CWaitCursor hourglass;
	CDialog::OnInitDialog();

	Main->m_pScripts->LoadNames();

	for ( int i = 0; i < Main->m_pScripts->m_aNames.GetSize(); i++ )
	{
		CTObject * pBase = (CTObject *) Main->m_pScripts->m_aNames.GetAt(i);
		if ( pBase )
		{
			CStringBlock block;
			block.m_csFilename = pBase->m_csFilename;
			block.m_csValue = pBase->m_csValue;
			block.Load();
			int index = this->m_ccbGroupNames.AddString(block.m_csValue);
			this->m_ccbGroupNames.SetItemData(index, i);
		}
	}

	this->m_ccbGroupNames.SetCurSel(0);
	this->OnSelchangeNamegrouplist();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


int CNameEditDlg::OnVKeyToItem(UINT nKey, CListBox* pListBox, UINT nIndex) 
{
	if (this->GetFocus()->GetSafeHwnd() == this->m_clbNameList.GetSafeHwnd())
	{
		if (nKey == VK_DELETE)
		{
			int iGroup = this->m_ccbGroupNames.GetCurSel();
			iGroup = this->m_ccbGroupNames.GetItemData(iGroup);
			int iSel = this->m_clbNameList.GetCurSel();
			CString csName;
			this->m_clbNameList.GetText(iSel, csName);
			if (iSel != -1 && iGroup != -1)
			{
				CStringBlock * pBlock = (CStringBlock *) Main->m_pScripts->m_aNames.GetAt(iGroup);
				if ( pBlock )
				{
					for ( int i = 0; i < pBlock->GetSize(); i++ )
					{
						if ( pBlock->GetAt(i) == csName )
						{
							pBlock->RemoveAt(i);
							i--;
						}
					}
					this->m_clbNameList.DeleteString(iSel);
				}
			}
			return(-2);
		}
	}
	return CDialog::OnVKeyToItem(nKey, pListBox, nIndex);
}

void CNameEditDlg::OnSelchangeNamegrouplist() 
{
	// The group selection changed...
	this->m_clbNameList.ResetContent();
	int iSel = this->m_ccbGroupNames.GetCurSel();
	if ( iSel == -1 )
		return;
	CTObject * pBase = (CTObject *) Main->m_pScripts->m_aNames.GetAt( this->m_ccbGroupNames.GetItemData(iSel) );
	if ( pBase )
	{
		CStringBlock block;
		block.m_csFilename = pBase->m_csFilename;
		block.m_csValue = pBase->m_csValue;
		block.m_bType = TYPE_NAME;
		block.m_bIgnoreBlanks = true;
		block.m_bIgnoreComments = true;
		block.m_bStringsOnly = true;
		block.Load();
		for ( int i = 0; i < block.GetSize(); i++ )
		{
			CString csName = block.GetAt(i);
			csName = csName.SpanExcluding("//");
			csName = csName.SpanExcluding("0123456789");
			if ( csName == "" )
				continue;
			this->m_clbNameList.AddString(csName);
		}
	}
}

void CNameEditDlg::OnCancel() 
{
	Main->m_pScripts->ReloadNames();
	CDialog::OnCancel();
}
