/*
 $Id: NewScriptObjectDlg.cpp,v 1.4 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// NewScriptObjectDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "NewScriptObjectDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewScriptObjectDlg dialog


CNewScriptObjectDlg::CNewScriptObjectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNewScriptObjectDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNewScriptObjectDlg)
	m_iMode = -1;
	//}}AFX_DATA_INIT
}


void CNewScriptObjectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewScriptObjectDlg)
	DDX_Control(pDX, IDC_NSO_NAME, m_ceName);
	DDX_Control(pDX, IDC_NSO_DEFNAME, m_ceDefName);
	DDX_Control(pDX, IDC_NSO_COPYBASE, m_cbCopyBase);
	DDX_Radio(pDX, IDC_NSO_COPYBASE, m_iMode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNewScriptObjectDlg, CDialog)
	//{{AFX_MSG_MAP(CNewScriptObjectDlg)
	ON_EN_CHANGE(IDC_NSO_NAME, OnChangeNsoName)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewScriptObjectDlg message handlers

void CNewScriptObjectDlg::OnChangeNsoName() 
{
	CString csName;
	this->m_ceName.GetWindowText(csName);
	csName.MakeUpper();
	if ( csName == "" )
	{
		this->m_ceDefName.SetWindowText("");
		return;
	}
	CString csDef;
	switch (m_bType)
	{
	case TYPE_ITEM:
		csDef.Format("I_%s", csName);
		break;
	case TYPE_CHAR:
		csDef.Format("C_%s", csName);
		break;
	case TYPE_TEMPLATE:
		csDef.Format("TPL_%s", csName);
		break;
	case TYPE_SPAWN:
		csDef.Format("SPW_%s", csName);
		break;
	case TYPE_TRIGGER:
		csDef.Format("T_%s", csName);
		break;
	case TYPE_PLOT:
		csDef.Format("P_%s", csName);
		break;
	case TYPE_REGION:
		csDef.Format("R_%s", csName);
		break;
	case TYPE_SKILLCLASS:
		csDef.Format("Class_%s", csName);
		break;
	case TYPE_NAME:
		csDef.Format("NAMES_%s", csName);
		break;
	}
	csDef.Replace(" ", "_");
	// See if this def already exists
	bool bExists = true;
	CString csNewDef = csDef;
	int index = 1;
	while ( bExists )
	{
		int iDef = Main->m_pScripts->m_aDefs.Find(csNewDef);
		if ( iDef == -1 )
			bExists = false;
		else
			csNewDef.Format("%s_%ld", csDef, ++index);
	}
	this->m_ceDefName.SetWindowText(csNewDef);
}

void CNewScriptObjectDlg::OnOK() 
{
	UpdateData(TRUE);
	m_bMode = m_iMode ? true : false;
	this->m_ceDefName.GetWindowText(m_csDef);
	this->m_ceName.GetWindowText(m_csName);
	CDialog::OnOK();
}

void CNewScriptObjectDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

BOOL CNewScriptObjectDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	switch ( m_bType )
	{
	case TYPE_ITEM:
	case TYPE_CHAR:
		this->m_iMode = 0;
		break;
	case TYPE_TEMPLATE:
	case TYPE_SPAWN:
	case TYPE_TRIGGER:
	case TYPE_PLOT:
	case TYPE_REGION:
	case TYPE_SKILLCLASS:
	case TYPE_NAME:
		this->m_cbCopyBase.EnableWindow(FALSE);
		this->m_iMode = 1;
		break;
	}
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
