/*
 $Id: RemoteConsoleDlg.h,v 1.6 2002/11/17 04:25:27 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_REMOTECONSOLEDLG_H__5D6AFB61_2981_11D3_8723_00805FD91B8C__INCLUDED_)
#define AFX_REMOTECONSOLEDLG_H__5D6AFB61_2981_11D3_8723_00805FD91B8C__INCLUDED_

#include "RemoteConsole.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RemoteConsoleDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CRemoteConsoleDlg dialog

class CRemoteConsoleDlg : public CDialog
{
// Construction
public:
	CString m_csCommand;
	bool m_bIsConnected;
	int m_nIDTimer;
	CStringArray m_saMessages;
	virtual ~CRemoteConsoleDlg();
	CRemoteConsole * m_rConsole;
	CRemoteConsoleDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CRemoteConsoleDlg)
	enum { IDD = IDD_REMOTECONSOLEDLG };
	CComboBox	m_ccbCommand;
	CComboBox	m_ccbBroadcast;
	CButton	m_cbLogging;
	CButton	m_cbCommand;
	CButton	m_cbBroadcast;
	CButton	m_cbVerbose;
	CButton	m_cbShutdown;
	CButton	m_cbSecure;
	CButton	m_cbSave;
	CButton	m_cbProfile;
	CButton	m_cbPause;
	CButton	m_cbLog;
	CButton	m_cbInformation;
	CButton	m_cbHearall;
	CButton	m_cbGarbage;
	CButton	m_cbClient;
	CButton	m_cbAccountUpdate;
	CRichEditCtrl	m_creConsole;
	CButton	m_cbReconnect;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRemoteConsoleDlg)
	public:
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	virtual BOOL Create( UINT IDD, CWnd* pParentWnd);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	void OnRConsoleMessage(WPARAM wParam, LPARAM lParam);
	void OnRConsoleReconnect(WPARAM wParam, LPARAM lParam);
// Implementation
protected:
	CString m_csLogFile;
	bool m_bLogging;
	CWnd * m_pParent;
	CRect m_crConsole, m_crLog, m_crVerbose, m_crHearAll, m_crPause, m_crSecure, m_crGarbage;
	CRect m_crInformation, m_crClient, m_crSave, m_crShutdown, m_crProfile, m_crAccount, m_crBroadcast;
	CRect m_crText, m_crReConnect, m_crCommand, m_crCommandText, m_crLogging, m_crOriginal;

	int iTop, iLeft, iBottom, iRight;

	// Generated message map functions
	//{{AFX_MSG(CRemoteConsoleDlg)
	afx_msg void OnSendtext();
	afx_msg void OnReconnect();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnRcLog();
	afx_msg void OnRcAccount();
	afx_msg void OnRcClient();
	afx_msg void OnRcGarbage();
	afx_msg void OnRcHearall();
	afx_msg void OnRcInformation();
	afx_msg void OnRcPause();
	afx_msg void OnRcProfile();
	afx_msg void OnRcSave();
	afx_msg void OnRcSecure();
	afx_msg void OnRcShutdown();
	afx_msg void OnRcVerbose();
	virtual BOOL OnInitDialog();
	afx_msg void OnSendcommand();
	afx_msg void OnEnableLogging();
	afx_msg void OnRcOptionsChangeprofile();
	afx_msg void OnRcOptionsClearwindowbuffer();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_REMOTECONSOLEDLG_H__5D6AFB61_2981_11D3_8723_00805FD91B8C__INCLUDED_)
