/*
 $Id: RemoteConsoleLoginDlg.cpp,v 1.5 2002/08/07 22:28:50 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// RemoteConsoleLoginDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "RemoteConsoleLoginDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRemoteConsoleLoginDlg dialog


CRemoteConsoleLoginDlg::CRemoteConsoleLoginDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRemoteConsoleLoginDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRemoteConsoleLoginDlg)
	m_csAccount = _T("");
	m_csPassword = _T("");
	//}}AFX_DATA_INIT
	m_iSel = 0;
}


void CRemoteConsoleLoginDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRemoteConsoleLoginDlg)
	DDX_Control(pDX, IDC_ACCTNAME, m_ccbName);
	DDX_Text(pDX, IDC_ACCT, m_csAccount);
	DDX_Text(pDX, IDC_PWD, m_csPassword);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRemoteConsoleLoginDlg, CDialog)
	//{{AFX_MSG_MAP(CRemoteConsoleLoginDlg)
	ON_CBN_SELCHANGE(IDC_ACCTNAME, OnSelchangeAcctname)
	ON_CBN_EDITCHANGE(IDC_ACCTNAME, OnEditchangeAcctname)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRemoteConsoleLoginDlg message handlers

BOOL CRemoteConsoleLoginDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Check the registry to see if we have account info saved

	// First, see if it's saved the old way
	Main->DeleteRegistryValue("SaveRemoteLoginInfo");
	m_csAccount = Main->GetRegistryString("RemoteLoginAccount");
	m_csPassword = Encrypt(Main->GetRegistryString("RemoteLoginPassword"));

	// If so, save it in the new way, storing the Account field as the name
	if ( !m_csPassword.IsEmpty() )
	{
		m_csAccountName = m_csAccount;
		if ( m_csAccountName.IsEmpty() )
			m_csAccountName = "RemoteAdmin";
		// Create the new key
		CString csKey;
		csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Console Logins\\%s", m_csAccountName);
		Main->PutRegistryString("Account", m_csAccount, HKEY_LOCAL_MACHINE, csKey);
		Main->PutRegistryString("Password", Encrypt(m_csPassword), HKEY_LOCAL_MACHINE, csKey);
		// Then delete the old values so we don't do this again
		Main->DeleteRegistryValue("RemoteLoginAccount");
		Main->DeleteRegistryValue("RemoteLoginPassword");
		// Set this account as the active account
		Main->PutRegistryString("LastRemoteLoginAccount", m_csAccountName);
	}

	// Now populate the Names combo box
	// We have to enumerate the keys in the Console Logins section
	HKEY hKey;
	LONG lStatus;
	lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Console Logins", 0, KEY_ALL_ACCESS, &hKey);
	int iIndex = 0;
	if ( lStatus == ERROR_SUCCESS )
	{
		while (lStatus == ERROR_SUCCESS)
		{
			char szBuffer[MAX_PATH];
			DWORD dwSize = sizeof(szBuffer);
			lStatus = RegEnumKeyEx(hKey, iIndex, &szBuffer[0], &dwSize, 0, NULL, NULL, NULL);
			if (lStatus == ERROR_SUCCESS)
			{
				CString csProfile;
				csProfile.Format("%s", szBuffer);
				m_ccbName.AddString(csProfile);
			}
			iIndex++;
		}
		RegCloseKey(hKey);
	}

	// Now select the last selected login

	CString csLast = Main->GetRegistryString("LastRemoteLoginAccount");
	if ( csLast.IsEmpty() )
		m_ccbName.SetCurSel(-1);
	else
		m_ccbName.SelectString(0, csLast);
	OnSelchangeAcctname();

	UpdateData(FALSE);	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRemoteConsoleLoginDlg::OnOK() 
{
	// Save the current stuff
	UpdateData(TRUE);
	CString csKey;
	m_ccbName.GetWindowText(m_csAccountName);
	csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Console Logins\\%s", m_csAccountName);
	Main->PutRegistryString("Account", m_csAccount, HKEY_LOCAL_MACHINE, csKey);
	Main->PutRegistryString("Password", Encrypt(m_csPassword), HKEY_LOCAL_MACHINE, csKey);
	Main->PutRegistryString("LastRemoteLoginAccount", m_csAccountName);

	CDialog::OnOK();
}

void CRemoteConsoleLoginDlg::OnSelchangeAcctname() 
{
	UpdateData(TRUE);
	// Save the previous stuff?
	CString csKey;
	/*
	if ( m_iSel != -1 )
	{
		m_ccbName.GetLBText(m_iSel, m_csAccountName);
		csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Console Logins\\%s", m_csAccountName);
		Main->PutRegistryString("Account", m_csAccount, HKEY_LOCAL_MACHINE, csKey);
		Main->PutRegistryString("Password", Encrypt(m_csPassword), HKEY_LOCAL_MACHINE, csKey);
	}
	*/
	
	// Populate the fields with the values of the new selection
	m_iSel = m_ccbName.GetCurSel();
	if ( m_iSel == -1 )
	{
		m_csAccount = "";
		m_csPassword = "";
		UpdateData(FALSE);
		return;
	}
	m_ccbName.GetLBText(m_iSel, m_csAccountName);
	csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Console Logins\\%s", m_csAccountName);
	m_csAccount = Main->GetRegistryString("Account", "", HKEY_LOCAL_MACHINE, csKey);
	m_csPassword = Encrypt(Main->GetRegistryString("Password", "", HKEY_LOCAL_MACHINE, csKey));

	// Update the last account setting
	Main->PutRegistryString("LastRemoteLoginAccount", m_csAccountName);
	UpdateData(FALSE);
}

void CRemoteConsoleLoginDlg::OnEditchangeAcctname() 
{
	m_csAccount = "";
	m_csPassword = "";
	UpdateData(FALSE);
	m_iSel = -1;
}
