#if !defined(AFX_ROOFINGDLG_H__4ABBCED2_5D10_4A1E_8D2E_F7D32A8C0137__INCLUDED_)
#define AFX_ROOFINGDLG_H__4ABBCED2_5D10_4A1E_8D2E_F7D32A8C0137__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RoofingDlg.h : header file
//
/*
 **********************************************************************
 * Copyright (C) Adron 2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************
*/

#include "RoofImage.h"

/////////////////////////////////////////////////////////////////////////////
// CRoofingDlg dialog

class CRoofingDlg : public CDialog
{
// Construction
public:
	enum testmodes {NOTEST=0, TEST=1, REST=2};
	unsigned GetFlags(char *pline, char *line, char *nline);
	bool Generate(testmodes testmode);
	virtual ~CRoofingDlg();
	CPoint m_base;
	unsigned Compare(char middle, char relative);
	short LookupID(unsigned flags);
	void CheckRemove();
	void CheckGenerate();
	void CheckAdd();
	bool AddVY(int y1, int y2, int x, int hlimit=1000);
	bool AddVX(int x1, int x2, int y, int hlimit=1000);
	bool Calculate();
	struct Edge {
		CRect rc; // Corners
		bool up; // Goes in up direction ?
		bool tent; // Tent style roof ?
	};
	struct TileMask {
		unsigned flags;
		short id;
		TileMask(unsigned f, short i) : flags(f), id(i) {}
		TileMask() : flags(0), id(0) {}
	};
	struct TileSet {
		CString name;
		CList<TileMask, TileMask&> tiles;
	};
	CList<TileSet*, TileSet*&> m_tilesets;
	CList<Edge, Edge&> m_edges;
	CRoofingDlg(CWnd* pParent = NULL);   // standard constructor
	TileSet *m_tileset;
	enum flagsenum {LOWER=1, HIGHER=2, EVEN=4, EMPTY=8};

// Dialog Data
	//{{AFX_DATA(CRoofingDlg)
	enum { IDD = IDD_ROOFING };
	CButton	m_testgen;
	CButton	m_noscript;
	CButton	m_tent;
	CComboBox	m_rooftype;
	CButton	m_clear;
	CButton	m_removelast;
	CEdit	m_height;
	CButton	m_generate;
	CButton	m_add;
	CButton	m_up;
	CRoofImage	m_roofimage;
	CEdit	m_y2;
	CEdit	m_y1;
	CEdit	m_x2;
	CEdit	m_x1;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRoofingDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CRoofingDlg)
	afx_msg void OnAdd();
	afx_msg void OnClear();
	afx_msg void OnGenerate();
	afx_msg void OnRemovelast();
	afx_msg void OnChangeX1();
	afx_msg void OnChangeX2();
	afx_msg void OnChangeY1();
	afx_msg void OnChangeY2();
	afx_msg void OnChangeHeight();
	virtual BOOL OnInitDialog();
	afx_msg void OnTestgen();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ROOFINGDLG_H__4ABBCED2_5D10_4A1E_8D2E_F7D32A8C0137__INCLUDED_)
