/*
 $Id: SPAWNTAB.CPP,v 1.16 2002/11/13 17:52:35 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

/**********************************************************************
 * Changes:
 *  - 7 May 2002 - PiotrBanasik
 *    + Added a shrink button
 *    + Rearranged a fair bit on the bottom to make it fit
 * 
 **********************************************************************/

// SpawnTab.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "SpawnTab.h"
#include "ItemTweakTab.h"
#include "FileReadProgress.h"
#include "SpawnMessageDlg.h"
#include "CNPC.h"
#include "tables.h"
#include "NPCEditDlg.h"
#include "RemoteConnection.h"
#include "SpawnGroupEditDlg.h"
#include "SearchCritDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSpawnTab property page

IMPLEMENT_DYNCREATE(CSpawnTab, CPropertyPage)

int CSpawnTab::iIDSort = 1;
int CSpawnTab::iNameSort = 1;

CSpawnTab::CSpawnTab() : CPropertyPage(CSpawnTab::IDD)
{
	//{{AFX_DATA_INIT(CSpawnTab)
	//}}AFX_DATA_INIT
	m_iCatSeq = 0;
}

CSpawnTab::~CSpawnTab()
{
	Unload();
}

void CSpawnTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpawnTab)
	DDX_Control(pDX, IDC_CREATURELIST, m_clcCreatures);
	DDX_Control(pDX, IDC_NPCTREE, m_ctcNPC);
	DDX_Control(pDX, IDC_HOMEDIST, m_ceHomedist);
	DDX_Control(pDX, IDC_NPC_ID, m_csNPCId);
	DDX_Control(pDX, IDC_MIN_TIME, m_ceMinTime);
	DDX_Control(pDX, IDC_MAX_TIME, m_ceMaxTime);
	DDX_Control(pDX, IDC_MAX_DIST, m_ceMaxDist);
	DDX_Control(pDX, IDC_AMOUNT, m_ceAmount);
	DDX_Control(pDX, IDC_NPCDISPLAY, m_Display);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSpawnTab, CPropertyPage)
	//{{AFX_MSG_MAP(CSpawnTab)
	ON_BN_CLICKED(IDC_SUMMON, OnSummon)
	ON_BN_CLICKED(IDC_PLACE_SPAWNPOINT, OnPlaceSpawnpoint)
	ON_BN_CLICKED(IDC_INIT_SPAWNPOINT, OnInitSpawnpoint)
	ON_BN_CLICKED(IDC_SETHOME, OnSethome)
	ON_BN_CLICKED(IDC_SETHOMEDIST, OnSethomedist)
	ON_NOTIFY(TVN_SELCHANGED, IDC_NPCTREE, OnSelchangedNpctree)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_CREATURELIST, OnColumnclickCreaturelist)
	ON_NOTIFY(NM_CLICK, IDC_CREATURELIST, OnClickCreaturelist)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_CREATURELIST, OnItemchangedCreaturelist)
	ON_BN_CLICKED(IDC_SPREMOVE, OnSpremove)
	ON_BN_CLICKED(IDC_SPFREEZE, OnSpfreeze)
	ON_BN_CLICKED(IDC_FINDNPC, OnFindnpc)
	ON_BN_CLICKED(IDC_STKILL, OnStkill)
	ON_EN_CHANGE(IDC_HOMEDIST, OnChangeParams)
	ON_EN_CHANGE(IDC_AMOUNT, OnChangeParams)
	ON_EN_CHANGE(IDC_MIN_TIME, OnChangeParams)
	ON_EN_CHANGE(IDC_MAX_TIME, OnChangeParams)
	ON_EN_CHANGE(IDC_MAX_DIST, OnChangeParams)
	ON_BN_CLICKED(IDC_SHRINK, OnShrink)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpawnTab message handlers

BOOL CSpawnTab::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	LoadScripts();
	this->m_clcCreatures.InsertColumn(0, "NPC Type", LVCFMT_LEFT, 120, -1);
	this->m_clcCreatures.InsertColumn(1, "ID", LVCFMT_LEFT, 120, -1);

	CString csValue;
	csValue = Main->GetRegistryString("NPCSpawnAmount", "1");
	m_ceAmount.SetWindowText(csValue);
	csValue = Main->GetRegistryString("NPCHomedist", "5");
	m_ceHomedist.SetWindowText(csValue);
	csValue = Main->GetRegistryString("NPCSpawnMaxDist", "0");
	m_ceMaxDist.SetWindowText(csValue);
	csValue = Main->GetRegistryString("NPCSpawnMaxTime", "20");
	m_ceMaxTime.SetWindowText(csValue);
	csValue = Main->GetRegistryString("NPCSpawnMinTime", "5");
	m_ceMinTime.SetWindowText(csValue);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CSpawnTab::OnSummon() 
{
	CString csCmd, csID;
	m_csNPCId.GetWindowText(csID);
	DWORD dwID = (DWORD) ahextoi(csID);
	if ( dwID > 0x7FFF )
	{
		AfxMessageBox("Spawn Groups cannot be summoned.  They must be spawned.", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	csCmd.Format(".addnpc %s", csID);
	SendToUO(csCmd);
}

void CSpawnTab::OnPlaceSpawnpoint() 
{
	SendToUO(".add 01ea7");
}

void CSpawnTab::OnInitSpawnpoint() 
{
	CWaitCursor hourglass;
	CString csAmount, csMinTime, csMaxTime, csMaxDist, csID;
	this->m_ceAmount.GetWindowText(csAmount);
	this->m_ceMaxDist.GetWindowText(csMaxDist);
	this->m_ceMinTime.GetWindowText(csMinTime);
	this->m_ceMaxTime.GetWindowText(csMaxTime);
	this->m_csNPCId.GetWindowText(csID);

	if (csID == "")
	{
		AfxMessageBox("No creature is selected.", MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	int iAmount, iMinTime, iMaxTime, iMaxDist;
	iAmount = atoi(csAmount);
	if (iAmount == 0)
		iAmount = 1;
	iMaxDist = atoi(csMaxDist);
	iMinTime = atoi(csMinTime);
	//if (iMinTime == 0)
	//	iMinTime = 1;
	iMaxTime = atoi(csMaxTime);
	if (iMaxTime <= iMinTime)
		iMaxTime = iMinTime + 1;

	CString csCmd;
	csCmd.Format(".act.type %ld", ITEM_SPAWN_CHAR);
	SendToUO(csCmd);
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	csCmd.Format(".act.amount %ld", iAmount);
	SendToUO(csCmd);
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	csCmd.Format(".act.more %s", csID);
	SendToUO(csCmd);
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	csCmd.Format(".act.morep %ld %ld %ld", iMinTime, iMaxTime, iMaxDist);
	SendToUO(csCmd);
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	csCmd.Format(".act.attr %04x", ATTR_INVIS | ATTR_MAGIC | ATTR_MOVE_NEVER);
	SendToUO(csCmd);
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	SendToUO(".act.timer 1");
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(KS_ESCAPE);

	if (Main->m_dwSpawnMessage)
	{
		CSpawnMessageDlg mDlg;
		mDlg.Create(IDD_SPAWNMESSAGE_DLG);
		//mDlg.SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
		mDlg.m_csMessage = "Spawn Point Initialized";
		mDlg.UpdateData(false);
		Sleep(3000);
		mDlg.EndDialog(IDOK);
	}	
}

void CSpawnTab::OnSethome() 
{
	SendToUO(".set home");	
}

void CSpawnTab::OnSethomedist() 
{
	CString csVal;
	m_ceHomedist.GetWindowText(csVal);
	CString csCmd;
	csCmd.Format(".set homedist %s", csVal);
	SendToUO(csCmd);
}

void CSpawnTab::OnSelchangedNpctree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	this->m_clcCreatures.SetHotItem(-1);

	HTREEITEM hSelectedItem  = NULL;
	HTREEITEM hParentItem = NULL;
	this->m_clcCreatures.DeleteAllItems();
	this->m_csNPCId.SetWindowText("");

	// Do the bold/nobold thing
	if (pNMTreeView != NULL)
	{
		HTREEITEM hOldItem = pNMTreeView->itemOld.hItem;
		if (hOldItem != NULL)
			this->m_ctcNPC.SetItemState(hOldItem, 0, TVIS_BOLD);
	}
	
	hSelectedItem = this->m_ctcNPC.GetSelectedItem();
	this->m_ctcNPC.SetItemState(hSelectedItem, TVIS_BOLD, TVIS_BOLD);
	hParentItem = this->m_ctcNPC.GetParentItem(hSelectedItem);

	if (hParentItem != NULL)
	{
		CString csParent = this->m_ctcNPC.GetItemText(hParentItem);
		CString csSelected = this->m_ctcNPC.GetItemText(hSelectedItem);
		CCategory * pCategory = FindCategory(&Main->m_pScripts->m_olNPCs, csParent);
		if (pCategory == NULL)
			return;
		CSubsection * pSubsection = FindSubsection(pCategory, csSelected);
		if (pSubsection == NULL)
			return;
		if (!pSubsection->m_ItemList.IsEmpty())
		{
			POSITION pos = pSubsection->m_ItemList.GetHeadPosition();
			int iCount = 0;
			while (pos != NULL)
			{
				CSObject * pObject = (CSObject *) pSubsection->m_ItemList.GetNext(pos);
				CString csDef;
				if ( pObject->m_bType == TYPE_CHAR )
				{
					CNPC npc;
					npc.CopyBase(pObject);
					npc.Load();
					csDef = npc.m_csDefName;
				}

				this->m_clcCreatures.InsertItem(iCount, pObject->m_csDescription, 0);
				if ( csDef != "" )
					this->m_clcCreatures.SetItemText(iCount, 1, csDef);
				else
					this->m_clcCreatures.SetItemText(iCount, 1, pObject->m_csValue);
				this->m_clcCreatures.SetItemData(iCount, (DWORD)pObject);
				iCount++;
			}
		}
	}

	m_Display.SetArtIndex(-1);
	m_Display.SetArtColor(0);

	iNameSort = 1;
	iIDSort = 1;
	this->m_clcCreatures.SortItems(CompareFunc, 0);
	iNameSort = -1;
}

int CALLBACK CSpawnTab::CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	CSObject * pObject1 = (CSObject *) lParam1;
	CSObject * pObject2 = (CSObject *) lParam2;

	if ( pObject1 && pObject2 )
	{
		if (lParamSort == 0)
		{
			if (iNameSort == 0)
				return (lParam1 < lParam2 ? 1 : -1);
			if (iNameSort == 1)
				return (pObject1->m_csDescription < pObject2->m_csDescription ? -1 : 1);
			if (iNameSort == -1)
				return (pObject1->m_csDescription < pObject2->m_csDescription ? 1 : -1);
		}
		else
		{
			if (iIDSort == 0)
				return (lParam1 < lParam2 ? 1 : -1);
			if (iIDSort == 1)
				return (pObject1->m_csValue < pObject2->m_csValue ? -1 : 1);
			if (iIDSort == -1)
				return (pObject1->m_csValue < pObject2->m_csValue ? 1 : -1);
		}
	}
	return 0;
}

void CSpawnTab::OnColumnclickCreaturelist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	this->m_clcCreatures.SortItems(CompareFunc, pNMListView->iSubItem);
	if (pNMListView->iSubItem == 0)
	{
		switch(iNameSort)
		{
		case -1:
			iNameSort = 1;
			break;
		case 0:
			iNameSort = 1;
			break;
		case 1:
			iNameSort = -1;
			break;
		}
	}
	else
	{
		switch(iIDSort)
		{
		case -1:
			iIDSort = 1;
			break;
		case 0:
			iIDSort = 1;
			break;
		case 1:
			iIDSort = -1;
			break;
		}
	}
	*pResult = 0;
}

void CSpawnTab::OnClickCreaturelist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int iSelIndex = this->m_clcCreatures.GetNextItem(-1, LVNI_SELECTED);
	if (iSelIndex == -1)
	{
		this->m_csNPCId.SetWindowText("");
		m_Display.SetArtIndex(-1);
		m_Display.SetArtColor(0);
		return;
	}
	this->m_clcCreatures.SetHotItem(iSelIndex);
	CSObject * pObject = (CSObject *) this->m_clcCreatures.GetItemData(iSelIndex);
	this->m_csNPCId.SetWindowText(pObject->m_csValue);

	if ( pObject->m_csFilename == "" )
		return;
	// Is this an NPC or a spawn group?
	if ( pObject->m_bType == TYPE_CHAR )
	{
		CNPC npc;
		npc.CopyBase(pObject);
		npc.Load();
		WORD wID;
		if ( isdigit(npc.m_csValue.GetAt(0) ) )
		{
			if ( ahextoi(npc.m_csValue) < 0x0400 && ahextoi(npc.m_csValue) != 0 )
				wID = (WORD) ahextoi(npc.m_csValue);
			else
				wID = npc.m_wID;
		}
		else
		{
			if ( DefLookup(npc.m_csValue) < 0x0400 && DefLookup(npc.m_csValue) != 0 )
				wID = (WORD) DefLookup(npc.m_csValue);
			else
				wID = npc.m_wID;
		}
		WORD wColor = (WORD) DefLookup(npc.m_csColor);
		m_Display.SetArtColor(wColor);
		m_Display.SetArtIndex(wID);
	}
	else if ( pObject->m_bType == TYPE_SPAWN )
	{
		// What should we display for a spawn group?
		// Nothing for now
	}

	*pResult = 0;
}

void CSpawnTab::OnItemchangedCreaturelist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	OnClickCreaturelist(pNMHDR, pResult);

	*pResult = 0;
}

void CSpawnTab::FillCategoryTree()
{
	HTREEITEM CategoryParent;
	HTREEITEM SubsectionParent;
	TV_INSERTSTRUCT InsertItem;

	m_ctcNPC.DeleteAllItems();
	if (!Main->m_pScripts->m_olNPCs.IsEmpty())
	{
		POSITION pos = Main->m_pScripts->m_olNPCs.GetHeadPosition();
		while (pos != NULL)
		{
			CCategory * pCategory = (CCategory *) Main->m_pScripts->m_olNPCs.GetNext(pos);
			InsertItem.item.mask = TVIF_TEXT;
			InsertItem.item.pszText = (char *)LPCTSTR(pCategory->m_csName);
			InsertItem.item.cchTextMax = pCategory->m_csName.GetLength();
			InsertItem.hParent = NULL;
			InsertItem.hInsertAfter = TVI_SORT;
			CategoryParent = this->m_ctcNPC.InsertItem(&InsertItem);
			if (!pCategory->m_SubsectionList.IsEmpty())
			{
				POSITION sPos = pCategory->m_SubsectionList.GetHeadPosition();
				while (sPos != NULL)
				{
					CSubsection * pSubsection = (CSubsection *) pCategory->m_SubsectionList.GetNext(sPos);
					InsertItem.item.mask = TVIF_TEXT;
					InsertItem.item.pszText = (char *)LPCTSTR(pSubsection->m_csName);
					InsertItem.item.cchTextMax = pSubsection->m_csName.GetLength();
					InsertItem.hParent = CategoryParent;
					InsertItem.hInsertAfter = TVI_SORT;
					SubsectionParent = this->m_ctcNPC.InsertItem(&InsertItem);
				}
			}
		}
	}
	m_iCatSeq = Main->m_pScripts->m_iNCatSeq;
}

void CSpawnTab::SelectTreeItem(CString csParent, CString csChild)
{
	HTREEITEM hParent = m_ctcNPC.GetFirstVisibleItem();
	HTREEITEM hChild;
	
	while (hParent != NULL)
	{
		CString csPText = m_ctcNPC.GetItemText(hParent);
		if (csPText == csParent)
		{
			hChild = m_ctcNPC.GetChildItem(hParent);
			while (hChild != NULL)
			{
				CString csCText = m_ctcNPC.GetItemText(hChild);
				if (csCText == csChild)
				{
					m_ctcNPC.SelectItem(hChild);
					return;
				}
				hChild = m_ctcNPC.GetNextSiblingItem(hChild);
			}
			// Couldn't find the child...
			m_ctcNPC.SelectItem(hParent);
			return;
		}
		hParent = m_ctcNPC.GetNextSiblingItem(hParent);
	}
	m_Display.SetArtIndex(-1);
	m_Display.SetArtColor(0);
}

void CSpawnTab::Unload()
{
}

void CSpawnTab::LoadScripts()
{
	CString csScpPath = GetScriptPath();

	CWaitCursor hourglass;
	
	CFileReadProgress dlg;
	dlg.Create(IDD_FILEREAD_PROGRESS);
	Main->m_pScripts->CategorizeNPCs();
	
	// Now add all of the categories to the category list box
	
	FillCategoryTree();

}

void CSpawnTab::OnSpremove() 
{
	SendToUO(".remove");
}

void CSpawnTab::OnSpfreeze() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".set flags=4");
	else
		SendToUO(".set flags 4");	
}


void CSpawnTab::OnFindnpc() 
{
	CSearchCritDlg dlg;
	if ( dlg.DoModal() != IDOK )
		return;
	Find( dlg.m_csValue, dlg.m_iCrit, false );
	return;
}

BOOL CSpawnTab::PreTranslateMessage(MSG* pMsg) 
{
	if ( pMsg->message == WM_KEYDOWN )
	{
		if ( pMsg->wParam == VK_F3 )
		{
			if ( GetAsyncKeyState(VK_SHIFT) )
				FindPrevious();
			else
				Find();
			return TRUE;
		}
	}	
	return CPropertyPage::PreTranslateMessage(pMsg);
}

void CSpawnTab::Find(CString csString, int iCrit, bool bPrevious)
{
	if ( csString != "" )
	{
		// this is a new search
		this->m_csSearchValue = csString;
		this->m_iSearchCrit = iCrit;
		this->m_pSearchCategory = NULL;
		this->m_pSearchSubsection = NULL;
		this->m_pSearchNPC = NULL;
	}
	POSITION catPos;
	if ( this->m_pSearchCategory )
		catPos = Main->m_pScripts->m_olNPCs.Find( this->m_pSearchCategory );
	else
	{
		if ( !bPrevious )
			catPos = Main->m_pScripts->m_olNPCs.GetHeadPosition();
		else
			catPos = Main->m_pScripts->m_olNPCs.GetTailPosition();
	}
	while ( catPos != NULL )
	{
		CCategory * pCategory;
		if ( !bPrevious )
			pCategory = (CCategory *) Main->m_pScripts->m_olNPCs.GetNext( catPos );
		else
			pCategory = (CCategory *) Main->m_pScripts->m_olNPCs.GetPrev( catPos );
		if ( pCategory == NULL )
			break;
		POSITION subPos;
		if ( this->m_pSearchSubsection )
			subPos = pCategory->m_SubsectionList.Find( this->m_pSearchSubsection );
		else
		{
			if ( !bPrevious )
				subPos = pCategory->m_SubsectionList.GetHeadPosition();
			else
				subPos = pCategory->m_SubsectionList.GetTailPosition();
		}
		while ( subPos != NULL )
		{
			CSubsection * pSubsection;
			if ( !bPrevious )
				pSubsection = ( CSubsection *) pCategory->m_SubsectionList.GetNext( subPos );
			else
				pSubsection = ( CSubsection *) pCategory->m_SubsectionList.GetPrev( subPos );
			if ( pSubsection == NULL )
				break;
			POSITION npcPos;
			if ( this->m_pSearchNPC )
			{
				npcPos = pSubsection->m_ItemList.Find( this->m_pSearchNPC );
				if ( npcPos )
				{
					CSObject * pNPC;
					if ( !bPrevious )
						pNPC = ( CSObject * ) pSubsection->m_ItemList.GetNext( npcPos );
					else
						pNPC = ( CSObject * ) pSubsection->m_ItemList.GetPrev( npcPos );
				}
			}
			else
			{
				if ( !bPrevious )
					npcPos = pSubsection->m_ItemList.GetHeadPosition();
				else
					npcPos = pSubsection->m_ItemList.GetTailPosition();
			}
			while ( npcPos != NULL )
			{
				CSObject * pNPC;
				if ( !bPrevious )
					pNPC = ( CSObject * ) pSubsection->m_ItemList.GetNext( npcPos );
				else
					pNPC = ( CSObject * ) pSubsection->m_ItemList.GetPrev( npcPos );
				if ( pNPC == NULL )
					break;
				CSObject * pSelection = NULL;
				CString csValue, csTest;
				csTest = this->m_csSearchValue;
				csTest.MakeLower();
				switch ( this->m_iSearchCrit )
				{
				case 0:
					// ID
					csValue = pNPC->m_csValue;
					csValue.MakeLower();
					if ( csValue.Find( csTest ) != -1 )
						pSelection = pNPC;
					break;
				case 1:
					// Description
					csValue = pNPC->m_csDescription;
					csValue.Replace("@", pNPC->m_csSubsection);
					csValue.MakeLower();
					if ( csValue.Find( csTest ) != -1 )
						pSelection = pNPC;
					break;
				default:
					break;
				}
				if ( pSelection != NULL )
				{
					HTREEITEM hRoot = this->m_ctcNPC.GetRootItem();
					HTREEITEM hCat = this->m_ctcNPC.GetNextItem( hRoot, TVGN_NEXT );
					while ( hCat != NULL )
					{
						if ( this->m_ctcNPC.GetItemText( hCat ) == pCategory->m_csName )
						{
							HTREEITEM hSub = this->m_ctcNPC.GetChildItem( hCat );
							while ( hSub != NULL )
							{
								if ( this->m_ctcNPC.GetItemText( hSub ) == pSubsection->m_csName )
								{
									this->m_ctcNPC.SelectItem( hSub );
									for ( int i = 0; i < this->m_clcCreatures.GetItemCount(); i++ )
									{
										CSObject * pNPC = (CSObject *) this->m_clcCreatures.GetItemData(i);
										if ( pNPC == pSelection )
										{
											this->m_clcCreatures.SetItemState( i, LVIS_SELECTED, LVIS_SELECTED );
											this->m_clcCreatures.EnsureVisible( i, FALSE );
											this->m_pSearchCategory = pCategory;
											this->m_pSearchNPC = pNPC;
											this->m_pSearchSubsection = pSubsection;
											return;
										}
									}
									return;
								}
								hSub = this->m_ctcNPC.GetNextItem( hSub, TVGN_NEXT );
							}
						}
						hCat = this->m_ctcNPC.GetNextItem( hCat, TVGN_NEXT );
					}
					return;
				}
			}
			this->m_pSearchNPC = NULL;
		}
		this->m_pSearchSubsection = NULL;
	}
	AfxMessageBox("No matching item was found", MB_OK | MB_ICONINFORMATION);
}

void CSpawnTab::OnStkill() 
{
	SendToUO(".kill");
}

void CSpawnTab::OnChangeParams() 
{
	UpdateData();
	if ( !this->IsWindowVisible() )
		return;

	CString csAmount, csMinTime, csMaxTime, csHomedist, csDist;

	m_ceAmount.GetWindowText(csAmount);
	m_ceHomedist.GetWindowText(csHomedist);
	m_ceMaxDist.GetWindowText(csDist);
	m_ceMaxTime.GetWindowText(csMaxTime);
	m_ceMinTime.GetWindowText(csMinTime);

	Main->PutRegistryString("NPCSpawnAmount", csAmount);
	Main->PutRegistryString("NPCHomedist", csHomedist);
	Main->PutRegistryString("NPCSpawnMaxDist", csDist);
	Main->PutRegistryString("NPCSpawnMaxTime", csMaxTime);
	Main->PutRegistryString("NPCSpawnMinTime", csMinTime);
}

void CSpawnTab::FindPrevious()
{
	Find("", m_iSearchCrit, true);
	return;
}

void CSpawnTab::OnShrink() 
{
	SendToUO(".shrink");	
}

BOOL CSpawnTab::OnSetActive() 
{
	if ( Main->m_pScripts->m_iNCatSeq != m_iCatSeq )
		this->FillCategoryTree();

	if ( csUOPath != "" )
		m_Display.SetMulPath(csUOPath);

	CString csRegKey, csValue;
	csValue = Main->GetRegistryString("MulPath", "" );
	if ( csValue != "" )
		m_Display.SetMulPath(csValue);
	csRegKey.Format("Mul%ld", VERFILE_ANIM);
	csValue = Main->GetRegistryString(csRegKey, "");
	if ( csValue != "" )
		m_Display.SetCustomMulFile(VERFILE_ANIM, csValue);
	csRegKey.Format("Mul%ld", VERFILE_ANIMIDX);
	csValue = Main->GetRegistryString(csRegKey, "");
	if ( csValue != "" )
		m_Display.SetCustomMulFile(VERFILE_ANIMIDX, csValue);
	csRegKey.Format("Mul%ld", VERFILE_ANIM2);
	csValue = Main->GetRegistryString(csRegKey, "");
	if ( csValue != "" )
		m_Display.SetCustomMulFile(VERFILE_ANIM2, csValue);
	csRegKey.Format("Mul%ld", VERFILE_ANIMIDX2);
	csValue = Main->GetRegistryString(csRegKey, "");
	if ( csValue != "" )
		m_Display.SetCustomMulFile(VERFILE_ANIMIDX2, csValue);

	return CPropertyPage::OnSetActive();
}
