/*
 $Id: SPAWNTAB.H,v 1.6 2002/05/16 01:31:57 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

/**********************************************************************
 * Changes:
 *  - 7 May 2002 - PiotrBanasik
 *    + Added a shrink button
 *    + Rearranged a fair bit on the bottom to make it fit
 * 
 **********************************************************************/


//{{AFX_INCLUDES()
#include "uoart.h"
//}}AFX_INCLUDES
#if !defined(AFX_SPAWNTAB_H__DFB29CFC_D431_11D2_A613_004F4905E937__INCLUDED_)
#define AFX_SPAWNTAB_H__DFB29CFC_D431_11D2_A613_004F4905E937__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// SpawnTab.h : header file
//

#include "CNPC.h"

/////////////////////////////////////////////////////////////////////////////
// CSpawnTab dialog

class CSpawnTab : public CPropertyPage
{
	DECLARE_DYNCREATE(CSpawnTab)

// Construction
public:
	void LoadScripts();
	void Unload();
	void SelectTreeItem(CString csParent, CString csChild);
	void FillCategoryTree();
	void NPCEditor(bool bEditContext);
	static int CALLBACK CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	static int iIDSort;
	static int iNameSort;
	CSpawnTab();
	~CSpawnTab();

// Dialog Data
	//{{AFX_DATA(CSpawnTab)
	enum { IDD = IDD_SPAWN_TAB };
	CListCtrl	m_clcCreatures;
	CTreeCtrl	m_ctcNPC;
	CEdit	m_ceHomedist;
	CStatic	m_csNPCId;
	CEdit	m_ceMinTime;
	CEdit	m_ceMaxTime;
	CEdit	m_ceMaxDist;
	CEdit	m_ceAmount;
	CUOArt	m_Display;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CSpawnTab)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CString m_csSearchValue;
	int m_iSearchCrit;
	int m_iCatSeq;
	CCategory * m_pSearchCategory;
	CSubsection * m_pSearchSubsection;
	CSObject * m_pSearchNPC;
	void Find(CString csString = "", int iCrit = 0, bool bPrevious = false);
	void FindPrevious();
	// Generated message map functions
	//{{AFX_MSG(CSpawnTab)
	virtual BOOL OnInitDialog();
	afx_msg void OnSummon();
	afx_msg void OnPlaceSpawnpoint();
	afx_msg void OnInitSpawnpoint();
	afx_msg void OnSethome();
	afx_msg void OnSethomedist();
	afx_msg void OnSelchangedNpctree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnColumnclickCreaturelist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClickCreaturelist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemchangedCreaturelist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSpremove();
	afx_msg void OnSpfreeze();
	afx_msg void OnFindnpc();
	afx_msg void OnStkill();
	afx_msg void OnChangeParams();
	afx_msg void OnShrink();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SPAWNTAB_H__DFB29CFC_D431_11D2_A613_004F4905E937__INCLUDED_)
