/*
 $Id: SkillMenuEditDlg.cpp,v 1.5 2002/05/14 20:03:35 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// SkillMenuEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "SkillMenuEditDlg.h"
#include "RemoteConnection.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const char * RootMenus[] =
{
	"ALCHEMY",
	"BLACKSMITHING",
	"BOWCRAFT",
	"CARPENTRY",
	"CARTOGRAPHY",
	"INSCRIPTION",
	"MAGERY 40",
	"TAILORING",
	"TINKERING",
	"MAGERY 56",
	"COOKING",
	"BOWCRAFT 1",
};

/////////////////////////////////////////////////////////////////////////////
// CSkillMenuEditDlg dialog

CSkillMenuEditDlg::CSkillMenuEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSkillMenuEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSkillMenuEditDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
		m_bFileExists = false;
}


void CSkillMenuEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSkillMenuEditDlg)
	DDX_Control(pDX, IDOK, m_cbDlgOK);
	DDX_Control(pDX, IDCANCEL, m_cbDlgCancel);
	DDX_Control(pDX, IDC_DELETEENTRY, m_cbDeleteEntry);
	DDX_Control(pDX, IDC_EDITENTRY, m_cbEditEntry);
	DDX_Control(pDX, IDC_NEWOPTION, m_cbNewOption);
	DDX_Control(pDX, IDC_NEWSUBMENU, m_cbNewSubmenu);
	DDX_Control(pDX, IDC_REMOVERESOURCE, m_cbRemoveResource);
	DDX_Control(pDX, IDC_REMOVESKILL, m_cbRemoveSkill);
	DDX_Control(pDX, IDC_ADDRESOURCE, m_cbAddResource);
	DDX_Control(pDX, IDC_ADDSKILL, m_cbAddSkill);
	DDX_Control(pDX, IDC_CSTATIC, m_csStatic);
	DDX_Control(pDX, IDC_PCANCEL, m_cbCancel);
	DDX_Control(pDX, IDC_PDONE, m_cbDone);
	DDX_Control(pDX, IDC_DESCRIPTION, m_ceDescription);
	DDX_Control(pDX, IDC_COMMENTS, m_ceComments);
	DDX_Control(pDX, IDC_SKILLLIST, m_clbSkillList);
	DDX_Control(pDX, IDC_RESOURCELIST, m_clbResourceList);
	DDX_Control(pDX, IDC_SKILLVAL, m_ceSkillValue);
	DDX_Control(pDX, IDC_RESOURCEAMT, m_ceResourceAmount);
	DDX_Control(pDX, IDC_REPLICATE, m_cbReplicate);
	DDX_Control(pDX, IDC_MAKE, m_ccbOptions);
	DDX_Control(pDX, IDC_GRAPHIC, m_ccbGraphics);
	DDX_Control(pDX, IDC_SKILLS, m_ccbSkills);
	DDX_Control(pDX, IDC_RESOURCE, m_ccbResources);
	DDX_Control(pDX, IDC_SKILLTREE, m_ctcSkillTree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSkillMenuEditDlg, CDialog)
	//{{AFX_MSG_MAP(CSkillMenuEditDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_ADDRESOURCE, OnAddresource)
	ON_BN_CLICKED(IDC_REMOVERESOURCE, OnRemoveresource)
	ON_BN_CLICKED(IDC_ADDSKILL, OnAddskill)
	ON_BN_CLICKED(IDC_REMOVESKILL, OnRemoveskill)
	ON_BN_CLICKED(IDC_PDONE, OnPdone)
	ON_BN_CLICKED(IDC_NEWSUBMENU, OnNewsubmenu)
	ON_BN_CLICKED(IDC_NEWOPTION, OnNewoption)
	ON_BN_CLICKED(IDC_EDITENTRY, OnEditentry)
	ON_BN_CLICKED(IDC_DELETEENTRY, OnDeleteentry)
	ON_BN_CLICKED(IDC_PCANCEL, OnPcancel)
	ON_NOTIFY(TVN_SELCHANGED, IDC_SKILLTREE, OnSelchangedSkilltree)
	ON_BN_CLICKED(IDOK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSkillMenuEditDlg message handlers

BOOL CSkillMenuEditDlg::OnInitDialog() 
{
	CWaitCursor hourglass;
	CDialog::OnInitDialog();
	
	EnableParameters(FALSE);
	if ( Main->GetProfileType() == PROFILE_REMOTE )
		GetFiles();
	AddBaseMenus();
	FillSkills();
	FillResources();
	FillOptions();
	LoadSkillMenu();
	PopulateTree();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSkillMenuEditDlg::AddBaseMenus()
{
	// There are a few base menus we'll need to create.  One for each group that is handled in the
	// tusskill.scp file.
	
	HTREEITEM hItem;
	CSkillRootMenu * pGroup = NULL;
	// Alchemy
	pGroup = new (CSkillRootMenu);
	pGroup->m_csName = "Alchemy";
	pGroup->m_csInternalName = "ALCHEMY";
	pGroup->m_csSkillGroup = "ALCHEMY";
	hItem = m_ctcSkillTree.InsertItem(pGroup->m_csName, TVI_ROOT, TVI_LAST);
	m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup);
	m_oRootMenus.SetAtGrow(0, pGroup);
	// Blacksmithing
	pGroup = new (CSkillRootMenu);
	pGroup->m_csName = "Blacksmithing";
	pGroup->m_csInternalName = "BLACKSMITHING";
	pGroup->m_csSkillGroup = "BLACKSMITHING";
	hItem = m_ctcSkillTree.InsertItem(pGroup->m_csName, TVI_ROOT, TVI_LAST);
	m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup);
	m_oRootMenus.SetAtGrow(1, pGroup);
	// Bowcraft
	pGroup = new (CSkillRootMenu);
	pGroup->m_csName = "Bowcraft";
	pGroup->m_csInternalName = "BOWCRAFT";
	pGroup->m_csSkillGroup = "BOWCRAFT";
	hItem = m_ctcSkillTree.InsertItem(pGroup->m_csName, TVI_ROOT, TVI_LAST);
	m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup);
	m_oRootMenus.SetAtGrow(2, pGroup);
	// Fletching
	pGroup = new (CSkillRootMenu);
	pGroup->m_csName = "Fletching";
	pGroup->m_csInternalName = "BOWCRAFT 1";
	pGroup->m_csSkillGroup = "BOWCRAFT 1";
	hItem = m_ctcSkillTree.InsertItem(pGroup->m_csName, TVI_ROOT, TVI_LAST);
	m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup);
	m_oRootMenus.SetAtGrow(11, pGroup);
	// Carpentry
	pGroup = new (CSkillRootMenu);
	pGroup->m_csName = "Carpentry";
	pGroup->m_csInternalName = "CARPENTRY";
	pGroup->m_csSkillGroup = "CARPENTRY";
	hItem = m_ctcSkillTree.InsertItem(pGroup->m_csName, TVI_ROOT, TVI_LAST);
	m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup);
	m_oRootMenus.SetAtGrow(3, pGroup);
	// Cartography
	pGroup = new (CSkillRootMenu);
	pGroup->m_csName = "Cartography";
	pGroup->m_csInternalName = "CARTOGRAPHY";
	pGroup->m_csSkillGroup = "CARTOGRAPHY";
	hItem = m_ctcSkillTree.InsertItem(pGroup->m_csName, TVI_ROOT, TVI_LAST);
	m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup);
	m_oRootMenus.SetAtGrow(4, pGroup);
	// Inscription
	pGroup = new (CSkillRootMenu);
	pGroup->m_csName = "Inscription";
	pGroup->m_csInternalName = "INSCRIPTION";
	pGroup->m_csSkillGroup = "INSCRIPTION";
	hItem = m_ctcSkillTree.InsertItem(pGroup->m_csName, TVI_ROOT, TVI_LAST);
	m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup);
	m_oRootMenus.SetAtGrow(5, pGroup);
	// Magery
	pGroup = new (CSkillRootMenu);
	pGroup->m_csName = "Summoning";
	pGroup->m_csInternalName = "MAGERY 40";
	pGroup->m_csSkillGroup = "MAGERY 40";
	hItem = m_ctcSkillTree.InsertItem(pGroup->m_csName, TVI_ROOT, TVI_LAST);
	m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup);
	m_oRootMenus.SetAtGrow(6, pGroup);
	// Tailoring
	pGroup = new (CSkillRootMenu);
	pGroup->m_csName = "Tailoring";
	pGroup->m_csInternalName = "TAILORING";
	pGroup->m_csSkillGroup = "TAILORING";
	hItem = m_ctcSkillTree.InsertItem(pGroup->m_csName, TVI_ROOT, TVI_LAST);
	m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup);
	m_oRootMenus.SetAtGrow(7, pGroup);
	// Tinkering
	pGroup = new (CSkillRootMenu);
	pGroup->m_csName = "Tinkering";
	pGroup->m_csInternalName = "TINKERING";
	pGroup->m_csSkillGroup = "TINKERING";
	hItem = m_ctcSkillTree.InsertItem(pGroup->m_csName, TVI_ROOT, TVI_LAST);
	m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup);
	m_oRootMenus.SetAtGrow(8, pGroup);
	// Polymorph
	pGroup = new (CSkillRootMenu);
	pGroup->m_csName = "Polymorph";
	pGroup->m_csInternalName = "MAGERY 56";
	pGroup->m_csSkillGroup = "MAGERY 56";
	hItem = m_ctcSkillTree.InsertItem(pGroup->m_csName, TVI_ROOT, TVI_LAST);
	m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup);
	m_oRootMenus.SetAtGrow(9, pGroup);
	// Cooking
	pGroup = new (CSkillRootMenu);
	pGroup->m_csName = "Cooking";
	pGroup->m_csInternalName = "COOKING";
	pGroup->m_csSkillGroup = "COOKING";
	hItem = m_ctcSkillTree.InsertItem(pGroup->m_csName, TVI_ROOT, TVI_LAST);
	m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup);
	m_oRootMenus.SetAtGrow(10, pGroup);
}

CSkillMenuEditDlg::~CSkillMenuEditDlg()
{
}

void CSkillMenuEditDlg::OnDestroy() 
{
	CDialog::OnDestroy();

	m_ctcSkillTree.DeleteAllItems();
	for (int i = 0; i < m_oRootMenus.GetSize(); i++)
	{
		CSkillMenuGroup * pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(i);
		if ( pGroup )
			delete pGroup;
	}
	m_oRootMenus.RemoveAll();
}

void CSkillMenuEditDlg::FillResources()
{
	for (int i = 0; i < 43; i++)
	{
		int iSel = m_ccbResources.AddString(ResourceNames[i]);
		m_ccbResources.SetItemData(iSel, i);
	}
}

void CSkillMenuEditDlg::FillSkills()
{
	// Read the skill definitions from tustables.scp
	CString csScriptPath = GetScriptPath();
	CString csFile;
	if ( Main->GetProfileType() == PROFILE_REMOTE || csScriptPath == "" )
		csFile = Main->GetProfileType() == PROFILE_REMOTE ? RMT_TABLE_FILE : TABLE_FILE;
	else
		csFile.Format("%s%s", csScriptPath, TABLE_FILE);
	CStdioFile csfTables;
	if ( csfTables.Open( csFile, CFile::modeRead | CFile::shareDenyNone ) )
	{
		BOOL bStatus = TRUE;
		CString csLine, csUp;
		while ( bStatus )
		{
			if ( csLine == "" )
				bStatus = csfTables.ReadString(csLine);
			if ( !bStatus )
				break;
			csLine.TrimLeft();
			csUp = csLine;
			if (csUp.Find("[SKILL ") == 0)
			{
				while ( bStatus )
				{
					bStatus = csfTables.ReadString(csLine);
					csLine.TrimLeft();
					if ( csLine.Find("[") != -1 )
						break;
					csUp = csLine;
					csUp.MakeUpper();
					if (csUp.Find("KEY=") == 0)
					{
						CString csKey = csLine.Mid(4);
						this->m_ccbSkills.AddString(csKey);
						break;
					}
				}
			}
			else
				csLine = "";
		}
		csfTables.Close();
	}
	else
	{
		CString csMessage;
		csMessage.Format("Unable to open file %s", csFile);
		AfxMessageBox( csMessage, MB_OK | MB_ICONEXCLAMATION );
	}
}

void CSkillMenuEditDlg::FillOptions()
{
	// Read this info from the defs.
	CString csScriptPath = GetScriptPath();
	for ( int i = 0; i < 2; i++ )
	{
		CString csFile;
		switch (i)
		{
		case 0:
			if (csScriptPath == "")
				csFile = DEFS_FILE;
			else
				csFile.Format("%s%s", csScriptPath, DEFS_FILE);
			break;
		case 1:
			if ( Main->GetProfileType() == PROFILE_REMOTE || csScriptPath == "" )
				csFile = Main->GetProfileType() == PROFILE_REMOTE ? RMT_DEFS_FILE : USER_DEFS_FILE;
			else
				csFile.Format("%s%s", csScriptPath, USER_DEFS_FILE);
			break;
		}
		CStdioFile csfDefs;
		if ( csfDefs.Open(csFile, CFile::modeRead | CFile::shareDenyNone) )
		{
			BOOL bStatus = TRUE;
			CString csLine, csUp;
			while ( bStatus )
			{
				if ( csLine == "" )
					bStatus = csfDefs.ReadString(csLine);
				if ( !bStatus )
					break;
				csUp = csLine;
				csUp.MakeUpper();
				if ( csUp.Find("[ITEM") != -1 )
				{
					while ( bStatus )
					{
						bStatus = csfDefs.ReadString(csLine);
						if (!bStatus)
							break;
						if ( csLine.Find("[") != -1 )
							break;
						if ( csLine.Find("//") != -1 )
							csLine = csLine.Left(csLine.Find("//"));
						CString csName = csLine.SpanExcluding(" \t");
						CString csValue = "";
						if ( csName.GetLength() != csLine.GetLength() )
							csValue = csLine.Mid(csName.GetLength());
						csValue.TrimLeft();
						csValue.TrimRight();
						csValue = csValue.SpanExcluding("{");
						int iValue = 0;
						if (csValue == "")
							continue;
						if (csValue.GetAt(0) == '0')
							iValue = ahextoi(csValue);
						else
							iValue = atoi(csValue);
						if ( iValue > 0x8000 )
							continue;
						if ( m_ccbOptions.FindStringExact(-1, csName ) == -1 )
							this->m_ccbOptions.AddString(csName);
						if ( iValue < 0x4000 && m_ccbGraphics.FindStringExact(-1, csName) == -1 )
							this->m_ccbGraphics.AddString(csName);
					}
				}
				else
					csLine = "";
			}
			csfDefs.Close();
		}
		else
		{
			CString csMessage;
			csMessage.Format("Unable to open file %s", csFile);
			AfxMessageBox( csMessage, MB_OK | MB_ICONEXCLAMATION );
		}
	}
}

void CSkillMenuEditDlg::OnAddresource() 
{
	CString csAmount, csResource;
	m_ceResourceAmount.GetWindowText(csAmount);
	m_ccbResources.GetWindowText(csResource);
	if ( csResource == "" )
		return;
	CString csResourceString;
	int iSel = m_ccbResources.FindStringExact(-1, csResource);
	if ( iSel != -1 )
	{
		iSel = m_ccbResources.GetItemData(iSel);
		csResourceString.Format("%s %s", csAmount, Resources[iSel]);
	}
	else
	{
		if ( IsDef(csResource) )
			csResourceString.Format("%s %s", csAmount, csResource);
		else
			csResourceString.Format("%s,%s", csAmount, csResource);
	}
	m_clbResourceList.AddString(csResourceString);
}

void CSkillMenuEditDlg::OnRemoveresource() 
{
	int iSelCount = m_clbResourceList.GetSelCount();
	int * pSel = new int [iSelCount];
	m_clbResourceList.GetSelItems(iSelCount, pSel);
	for (int i = 0; i < iSelCount; i++)
		m_clbResourceList.DeleteString(pSel[i] - i);
	delete [] pSel;
}

void CSkillMenuEditDlg::OnAddskill() 
{
		CString csValue, csSkill;
		m_ceSkillValue.GetWindowText(csValue);
		m_ccbSkills.GetWindowText(csSkill);
		csValue.TrimLeft();
		csValue.TrimRight();
		if ( csValue == "" )
		{
			AfxMessageBox("Please enter a valid number in the skill value field.", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		if ( csValue.SpanIncluding("0123456789.") != csValue )
		{
			AfxMessageBox("Invalid data in the skill value field.  Please re-enter", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		CString csSkillString;
		csSkillString.Format("%s=%s", csSkill, csValue);
		m_clbSkillList.AddString(csSkillString);
}

void CSkillMenuEditDlg::OnRemoveskill() 
{
	int iSelCount = m_clbSkillList.GetSelCount();
	int * pSel = new int [iSelCount];
	m_clbSkillList.GetSelItems(iSelCount, pSel);
	for ( int i = 0; i < iSelCount; i++ )
		m_clbSkillList.DeleteString(pSel[i] - i);
	delete [] pSel;
}

void CSkillMenuEditDlg::FillGroupData(CSkillMenuGroup *pGroup)
{
	m_clbSkillList.ResetContent();
	m_clbResourceList.ResetContent();
	m_ccbOptions.SetWindowText("");
	m_ccbSkills.SetCurSel(-1);
	m_ccbGraphics.SetWindowText("");
	m_ccbResources.SetWindowText("");
	m_ceDescription.SetWindowText("");
	m_ceResourceAmount.SetWindowText("");
	m_ceSkillValue.SetWindowText("");
	m_cbReplicate.ShowWindow(SW_HIDE);
	m_ccbOptions.ShowWindow(SW_HIDE);
	m_csStatic.ShowWindow(SW_HIDE);
	m_cbReplicate.SetCheck(0);
	m_ceDescription.SetWindowText(pGroup->m_csName);
	m_ccbGraphics.SetWindowText(pGroup->m_csGraphic);
	for (int i = 0; i < pGroup->m_csaRestest.GetSize(); i++)
		m_clbResourceList.AddString(pGroup->m_csaRestest.GetAt(i) );
	for (i = 0; i < pGroup->m_csaSkillReqs.GetSize(); i++)
		m_clbSkillList.AddString(pGroup->m_csaSkillReqs.GetAt(i) );
	CString csComments;
	for (i = 0; i < pGroup->m_csaComments.GetSize(); i++)
	{
		if ( csComments == "" )
			csComments = pGroup->m_csaComments.GetAt(i);
		else
		{
			CString csTemp = csComments;
			csComments.Format("%s%c%c%s", csTemp, 0x0d, 0x0a, pGroup->m_csaComments.GetAt(i));
		}
	}
	m_ceComments.SetWindowText(csComments);
}

void CSkillMenuEditDlg::FillItemData(CSkillMenuItem *pItem)
{
	m_clbSkillList.ResetContent();
	m_clbResourceList.ResetContent();
	m_ccbOptions.SetWindowText("");
	m_ccbSkills.SetCurSel(-1);
	m_ccbGraphics.SetWindowText("");
	m_ccbResources.SetWindowText("");
	m_ceDescription.SetWindowText("");
	m_ceResourceAmount.SetWindowText("");
	m_ceSkillValue.SetWindowText("");
	if ( pItem->m_option_type == CSkillMenuItem::OPT_MAKEITEM )
	{
		m_cbReplicate.ShowWindow(SW_SHOW);
		this->m_cbReplicate.SetCheck(pItem->m_bReplicate);
	}
	else
	{
		m_cbReplicate.ShowWindow(SW_HIDE);
		this->m_cbReplicate.SetCheck(0);
	}
	m_ccbOptions.ShowWindow(SW_SHOW);
	m_csStatic.ShowWindow(SW_SHOW);
	switch ( pItem->m_option_type )
	{
	case CSkillMenuItem::OPT_SUMMON:
		m_csStatic.SetWindowText("Summon");
		break;
	case CSkillMenuItem::OPT_DRAWMAP:
		m_csStatic.SetWindowText("Detail Level");
		break;
	case CSkillMenuItem::OPT_POLY:
		m_csStatic.SetWindowText("Polymorph");
		break;
	case CSkillMenuItem::OPT_REPAIR:
		m_csStatic.SetWindowText("Repair");
		m_ccbOptions.ShowWindow(SW_HIDE);
		m_cbReplicate.ShowWindow(SW_HIDE);
		break;
	case CSkillMenuItem::OPT_MAKEITEM:
	default:
		m_csStatic.SetWindowText("Item to create");
		break;
	}
	m_ceDescription.SetWindowText(pItem->m_csName);
	m_ccbGraphics.SetWindowText(pItem->m_csGraphic);
	for (int i = 0; i < pItem->m_csaRestest.GetSize(); i++)
		m_clbResourceList.AddString(pItem->m_csaRestest.GetAt(i) );
	for (i = 0; i < pItem->m_csaSkillReqs.GetSize(); i++)
		m_clbSkillList.AddString(pItem->m_csaSkillReqs.GetAt(i) );
	CString csComments;
	for (i = 0; i < pItem->m_csaComments.GetSize(); i++)
	{
		if ( csComments == "" )
			csComments = pItem->m_csaComments.GetAt(i);
		else
		{
			CString csTemp = csComments;
			csComments.Format("%s%c%c%s", csTemp, 0x0d, 0x0a, pItem->m_csaComments.GetAt(i));
		}
	}
	this->m_ccbOptions.SetWindowText(pItem->m_csTarget);
	m_ceComments.SetWindowText(csComments);
}

bool CSkillMenuEditDlg::GetGroupData(CSkillMenuGroup *pGroup)
{
	// Validate the data
	CString csGraphic, csName;
	m_ccbGraphics.GetWindowText(csGraphic);
	m_ceDescription.GetWindowText(csName);
	if ( csGraphic == "" )
	{
		// Root menus without graphics are ok...others should get warnings.
		HTREEITEM hItem = this->m_ctcSkillTree.GetSelectedItem();
		if ( hItem != NULL )
		{
			if (this->m_ctcSkillTree.GetParentItem(hItem) != NULL)
			{
				if ( AfxMessageBox("This submenu has no graphic.  Is this what you had in mind?.", MB_YESNO | MB_ICONQUESTION) == IDNO )
					return false;
			}
		}
	}
	if ( csName == "" )
	{
		if ( AfxMessageBox("Are you sure you don't want a description for this menu?", MB_YESNO | MB_ICONQUESTION) == IDNO )
			return false;
	}
	// Save the data
	pGroup->m_csaComments.RemoveAll();
	pGroup->m_csaRestest.RemoveAll();
	pGroup->m_csaSkillReqs.RemoveAll();
	pGroup->m_csaComments.RemoveAll();
	pGroup->m_csGraphic = csGraphic;
	pGroup->m_csName = csName;
	CString csTemp;
	for (int i = 0; i < m_clbResourceList.GetCount(); i++ )
	{
		m_clbResourceList.GetText(i, csTemp);
		pGroup->m_csaRestest.Add(csTemp);
	}
	csTemp = "";
	for ( i = 0; i < m_clbSkillList.GetCount(); i++ )
	{
		m_clbSkillList.GetText(i, csTemp);
		pGroup->m_csaSkillReqs.Add(csTemp);
	}
	csTemp = "";
	for ( i = 0; i < m_ceComments.GetLineCount(); i++ )
	{
		m_ceComments.GetLine(i, csTemp.GetBuffer(csTemp.GetLength()));
		pGroup->m_csaComments.Add(csTemp);
	}
	return true;
}

bool CSkillMenuEditDlg::GetItemData(CSkillMenuItem *pItem)
{
	// Validate the data
	CString csGraphic, csName, csOption;
	m_ccbGraphics.GetWindowText(csGraphic);
	m_ceDescription.GetWindowText(csName);
	m_ccbOptions.GetWindowText(csOption);
	if ( csGraphic == "" )
	{
		if ( AfxMessageBox("This submenu has no graphic.  Is this what you had in mind?.", MB_YESNO | MB_ICONQUESTION) == IDNO )
			return false;
	}
	if ( csName == "" )
	{
		if ( AfxMessageBox("Are you sure you don't want a description for this menu?", MB_YESNO | MB_ICONQUESTION) == IDNO )
			return false;
	}
	if ( csOption == "" )
	{
		AfxMessageBox("You need to specify a result for this skill option", MB_OK | MB_ICONEXCLAMATION );
		return false;
	}
	// Save the data
	pItem->m_csaComments.RemoveAll();
	pItem->m_csaRestest.RemoveAll();
	pItem->m_csaSkillReqs.RemoveAll();
	pItem->m_csaComments.RemoveAll();
	pItem->m_csGraphic = csGraphic;
	pItem->m_csName = csName;
	pItem->m_csTarget = csOption;
	CString csTemp;
	for (int i = 0; i < m_clbResourceList.GetCount(); i++ )
	{
		m_clbResourceList.GetText(i, csTemp);
		pItem->m_csaRestest.Add(csTemp);
	}
	csTemp = "";
	for ( i = 0; i < m_clbSkillList.GetCount(); i++ )
	{
		m_clbSkillList.GetText(i, csTemp);
		pItem->m_csaSkillReqs.Add(csTemp);
	}
	csTemp = "";
	for ( i = 0; i < m_ceComments.GetLineCount(); i++ )
	{
		m_ceComments.GetLine(i, csTemp.GetBuffer(csTemp.GetLength()));
		pItem->m_csaComments.Add(csTemp);
	}
	return true;
}

void CSkillMenuEditDlg::EnableParameters(BOOL bEnable)
{
	m_cbReplicate.EnableWindow(bEnable);
	m_ccbGraphics.EnableWindow(bEnable);
	m_ccbOptions.EnableWindow(bEnable);
	m_ccbResources.EnableWindow(bEnable);
	m_ccbSkills.EnableWindow(bEnable);
	m_ceComments.EnableWindow(bEnable);
	m_ceDescription.EnableWindow(bEnable);
	m_ceResourceAmount.EnableWindow(bEnable);
	m_ceSkillValue.EnableWindow(bEnable);
	m_clbResourceList.EnableWindow(bEnable);
	m_clbSkillList.EnableWindow(bEnable);
	m_cbCancel.EnableWindow(bEnable);
	m_cbDone.EnableWindow(bEnable);
	m_cbAddResource.EnableWindow(bEnable);
	m_cbAddSkill.EnableWindow(bEnable);
	m_cbRemoveResource.EnableWindow(bEnable);
	m_cbRemoveSkill.EnableWindow(bEnable);
	m_cbNewOption.EnableWindow(!bEnable);
	m_cbNewSubmenu.EnableWindow(!bEnable);
	m_cbDeleteEntry.EnableWindow(!bEnable);
	m_cbEditEntry.EnableWindow(!bEnable);
	m_cbDlgCancel.EnableWindow(!bEnable);
	if ( m_bFileExists )
		m_cbDlgOK.EnableWindow(!bEnable);
	m_ctcSkillTree.EnableWindow(!bEnable);
}

void CSkillMenuEditDlg::OnPdone() 
{
	CSkillMenuGroup * pGroup = dynamic_cast <CSkillMenuGroup *> (m_pCurrentObject);
	if ( pGroup != NULL )
	{
		if ( !GetGroupData(pGroup) )
			return;
		EnableParameters(FALSE);
		if ( !m_bEditMode )
		{
			HTREEITEM hParent = this->m_ctcSkillTree.GetSelectedItem();
			CSkillMenuGroup * pParentGroup = (CSkillMenuGroup *) m_ctcSkillTree.GetItemData(hParent);
			pGroup->m_csSkillGroup = pParentGroup->m_csSkillGroup;
			// Assign an index to this guy.
			int iRootIndex = FindTable(pGroup->m_csSkillGroup, RootMenus, 12, sizeof(char*));
			if ( iRootIndex == -1 )
			{
				CString csMessage;
				csMessage.Format("Unable to locate root menu %s for this group.", pGroup->m_csSkillGroup);
				AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
				delete pGroup;
				return;
			}
			int iNewIndex = 0;
			CSkillRootMenu * pRoot = (CSkillRootMenu *) m_oRootMenus.GetAt(iRootIndex);
			if ( pRoot == NULL )
			{
				CString csMessage;
				csMessage.Format("Unable to locate root menu object %s for this group.", pGroup->m_csSkillGroup);
				AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
				delete pGroup;
				return;
			}
			for ( int i = 1; i < pRoot->m_oSubmenus.GetSize(); i++ )
			{
				if ( pRoot->m_oSubmenus.GetAt(i) == NULL )
				{
					iNewIndex = i;
					break;
				}
			}
			if ( iNewIndex == 0 )
				iNewIndex = pRoot->m_oSubmenus.GetUpperBound() + 1;
			pRoot->m_oSubmenus.SetAtGrow(iNewIndex, pGroup);
			pGroup->m_csInternalName.Format("%s %ld", pGroup->m_csSkillGroup, iNewIndex);
			// Stick this into the parent list.
			if ( pParentGroup->m_olChildren.IsEmpty() )
				pParentGroup->m_olChildren.AddHead(pGroup);
			else
				pParentGroup->m_olChildren.AddTail(pGroup);
			// Put it in the tree
			HTREEITEM hItem = this->m_ctcSkillTree.InsertItem( pGroup->m_csName, hParent, TVI_LAST );
			m_ctcSkillTree.SetItemData( hItem, (DWORD) pGroup );
		}
		return;
	}
	CSkillMenuItem * pItem = dynamic_cast <CSkillMenuItem *> (m_pCurrentObject);
	if ( pItem != NULL )
	{
		if ( !GetItemData(pItem) )
			return;
		EnableParameters(FALSE);
		if ( !m_bEditMode )
		{
			HTREEITEM hParent = this->m_ctcSkillTree.GetSelectedItem();
			CSkillMenuGroup * pParentGroup = (CSkillMenuGroup *) m_ctcSkillTree.GetItemData( hParent );
			if ( pParentGroup->m_olChildren.IsEmpty() )
				pParentGroup->m_olChildren.AddHead(pItem);
			else
				pParentGroup->m_olChildren.AddTail(pItem);
			HTREEITEM hItem = this->m_ctcSkillTree.InsertItem( pItem->m_csName, hParent, TVI_LAST );
			m_ctcSkillTree.SetItemData( hItem, (DWORD) pItem );
		}
		return;
	}
	// We shouldn't get here
	EnableParameters(FALSE);
	AfxMessageBox("Somehow, Axis lost track of the entry it was editing.", MB_OK | MB_ICONSTOP);
	return;
}

void CSkillMenuEditDlg::OnNewsubmenu() 
{
	m_bEditMode = false;	
	HTREEITEM hItem = this->m_ctcSkillTree.GetSelectedItem();
	CTObject * pObject = (CSObject *) m_ctcSkillTree.GetItemData(hItem);
	CSkillMenuGroup * pGroup = dynamic_cast <CSkillMenuGroup *> (pObject);
	if ( pGroup == NULL )
	{
		// This is an item...select its parent
		m_ctcSkillTree.SelectItem(m_ctcSkillTree.GetParentItem(hItem));
	}
	CSkillMenuGroup * pNewGroup = new (CSkillMenuGroup);
	m_pCurrentObject = pNewGroup;
	FillGroupData(pNewGroup);
	EnableParameters(TRUE);
}

void CSkillMenuEditDlg::OnNewoption() 
{
	m_bEditMode = false;	
	HTREEITEM hItem = this->m_ctcSkillTree.GetSelectedItem();
	CTObject * pObject = (CSObject *) m_ctcSkillTree.GetItemData(hItem);
	CSkillMenuGroup * pGroup = dynamic_cast <CSkillMenuGroup *> (pObject);
	if ( pGroup == NULL )
	{
		// This is an item...select its parent
		m_ctcSkillTree.SelectItem(m_ctcSkillTree.GetParentItem(hItem));
		pObject = (CSObject *) m_ctcSkillTree.GetItemData(hItem);
		pGroup = dynamic_cast <CSkillMenuGroup *> (pObject);
	}
	CSkillMenuItem * pNewItem = new (CSkillMenuItem);
	m_pCurrentObject = pNewItem;
	switch (FindTable(pGroup->m_csSkillGroup, RootMenus, 12, sizeof(char *)))
	{
	case 4:
		pNewItem->m_option_type = CSkillMenuItem::OPT_DRAWMAP;
		break;
	case 6:
		pNewItem->m_option_type = CSkillMenuItem::OPT_SUMMON;
		break;
	case 9:
		pNewItem->m_option_type = CSkillMenuItem::OPT_POLY;
		break;
	case 0:
	case 1:
	case 2:
	case 3:
	case 5:
	case 7:
	case 8:
	case 10:
	case 11:
	default:
		pNewItem->m_option_type = CSkillMenuItem::OPT_MAKEITEM;
		break;
	}
	FillItemData(pNewItem);
	EnableParameters(TRUE);	
}

void CSkillMenuEditDlg::OnEditentry() 
{
	m_bEditMode = true;
	HTREEITEM hItem = this->m_ctcSkillTree.GetSelectedItem();
	CSObject * pObject = (CSObject *) m_ctcSkillTree.GetItemData(hItem);
	m_pCurrentObject = pObject;
	CSkillMenuGroup * pGroup = dynamic_cast <CSkillMenuGroup *> (pObject);
	if ( pGroup )
	{
		FillGroupData(pGroup);
		EnableParameters(TRUE);
		return;
	}
	CSkillMenuItem * pItem = dynamic_cast <CSkillMenuItem *> (pObject);
	if ( pItem )
	{
		FillItemData(pItem);
		EnableParameters(TRUE);
		return;
	}
	m_pCurrentObject = NULL;

}

void CSkillMenuEditDlg::OnDeleteentry() 
{
	HTREEITEM hItem = this->m_ctcSkillTree.GetSelectedItem();
	if ( m_ctcSkillTree.GetParentItem(hItem) == NULL )
	{
		AfxMessageBox("You can't delete that menu", MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	CSObject * pObject = (CSObject *) m_ctcSkillTree.GetItemData(hItem);
	CSkillMenuGroup * pGroup = dynamic_cast <CSkillMenuGroup *> (pObject);
	if ( pGroup )
	{
		m_ctcSkillTree.DeleteItem(hItem);
		delete pGroup;
		return;
	}
	CSkillMenuItem * pItem = dynamic_cast <CSkillMenuItem *> (pObject);
	if ( pItem )
	{
		m_ctcSkillTree.DeleteItem(hItem);
		delete pItem;
		return;
	}
	// This shouldn't happen
	m_ctcSkillTree.DeleteItem(hItem);
	delete pObject;
}

void CSkillMenuEditDlg::OnPcancel() 
{
	if ( !m_bEditMode && m_pCurrentObject )
		delete m_pCurrentObject;
	EnableParameters(FALSE);
}

void CSkillMenuEditDlg::OnSelchangedSkilltree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	
	HTREEITEM hItem = m_ctcSkillTree.GetSelectedItem();
	CSObject * pObject = (CSObject *) m_ctcSkillTree.GetItemData(hItem);
	CSkillMenuGroup * pGroup = dynamic_cast <CSkillMenuGroup *> (pObject);
	if ( pGroup )
	{
		FillGroupData(pGroup);
		return;
	}
	CSkillMenuItem * pItem = dynamic_cast <CSkillMenuItem *> (pObject);
	if ( pItem )
	{
		FillItemData(pItem);
		return;
	}
	
	*pResult = 0;
}

void CSkillMenuEditDlg::LoadSkillMenu()
{
	CString csScriptPath = GetScriptPath();
	CString csFile;
	if ( Main->GetProfileType() == PROFILE_REMOTE || csScriptPath == "" )
		csFile = Main->GetProfileType() == PROFILE_REMOTE ? RMT_SKILL_FILE : SKILL_FILE;
	else
		csFile.Format("%s%s", csScriptPath, SKILL_FILE);
	CStdioFile csfFile;
	if ( csfFile.Open(csFile, CFile::modeRead | CFile::shareDenyNone) )
	{
		CString csLine;
		BOOL bStatus = TRUE;
		while ( bStatus )
		{
			if ( csLine == "" )
				bStatus = csfFile.ReadString(csLine);
			csLine.MakeUpper();
			if ( !bStatus )
				break;
			if ( csLine.Find("[") == -1 )
			{
				// This must be a comment or something.
				m_csaComments.Add(csLine);
				csLine = "";
			}
			else
			{
				// This is a new group.  Which one is it?
				CSkillMenuGroup * pGroup = NULL;
				CString csTemp = csLine.Mid(csLine.Find("[") + 1);
				csTemp = csTemp.SpanExcluding("]");
				csTemp.MakeUpper();
				// Is this one of the root menus?
				switch ( FindTable(csTemp, RootMenus, 12, sizeof(char *) ) )
				{
				case 0:	// Alchemy
					pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(0);
					break;
				case 1:	// Blacksmithing
					pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(1);
					break;
				case 2:	// Bowcraft
					pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(2);
					break;
				case 3: // Carpentry
					pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(3);
					break;
				case 4: // Cartography
					pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(4);
					break;
				case 5: // Inscription
					pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(5);
					break;
				case 6:	// Summoning
					pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(6);
					break;
				case 7:	// Tailoring
					pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(7);
					break;
				case 8:	// Tinkering
					pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(8);
					break;
				case 9:	// Polymorph
					pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(9);
					break;
				case 10:	// Cooking
					pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(10);
					break;
				case 11:	// Fletching
					pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(11);
					break;
				default:
					{
						// Not a root menu...what is the index of this guy?
						if ( csTemp.Find(" ") == -1 )
						{
							CString csMessage;
							csMessage.Format("Menu %s has no index, and is not a root menu.  It will not be loaded.", csTemp);
							AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
						}
						else
						{
							CString csIndex = csTemp.Mid(csTemp.Find(" ") + 1);
							int iIndex = atoi(csIndex);
							CSkillRootMenu * pRoot = NULL;
							CString csSkillGroup = csTemp.SpanExcluding(" ");
							if ( FindTable(csSkillGroup, RootMenus, 12, sizeof(char*)) != -1 )
								pRoot = (CSkillRootMenu *) m_oRootMenus.GetAt(FindTable(csSkillGroup, RootMenus, 12, sizeof(char*)));
							if ( pRoot == NULL )
							{
								CString csMessage;
								csMessage.Format("Could not determine the root group for menu %s.  This menu will not be loaded.", csTemp);
								AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
							}
							else
							{
								if ( pRoot->m_oSubmenus.GetUpperBound() >= iIndex)
								{
									// Does it comflict with an existing group?
									CSkillMenuGroup * pExistingGroup = (CSkillMenuGroup *) pRoot->m_oSubmenus.GetAt(iIndex);
									if ( pExistingGroup != NULL )
									{
										if ( pExistingGroup->m_csInternalName != csTemp )
										{
											CString csMessage;
											csMessage.Format("Duplicate index found.  Menu %s conflicts with menu %s.\n%s will not be loaded.", csTemp, pGroup->m_csInternalName, csTemp);
											AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
										}
										else
										{
											// This is our group.
											pGroup = pExistingGroup;
										}
									}
									else
									{
										// This group isn't linked anywhere yet.
										CString csMessage;
										csMessage.Format("Found a definition for skill menu %s before it has been declared.  The menu will not be loaded.", csTemp);
										AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
									}
								}
								else
								{
									// This group isn't linked anywhere yet.
									CString csMessage;
									csMessage.Format("Found a definition for skill menu %s before it has been declared.  The menu will not be loaded.", csTemp);
									AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
								}
							}
						}
					}
					break;
				}
				// Now read the group.
				while ( bStatus )
				{
					CString csSkillGroup = csTemp.SpanExcluding(" ");
					bStatus = csfFile.ReadString(csLine);
					csLine.MakeUpper();
					if ( !bStatus )
						break;
					if ( csLine.Find("[") != -1 )
						break;
					if ( pGroup == NULL )
						continue;	// We aren't reading this group.
					if ( csLine == "" )
						continue;
					if ( csLine.Find("//") == 0 )
					{
						pGroup->m_csaComments.Add(csLine);
						continue;
					}
					if ( csLine.Find("ONOPTION") == 0 )
					{
						// This is a new menu or item.  Which is it?  We'll find out later
						CStringArray csaTags;
						csaTags.RemoveAll();	// Make sure this gets cleaned out.
						csaTags.Add(csLine);
						while ( bStatus )
						{
							bStatus = csfFile.ReadString(csLine);
							csLine.MakeUpper();
							if ( !bStatus)
								break;
							csLine.TrimLeft();
							csLine.TrimRight();
							if (csLine == "" )
								break;
							if (csLine.Find("//") == 0)
								pGroup->m_csaComments.Add(csLine);
							else
								csaTags.Add(csLine);
							if (csLine.Find("SKILLMENU") == 0)
							{
								// This should be the last line
								CSkillMenuGroup * pNewGroup = new (CSkillMenuGroup);
								CString csIndex = csLine.Mid(csLine.Find("=") + 1);
								int iIndex = atoi(csIndex);
								CSkillRootMenu * pRoot = NULL;
								if ( FindTable(csSkillGroup, RootMenus, 12, sizeof(char*)) != -1 )
									pRoot = (CSkillRootMenu *) m_oRootMenus.GetAt(FindTable(csSkillGroup, RootMenus, 12, sizeof(char*)));
								if ( pRoot->m_oSubmenus.GetUpperBound() >= iIndex && pRoot->m_oSubmenus.GetAt(iIndex) != NULL )
								{
									CSkillMenuGroup * pExistingGroup = (CSkillMenuGroup*) pRoot->m_oSubmenus.GetAt(iIndex);
									CString csMessage;
									csMessage.Format("Skill Menu %s %s called from %s conflicts with existing menu %s", csSkillGroup, csIndex, pGroup->m_csInternalName, pExistingGroup->m_csInternalName);
									AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
									delete pNewGroup;
								}
								else
								{
									pRoot->m_oSubmenus.SetAtGrow(iIndex, pNewGroup);
									pNewGroup->m_csSkillGroup = csSkillGroup;
									pNewGroup->Read(&csaTags);
									if ( pGroup->m_olChildren.IsEmpty() )
										pGroup->m_olChildren.AddHead(pNewGroup);
									else
										pGroup->m_olChildren.AddTail(pNewGroup);
								}
								break;
							}
							if ( csLine.Find("MAKEITEM") == 0 ||
								csLine.Find("SUMMON") == 0 ||
								csLine.Find("DRAWMAP") == 0 ||
								csLine.Find("POLY") == 0 || 
								csLine.Find("REPAIR") == 0 )
							{
								// This is the last line
								CSkillMenuItem * pNewItem = new (CSkillMenuItem);
								pNewItem->Read(&csaTags);
								if ( pGroup->m_olChildren.IsEmpty() )
									pGroup->m_olChildren.AddHead(pNewItem);
								else
									pGroup->m_olChildren.AddTail(pNewItem);
							}
						}
					}
				}
			}
		}
		csfFile.Close();
		m_bFileExists = true;
	}
	else
	{
		CString csMessage;
		csMessage.Format("Unable to open file %s.  You will not be able to make modifications to the skill table.", csFile);
		AfxMessageBox(csMessage, MB_OK | MB_ICONSTOP);
		m_cbDlgOK.EnableWindow(FALSE);
		m_bFileExists = false;
	}
	return;
}

bool CSkillMenuEditDlg::SaveSkillMenu()
{
	return true;
}

void CSkillMenuEditDlg::GetFiles()
{
	CRemoteConnection remote;
	remote.GetCustomFile("grayskill");
	CFileStatus st;
	if ( !CFile::GetStatus(RMT_DEFS_FILE, st) )
		remote.GetCustomFile("graydefs");
	if ( !CFile::GetStatus(RMT_TABLE_FILE, st) )
		remote.GetCustomFile("graytables");
}

void CSkillMenuEditDlg::PopulateTree()
{
	HTREEITEM hRoot = m_ctcSkillTree.GetNextItem(NULL, TVGN_CHILD);
	if ( hRoot == NULL )
		return;
	HTREEITEM hChild = m_ctcSkillTree.GetNextItem(hRoot, TVGN_NEXT);
	while ( hChild != NULL)
	{
		CSkillMenuGroup * pGroup = (CSkillMenuGroup *) m_ctcSkillTree.GetItemData(hChild);
		if ( pGroup )
			PopulateMenu(hChild, pGroup);
		hChild = m_ctcSkillTree.GetNextItem(hChild, TVGN_NEXT);
	}
}

void CSkillMenuEditDlg::PopulateMenu(HTREEITEM hMenu, CSkillMenuGroup * pGroup)
{
	// Add the submenus
	POSITION pos = pGroup->m_olChildren.GetHeadPosition();
	while ( pos != NULL )
	{
		CSObject * pObject = (CSObject *) pGroup->m_olChildren.GetNext(pos);
		CSkillMenuGroup * pChildGroup = dynamic_cast <CSkillMenuGroup *> (pObject);
		if ( pChildGroup )
		{
			HTREEITEM hChild = m_ctcSkillTree.InsertItem(pChildGroup->m_csName, hMenu, TVI_LAST);
			m_ctcSkillTree.SetItemData(hChild, (DWORD) pChildGroup);
			PopulateMenu(hChild, pChildGroup);
			continue;
		}
		CSkillMenuItem * pChildItem = dynamic_cast <CSkillMenuItem *> (pObject);
		if ( pChildItem )
		{
			HTREEITEM hChild = m_ctcSkillTree.InsertItem(pChildItem->m_csName, hMenu, TVI_LAST);
			m_ctcSkillTree.SetItemData(hChild, (DWORD) pChildItem);
		}
	}
}

void CSkillMenuEditDlg::OnOk() 
{
	CWaitCursor hourglass;
	// Save the menus in a particular order
	// Summon, Poly, Alchemy, Inscription, Cartography, Bowcraft, Blacksmithing, Carpentry, Tailoring, Tinkering, Cooking
	//
	// Some of these can be saved with no special handling....others will need some tweaking
	CStdioFile csfOut;
	if ( !csfOut.Open(TMP_SKILL_FILE, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyWrite))
	{
		CString csMessage;
		char szPath[MAX_PATH];
		memset(&szPath[0], 0x00, sizeof(szPath) );
		getcwd(&szPath[0], sizeof(szPath));
		csMessage.Format("Unable to open temporary file %s%s for output.", szPath, TMP_SKILL_FILE);
		AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	for ( int i = 0; i < m_csaComments.GetSize(); i++ )
	{
		csfOut.WriteString(m_csaComments.GetAt(i));
		csfOut.WriteString("\n");
	}
	csfOut.WriteString("\n");
	// Summon Menu
	CSkillMenuGroup * pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(6);
	pGroup->WriteMenu(&csfOut);
	// Poly
	pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(9);
	pGroup->WriteMenu(&csfOut);
	// Alchemy
	pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(0);
	pGroup->WriteMenu(&csfOut);
	// Inscription
	pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(5);
	pGroup->WriteMenu(&csfOut);
	// Cartography
	pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(4);
	pGroup->WriteMenu(&csfOut);
	// Bowcraft -- needs to include fletching
	pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(2);
	CString csLine;
	csLine.Format("[%s]\n", pGroup->m_csInternalName);
	csfOut.WriteString(csLine);
	csLine.Format("%s\n\n", pGroup->m_csName);
	csfOut.WriteString(csLine);
	POSITION pos = pGroup->m_olChildren.GetHeadPosition();
	while ( pos != NULL )
	{
		CSObject * pObject = (CSObject *) pGroup->m_olChildren.GetNext(pos);
		CSkillMenuGroup * pSubMenu = dynamic_cast <CSkillMenuGroup *> (pObject);
		if ( pSubMenu != NULL )
		{
			pSubMenu->Write(&csfOut);
			continue;
		}
		CSkillMenuItem * pItem = dynamic_cast <CSkillMenuItem *> (pObject);
		if ( pItem != NULL )
		{
			pItem->Write(&csfOut);
			continue;
		}
	}
	CSkillMenuGroup * pFletch = (CSkillMenuGroup *) m_oRootMenus.GetAt(11);
	pFletch->WriteMenu(&csfOut);
	pos = pGroup->m_olChildren.GetHeadPosition();
	while ( pos != NULL )
	{
		CSObject * pObject = (CSObject *) pGroup->m_olChildren.GetNext(pos);
		CSkillMenuGroup * pSubMenu = dynamic_cast <CSkillMenuGroup *> (pObject);
		if ( pSubMenu != NULL )
			pSubMenu->WriteMenu(&csfOut);
	}
	// Blacksmithing
	pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(1);
	pGroup->WriteMenu(&csfOut);
	// Carpentry
	pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(3);
	pGroup->WriteMenu(&csfOut);
	// Tailoring
	pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(7);
	pGroup->WriteMenu(&csfOut);
	// Tinkering
	pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(8);
	pGroup->WriteMenu(&csfOut);
	// Cooking
	pGroup = (CSkillMenuGroup *) m_oRootMenus.GetAt(10);
	pGroup->WriteMenu(&csfOut);

	csfOut.Close();

	UpdateFiles( TMP_SKILL_FILE, SKILL_FILE, RMT_SKILL_FILE, "grayskill" );
	CDialog::OnOK();	
}
