/*
 $Id: SpawnGroupEditDlg.h,v 1.3 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_SPAWNGROUPEDITDLG_H__EEB0DC51_1DB8_11D3_871F_00805FD91B8C__INCLUDED_)
#define AFX_SPAWNGROUPEDITDLG_H__EEB0DC51_1DB8_11D3_871F_00805FD91B8C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SpawnGroupEditDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSpawnGroupEditDlg dialog

class CSpawnGroupEditDlg : public CDialog
{
// Construction
public:
	CString m_csName;
	CString m_csDescription;
	CString m_csSubsection;
	CString m_csCategory;
	DWORD m_dwID;
	CSpawnGroupEditDlg(CWnd* pParent = NULL);   // standard constructor
	static int CALLBACK CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	static int iIDSort;
	static int iNameSort;
	CTSpawnDef * m_pSpawn;
	virtual ~CSpawnGroupEditDlg();
protected:
	CDrewskyApp * m_pApp;


// Dialog Data
	//{{AFX_DATA(CSpawnGroupEditDlg)
	enum { IDD = IDD_SPAWNGROUP_EDIT_DLG };
	CEdit	m_ceName;
	CComboBox	m_ccbSpawnGroupEntry;
	CEdit	m_ceDescription;
	CComboBox	m_ccbSubsection;
	CComboBox	m_ccbCategory;
	CEdit	m_ceWeight;
	CListCtrl	m_clcSpawnGroupList;
	CListCtrl	m_clcNPCList;
	CTreeCtrl	m_ctcCategoryTree;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSpawnGroupEditDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void RetrieveFields();
	void PopulateFields();
	void FillCategoryList();
	void FillCategoryTree();

	// Generated message map functions
	//{{AFX_MSG(CSpawnGroupEditDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeSgcategory();
	afx_msg void OnSelchangedSgcategorytree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSgaddcategory();
	afx_msg void OnSgaddsubsection();
	afx_msg void OnSgadd();
	afx_msg void OnSgremove();
	virtual void OnOK();
	afx_msg void OnClickSgnpclist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkSgnpclist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKeydownSpawngrouplist(NMHDR* pNMHDR, LRESULT* pResult);
	virtual void OnCancel();
	afx_msg void OnSelchangeSgname();
	afx_msg void OnNewspawngroup();
	afx_msg void OnDblclkSpawngrouplist(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SPAWNGROUPEDITDLG_H__EEB0DC51_1DB8_11D3_871F_00805FD91B8C__INCLUDED_)
