/*
 $Id: StatRateEditDlg.cpp,v 1.4 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// StatRateEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "StatRateEditDlg.h"
#include "RemoteConnection.h"
#include "SpawnMessageDlg.h"
#include "RemoteConsole.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStatRateEditDlg dialog


CStatRateEditDlg::CStatRateEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStatRateEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStatRateEditDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CStatRateEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStatRateEditDlg)
	DDX_Control(pDX, IDOK, m_cbSave);
	DDX_Control(pDX, IDC_STR2, m_ceStr2);
	DDX_Control(pDX, IDC_STR1, m_ceStr1);
	DDX_Control(pDX, IDC_INT3, m_ceInt3);
	DDX_Control(pDX, IDC_INT2, m_ceInt2);
	DDX_Control(pDX, IDC_INT1, m_ceInt1);
	DDX_Control(pDX, IDC_DEX3, m_ceDex3);
	DDX_Control(pDX, IDC_DEX2, m_ceDex2);
	DDX_Control(pDX, IDC_DEX1, m_ceDex1);
	DDX_Control(pDX, IDC_STR3, m_ceStr3);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStatRateEditDlg, CDialog)
	//{{AFX_MSG_MAP(CStatRateEditDlg)
	ON_BN_CLICKED(IDOK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStatRateEditDlg message handlers

void CStatRateEditDlg::OnOk() 
{
	CWaitCursor hourglass;
	// Save the rates
	CString csS1, csS2, csS3, csI1, csI2, csI3, csD1, csD2, csD3;
	this->m_ceStr1.GetWindowText(csS1);
	this->m_ceStr2.GetWindowText(csS2);
	this->m_ceStr3.GetWindowText(csS3);
	this->m_ceInt1.GetWindowText(csI1);
	this->m_ceInt2.GetWindowText(csI2);
	this->m_ceInt3.GetWindowText(csI3);
	this->m_ceDex1.GetWindowText(csD1);
	this->m_ceDex2.GetWindowText(csD2);
	this->m_ceDex3.GetWindowText(csD3);
	int s1, s2, s3, i1, i2, i3, d1, d2, d3;
	s1 = atoi(csS1);
	s2 = atoi(csS2);
	s3 = atoi(csS3);
	i1 = atoi(csI1);
	i2 = atoi(csI2);
	i3 = atoi(csI3);
	d1 = atoi(csD1);
	d2 = atoi(csD2);
	d3 = atoi(csD3);
	if (s1 && s2 && s3 && i1 && i2 && i3 && d1 && d2 && d3)
	{
		Main->m_pScripts->m_tables.m_statAdvance[STAT_STR].m_Rate[0] = s1;
		Main->m_pScripts->m_tables.m_statAdvance[STAT_STR].m_Rate[1] = s2;
		Main->m_pScripts->m_tables.m_statAdvance[STAT_STR].m_Rate[2] = s3;
		Main->m_pScripts->m_tables.m_statAdvance[STAT_INT].m_Rate[0] = i1;
		Main->m_pScripts->m_tables.m_statAdvance[STAT_INT].m_Rate[1] = i2;
		Main->m_pScripts->m_tables.m_statAdvance[STAT_INT].m_Rate[2] = i3;
		Main->m_pScripts->m_tables.m_statAdvance[STAT_DEX].m_Rate[0] = d1;
		Main->m_pScripts->m_tables.m_statAdvance[STAT_DEX].m_Rate[1] = d2;
		Main->m_pScripts->m_tables.m_statAdvance[STAT_DEX].m_Rate[2] = d3;
		if ( !Main->m_pScripts->SaveTables() )
			return;
	}
	else
	{
		AfxMessageBox("Values for the rates can not be 0", MB_OK | MB_ICONSTOP);
		return;
	}
	CDialog::OnOK();
}

BOOL CStatRateEditDlg::OnInitDialog() 
{
	CWaitCursor hourglass;
	CDialog::OnInitDialog();

	Main->m_pScripts->LoadTables();

	CString csAdv;
	csAdv.Format("%ld", Main->m_pScripts->m_tables.m_statAdvance[STAT_STR].m_Rate[0]);
	this->m_ceStr1.SetWindowText(csAdv);
	csAdv.Format("%ld", Main->m_pScripts->m_tables.m_statAdvance[STAT_STR].m_Rate[1]);
	this->m_ceStr2.SetWindowText(csAdv);
	csAdv.Format("%ld", Main->m_pScripts->m_tables.m_statAdvance[STAT_STR].m_Rate[2]);
	this->m_ceStr3.SetWindowText(csAdv);
	csAdv.Format("%ld", Main->m_pScripts->m_tables.m_statAdvance[STAT_INT].m_Rate[0]);
	this->m_ceInt1.SetWindowText(csAdv);
	csAdv.Format("%ld", Main->m_pScripts->m_tables.m_statAdvance[STAT_INT].m_Rate[1]);
	this->m_ceInt2.SetWindowText(csAdv);
	csAdv.Format("%ld", Main->m_pScripts->m_tables.m_statAdvance[STAT_INT].m_Rate[2]);
	this->m_ceInt3.SetWindowText(csAdv);
	csAdv.Format("%ld", Main->m_pScripts->m_tables.m_statAdvance[STAT_DEX].m_Rate[0]);
	this->m_ceDex1.SetWindowText(csAdv);
	csAdv.Format("%ld", Main->m_pScripts->m_tables.m_statAdvance[STAT_DEX].m_Rate[1]);
	this->m_ceDex2.SetWindowText(csAdv);
	csAdv.Format("%ld", Main->m_pScripts->m_tables.m_statAdvance[STAT_DEX].m_Rate[2]);
	this->m_ceDex3.SetWindowText(csAdv);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
