/*
 $Id: SupportDlg.cpp,v 1.4 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// SupportDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "SupportDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSupportDlg dialog


CSupportDlg::CSupportDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSupportDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSupportDlg)
	m_csEmail = _T("");
	//}}AFX_DATA_INIT
}


void CSupportDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSupportDlg)
	DDX_Control(pDX, IDC_STATUS, m_csStatus);
	DDX_Control(pDX, IDC_REPLY_EMAIL, m_ceEmail);
	DDX_Control(pDX, IDC_PROBLEM_DESCRIPTION, m_ceProblem);
	DDX_Control(pDX, IDC_INCLUDE_LOGS, m_cbIncludeLogs);
	DDX_Text(pDX, IDC_REPLY_EMAIL, m_csEmail);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSupportDlg, CDialog)
	//{{AFX_MSG_MAP(CSupportDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSupportDlg message handlers

void CSupportDlg::OnOK() 
{
	CWaitCursor hourglass;
	Main->m_log.Add("Sending e-mail to support");
	UpdateData(TRUE);
	if ( m_csEmail == "" )
	{
		if (AfxMessageBox("If you don't include an e-mail address, the developers will not be able to contact you", MB_OKCANCEL) == IDCANCEL )
			return;
	}
	else
	{
		int at, dot, end;
		at = m_csEmail.Find("@");
		dot = m_csEmail.ReverseFind('.');
		end = m_csEmail.GetLength() - 1;
		if ( at == -1 || dot == -1 || (dot - at < 1) || (dot == end) )
		{
			if ( AfxMessageBox("The e-mail address is not valid...the developers will not be able to contact you", MB_OKCANCEL ) == IDCANCEL )
				return;
			m_csEmail = "";
		}
	}
	
	if ( m_csEmail == "" )
		m_csEmail = "anonymous@fingolfin.net";

	CString csMessage, csDescription;
	this->m_ceProblem.GetWindowText(csDescription);

	CSocket sock;
	sock.m_hSocket = socket(AF_INET, SOCK_STREAM, 0);
	setsockopt(sock.m_hSocket, SOL_SOCKET, SO_DONTLINGER, "1", 1);

	m_csStatus.SetWindowText("Connecting to server...");
	int result = sock.Connect("fingolfin.net", 25);
	if ( result == SOCKET_ERROR )
	{
		Main->m_log.Add("Unable to connect to support server");
		Main->m_log.Add("Error was %ld - %s", WSAGetLastError(), strerror(WSAGetLastError()) );
		sock.Close();
		AfxMessageBox("Unable to send message to support server.  Try again later", MB_OK);
		return;
	}
	int iCommand = 0;
	while ( iCommand < SMTP_QTY )
	{
		int i = 0;
		while ( i++ < 5000 )
		{
			FD_SET fd;
			FD_ZERO(&fd);
			FD_SET(sock.m_hSocket, &fd);
			struct timeval timeout;
			timeout.tv_sec = 0;
			timeout.tv_usec = 1000;
			int rc = select(sock.m_hSocket + 1, &fd, 0, 0, &timeout);
			if ( rc > 0 )
				break;
			if (rc < 0)
			{
				Main->m_log.Add("Socket error on select(): %ld - %s", WSAGetLastError(), strerror(WSAGetLastError()));
				break;
			}
		}
		char szBuffer[1024];
		memset(szBuffer, 0, sizeof(szBuffer));
		result = sock.Receive(&szBuffer[0], sizeof(szBuffer));
		if ( result == SOCKET_ERROR )
		{
			Main->m_log.Add("Socket error on Receive(): %ld - %s", WSAGetLastError(), strerror(WSAGetLastError()));
			break;
		}
		CString csMessage;
		int buflen = 0;
		switch (iCommand)
		{
		case SMTP_HELO:
			m_csStatus.SetWindowText("Initializing protocol...");
			csMessage.Format("HELO unknown axis user\n");
			result = sock.Send(csMessage, csMessage.GetLength() );
			buflen = csMessage.GetLength();
			break;
		case SMTP_MAIL:
			csMessage.Format("MAIL FROM: %s\n", m_csEmail);
			result = sock.Send(csMessage, csMessage.GetLength());
			buflen = csMessage.GetLength();
			break;
		case SMTP_RCPT:
			csMessage.Format("RCPT TO: %s\n", "devteam@fingolfin.net");
			result = sock.Send(csMessage, csMessage.GetLength() );
			buflen = csMessage.GetLength();
			break;
		case SMTP_DATA:
			csMessage.Format("DATA\n");
			result = sock.Send(csMessage, csMessage.GetLength() );
			buflen = csMessage.GetLength();
			break;
		case SMTP_SENDDATA:
			{
				m_csStatus.SetWindowText("Sending message...");
				csMessage.Format("Subject: Axis problem report\n\n");
				buflen = csMessage.GetLength();
				result = sock.Send(csMessage, buflen);
				if ( buflen != result )
					goto senderror;
				// Send the description.
				int iSent = 0;
				while ( iSent < csDescription.GetLength() )
				{
					char szData[1024];
					memset(&szData[0], 0x00, sizeof(szData));
					if ( csDescription.GetLength() - iSent < 1024 )
					{
						// send the rest now
						buflen = csDescription.GetLength() - iSent;
						strcpy(&szData[0], csDescription.Mid(iSent));
						result = sock.Send(&szData[0], buflen);
						if ( buflen != result )
							goto senderror;
					}
					else
					{
						// Send the next chunk
						strcpy(&szData[0], csDescription.Mid(iSent, 1024));
						buflen = 1024;
						result = sock.Send(&szData[0], 1024);
						if ( buflen != result )
							goto senderror;
					}
					iSent+=buflen;
					Sleep(10);
				}
				if ( m_cbIncludeLogs.GetCheck() )
				{
					// Send the logs
					for ( int i = 0; i < 2; i++ )
					{
						CStdioFile fLog;
						CString csFilename = i ? "axis.log" : "axis.log.old";
						if ( fLog.Open(csFilename, CFile::modeRead | CFile::typeText | CFile::shareDenyNone) )
						{
							csMessage.Format("\n\n-----------------Contents of %s------------------------\n\n", csFilename);
							result = sock.Send(csMessage, csMessage.GetLength());
							Sleep(10);
							if ( result != csMessage.GetLength() )
								goto senderror;
							int bytes = 1;
							while (bytes)
							{
								char szData[1024];
								memset(&szData[0], 0, sizeof(szData));
								bytes = fLog.Read(&szData[0], 1024);
								if ( bytes > 0 )
								{
									result = sock.Send(&szData[0], bytes);
									if ( result != bytes)
										goto senderror;
									Sleep(10);
								}
							}
							csMessage.Format("\n\n-----------------End of %s------------------------\n\n", csFilename);
							result = sock.Send(csMessage, csMessage.GetLength());
							buflen = csMessage.GetLength();
							fLog.Close();
						}
					}
				}
				csMessage.Format("%c%c.%c%c", 0x0d, 0x0a, 0x0d, 0x0a);
				result = sock.Send(csMessage, csMessage.GetLength());
				Sleep(10);
				buflen = csMessage.GetLength();
			}
			break;
		case SMTP_QUIT:
			m_csStatus.SetWindowText("Disconnecting...");
			result = sock.Send("QUIT\n", 5);
			buflen = 5;
			break;
		default:
			break;
		}
		if ( result != buflen )
		{
senderror:
			Main->m_log.Add("Error sending message to support server on command %ld.", iCommand);
			Main->m_log.Add("Error was %ld - %s", WSAGetLastError(), strerror(WSAGetLastError()));
			AfxMessageBox("Error sending message to support server. Try again later", MB_OK);
			break;
		}
		iCommand++;
	}

	shutdown(sock.m_hSocket, 2);
	closesocket(sock.m_hSocket);
	sock.m_hSocket = INVALID_SOCKET;
	m_csStatus.SetWindowText("Done");
	CDialog::OnOK();
}

BOOL CSupportDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	this->m_cbIncludeLogs.SetCheck(1);	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
