/*
 $Id: TemplateEditDlg.cpp,v 1.4 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// TemplateEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "TemplateEditDlg.h"
#include "LootItemEditDlg.h"
#include "SpawnMessageDlg.h"
#include "RemoteConnection.h"
#include "RemoteConsole.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTemplateEditDlg dialog


CTemplateEditDlg::CTemplateEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTemplateEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTemplateEditDlg)
	//}}AFX_DATA_INIT
	this->m_pSelectedTemplate = NULL;
	this->m_iType = 0;
	this->m_dwNextID = 500000;
	this->m_dwTemplateID = 0;
	m_bNew = false;
	m_bNewMode = false;
}


void CTemplateEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTemplateEditDlg)
	DDX_Control(pDX, IDC_TYPENORMAL, m_cbNormal);
	DDX_Control(pDX, IDC_TYPESELL, m_cbSell);
	DDX_Control(pDX, IDC_TYPEBUY, m_cbBuy);
	DDX_Control(pDX, IDCANCEL, m_cbCancel);
	DDX_Control(pDX, IDC_TMPL_NEW, m_cbNew);
	DDX_Control(pDX, IDC_TMPL_EDIT, m_cbEdit);
	DDX_Control(pDX, IDC_TMPL_CANCEL, m_cbCancelEdits);
	DDX_Control(pDX, IDC_TMPL_APPLY, m_cbApply);
	DDX_Control(pDX, IDC_TMPL_ADD, m_cbAddItem);
	DDX_Control(pDX, IDOK, m_cbSave);
	DDX_Control(pDX, IDC_TMPL_ID, m_ccbID);
	DDX_Control(pDX, IDC_TMPL_DEF, m_ceDef);
	DDX_Control(pDX, IDC_TMPL_ITEMLIST, m_clcItemList);
	DDX_Control(pDX, IDC_TMPL_ITEM, m_ccbItem);
	DDX_Control(pDX, IDC_TMPL_CONTAINER, m_ccbContainer);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTemplateEditDlg, CDialog)
	//{{AFX_MSG_MAP(CTemplateEditDlg)
	ON_BN_CLICKED(IDC_TMPL_ADD, OnTmplAdd)
	ON_NOTIFY(LVN_KEYDOWN, IDC_TMPL_ITEMLIST, OnKeydownTmplItemlist)
	ON_NOTIFY(NM_DBLCLK, IDC_TMPL_ITEMLIST, OnDblclkTmplItemlist)
	ON_CBN_SELCHANGE(IDC_TMPL_ID, OnSelchangeTmplId)
	ON_BN_CLICKED(IDC_TMPL_NEW, OnTmplNew)
	ON_BN_CLICKED(IDC_TYPEBUY, OnTypebuy)
	ON_BN_CLICKED(IDC_TYPESELL, OnTypesell)
	ON_BN_CLICKED(IDC_TYPENORMAL, OnTypenormal)
	ON_BN_CLICKED(IDC_TMPL_EDIT, OnTmplEdit)
	ON_BN_CLICKED(IDC_TMPL_APPLY, OnTmplApply)
	ON_BN_CLICKED(IDC_TMPL_CANCEL, OnTmplCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTemplateEditDlg message handlers

void CTemplateEditDlg::OnTmplAdd() 
{
	CNPCLootItem * pItem = new ( CNPCLootItem );
	this->m_ccbItem.GetWindowText( pItem->m_csName );
	int iIndex = this->m_clcItemList.InsertItem( this->m_clcItemList.GetItemCount(), pItem->m_csName );
	this->m_clcItemList.SetItemData( iIndex, (DWORD) pItem );
	if ( this->m_pSelectedTemplate != NULL && pItem != NULL )
	{
		if ( m_olItems.IsEmpty() )
			m_olItems.AddHead( pItem );
		else
			m_olItems.AddTail( pItem );
	}
}

BOOL CTemplateEditDlg::OnInitDialog() 
{
	CWaitCursor hourglass;
	CDialog::OnInitDialog();

	Main->m_pScripts->LoadDefs();
	Main->m_pScripts->LoadTemplates();
	// Main->m_pScripts->LoadItems();
	
	this->m_clcItemList.DeleteAllItems();
	this->m_clcItemList.InsertColumn(0, "Name", LVCFMT_LEFT, 120);
	this->m_clcItemList.InsertColumn(1, "Amount", LVCFMT_LEFT, 60);
	this->m_clcItemList.InsertColumn(2, "Chance", LVCFMT_LEFT, 50);
	this->m_clcItemList.InsertColumn(3, "Color", LVCFMT_LEFT, 75);

	FillContainers();
	FillItems();

	for ( int i = 0; i < Main->m_pScripts->m_aTemplates.GetSize(); i++ )
	{
		CTemplate * pTemplate = (CTemplate *) Main->m_pScripts->m_aTemplates.GetAt(i);
		if ( pTemplate )
		{
			CString csEntry;
			csEntry.Format("%s [%ld]", pTemplate->m_csDescription, pTemplate->m_dwID);
			int index = this->m_ccbID.AddString(csEntry);
			this->m_ccbID.SetItemData(index, (DWORD) pTemplate);
		}
	}
	if ( this->m_pSelectedTemplate  != NULL )
	{
		for (i = 0; this->m_ccbID.GetCount(); i++)
		{
			CTemplate * pTemplate = (CTemplate *) m_ccbID.GetItemData(i);
			if ( m_pSelectedTemplate == pTemplate )
			{
				this->m_ccbID.SetCurSel(i);
				this->OnSelchangeTmplId();
				this->OnTmplEdit();
				break;
			}
		}
	}
	else if ( m_bNewMode )
		this->OnTmplNew();
	else
	{
		if ( m_ccbID.GetCount() != 0 )
			this->m_ccbID.SetCurSel(0);
		this->OnSelchangeTmplId();
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTemplateEditDlg::OnKeydownTmplItemlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;
	// Check to see if this is the delete key
	if (pLVKeyDow->wVKey == VK_DELETE)
	{
		// Delete the selected items from the list control
		while (this->m_clcItemList.GetSelectedCount() > 0)
		{
			int iSel = this->m_clcItemList.GetNextItem(-1, LVNI_SELECTED);
			if (iSel != -1)
			{
				this->m_clcItemList.DeleteItem(iSel);
				CNPCLootItem * pItem = ( CNPCLootItem * ) this->m_clcItemList.GetItemData( iSel );
				// Find this one and remove it from the template's item list
				if ( pItem != NULL )
				{
					POSITION pos = this->m_pSelectedTemplate->m_olItemList.Find( pItem );
					if ( pos != NULL )
						this->m_pSelectedTemplate->m_olItemList.RemoveAt( pos );
					delete pItem;
				}
			}
		}
	}
	*pResult = 0;
}

void CTemplateEditDlg::OnDblclkTmplItemlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Edit this guy
	int iSel = this->m_clcItemList.GetNextItem(-1, LVNI_SELECTED);
	CLootItemEditDlg dlg;
	dlg.m_csName = this->m_clcItemList.GetItemText(iSel, 0);
	CString csRange = this->m_clcItemList.GetItemText(iSel, 1);
	if (csRange.Find("-") != -1)
	{
		dlg.m_csMin = csRange.Left(csRange.Find("-"));
		dlg.m_csMax = csRange.Mid(csRange.Find("-") + 1);
	}
	else
	{
		dlg.m_csMin = csRange;
		dlg.m_csMax = csRange;
	}
	CString csFreq = this->m_clcItemList.GetItemText(iSel, 2);
	if (csFreq != "")
		dlg.m_csFrequency = csFreq.Mid(csFreq.Find("1 in ") + 5);
	else
		dlg.m_csFrequency = "";
	dlg.m_csColor = this->m_clcItemList.GetItemText(iSel, 3);
	dlg.m_bNewbie = false;	// template items should never be newbied
	
	if (dlg.DoModal() == IDOK)
	{
		if (dlg.m_csMin == dlg.m_csMax)
			csRange = dlg.m_csMin;
		else
			csRange.Format("%s - %s", dlg.m_csMin, dlg.m_csMax);
		this->m_clcItemList.SetItemText(iSel, 1, csRange);
		if (dlg.m_csFrequency != "")
			csFreq.Format("1 in %s", dlg.m_csFrequency);
		else
			csFreq = "";
		this->m_clcItemList.SetItemText(iSel, 2, csFreq);
		this->m_clcItemList.SetItemText(iSel, 3, dlg.m_csColor);
		// We need to actually save this stuff...DUH!
		CNPCLootItem * pItem = (CNPCLootItem *) this->m_clcItemList.GetItemData(iSel);
		if (pItem != NULL)
		{
			pItem->m_csColor = dlg.m_csColor;
			pItem->m_iProbability = atoi(dlg.m_csFrequency);
			if (pItem->m_iProbability < 1)
				pItem->m_iProbability = 1;
			pItem->m_irAmount.max = atoi(dlg.m_csMax);
			pItem->m_irAmount.min = atoi(dlg.m_csMin);
		}
	}

	*pResult = 0;
}

void CTemplateEditDlg::OnSelchangeTmplId() 
{
	// Show the values for the new selection
	this->m_pSelectedTemplate = ( CTemplate * ) this->m_ccbID.GetItemData( this->m_ccbID.GetCurSel() );
	CopyItems(&(m_pSelectedTemplate->m_olItemList), &m_olItems);
	DisplayTemplate( this->m_pSelectedTemplate );
}

void CTemplateEditDlg::OnTmplNew() 
{
	// Save the changes for the current selection
	// Create a new one
	m_bNew = true;
	EnableWindows(true);
	this->m_pSelectedTemplate = new CTemplate;
	this->m_pSelectedTemplate->m_dwID = Main->m_pScripts->m_dwNextTemplate;
	CString csID;
	csID.Format("%06ld", m_pSelectedTemplate->m_dwID);
	int iIndex = this->m_ccbID.AddString(csID);
	m_ccbID.SetItemData( iIndex, (DWORD) m_pSelectedTemplate );
	DisplayTemplate( this->m_pSelectedTemplate );
}

CTemplateEditDlg::~CTemplateEditDlg()
{
	POSITION pos = m_olItems.GetHeadPosition();
	while ( pos )
	{
		CSObject * pObj = (CSObject *) m_olItems.GetNext(pos);
		if ( pObj )
			delete pObj;		
	}
}

void CTemplateEditDlg::OnOK() 
{
	CWaitCursor hourglass;
	// Update the template file.
	if ( !Main->m_pScripts->SaveTemplates() )
		return;
	Main->m_pScripts->RecategorizeItems();
	CDialog::OnOK();
}

void CTemplateEditDlg::UpdateTemplate(CTemplate *pTemplate)
{
	if ( pTemplate == NULL )
		return;
	pTemplate->m_bCustom = true;
	this->m_ceDef.GetWindowText( pTemplate->m_csDescription );
	CString csTemp;
	this->m_ccbContainer.GetWindowText( csTemp );
	pTemplate->m_dwContainerID = DefLookup( csTemp );
	if ( pTemplate->m_dwContainerID == 0 )
		pTemplate->m_csContainer = csTemp;
	CopyItems(&m_olItems, &(pTemplate->m_olItemList));
}

void CTemplateEditDlg::DisplayTemplate(CTemplate * pTemplate)
{
	if ( pTemplate == NULL )
		return;
	this->m_ceDef.SetWindowText( pTemplate->m_csDescription );
	CString csTemp;
	csTemp.Format("%ld", pTemplate->m_dwID );
	this->m_ccbID.SetWindowText( csTemp );
	if ( pTemplate->m_dwContainerID != 0 )
		csTemp.Format("%04x", pTemplate->m_dwContainerID );
	else
		csTemp.Format("%s", pTemplate->m_csContainer );
	this->m_ccbContainer.SetWindowText( csTemp );
	// Make copies of the items, becuase they get deleted when we update.
	this->m_clcItemList.DeleteAllItems();
	POSITION pos = m_olItems.GetHeadPosition();
	int iCount = 0;
	while ( pos != NULL )
	{
		CNPCLootItem * pItem = ( CNPCLootItem * ) m_olItems.GetNext( pos );
		if ( pItem != NULL )
		{
			if ( pItem->m_csWeight != "" )
				this->m_clcItemList.InsertItem( iCount, pItem->m_csWeight );
			else
			{
				this->m_clcItemList.InsertItem( iCount, pItem->m_csName );
				CString csAmount;
				if ( pItem->m_irAmount.min != pItem->m_irAmount.max )
					csAmount.Format("%ld - %ld", pItem->m_irAmount.min, pItem->m_irAmount.max );
				else
					csAmount.Format("%ld", pItem->m_irAmount.min );
				this->m_clcItemList.SetItemText( iCount, 1, csAmount );
				CString csTemp;
				if ( pItem->m_iProbability > 1 )
					csTemp.Format( "1 in %ld", pItem->m_iProbability );
				this->m_clcItemList.SetItemText( iCount, 2, csTemp );
				this->m_clcItemList.SetItemText( iCount, 3, pItem->m_csColor );
				this->m_clcItemList.SetItemData( iCount, (DWORD) pItem );
			}
			iCount++;
		}
	}
	switch ( pTemplate->m_iBuySell )
	{
	case -1:
		this->CheckRadioButton( IDC_TYPEBUY, IDC_TYPENORMAL, IDC_TYPESELL );
		break;
	case 0:
		this->CheckRadioButton( IDC_TYPEBUY, IDC_TYPENORMAL, IDC_TYPENORMAL );
		break;
	case 1:
		this->CheckRadioButton( IDC_TYPEBUY, IDC_TYPENORMAL, IDC_TYPEBUY );
		break;
	}

}

void CTemplateEditDlg::OnTypebuy() 
{
	if ( this->m_pSelectedTemplate != NULL )
		this->m_pSelectedTemplate->m_iBuySell = 1;
}

void CTemplateEditDlg::OnTypesell() 
{
	if ( this->m_pSelectedTemplate != NULL )
		this->m_pSelectedTemplate->m_iBuySell = -1;
}

void CTemplateEditDlg::OnTypenormal() 
{
	if ( this->m_pSelectedTemplate != NULL )
		this->m_pSelectedTemplate->m_iBuySell = 0;
}

void CTemplateEditDlg::FillContainers()
{
	for ( int i = 0; i < Main->m_pScripts->m_aDefs.GetSize(); i++ )
	{
		CDef * pDef = (CDef *) Main->m_pScripts->m_aDefs.GetAt(i);
		if ( pDef && pDef->m_csGroup.Find("CONTAINER") != -1 )
			this->m_ccbContainer.AddString(pDef->m_csValue);
	}
}

void CTemplateEditDlg::FillItems()
{
	for ( int i = 0; i < Main->m_pScripts->m_aDefs.GetSize(); i++ )
	{
		CDef * pDef = (CDef *) Main->m_pScripts->m_aDefs.GetAt(i);
		if ( pDef && pDef->m_csGroup.Find("ITEMS_") != -1 )
			this->m_ccbItem.AddString(pDef->m_csValue);
	}
}


void CTemplateEditDlg::OnTmplEdit() 
{
	m_bNew = false;
	EnableWindows(true);
}

void CTemplateEditDlg::EnableWindows(bool bEnable)
{
	this->m_cbAddItem.EnableWindow(bEnable);
	this->m_cbApply.ShowWindow(bEnable ? SW_SHOW : SW_HIDE);
	this->m_cbBuy.EnableWindow(bEnable);
	this->m_cbCancel.EnableWindow(!bEnable);
	this->m_cbCancelEdits.ShowWindow(bEnable ? SW_SHOW : SW_HIDE);
	this->m_cbEdit.EnableWindow(!bEnable);
	this->m_cbNew.EnableWindow(!bEnable);
	this->m_cbNormal.EnableWindow(bEnable);
	this->m_cbSave.EnableWindow(!bEnable);
	this->m_cbSell.EnableWindow(bEnable);
	this->m_ccbContainer.EnableWindow(bEnable);
	this->m_ccbID.EnableWindow(!bEnable);
	this->m_ccbItem.EnableWindow(bEnable);
	this->m_ceDef.EnableWindow(bEnable);
	this->m_clcItemList.EnableWindow(bEnable);
}

void CTemplateEditDlg::OnTmplApply() 
{
	UpdateTemplate( this->m_pSelectedTemplate );
	if ( m_bNew )
		Main->m_pScripts->m_aTemplates.Insert(m_pSelectedTemplate);
	EnableWindows(false);
}

void CTemplateEditDlg::OnTmplCancel() 
{
	if ( m_bNew )
	{
		delete m_pSelectedTemplate;
		m_pSelectedTemplate = NULL;
	}
	EnableWindows(false);
}

void CTemplateEditDlg::CopyItems(CPtrList * pSrc, CPtrList * pDst)
{
	if ( pSrc == NULL || pDst == NULL )
		return;
	// Clean out the destination list;
	POSITION pos = pDst->GetHeadPosition();
	while ( pos )
	{
		CNPCLootItem * pItem = (CNPCLootItem *) pDst->GetNext(pos);
		if ( pItem )
			delete pItem;
	}
	pDst->RemoveAll();
	pos = pSrc->GetHeadPosition();
	while ( pos )
	{
		CNPCLootItem * pItem = (CNPCLootItem *) pSrc->GetNext(pos);
		if ( !pItem )
			continue;
		CNPCLootItem * pNew = new (CNPCLootItem);
		pNew->Copy(pItem);
		if ( pDst->IsEmpty() )
			pDst->AddHead( pNew );
		else
			pDst->AddTail( pNew );
	}
	return;
}

void CTemplateEditDlg::OnCancel() 
{
	Main->m_pScripts->ReloadTemplates();
	Main->m_pScripts->RecategorizeItems();
	CDialog::OnCancel();
}
