/*
 $Id: TemplateEditDlg.h,v 1.3 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_TEMPLATEEDITDLG_H__32032641_4FFE_11D3_872C_00805FD91B8C__INCLUDED_)
#define AFX_TEMPLATEEDITDLG_H__32032641_4FFE_11D3_872C_00805FD91B8C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TemplateEditDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CTemplateEditDlg dialog

class CTemplateEditDlg : public CDialog
{
// Construction
public:
	DWORD m_dwTemplateID;
	void FillItems();
	void FillContainers();
	DWORD m_dwNextID;
	int m_iType;
	void DisplayTemplate( CTemplate * );
	CTemplate * m_pSelectedTemplate;
	void UpdateTemplate(CTemplate * pTemplate);
	virtual ~CTemplateEditDlg();
	CTemplateEditDlg(CWnd* pParent = NULL);   // standard constructor
	bool m_bNewMode;

// Dialog Data
	//{{AFX_DATA(CTemplateEditDlg)
	enum { IDD = IDD_TEMPLATEEDIT_DLG };
	CButton	m_cbNormal;
	CButton	m_cbSell;
	CButton	m_cbBuy;
	CButton	m_cbCancel;
	CButton	m_cbNew;
	CButton	m_cbEdit;
	CButton	m_cbCancelEdits;
	CButton	m_cbApply;
	CButton	m_cbAddItem;
	CButton	m_cbSave;
	CComboBox	m_ccbID;
	CEdit	m_ceDef;
	CListCtrl	m_clcItemList;
	CComboBox	m_ccbItem;
	CComboBox	m_ccbContainer;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTemplateEditDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void EnableWindows(bool bEnable);
	bool m_bNew;
	CPtrList m_olItems;
	void CopyItems(CPtrList * pSrc, CPtrList * pDst);

	// Generated message map functions
	//{{AFX_MSG(CTemplateEditDlg)
	afx_msg void OnTmplAdd();
	virtual BOOL OnInitDialog();
	afx_msg void OnKeydownTmplItemlist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkTmplItemlist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangeTmplId();
	afx_msg void OnTmplNew();
	virtual void OnOK();
	afx_msg void OnTypebuy();
	afx_msg void OnTypesell();
	afx_msg void OnTypenormal();
	afx_msg void OnTmplEdit();
	afx_msg void OnTmplApply();
	afx_msg void OnTmplCancel();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TEMPLATEEDITDLG_H__32032641_4FFE_11D3_872C_00805FD91B8C__INCLUDED_)
