/*
 $Id: TriggerEditDlg.cpp,v 1.5 2002/05/14 20:03:35 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// TriggerEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "TriggerEditDlg.h"
#include "SpawnMessageDlg.h"
#include "RemoteConnection.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTriggerEditDlg dialog


CTriggerEditDlg::CTriggerEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTriggerEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTriggerEditDlg)
	//}}AFX_DATA_INIT
	m_bSingleMode = true;
	m_iSel = -1;
	m_dwNextRegion = 65000;
	m_dwNextTrig = 1400;
}


void CTriggerEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTriggerEditDlg)
	DDX_Control(pDX, IDC_NEWREGIONTRIG, m_cbNewRegionTrig);
	DDX_Control(pDX, IDC_NEWTRIGGER, m_cbNewTrigger);
	DDX_Control(pDX, IDC_OLDCLIP, m_ceOldClip);
	DDX_Control(pDX, IDC_QUICKCLIP, m_ceQuickClip);
	DDX_Control(pDX, IDC_TOPERATORS, m_ccbOperators);
	DDX_Control(pDX, IDC_TRIGGEREDITBOX, m_ceTrigEdit);
	DDX_Control(pDX, IDC_TVERBS, m_ccbVerbs);
	DDX_Control(pDX, IDC_TEVALUATORS, m_ccbEvaluators);
	DDX_Control(pDX, IDC_TREFERENCES, m_ccbReferences);
	DDX_Control(pDX, IDC_TCONDITIONS, m_ccbConditions);
	DDX_Control(pDX, IDC_TATTRIBUTES, m_ccbAttributes);
	DDX_Control(pDX, IDC_TRIGGER_EVENT, m_ccbEvent);
	DDX_Control(pDX, IDC_TRIG_ID, m_ccbTriggerID);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTriggerEditDlg, CDialog)
	//{{AFX_MSG_MAP(CTriggerEditDlg)
	ON_BN_CLICKED(IDC_NEWTRIGGER, OnNewtrigger)
	ON_BN_CLICKED(IDOK, OnOk)
	ON_BN_CLICKED(IDC_INSRTATTR, OnInsrtattr)
	ON_BN_CLICKED(IDC_INSRTCOND, OnInsrtcond)
	ON_BN_CLICKED(IDC_INSRTEVAL, OnInsrteval)
	ON_BN_CLICKED(IDC_INSRTEVNT, OnInsrtevnt)
	ON_BN_CLICKED(IDC_INSRTREF, OnInsrtref)
	ON_BN_CLICKED(IDC_INSRTVERB, OnInsrtverb)
	ON_BN_CLICKED(IDC_INSRTOP, OnInsrtop)
	ON_CBN_SELCHANGE(IDC_TRIG_ID, OnSelchangeTrigId)
	ON_EN_CHANGE(IDC_TRIGGEREDITBOX, OnChangeTriggereditbox)
	ON_BN_CLICKED(IDC_NEWREGIONTRIG, OnNewregiontrig)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTriggerEditDlg message handlers

void CTriggerEditDlg::OnNewtrigger() 
{
	CString csID;
	csID.Format("TRIG %ld", m_dwNextTrig);
	CTrigger * pNewTrigger = new (CTrigger);
	pNewTrigger->m_csID = csID;
	pNewTrigger->m_bIsCustom = true;
	m_dwNextTrig++;
	int iIndex = this->m_ccbTriggerID.AddString( csID );
	this->m_ccbTriggerID.SetItemDataPtr( iIndex, (void *) pNewTrigger );
	this->m_ccbTriggerID.SelectString( -1, csID );	
}

void CTriggerEditDlg::OnOk() 
{
	if ( this->m_bSingleMode )
	{
		CDialog::OnOK();
		return;
	}
	// Save all of the triggers.
	CStdioFile csfTriggers;
	if (csfTriggers.Open( TMP_TRIGGER_FILE, CFile::modeWrite | CFile::modeCreate | CFile::shareDenyNone ) )
	{
		for ( int i = 0; i < this->m_ccbTriggerID.GetCount(); i++ )
		{
			CTrigger * pTrigger = (CTrigger *) this->m_ccbTriggerID.GetItemDataPtr( i );
			if ( pTrigger && pTrigger->m_bIsCustom )
			{
				CString csLine;
				csLine.Format("[%s]\n", pTrigger->m_csID );
				csfTriggers.WriteString(csLine);
				for ( int j = 0; j <= pTrigger->m_csaEvents.GetUpperBound(); j++ )
				{
					csLine.Format("%s\n", pTrigger->m_csaEvents.GetAt(j));
					csfTriggers.WriteString(csLine);
				}
				csfTriggers.WriteString("\n");
			}
		}
	}
	csfTriggers.Close();
	UpdateFiles( TMP_TRIGGER_FILE, USER_TRIGGER_FILE, RMT_TRIGGER_FILE, "graytrig" );
	CDialog::OnOK();
}

BOOL CTriggerEditDlg::OnInitDialog() 
{
	CWaitCursor hourglass;
	CDialog::OnInitDialog();
	
	FillEvents();
	FillEvaluators();
	FillAttributes();
	FillVerbs();
	FillReferences();
	FillConditions();

	if ( this->m_bSingleMode )
	{
		// don't read the tustrig.scp file
		// fill the edit box with the stuff from the trigger
		if ( m_pCurrentTrigger )
		{
			for ( int i = 0; i <= this->m_pCurrentTrigger->m_csaEvents.GetUpperBound(); i++ )
			{
				CString csTrigger;
				for ( int i = 0; i <= m_pCurrentTrigger->m_csaEvents.GetUpperBound(); i++ )
				{
					CString csTemp = csTrigger;
					if ( csTrigger != "" )
						csTemp.Format("%s%c%c%s", csTrigger, 0x0d, 0x0a, m_pCurrentTrigger->m_csaEvents.GetAt(i));
					else
						csTemp.Format("%s", m_pCurrentTrigger->m_csaEvents.GetAt(i));
					csTrigger = csTemp;
				}
				this->m_ceTrigEdit.SetWindowText(csTrigger);
			}
		}
		this->m_ccbTriggerID.ShowWindow( SW_HIDE );
		this->m_cbNewTrigger.ShowWindow( SW_HIDE );
		this->m_cbNewRegionTrig.ShowWindow( SW_HIDE );
	}
	else
	{
		// read the files from the trigger scripts
		CStdioFile csfTrigFile;
		CString csScpPath = GetScriptPath();
		CString csFile;
		if ( Main->GetProfileType() == PROFILE_REMOTE || csScpPath == "" )
			csFile = TRIGGER_FILE;
		else
			csFile.Format("%s%s", csScpPath, TRIGGER_FILE);
		if (csfTrigFile.Open( csFile, CFile::modeRead | CFile::shareDenyNone ))
		{
			ReadFile( &csfTrigFile, false );
			csfTrigFile.Close();
		}
		if ( Main->GetProfileType() == PROFILE_REMOTE )
		{
			CRemoteConnection remote;
			remote.GetCustomFile("graytrig");
		}
		if ( Main->GetProfileType() == PROFILE_REMOTE || csScpPath == "" )
			csFile = Main->GetProfileType() == PROFILE_REMOTE ? RMT_TRIGGER_FILE : USER_TRIGGER_FILE;
		else
			csFile.Format("%s%s", csScpPath, USER_TRIGGER_FILE);

		if (csfTrigFile.Open( csFile, CFile::modeRead | CFile::shareDenyNone ) )
		{
			ReadFile( &csfTrigFile, true );
			csfTrigFile.Close();
		}
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTriggerEditDlg::FillEvents()
{
	this->m_ccbEvent.AddString("DAMAGE");
	this->m_ccbEvent.AddString("DCLICK");
	this->m_ccbEvent.AddString("DROPON_CHAR");
	this->m_ccbEvent.AddString("DROPON_GROUND");
	this->m_ccbEvent.AddString("DROPON_ITEM");
	this->m_ccbEvent.AddString("DROPON_TYPE");
	this->m_ccbEvent.AddString("EQUIP");
	this->m_ccbEvent.AddString("HEAR");
	this->m_ccbEvent.AddString("PICKUP_GROUND");
	this->m_ccbEvent.AddString("PICKUP_PACK");
	this->m_ccbEvent.AddString("SPELL");
	this->m_ccbEvent.AddString("STEP");
	this->m_ccbEvent.AddString("TARGON_CHAR");
	this->m_ccbEvent.AddString("TARGON_GROUND");
	this->m_ccbEvent.AddString("TARGON_ITEM");
	this->m_ccbEvent.AddString("TARGON_TYPE");
	this->m_ccbEvent.AddString("TIMER");
	this->m_ccbEvent.AddString("UNEQUIP");
}

void CTriggerEditDlg::FillAttributes()
{
	// CObjBase stuff
	m_ccbAttributes.AddString("TYPEDEF");
	m_ccbAttributes.AddString("NAME");
	m_ccbAttributes.AddString("TIMER");
	m_ccbAttributes.AddString("COLOR");
	m_ccbAttributes.AddString("UID");
	m_ccbAttributes.AddString("P");
	m_ccbAttributes.AddString("Z");
	// CItem stuff
	m_ccbAttributes.AddString("ID");
	m_ccbAttributes.AddString("AMOUNT");
	m_ccbAttributes.AddString("TYPE");
	m_ccbAttributes.AddString("ATTR");
	m_ccbAttributes.AddString("LINK");
	m_ccbAttributes.AddString("MORE1");
	m_ccbAttributes.AddString("MORE2");
	m_ccbAttributes.AddString("MOREP");
	m_ccbAttributes.AddString("MOREX");
	m_ccbAttributes.AddString("MOREY");
	m_ccbAttributes.AddString("MOREZ");
	m_ccbAttributes.AddString("HITPOINTS");
	m_ccbAttributes.AddString("FRUIT");
	// CChar stuff
	m_ccbAttributes.AddString("DIR");
	m_ccbAttributes.AddString("BODY");
	m_ccbAttributes.AddString("XBODY");
	m_ccbAttributes.AddString("XSKIN");
	m_ccbAttributes.AddString("HOME");
	m_ccbAttributes.AddString("FONT");
	m_ccbAttributes.AddString("FLAGS");
	m_ccbAttributes.AddString("ACTION");
	m_ccbAttributes.AddString("TITLE");
	m_ccbAttributes.AddString("HITS");
	m_ccbAttributes.AddString("STAMINA");
	m_ccbAttributes.AddString("MANA");
	m_ccbAttributes.AddString("FOOD");
	m_ccbAttributes.AddString("CREATE");
	m_ccbAttributes.AddString("ACTARG1");
	m_ccbAttributes.AddString("ACTARG2");
	m_ccbAttributes.AddString("STR");
	m_ccbAttributes.AddString("DEX");
	m_ccbAttributes.AddString("INT");
	m_ccbAttributes.AddString("KARMA");
	m_ccbAttributes.AddString("FAME");
	m_ccbAttributes.AddString("KILLS");
	// Skills...ugh
}

void CTriggerEditDlg::FillVerbs()
{
	// CObjBase stuff
	m_ccbVerbs.AddString("REMOVE");
	m_ccbVerbs.AddString("MESSAGE");
	m_ccbVerbs.AddString("SPEAK");
	m_ccbVerbs.AddString("SOUND");
	m_ccbVerbs.AddString("EFFECT");
	m_ccbVerbs.AddString("FIX");
	m_ccbVerbs.AddString("FLIP");
	m_ccbVerbs.AddString("SHOW");
	m_ccbVerbs.AddString("MOVE");
	m_ccbVerbs.AddString("SPELLEFFECT");
	m_ccbVerbs.AddString("EDIT");
	m_ccbVerbs.AddString("NUDGEUP");
	m_ccbVerbs.AddString("NUDGEDOWN");
	// CItem stuff
	m_ccbVerbs.AddString("DUPE");
	m_ccbVerbs.AddString("BOUNCE");
	// CChar stuff
	m_ccbVerbs.AddString("DAMAGE");
	m_ccbVerbs.AddString("POLY");
	m_ccbVerbs.AddString("RESURRECT");
	m_ccbVerbs.AddString("GO");
	m_ccbVerbs.AddString("GOUID");
	m_ccbVerbs.AddString("GOCHAR");
	m_ccbVerbs.AddString("GOSOCK");
	m_ccbVerbs.AddString("GOCLI");
	m_ccbVerbs.AddString("JAIL");
	m_ccbVerbs.AddString("KICK");
	m_ccbVerbs.AddString("KILL");
	m_ccbVerbs.AddString("GHOST");
	m_ccbVerbs.AddString("NEWITEM");
	m_ccbVerbs.AddString("COUNT");
	m_ccbVerbs.AddString("CONSUME");
	m_ccbVerbs.AddString("SUMMONCAGE");
	m_ccbVerbs.AddString("ANIM");
	m_ccbVerbs.AddString("SLEEP");
	m_ccbVerbs.AddString("FACE");
	m_ccbVerbs.AddString("DISCONNECT");
	m_ccbVerbs.AddString("ALLSKILLS");
	m_ccbVerbs.AddString("BANK");
	m_ccbVerbs.AddString("SELL");
	m_ccbVerbs.AddString("BUY");
	m_ccbVerbs.AddString("BYE");
	m_ccbVerbs.AddString("BOW");
	m_ccbVerbs.AddString("SALUTE");
	m_ccbVerbs.AddString("ATTACK");
	m_ccbVerbs.AddString("DRAWMAP");
	m_ccbVerbs.AddString("EMOTE");
	m_ccbVerbs.AddString("SKILL");
	m_ccbVerbs.AddString("INVUL");
	m_ccbVerbs.AddString("INVIS");
	m_ccbVerbs.AddString("SHRINK");
	m_ccbVerbs.AddString("FORGIVE");
	m_ccbVerbs.AddString("UNDERWEAR");
	m_ccbVerbs.AddString("PETSTABLE");
	m_ccbVerbs.AddString("PETRETRIEVE");
	m_ccbVerbs.AddString("SUMMONTO");
	m_ccbVerbs.AddString("HUNGRY");
	m_ccbVerbs.AddString("WHERE");
	m_ccbVerbs.AddString("SUICIDE");
	// CClient stuff
	m_ccbVerbs.AddString("SET");
	m_ccbVerbs.AddString("GMMENU");
	m_ccbVerbs.AddString("ITEMMENU");
	m_ccbVerbs.AddString("WEBLINK");
	m_ccbVerbs.AddString("SYSMESSAGE");
	m_ccbVerbs.AddString("GMPAGE");
	m_ccbVerbs.AddString("VERSION");
	m_ccbVerbs.AddString("INFORMATION");
	m_ccbVerbs.AddString("ADDITEM");
	m_ccbVerbs.AddString("ADDNPC");
	m_ccbVerbs.AddString("SUMMON");
	m_ccbVerbs.AddString("REPAIR");
	m_ccbVerbs.AddString("PRIVSHOW");
	m_ccbVerbs.AddString("GOTARG");
	m_ccbVerbs.AddString("ALLMOVE");
	m_ccbVerbs.AddString("DEBUG");
	m_ccbVerbs.AddString("LISTEN");
	m_ccbVerbs.AddString("HEARALL");
	m_ccbVerbs.AddString("GM");
	m_ccbVerbs.AddString("DETAIL");
	m_ccbVerbs.AddString("BANKSELF");
	m_ccbVerbs.AddString("RESEND");
	m_ccbVerbs.AddString("CAST");
	m_ccbVerbs.AddString("TELE");
	m_ccbVerbs.AddString("STATIC");
	m_ccbVerbs.AddString("RETURN 0");
	m_ccbVerbs.AddString("RETURN 1");
}

void CTriggerEditDlg::FillEvaluators()
{
	m_ccbEvaluators.AddString("==");
	m_ccbEvaluators.AddString("&&");
	m_ccbEvaluators.AddString("||");
	m_ccbEvaluators.AddString("!=");
	m_ccbEvaluators.AddString(">");
	m_ccbEvaluators.AddString("<");
	m_ccbEvaluators.AddString(">=");
	m_ccbEvaluators.AddString("<=");
}

void CTriggerEditDlg::FillReferences()
{
	m_ccbReferences.AddString("LINK.");
	m_ccbReferences.AddString("REGION.");
	m_ccbReferences.AddString("ACT.");
	m_ccbReferences.AddString("TARG.");
	m_ccbReferences.AddString("SRC.");
}

void CTriggerEditDlg::FillConditions()
{
	m_ccbConditions.AddString("IF");
	m_ccbConditions.AddString("ELSEIF");
	m_ccbConditions.AddString("ELSE");
	m_ccbConditions.AddString("ENDIF");
	m_ccbConditions.AddString("DORAND");
	m_ccbConditions.AddString("ENDDO");
}

void CTriggerEditDlg::OnInsrtattr() 
{
	CString csAttr;
	this->m_ccbAttributes.GetWindowText(csAttr);
	this->m_ceQuickClip.SetWindowText(csAttr);
	this->m_ceQuickClip.SetSel(0, -1);
	this->m_ceQuickClip.Copy();
	this->m_ceTrigEdit.Paste();
}

void CTriggerEditDlg::OnInsrtcond() 
{
	SaveClipboard();
	CString csCond;
	this->m_ccbConditions.GetWindowText(csCond);
	this->m_ceQuickClip.SetWindowText(csCond);
	this->m_ceQuickClip.SetSel(0, -1);
	this->m_ceQuickClip.Copy();
	this->m_ceTrigEdit.Paste();
	RestoreClipboard();
}

void CTriggerEditDlg::OnInsrteval() 
{
	SaveClipboard();
	CString csEval;
	this->m_ccbEvaluators.GetWindowText(csEval);
	this->m_ceQuickClip.SetWindowText(csEval);
	this->m_ceQuickClip.SetSel(0, -1);
	this->m_ceQuickClip.Copy();
	this->m_ceTrigEdit.Paste();
	RestoreClipboard();
}

void CTriggerEditDlg::OnInsrtevnt() 
{
	SaveClipboard();
	CString csEvnt, csText;
	this->m_ccbEvent.GetWindowText(csEvnt);
	csText.Format("ONTRIGGER=%s", csEvnt);
	this->m_ceQuickClip.SetWindowText(csText);
	this->m_ceQuickClip.SetSel(0, -1);
	this->m_ceQuickClip.Copy();
	this->m_ceTrigEdit.Paste();
	RestoreClipboard();
}

void CTriggerEditDlg::OnInsrtref() 
{
	SaveClipboard();
	CString csRef;
	this->m_ccbReferences.GetWindowText(csRef);
	this->m_ceQuickClip.SetWindowText(csRef);
	this->m_ceQuickClip.SetSel(0, -1);
	this->m_ceQuickClip.Copy();
	this->m_ceTrigEdit.Paste();
	RestoreClipboard();
}

void CTriggerEditDlg::OnInsrtverb() 
{
	SaveClipboard();
	CString csVerb;
	this->m_ccbVerbs.GetWindowText(csVerb);
	this->m_ceQuickClip.SetWindowText(csVerb);
	this->m_ceQuickClip.SetSel(0, -1);
	this->m_ceQuickClip.Copy();
	this->m_ceTrigEdit.Paste();
	RestoreClipboard();
}

void CTriggerEditDlg::OnInsrtop() 
{	
	SaveClipboard();
	CString csOp;
	this->m_ccbOperators.GetWindowText(csOp);
	this->m_ceQuickClip.SetWindowText(csOp);
	this->m_ceQuickClip.SetSel(0, -1);
	this->m_ceQuickClip.Copy();
	this->m_ceTrigEdit.Paste();
	RestoreClipboard();
}

void CTriggerEditDlg::FillOperators()
{
	m_ccbOperators.AddString("=");
	m_ccbOperators.AddString("+");
	m_ccbOperators.AddString("+-");
	m_ccbOperators.AddString("*");
	m_ccbOperators.AddString("/");
	m_ccbOperators.AddString("|");
	m_ccbOperators.AddString("^");
	m_ccbOperators.AddString("&");
	m_ccbOperators.AddString("!");
}

void CTriggerEditDlg::SaveClipboard()
{
	this->m_ceOldClip.Clear();
	this->m_ceOldClip.Paste();
}

void CTriggerEditDlg::RestoreClipboard()
{
	this->m_ceOldClip.SetSel(0, -1);
	this->m_ceOldClip.Copy();
}

void CTriggerEditDlg::OnSelchangeTrigId() 
{
	if ( m_iSel >= 0 )
	{
		CTrigger * pOldTrigger = (CTrigger *) this->m_ccbTriggerID.GetItemDataPtr( m_iSel );
		if ( pOldTrigger )
		{
			CStringArray csaNewEvents;
			for (int i = 0; i < this->m_ceTrigEdit.GetLineCount(); i++ )
			{
				char szLine[512];
				memset(&szLine[0], 0x00, sizeof(szLine));
				this->m_ceTrigEdit.GetLine( i, szLine, sizeof(szLine) );
				csaNewEvents.Add(szLine);
			}
			pOldTrigger->m_csaEvents.RemoveAll();
			pOldTrigger->m_csaEvents.Copy( csaNewEvents );
		}
	}

	m_iSel = this->m_ccbTriggerID.GetCurSel();
	this->m_ceTrigEdit.SetWindowText("");
	CTrigger * pNewTrigger = (CTrigger *) this->m_ccbTriggerID.GetItemDataPtr( m_iSel );

	if ( pNewTrigger )
	{
		CString csTrigger;
		for ( int i = 0; i <= pNewTrigger->m_csaEvents.GetUpperBound(); i++ )
		{
			CString csTemp = csTrigger;
			if ( csTrigger != "" )
				csTemp.Format("%s%c%c%s", csTrigger, 0x0d, 0x0a, pNewTrigger->m_csaEvents.GetAt(i));
			else
				csTemp.Format("%s", pNewTrigger->m_csaEvents.GetAt(i));
			csTrigger = csTemp;
		}
		this->m_ceTrigEdit.SetWindowText(csTrigger);
	}
	else
	{
		CTrigger * pNewTrigger = new (CTrigger);
		this->m_ccbTriggerID.SetItemDataPtr( m_iSel, (void *) pNewTrigger );
	}
	this->m_pCurrentTrigger = pNewTrigger;
	
}

void CTriggerEditDlg::OnChangeTriggereditbox() 
{
	if ( this->m_pCurrentTrigger )
		this->m_pCurrentTrigger->m_bIsCustom = true;
}

void CTriggerEditDlg::ReadFile(CStdioFile *pFile, bool bIsCustom)
{
	BOOL bStatus = TRUE;
	CTrigger * pTrigger = NULL;
	while ( bStatus )
	{
		CString csLine;
		bStatus = pFile->ReadString( csLine );
		if ( bStatus )
		{
			if ( csLine.Find("[") == 0 )
			{
				// got a new trigger entry
				if ( pTrigger )
				{
					// Anything to do to finish this guy up?
				}
				CString csTemp = csLine.Mid(1);
				csTemp = csTemp.SpanExcluding("]");
				csTemp.MakeUpper();
				if ( csTemp.Find("REGION") != -1 )
				{
					CString csID = csTemp.Mid(csTemp.Find("REGION") + 6);
					DWORD dwID = atoi(csID);
					if ( dwID >= m_dwNextRegion )
						m_dwNextRegion = dwID + 1;
				}
				if ( csTemp.Find("TRIG") != -1 )
				{
					CString csID = csTemp.Mid(csTemp.Find("TRIG") + 4);
					DWORD dwID = atoi(csID);
					if ( dwID >= m_dwNextTrig )
						m_dwNextTrig = dwID + 1;
				}
				// does this one already exist?
				int iIndex = this->m_ccbTriggerID.FindString( -1, csTemp );
				if ( iIndex != -1 )
				{
					pTrigger = (CTrigger *) this->m_ccbTriggerID.GetItemDataPtr( iIndex );
					pTrigger->m_csaEvents.RemoveAll();
				}
				else
				{
					pTrigger = new (CTrigger);
					iIndex = this->m_ccbTriggerID.AddString(csTemp);
					this->m_ccbTriggerID.SetItemDataPtr( iIndex, (void *) pTrigger );
				}
				pTrigger->m_csID = csTemp;
				pTrigger->m_bIsCustom = bIsCustom;
			}
			else
			{
				// either we are before the triggers, or we are inside one
				if ( pTrigger )
					pTrigger->m_csaEvents.Add( csLine );
			}
		}
	}
}

CTriggerEditDlg::~CTriggerEditDlg()
{
}

BOOL CTriggerEditDlg::DestroyWindow() 
{
	for ( int i = 0; i < this->m_ccbTriggerID.GetCount(); i++ )
	{
		CTrigger * pTrigger = (CTrigger *) this->m_ccbTriggerID.GetItemDataPtr( i );
		if ( pTrigger )
		{
			pTrigger->m_csaEvents.RemoveAll();
			delete pTrigger;
		}
	}
	
	return CDialog::DestroyWindow();
}

void CTriggerEditDlg::OnNewregiontrig() 
{
	CString csID;
	csID.Format("REGION %ld", m_dwNextRegion);
	CTrigger * pNewTrigger = new (CTrigger);
	pNewTrigger->m_csID = csID;
	pNewTrigger->m_bIsCustom = true;
	m_dwNextRegion++;
	int iIndex = this->m_ccbTriggerID.AddString( csID );
	this->m_ccbTriggerID.SetItemDataPtr( iIndex, (void *) pNewTrigger );
	this->m_ccbTriggerID.SelectString( -1, csID );
}
