/*
 $Id: editgraymapdlg.h,v 1.4 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

//{{AFX_INCLUDES()
#include "uomap.h"
//}}AFX_INCLUDES
#if !defined(AFX_EDITGRAYMAPDLG_H__98315981_0270_11D3_8716_00805FD91B8C__INCLUDED_)
#define AFX_EDITGRAYMAPDLG_H__98315981_0270_11D3_8716_00805FD91B8C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "area.h"
// EditGraymapDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CEditGraymapDlg dialog

class CEditGraymapDlg : public CDialog
{
// Construction
public:
	void PopulateTreeView(HTREEITEM hItem, CArea *pArea);
	int m_dragRect;
	int m_button;
	int m_yOffset;
	int m_xOffset;
	WORD m_wFlags;
	CPoint m_pUOBottomRight;
	CPoint m_pUOTopLeft;
	CRect m_crRegion;
	CPoint m_pBottomRight;
	CPoint m_pTopLeft;
	void LoadMap();
	CByteArray m_bMapArray;
	DWORD m_dwColorMap[65536];
	virtual ~CEditGraymapDlg();
	CEditGraymapDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CEditGraymapDlg)
	enum { IDD = IDD_EDITGRAYMAP_DLG };
	CListBox	m_clbRectList;
	CTreeCtrl	m_ctcRegionTree;
	CListCtrl	m_clcValues;
	CButton	m_cbDrawRects;
	CStatic	m_csCursor;
	CStatic	m_csCoords;
	CUOMap	m_map;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditGraymapDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	bool m_bSearching;
	CArea * SetCustomArea(CArea * pArea);
	void DisplayValues(CArea * pArea);
	void GetFlags();
	void SetFlags();

	// Generated message map functions
	//{{AFX_MSG(CEditGraymapDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangedRegiontree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEndlabeleditRegiontree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKeydownRegiontree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnNewroom();
	afx_msg void OnNewarea();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSetpoint();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRemoverect();
	afx_msg void OnDblclkMapvals(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLocatearea();
	afx_msg void OnLocateroom();
	afx_msg void OnMoveup();
	afx_msg void OnMovedown();
	afx_msg void OnZoomin();
	afx_msg void OnZoomout();
	afx_msg void OnMouseDownMapdisplay(short Button, short Shift, long x, long y);
	afx_msg void OnMouseMoveMapdisplay(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpMapdisplay(short Button, short Shift, long x, long y);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITGRAYMAPDLG_H__98315981_0270_11D3_8716_00805FD91B8C__INCLUDED_)
