/*
 $Id: flagsbrainstab.cpp,v 1.9 2002/11/12 22:14:47 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// FlagsBrainsTab.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "FlagsBrainsTab.h"
#include "RemoteConnection.h"
#include "SpawnMessageDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFlagsBrainsTab property page

IMPLEMENT_DYNCREATE(CFlagsBrainsTab, CPropertyPage)

CFlagsBrainsTab::CFlagsBrainsTab() : CPropertyPage(CFlagsBrainsTab::IDD)
{
	//{{AFX_DATA_INIT(CFlagsBrainsTab)
	m_bInvulnerable = FALSE;
	m_bDead = FALSE;
	m_bParalyzed = FALSE;
	m_bInvisible = FALSE;
	m_bCorpse = FALSE;
	m_bWarmode = FALSE;
	m_bReactiveArmor = FALSE;
	m_bPoisoned = FALSE;
	m_bNightsight = FALSE;
	m_bMagicReflect = FALSE;
	m_bPolymorphed = FALSE;
	m_bIncognito = FALSE;
	m_bSpiritSpeak = FALSE;
	m_bInsubstantial = FALSE;
	m_bHasShield = FALSE;
	m_bStone = FALSE;
	m_bFlying = FALSE;
	m_bHallucinating = FALSE;
	m_bHidden = FALSE;
	m_bAggressor = FALSE;
	m_bCriminal = FALSE;
	m_bConjured = FALSE;
	m_bMounted = FALSE;
	m_bPet = FALSE;
	m_bSpawned = FALSE;
	m_bRidden = FALSE;
	m_bCommCrystal = FALSE;
	m_bEmote = FALSE;
	m_bInDoors = FALSE;
	m_bRespawn = FALSE;
	m_bSaveParity = FALSE;
	m_bScriptPlay = FALSE;
	m_bScriptRec = FALSE;
	//}}AFX_DATA_INIT
}

CFlagsBrainsTab::~CFlagsBrainsTab()
{
}

void CFlagsBrainsTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFlagsBrainsTab)
	DDX_Control(pDX, IDC_CMDSCRIPT, m_ceScript);
	DDX_Control(pDX, IDC_STATVALUE, m_ceStatValue);
	DDX_Control(pDX, IDC_SKILLVALUE, m_ceSkillValue);
	DDX_Control(pDX, IDC_STATS, m_ccbStats);
	DDX_Control(pDX, IDC_SKILLS, m_ccbSkills);
	DDX_Control(pDX, IDC_BRAINTYPES, m_ccbBrains);
	DDX_Control(pDX, IDC_FLAG_VALUE, m_csFlagValue);
	DDX_Check(pDX, IDC_INVULNERABLE, m_bInvulnerable);
	DDX_Check(pDX, IDC_DEAD, m_bDead);
	DDX_Check(pDX, IDC_PARALYZED, m_bParalyzed);
	DDX_Check(pDX, IDC_INVISIBLE, m_bInvisible);
	DDX_Check(pDX, IDC_CORPSE, m_bCorpse);
	DDX_Check(pDX, IDC_WARMODE, m_bWarmode);
	DDX_Check(pDX, IDC_REACTIVE_ARMOR, m_bReactiveArmor);
	DDX_Check(pDX, IDC_POISONED, m_bPoisoned);
	DDX_Check(pDX, IDC_NIGHTSIGHT, m_bNightsight);
	DDX_Check(pDX, IDC_MAGIC_REFLECT, m_bMagicReflect);
	DDX_Check(pDX, IDC_POLYMORPHED, m_bPolymorphed);
	DDX_Check(pDX, IDC_INCOGNITO, m_bIncognito);
	DDX_Check(pDX, IDC_SPIRITSPEAK, m_bSpiritSpeak);
	DDX_Check(pDX, IDC_INSUBSTANTIAL, m_bInsubstantial);
	DDX_Check(pDX, IDC_HAS_SHIELD, m_bHasShield);
	DDX_Check(pDX, IDC_STONE, m_bStone);
	DDX_Check(pDX, IDC_FLYING, m_bFlying);
	DDX_Check(pDX, IDC_HALLUCINATING, m_bHallucinating);
	DDX_Check(pDX, IDC_HIDDEN, m_bHidden);
	DDX_Check(pDX, IDC_CRIMINAL, m_bCriminal);
	DDX_Check(pDX, IDC_CONJURED, m_bConjured);
	DDX_Check(pDX, IDC_MOUNTED, m_bMounted);
	DDX_Check(pDX, IDC_PET, m_bPet);
	DDX_Check(pDX, IDC_SPAWNED, m_bSpawned);
	DDX_Check(pDX, IDC_RIDDEN, m_bRidden);
	DDX_Check(pDX, IDC_COMMCRYSTAL, m_bCommCrystal);
	DDX_Check(pDX, IDC_EMOTE, m_bEmote);
	DDX_Check(pDX, IDC_INDOORS, m_bInDoors);
	DDX_Check(pDX, IDC_RESPAWN, m_bRespawn);
	DDX_Check(pDX, IDC_SAVEPARITY, m_bSaveParity);
	DDX_Check(pDX, IDC_SCRIPT_PLAY, m_bScriptPlay);
	DDX_Check(pDX, IDC_SCRIPT_REC, m_bScriptRec);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFlagsBrainsTab, CPropertyPage)
	//{{AFX_MSG_MAP(CFlagsBrainsTab)
	ON_BN_CLICKED(IDC_INVULNERABLE, OnInvulnerable)
	ON_BN_CLICKED(IDC_DEAD, OnDead)
	ON_BN_CLICKED(IDC_PARALYZED, OnParalyzed)
	ON_BN_CLICKED(IDC_INVISIBLE, OnInvisible)
	ON_BN_CLICKED(IDC_CORPSE, OnCorpse)
	ON_BN_CLICKED(IDC_WARMODE, OnWarmode)
	ON_BN_CLICKED(IDC_REACTIVE_ARMOR, OnReactiveArmor)
	ON_BN_CLICKED(IDC_POISONED, OnPoisoned)
	ON_BN_CLICKED(IDC_NIGHTSIGHT, OnNightsight)
	ON_BN_CLICKED(IDC_MAGIC_REFLECT, OnMagicReflect)
	ON_BN_CLICKED(IDC_POLYMORPHED, OnPolymorphed)
	ON_BN_CLICKED(IDC_INCOGNITO, OnIncognito)
	ON_BN_CLICKED(IDC_SPIRITSPEAK, OnSpiritspeak)
	ON_BN_CLICKED(IDC_INSUBSTANTIAL, OnInsubstantial)
	ON_BN_CLICKED(IDC_HAS_SHIELD, OnHasShield)
	ON_BN_CLICKED(IDC_STONE, OnStone)
	ON_BN_CLICKED(IDC_FLYING, OnFlying)
	ON_BN_CLICKED(IDC_HALLUCINATING, OnHallucinating)
	ON_BN_CLICKED(IDC_HIDDEN, OnHidden)
	ON_BN_CLICKED(IDC_CRIMINAL, OnCriminal)
	ON_BN_CLICKED(IDC_CONJURED, OnConjured)
	ON_BN_CLICKED(IDC_MOUNTED, OnMounted)
	ON_BN_CLICKED(IDC_PET, OnPet)
	ON_BN_CLICKED(IDC_SPAWNED, OnSpawned)
	ON_BN_CLICKED(IDC_RIDDEN, OnRidden)
	ON_BN_CLICKED(IDC_RESETFLAGS, OnResetflags)
	ON_BN_CLICKED(IDC_SETFLAGS, OnSetflags)
	ON_BN_CLICKED(IDC_SETNORMAL, OnSetnormal)
	ON_BN_CLICKED(IDC_SETPARAINVULN, OnSetparainvuln)
	ON_BN_CLICKED(IDC_SETINVULINCOG, OnSetinvulincog)
	ON_BN_CLICKED(IDC_SETBRAIN, OnSetbrain)
	ON_BN_CLICKED(IDC_SETSKILL, OnSetskill)
	ON_BN_CLICKED(IDC_SETSTAT, OnSetstat)
	ON_BN_CLICKED(IDC_SETSCRIPT, OnSetscript)
	ON_BN_CLICKED(IDC_COMMCRYSTAL, OnCommcrystal)
	ON_BN_CLICKED(IDC_EMOTE, OnEmote)
	ON_BN_CLICKED(IDC_INDOORS, OnIndoors)
	ON_BN_CLICKED(IDC_RESPAWN, OnRespawn)
	ON_BN_CLICKED(IDC_SAVEPARITY, OnSaveparity)
	ON_BN_CLICKED(IDC_SCRIPT_PLAY, OnScriptPlay)
	ON_BN_CLICKED(IDC_SCRIPT_REC, OnScriptRec)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFlagsBrainsTab message handlers

void CFlagsBrainsTab::OnInvulnerable() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bInvulnerable)
		dwVal |= STATF_INVUL;
	else
		dwVal ^= STATF_INVUL;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);
}

void CFlagsBrainsTab::OnDead() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bDead)
		dwVal |= STATF_DEAD;
	else
		dwVal ^= STATF_DEAD;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnParalyzed() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bParalyzed)
		dwVal |= STATF_Freeze;
	else
		dwVal ^= STATF_Freeze;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnInvisible() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bInvisible)
		dwVal |= STATF_Invisible;
	else
		dwVal ^= STATF_Invisible;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnCorpse() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bCorpse)
		dwVal |= STATF_Sleeping;
	else
		dwVal ^= STATF_Sleeping;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnWarmode() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bWarmode)
		dwVal |= STATF_War;
	else
		dwVal ^= STATF_War;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnReactiveArmor() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bReactiveArmor)
		dwVal |= STATF_Reactive;
	else
		dwVal ^= STATF_Reactive;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnPoisoned() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bPoisoned)
		dwVal |= STATF_Poisoned;
	else
		dwVal ^= STATF_Poisoned;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnNightsight() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bNightsight)
		dwVal |= STATF_NightSight;
	else
		dwVal ^= STATF_NightSight;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnMagicReflect() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bMagicReflect)
		dwVal |= STATF_Reflection;
	else
		dwVal ^= STATF_Reflection;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnPolymorphed() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bPolymorphed)
		dwVal |= STATF_Polymorph;
	else
		dwVal ^= STATF_Polymorph;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnIncognito() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bIncognito)
		dwVal |= STATF_Incognito;
	else
		dwVal ^= STATF_Incognito;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnSpiritspeak() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bSpiritSpeak)
		dwVal |= STATF_SpiritSpeak;
	else
		dwVal ^= STATF_SpiritSpeak;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnInsubstantial() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bInsubstantial)
		dwVal |= STATF_Insubstantial;
	else
		dwVal ^= STATF_Insubstantial;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnHasShield() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bHasShield)
		dwVal |= STATF_HasShield;
	else
		dwVal ^= STATF_HasShield;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnStone() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bStone)
		dwVal |= STATF_Stone;
	else
		dwVal ^= STATF_Stone;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnFlying() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bFlying)
		dwVal |= STATF_Fly;
	else
		dwVal ^= STATF_Fly;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnHallucinating() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bHallucinating)
		dwVal |= STATF_Hallucinating;
	else
		dwVal ^= STATF_Hallucinating;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnHidden() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bHidden)
		dwVal |= STATF_Hidden;
	else
		dwVal ^= STATF_Hidden;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnCriminal() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bCriminal)
		dwVal |= STATF_Criminal;
	else
		dwVal ^= STATF_Criminal;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnConjured() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bConjured)
		dwVal |= STATF_Conjured;
	else
		dwVal ^= STATF_Conjured;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnMounted() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bMounted)
		dwVal |= STATF_OnHorse;
	else
		dwVal ^= STATF_OnHorse;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnPet() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bPet)
		dwVal |= STATF_Pet;
	else
		dwVal ^= STATF_Pet;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnSpawned() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bSpawned)
		dwVal |= STATF_Spawned;
	else
		dwVal ^= STATF_Spawned;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CFlagsBrainsTab::OnRidden() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bRidden)
		dwVal |= STATF_Ridden;
	else
		dwVal ^= STATF_Ridden;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);		
}

void CFlagsBrainsTab::OnResetflags() 
{
	m_bInvulnerable = FALSE;
	m_bDead = FALSE;
	m_bParalyzed = FALSE;
	m_bInvisible = FALSE;
	m_bCorpse = FALSE;
	m_bWarmode = FALSE;
	m_bReactiveArmor = FALSE;
	m_bPoisoned = FALSE;
	m_bNightsight = FALSE;
	m_bMagicReflect = FALSE;
	m_bPolymorphed = FALSE;
	m_bIncognito = FALSE;
	m_bSpiritSpeak = FALSE;
	m_bInsubstantial = FALSE;
	m_bHasShield = FALSE;
	m_bStone = FALSE;
	m_bFlying = FALSE;
	m_bHallucinating = FALSE;
	m_bHidden = FALSE;
	m_bAggressor = FALSE;
	m_bCriminal = FALSE;
	m_bConjured = FALSE;
	m_bMounted = FALSE;
	m_bPet = FALSE;
	m_bSpawned = FALSE;
	m_bRidden = FALSE;
	m_bCommCrystal = FALSE;
	m_bEmote = FALSE;
	m_bInDoors = FALSE;
	m_bRespawn = FALSE;
	m_bSaveParity = FALSE;
	m_bScriptPlay = FALSE;
	m_bScriptRec = FALSE;
	m_csFlagValue.SetWindowText("000000000");
	UpdateData(false);
}

void CFlagsBrainsTab::OnSetflags() 
{
	CString csVal;
	m_csFlagValue.GetWindowText(csVal);
	CString csCmd;

	if ( Main->m_dwCommandVersion )
		csCmd.Format(".set flags=%s", csVal);
	else
		csCmd.Format(".set flags %s", csVal);
	SendToUO(csCmd);
}

void CFlagsBrainsTab::OnSetnormal() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO((CString)".set flags=000020000");	
	else
		SendToUO((CString)".set flags 000020000");	
}

void CFlagsBrainsTab::OnSetparainvuln() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO((CString)".set flags=000000005");
	else
		SendToUO((CString)".set flags 000000005");	
}

void CFlagsBrainsTab::OnSetinvulincog() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO((CString)".set flags=000000801");
	else
		SendToUO((CString)".set flags 000000801");	
}

void CFlagsBrainsTab::OnSetbrain() 
{
	CString csCmd;
	CString csBrain;
	m_ccbBrains.GetWindowText(csBrain);
	int iSel = m_ccbBrains.FindStringExact(-1, csBrain);
	if (iSel == -1)
	{
		AfxMessageBox("No Brain Selected", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	else
		m_wBrainType = (WORD) m_ccbBrains.GetItemData(iSel);
	if ( Main->m_dwCommandVersion )
		csCmd.Format(".set npc=%ld", m_wBrainType);
	else
		csCmd.Format(".set npc %ld", m_wBrainType);
	SendToUO(csCmd);
}

BOOL CFlagsBrainsTab::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	CWaitCursor hourglass;
	LoadScripts();

	this->m_ccbStats.AddString("Str");
	this->m_ccbStats.AddString("Dex");
	this->m_ccbStats.AddString("Int");
	this->m_ccbStats.AddString("HitPoints");
	this->m_ccbStats.AddString("Stamina");
	this->m_ccbStats.AddString("Mana");
	this->m_ccbStats.AddString("MaxHits");
	this->m_ccbStats.AddString("MaxMana");
	this->m_ccbStats.AddString("MaxStam");

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFlagsBrainsTab::OnSetskill() 
{
	CString csSkill, csValue;
	m_ccbSkills.GetWindowText(csSkill);
	m_ceSkillValue.GetWindowText(csValue);
	if (csSkill != "" && csValue != "")
	{
		CString csCmd;
		if ( Main->m_dwCommandVersion )
			csCmd.Format(".set %s=%s", csSkill, csValue);
		else
			csCmd.Format(".set %s %s", csSkill, csValue);
		SendToUO(csCmd);
	}
}

void CFlagsBrainsTab::OnSetstat() 
{
	CString csStat, csValue;
	m_ccbStats.GetWindowText(csStat);
	m_ceStatValue.GetWindowText(csValue);
	if (csStat != "" && csValue != "")
	{
		CString csCmd;
		if ( Main->m_dwCommandVersion )
			csCmd.Format(".set %s=%s", csStat, csValue);
		else
			csCmd.Format(".set %s %s", csStat, csValue);
		SendToUO(csCmd);
	}
}

void CFlagsBrainsTab::LoadScripts()
{
	this->m_ccbBrains.ResetContent();
	this->m_ccbSkills.ResetContent();

	for ( int i = 0; i < Main->m_pScripts->m_tables.m_skills.GetSize(); i++ )
	{
		CTObject * pBase = (CTObject *) Main->m_pScripts->m_tables.m_skills.GetAt(i);
		if ( pBase )
		{
			CTSkillDef skill;
			skill.m_csFilename = pBase->m_csFilename;
			skill.m_dwFileOffset = pBase->m_dwFileOffset;
			skill.m_csValue = pBase->m_csValue;
			skill.Load();
			this->m_ccbSkills.AddString(skill.m_csKey);
		}
	}

	for ( i = 0; i < Main->m_pScripts->m_aDefs.GetSize(); i++ )
	{
		CDef * pDef = (CDef *) Main->m_pScripts->m_aDefs.GetAt(i);
		if ( pDef->m_csGroup == "BRAINS" )
		{
			int index = this->m_ccbBrains.AddString(pDef->m_csValue);
			this->m_ccbBrains.SetItemData(index, pDef->m_dwValueMin);
		}
	}

	m_iScriptSeq = Main->m_pScripts->m_iScriptSeq;
}

void CFlagsBrainsTab::OnSetscript() 
{
	CString csScript;
	this->m_ceScript.GetWindowText(csScript);
	csScript.TrimLeft();
	csScript.TrimRight();
	if (csScript != "")
	{
		CString csCmd;
		csCmd.Format(".script %s", csScript);
		SendToUO(csCmd);
	}
}

void CFlagsBrainsTab::Unload()
{
	this->m_ccbBrains.ResetContent();
	this->m_ccbSkills.ResetContent();
	this->m_ccbStats.ResetContent();
}

void CFlagsBrainsTab::OnCommcrystal() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bStone)
		dwVal |= STATF_COMM_CRYSTAL;
	else
		dwVal ^= STATF_COMM_CRYSTAL;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	}

void CFlagsBrainsTab::OnEmote() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bStone)
		dwVal |= STATF_EmoteAction;
	else
		dwVal ^= STATF_EmoteAction;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	}

void CFlagsBrainsTab::OnIndoors() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bStone)
		dwVal |= STATF_InDoors;
	else
		dwVal ^= STATF_InDoors;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	}

void CFlagsBrainsTab::OnRespawn() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bStone)
		dwVal |= STATF_RespawnNPC;
	else
		dwVal ^= STATF_RespawnNPC;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	}

void CFlagsBrainsTab::OnSaveparity() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bStone)
		dwVal |= STATF_SaveParity;
	else
		dwVal ^= STATF_SaveParity;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);		
}

void CFlagsBrainsTab::OnScriptPlay() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bStone)
		dwVal |= STATF_Script_Play;
	else
		dwVal ^= STATF_Script_Play;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	}

void CFlagsBrainsTab::OnScriptRec() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csFlagValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bStone)
		dwVal |= STATF_Script_Rec;
	else
		dwVal ^= STATF_Script_Rec;
	CString csNewVal;
	csNewVal.Format("%09x", dwVal);
	m_csFlagValue.SetWindowText(csNewVal);
	UpdateData(false);	}

BOOL CFlagsBrainsTab::OnSetActive() 
{
	if ( Main->m_pScripts->m_iScriptSeq != m_iScriptSeq )
		this->LoadScripts();
	
	return CPropertyPage::OnSetActive();
}
