/*
 $Id: flagsbrainstab.h,v 1.4 2002/11/12 21:29:14 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_FLAGSBRAINSTAB_H__DFB29CF5_D431_11D2_A613_004F4905E937__INCLUDED_)
#define AFX_FLAGSBRAINSTAB_H__DFB29CF5_D431_11D2_A613_004F4905E937__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// FlagsBrainsTab.h : header file
//

// Throw in the flags from graysvr.h

#define STATF_INVUL			0x00000001	// Invulnerability
#define STATF_DEAD			0x00000002
#define STATF_Freeze		0x00000004	// Paralyzed. (spell)
#define STATF_Invisible		0x00000008	// Invisible (spell).
#define STATF_Sleeping		0x00000010	// You look like a corpse ?
#define STATF_War			0x00000020	// War mode on ?
#define STATF_Reactive		0x00000040	// have reactive armor on.
#define STATF_Poisoned		0x00000080	// Poison level is in the poison object
#define STATF_NightSight	0x00000100	// All is light to you
#define STATF_Reflection	0x00000200	// Magic reflect on.
#define STATF_Polymorph		0x00000400	// We have polymorphed to another form.
#define STATF_Incognito		0x00000800	// Dont show skill titles
#define STATF_SpiritSpeak	0x00001000	// I can hear ghosts clearly.
#define STATF_Insubstantial	0x00002000	// Ghost has not manifest. or GM hidden
#define STATF_EmoteAction	0x00004000	// The creature will emote its actions to it's owners.
#define STATF_COMM_CRYSTAL	0x00008000	// I have a IT_COMM_CRYSTAL or listening item on me.
#define STATF_HasShield		0x00010000	// Using a shield
#define STATF_Script_Play	0x00020000	// Playing a Script. (book script)
#define STATF_Stone			0x00040000	// turned to stone.
#define STATF_Script_Rec	0x00080000	// Recording a script.
#define STATF_Fly			0x00100000	// Flying or running ? (anim)
#define STATF_RespawnNPC	0x00200000	// This NPC is a plot NPC that must respawn later.
#define STATF_Hallucinating	0x00400000	// eat 'shrooms or bad food.
#define STATF_Hidden		0x00800000	// Hidden (non-magical)
#define STATF_InDoors		0x01000000	// we are covered from the rain.
#define STATF_Criminal		0x02000000	// The guards will attack me. (someone has called guards)
#define STATF_Conjured		0x04000000	// This creature is conjured and will expire. (leave no corpse or loot)
#define STATF_Pet			0x08000000	// I am a pet/hirling. check for my owner memory.
#define STATF_Spawned		0x10000000	// I am spawned by a spawn item.
#define STATF_SaveParity	0x20000000	// Has this char been saved or not ?
#define STATF_Ridden		0x40000000	// This is the horse. (don't display me) I am being ridden
#define STATF_OnHorse		0x80000000	// Mounted on horseback.

/////////////////////////////////////////////////////////////////////////////
// CFlagsBrainsTab dialog

class CFlagsBrainsTab : public CPropertyPage
{
	DECLARE_DYNCREATE(CFlagsBrainsTab)

// Construction
public:
	void Unload();
	void LoadScripts();
	WORD m_wBrainType;
	CFlagsBrainsTab();
	virtual ~CFlagsBrainsTab();

// Dialog Data
	//{{AFX_DATA(CFlagsBrainsTab)
	enum { IDD = IDD_FLAGS_AND_BRAINS_TAB };
	CEdit	m_ceScript;
	CEdit	m_ceStatValue;
	CEdit	m_ceSkillValue;
	CComboBox	m_ccbStats;
	CComboBox	m_ccbSkills;
	CComboBox	m_ccbBrains;
	CStatic	m_csFlagValue;
	BOOL	m_bInvulnerable;
	BOOL	m_bDead;
	BOOL	m_bParalyzed;
	BOOL	m_bInvisible;
	BOOL	m_bCorpse;
	BOOL	m_bWarmode;
	BOOL	m_bReactiveArmor;
	BOOL	m_bPoisoned;
	BOOL	m_bNightsight;
	BOOL	m_bMagicReflect;
	BOOL	m_bPolymorphed;
	BOOL	m_bIncognito;
	BOOL	m_bSpiritSpeak;
	BOOL	m_bInsubstantial;
	BOOL	m_bHasShield;
	BOOL	m_bStone;
	BOOL	m_bFlying;
	BOOL	m_bHallucinating;
	BOOL	m_bHidden;
	BOOL	m_bAggressor;
	BOOL	m_bCriminal;
	BOOL	m_bConjured;
	BOOL	m_bMounted;
	BOOL	m_bPet;
	BOOL	m_bSpawned;
	BOOL	m_bRidden;
	BOOL	m_bCommCrystal;
	BOOL	m_bEmote;
	BOOL	m_bInDoors;
	BOOL	m_bRespawn;
	BOOL	m_bSaveParity;
	BOOL	m_bScriptPlay;
	BOOL	m_bScriptRec;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CFlagsBrainsTab)
	public:
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	int m_iScriptSeq;
	// Generated message map functions
	//{{AFX_MSG(CFlagsBrainsTab)
	afx_msg void OnInvulnerable();
	afx_msg void OnDead();
	afx_msg void OnParalyzed();
	afx_msg void OnInvisible();
	afx_msg void OnCorpse();
	afx_msg void OnWarmode();
	afx_msg void OnReactiveArmor();
	afx_msg void OnPoisoned();
	afx_msg void OnNightsight();
	afx_msg void OnMagicReflect();
	afx_msg void OnPolymorphed();
	afx_msg void OnIncognito();
	afx_msg void OnSpiritspeak();
	afx_msg void OnInsubstantial();
	afx_msg void OnHasShield();
	afx_msg void OnStone();
	afx_msg void OnFlying();
	afx_msg void OnHallucinating();
	afx_msg void OnHidden();
	afx_msg void OnCriminal();
	afx_msg void OnConjured();
	afx_msg void OnMounted();
	afx_msg void OnPet();
	afx_msg void OnSpawned();
	afx_msg void OnRidden();
	afx_msg void OnResetflags();
	afx_msg void OnSetflags();
	afx_msg void OnSetnormal();
	afx_msg void OnSetparainvuln();
	afx_msg void OnSetinvulincog();
	afx_msg void OnSetbrain();
	virtual BOOL OnInitDialog();
	afx_msg void OnSetskill();
	afx_msg void OnSetstat();
	afx_msg void OnSetscript();
	afx_msg void OnCommcrystal();
	afx_msg void OnEmote();
	afx_msg void OnIndoors();
	afx_msg void OnRespawn();
	afx_msg void OnSaveparity();
	afx_msg void OnScriptPlay();
	afx_msg void OnScriptRec();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FLAGSBRAINSTAB_H__DFB29CF5_D431_11D2_A613_004F4905E937__INCLUDED_)
