/*
 $Id: generaltab.cpp,v 1.8 2002/11/12 03:50:09 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/


/**********************************************************************
 * Changes:
 *  - 7 May 2002 - PiotrBanasik
 *    + Removed the Underwear Button from this form (who uses it that
 *      often anyways
 *    + Added NightSight Button in place of the Underwear button
 *    + Rearranged the buttons on the GM Page tab a little bit
 *      Split off Disconnect and Kick, and renamed Kick to Ban
 *      (Adjusted the confirmation box to say Ban aswell)
 *    + minor tweaks to make buttons not touch
 * 
 **********************************************************************/


// GeneralTab.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "GeneralTab.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGeneralTab property page

IMPLEMENT_DYNCREATE(CGeneralTab, CPropertyPage)

CGeneralTab::CGeneralTab() : CPropertyPage(CGeneralTab::IDD)
{
	//{{AFX_DATA_INIT(CGeneralTab)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CGeneralTab::~CGeneralTab()
{
}

void CGeneralTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGeneralTab)
	DDX_Control(pDX, IDC_IPCBLOCK, m_ceIPBlock);
	DDX_Control(pDX, IDC_SLIDERVALUE, m_csSliderValue);
	DDX_Control(pDX, IDC_SLIDER1, m_cscSlider);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGeneralTab, CPropertyPage)
	//{{AFX_MSG_MAP(CGeneralTab)
	ON_BN_CLICKED(IDC_INVULNERABLE, OnInvulnerable)
	ON_BN_CLICKED(IDC_SETALLMOVE, OnSetallmove)
	ON_BN_CLICKED(IDC_INVISIBLE, OnInvisible)
	ON_BN_CLICKED(IDC_FIX, OnFix)
	ON_BN_CLICKED(IDC_SETDETAIL, OnSetdetail)
	ON_BN_CLICKED(IDC_SETHEARALL, OnSethearall)
	ON_BN_CLICKED(IDC_GMTOGGLE, OnGmtoggle)
	ON_BN_CLICKED(IDC_CLIENTS, OnClients)
	ON_BN_CLICKED(IDC_SERVERINFO, OnServerinfo)
	ON_BN_CLICKED(IDC_ITEMINFO, OnIteminfo)
	ON_BN_CLICKED(IDC_ADMIN, OnAdmin)
	ON_BN_CLICKED(IDC_CLOCK, OnClock)
	ON_BN_CLICKED(IDC_FLIP, OnFlip)
	ON_BN_CLICKED(IDC_LINK, OnLink)
	ON_BN_CLICKED(IDC_DUPE, OnDupe)
	ON_BN_CLICKED(IDC_NUKE, OnNuke)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_BN_CLICKED(IDC_SHRINK, OnShrink)
	ON_BN_CLICKED(IDC_SETDEBUG, OnDebug)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_RESTOCK, OnRestock)
	ON_BN_CLICKED(IDC_RESTOCKALL, OnRestockall)
	ON_BN_CLICKED(IDC_RESPAWN, OnRespawn)
	ON_BN_CLICKED(IDC_DRY, OnDry)
	ON_BN_CLICKED(IDC_RAIN, OnRain)
	ON_BN_CLICKED(IDC_SNOW, OnSnow)
	ON_BN_CLICKED(IDC_PAGEON, OnPageon)
	ON_BN_CLICKED(IDC_PAGEOFF, OnPageoff)
	ON_BN_CLICKED(IDC_PAGEORIGIN, OnPageorigin)
	ON_BN_CLICKED(IDC_PAGEPLAYER, OnPageplayer)
	ON_BN_CLICKED(IDC_PAGEJAIL, OnPagejail)
	ON_BN_CLICKED(IDC_PAGEKICK, OnPagekick)
	ON_BN_CLICKED(IDC_PAGEDISCONNECT, OnPagedisconnect)
	ON_BN_CLICKED(IDC_PAGEQUEUE, OnPagequeue)
	ON_BN_CLICKED(IDC_PAGELIST, OnPagelist)
	ON_BN_CLICKED(IDC_PAGEDELETE, OnPagedelete)
	ON_BN_CLICKED(IDC_KILL, OnKill)
	ON_BN_CLICKED(IDC_JAIL, OnJail)
	ON_BN_CLICKED(IDC_BANK, OnBank)
	ON_BN_CLICKED(IDC_CONTROL, OnControl)
	ON_BN_CLICKED(IDC_FORGIVE, OnForgive)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_STOCK, OnStock)
	ON_BN_CLICKED(IDC_PURCHASES, OnPurchases)
	ON_BN_CLICKED(IDC_BUY, OnBuy)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_SETLIGHT, OnSetlight)
	ON_BN_CLICKED(IDC_SETEDIT, OnSetedit)
	ON_BN_CLICKED(IDC_BLOCK, OnBlock)
	ON_BN_CLICKED(IDC_UNBLOCK, OnUnblock)
	ON_BN_CLICKED(IDC_NIGHTSIGHT, OnNightsight)
	ON_BN_CLICKED(IDC_XRESTOCK, OnXrestock)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGeneralTab message handlers

void CGeneralTab::OnInvulnerable() 
{
	/*
	if ( Main->m_dwCommandVersion )
		SendToUO(".invulnerable=!src.invulnerable");
	else
	*/
		SendToUO((CString)".invulnerable");
}

void CGeneralTab::OnSetallmove() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".allmove=!src.allmove");
	else
		SendToUO((CString)".allmove");
}

void CGeneralTab::OnInvisible() 
{
	/*
	if ( Main->m_dwCommandVersion )
		SendToUO(".invisible=!src.invisible");
	else
	*/
		SendToUO((CString)".invisible");
}

void CGeneralTab::OnFix() 
{
	SendToUO((CString)".fix");
}

void CGeneralTab::OnSetdetail() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".detail=!src.detail");
	else
		SendToUO((CString)".detail");
}

void CGeneralTab::OnSethearall() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".hearall=!src.hearall");
	else
		SendToUO((CString)".hearall");
}

void CGeneralTab::OnGmtoggle() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".gm=!src.gm");
	else
		SendToUO((CString)".gm");	
}

void CGeneralTab::OnClients() 
{
	SendToUO((CString)".clients");
}

void CGeneralTab::OnServerinfo() 
{
	SendToUO((CString)".information");	
}

void CGeneralTab::OnIteminfo() 
{
	SendToUO((CString)".info");
}

void CGeneralTab::OnAdmin() 
{
	SendToUO((CString)".admin");	
}

void CGeneralTab::OnClock() 
{
	SendToUO((CString)".version");
}

void CGeneralTab::OnFlip() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".x.flip");
	else
		SendToUO((CString)".xflip");	
}

void CGeneralTab::OnLink() 
{
	SendToUO((CString)".link");	
}

void CGeneralTab::OnDupe() 
{
	SendToUO((CString)".dupe");	
}

void CGeneralTab::OnNuke() 
{
	SendToUO((CString)".nuke");	
}

void CGeneralTab::OnRemove() 
{
	SendToUO((CString)".remove");	
}

void CGeneralTab::OnShrink() 
{
	SendToUO((CString)".shrink");	
}

void CGeneralTab::OnDebug() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".debug=!src.debug");
	else
		SendToUO((CString)".debug");
}

void CGeneralTab::OnSave() 
{
	SendToUO((CString)".save 1");	
}

void CGeneralTab::OnRestock() 
{
	SendToUO((CString)".sector.restock");	
}

void CGeneralTab::OnRestockall() 
{
	SendToUO((CString)".sector.restock all");	
}

void CGeneralTab::OnRespawn() 
{
	SendToUO((CString)".sector.respawn");	
}

void CGeneralTab::OnDry() 
{
	SendToUO((CString)".sector.dry");
}

void CGeneralTab::OnRain() 
{
	SendToUO((CString)".sector.rain");	
}

void CGeneralTab::OnSnow() 
{
	SendToUO((CString)".sector.snow");	
}

void CGeneralTab::OnPageon() 
{
	SendToUO((CString)".page on");	
}

void CGeneralTab::OnPageoff() 
{
	SendToUO((CString)".page off");	
}

void CGeneralTab::OnPageorigin() 
{
	SendToUO((CString)".page origin");	
}

void CGeneralTab::OnPageplayer() 
{
	SendToUO((CString)".page player");	
}

void CGeneralTab::OnPagejail() 
{
	if(AfxMessageBox("Are you sure you wish to jail the client that sent this page?", MB_OKCANCEL | MB_ICONQUESTION) == IDOK)
		SendToUO((CString)".page jail");	
}

void CGeneralTab::OnPagekick() 
{
	if (AfxMessageBox("Are you sure you wish to BAN the client that sent this page?", MB_OKCANCEL | MB_ICONQUESTION) == IDOK)
		SendToUO((CString)".page ban");	
}

void CGeneralTab::OnPagedisconnect() 
{
	if (AfxMessageBox("Are you sure you wish to disconnect the client that sent this page?", MB_OKCANCEL | MB_ICONQUESTION) == IDOK)
		SendToUO((CString)".page disconnect");	
}

void CGeneralTab::OnPagequeue() 
{
	SendToUO((CString)".page queue");	
}

void CGeneralTab::OnPagelist() 
{
	SendToUO((CString)".page list");	
}

void CGeneralTab::OnPagedelete() 
{
	SendToUO((CString)".page delete");	
}

void CGeneralTab::OnKill() 
{
	SendToUO((CString)".kill");	
}

void CGeneralTab::OnJail() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".x.jail");
	else
		SendToUO((CString)".xjail");	
}

void CGeneralTab::OnBank() 
{
	SendToUO((CString)".bank");	
}

void CGeneralTab::OnControl() 
{
	SendToUO((CString)".control");	
}

void CGeneralTab::OnForgive() 
{
	SendToUO((CString)".set forgive");	
}

void CGeneralTab::OnDisconnect() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".x.disconnect");
	else
		SendToUO((CString)".xdisconnect");	
}

void CGeneralTab::OnStock() 
{
	SendToUO((CString)".bank 1a");	
}

void CGeneralTab::OnPurchases() 
{
	SendToUO((CString)".bank 1b");	
}

void CGeneralTab::OnBuy() 
{
	SendToUO((CString)".bank 1c");	
}

BOOL CGeneralTab::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_cscSlider.SetRange(0, 30);

	CWnd * pParent = this->GetParent();
	if (Main->m_dwAlwaysOnTop)
		// set the application to always on top
		pParent->SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	else
		// set it to not always on top
		pParent->SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGeneralTab::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// Somebody scrolled something...probably that darn slider bar
	
	if (pScrollBar->m_hWnd == m_cscSlider.m_hWnd)
	{
		// It was in fact the slider
		CString csValue;
		csValue.Format("%02ld", m_cscSlider.GetPos());
		m_csSliderValue.SetWindowText(csValue);
		return;
	}
	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CGeneralTab::OnSetlight() 
{
	CString csCmd;
	CString csVal;
	m_csSliderValue.GetWindowText(csVal);
	csCmd.Format(".sector.light %s", csVal);
	SendToUO(csCmd);
}

void CGeneralTab::OnSetedit() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".x.edit");
	else
		SendToUO((CString)".xedit");	
}

void CGeneralTab::OnBlock() 
{
	CString csIP;
	this->m_ceIPBlock.GetWindowText(csIP);
	CString csCmd;
	if ( Main->m_pScripts->m_bNewFormat )
		csCmd.Format(".serv.blockip %s", csIP);
	else
		csCmd.Format(".blockip %s", csIP);
	SendToUO(csCmd);
}

void CGeneralTab::OnUnblock() 
{
	CString csIP;
	this->m_ceIPBlock.GetWindowText(csIP);
	CString csCmd;
	if ( Main->m_pScripts->m_bNewFormat )
		csCmd.Format(".serv.unblockip %s", csIP);
	else
		csCmd.Format(".unblockip %s", csIP);
	SendToUO(csCmd);
}

void CGeneralTab::OnXrestock() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".x.restock");
	else
		SendToUO(".xrestock");
}

void CGeneralTab::OnNightsight() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".nightsight=!src.nightsight");
	else
		SendToUO(".nightsight");
}
