/*
 $Id: itemeditdlg.cpp,v 1.5 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// ItemEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "ItemEditDlg.h"
#include "ItemTweakTab.h"
#include "AddValueDialog.h"
#include "RemoteConnection.h"
#include "TriggerEditDlg.h"
#include "ColorSelectionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CItemEditDlg dialog


CItemEditDlg::CItemEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CItemEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CItemEditDlg)
	//}}AFX_DATA_INIT
	m_pItem = NULL;
	m_bNew = false;
	m_iEdits = 0;
	m_wBase = 0;
}


void CItemEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CItemEditDlg)
	DDX_Control(pDX, IDC_ITEMDISPLAY, m_csDisplay);
	DDX_Control(pDX, IDC_ITEMENTRY, m_ccbEntry);
	DDX_Control(pDX, IDOK, m_cbOK);
	DDX_Control(pDX, IDCANCEL, m_cbCancel);
	DDX_Control(pDX, IDC_TRIGEDIT, m_cbTrigEdit);
	DDX_Control(pDX, IDC_ITEM_NEW, m_cbNew);
	DDX_Control(pDX, IDC_ITEM_EDIT, m_cbEdit);
	DDX_Control(pDX, IDC_ITEM_CANCEL, m_cbCancelEdit);
	DDX_Control(pDX, IDC_ITEM_APPLY, m_cbApply);
	DDX_Control(pDX, IDC_IEPALETTE, m_cbPalette);
	DDX_Control(pDX, IDC_ADDSUBSECTION, m_cbAddSubsection);
	DDX_Control(pDX, IDC_ADDCATEGORY, m_cbAddCategory);
	DDX_Control(pDX, IDC_TRIGGERS, m_ceTriggers);
	DDX_Control(pDX, IDC_SELLVALUEMAX, m_ceSellValueMax);
	DDX_Control(pDX, IDC_BUYVALUEMAX, m_ceBuyValueMax);
	DDX_Control(pDX, IDC_NOINDEX, m_cbNoIndex);
	DDX_Control(pDX, IDC_COLORCOMBO, m_ccbColor);
	DDX_Control(pDX, IDC_DUPEITEM, m_ccbDupeitem);
	DDX_Control(pDX, IDC_REPAIRABLE, m_cbRepairable);
	DDX_Control(pDX, IDC_DYEABLE, m_cbDyeable);
	DDX_Control(pDX, IDC_MAGICAL, m_cbMagical);
	DDX_Control(pDX, IDC_WEIGHT, m_ceWeight);
	DDX_Control(pDX, IDC_SUBSECTION, m_ccbSubsection);
	DDX_Control(pDX, IDC_STATIC_ID, m_csBase);
	DDX_Control(pDX, IDC_SPELLID, m_ccbSpell);
	DDX_Control(pDX, IDC_SKILL, m_ccbSkill);
	DDX_Control(pDX, IDC_SELLVALUE, m_ceSellValue);
	DDX_Control(pDX, IDC_REQSTR, m_ceReqStr);
	DDX_Control(pDX, IDC_NAME, m_ceName);
	DDX_Control(pDX, IDC_ITEMTYPE, m_ccbItemType);
	DDX_Control(pDX, IDC_ITEMID, m_ceItemID);
	DDX_Control(pDX, IDC_HPMIN, m_ceHPMin);
	DDX_Control(pDX, IDC_HPMAX, m_ceHPMax);
	DDX_Control(pDX, IDC_DESCRIPTION, m_ceDescription);
	DDX_Control(pDX, IDC_DAMAGEMIN, m_ceDamageMin);
	DDX_Control(pDX, IDC_DAMAGEMAX, m_ceDamageMax);
	DDX_Control(pDX, IDC_CHARGES, m_ceCharges);
	DDX_Control(pDX, IDC_CATEGORY, m_ccbCategory);
	DDX_Control(pDX, IDC_BUYVALUE, m_ceBuyValue);
	DDX_Control(pDX, IDC_ARMOURMIN, m_ceArmourMin);
	DDX_Control(pDX, IDC_ARMOURMAX, m_ceArmourMax);
	DDX_Control(pDX, IDC_ARMOURBONUS, m_ceArmourBonus);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CItemEditDlg, CDialog)
	//{{AFX_MSG_MAP(CItemEditDlg)
	ON_CBN_SELCHANGE(IDC_CATEGORY, OnSelchangeCategory)
	ON_BN_CLICKED(IDC_MAGICAL, OnMagical)
	ON_CBN_SELCHANGE(IDC_ITEMTYPE, OnSelchangeItemtype)
	ON_CBN_SELCHANGE(IDC_DUPEITEM, OnSelchangeDupeitem)
	ON_BN_CLICKED(IDC_ADDCATEGORY, OnAddcategory)
	ON_BN_CLICKED(IDC_ADDSUBSECTION, OnAddsubsection)
	ON_BN_CLICKED(IDC_NOINDEX, OnNoindex)
	ON_EN_CHANGE(IDC_NAME, OnChangeName)
	ON_BN_CLICKED(IDC_TRIGEDIT, OnTrigedit)
	ON_BN_CLICKED(IDC_IEPALETTE, OnIepalette)
	ON_CBN_SELCHANGE(IDC_ITEMENTRY, OnSelchangeItementry)
	ON_BN_CLICKED(IDC_ITEM_NEW, OnItemNew)
	ON_BN_CLICKED(IDC_ITEM_EDIT, OnItemEdit)
	ON_BN_CLICKED(IDC_ITEM_APPLY, OnItemApply)
	ON_BN_CLICKED(IDC_ITEM_CANCEL, OnItemCancel)
	ON_EN_CHANGE(IDC_ITEMID, OnChangeItemid)
	ON_CBN_EDITCHANGE(IDC_COLORCOMBO, OnEditchangeColorcombo)
	ON_CBN_SELCHANGE(IDC_COLORCOMBO, OnSelchangeColorcombo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CItemEditDlg message handlers

BOOL CItemEditDlg::OnInitDialog() 
{
	CWaitCursor hourglass;
	CDialog::OnInitDialog();

	Main->m_pScripts->LoadItems();
	Main->m_pScripts->LoadTemplates();
	Main->m_pScripts->CategorizeItems();
	
	// Populate those darn combo boxes
	FillSpells();
	FillColors();
	FillDupeItems();
	
	for ( int i = 0; i < Main->m_pScripts->m_aItems.GetSize(); i++ )
	{
		CSObject * pItem = (CSObject *) Main->m_pScripts->m_aItems.GetAt(i);
		if ( !pItem )
			continue;
		if ( pItem->m_csDupeItem != "" )
		{
			CString csDupe;
			csDupe.Format("%s", pItem->m_csDupeItem);
			int iIndex = Main->m_pScripts->m_aItems.Find(csDupe);
			if ( iIndex == -1 )
			{
				csDupe.Format("%04x", ahextoi(pItem->m_csDupeItem));
				iIndex = Main->m_pScripts->m_aItems.Find(csDupe);
			}
			if ( iIndex != -1 )
			{
				CSObject * pDupe = (CSObject *) Main->m_pScripts->m_aItems.GetAt(iIndex);
				if ( pItem->m_csCategory == "<none>" )
					pItem->m_csCategory = pDupe->m_csCategory;
				if ( pItem->m_csSubsection == "<none>" )
					pItem->m_csSubsection = pDupe->m_csSubsection;
				if ( pItem->m_csDescription.Find("<unnamed>") != -1 )
					pItem->m_csDescription = pDupe->m_csDescription;
			}
		}
		if ( pItem->m_csDescription.Find("@") != -1 )
			pItem->m_csDescription.Replace("@", pItem->m_csSubsection);
		CString csString;
		csString.Format("%s [%s]", pItem->m_csDescription, pItem->m_csValue);
		int index = this->m_ccbEntry.AddString(csString);
		this->m_ccbEntry.SetItemData(index, (DWORD) pItem);
	}

	for ( i = 0; i < ITEM_QTY; i++)
	{
		int iIndex = m_ccbItemType.AddString(ItemTypeName[i]);
		m_ccbItemType.SetItemData(iIndex, i);
	}
	m_ccbItemType.SetCurSel(0);

	this->m_ccbDupeitem.AddString("__NO_ITEM__");

	// Fill in the category box
	if (!Main->m_pScripts->m_olItems.IsEmpty())
	{
		POSITION pos = Main->m_pScripts->m_olItems.GetHeadPosition();
		while (pos != NULL)
		{
			CCategory * pCategory = (CCategory *) Main->m_pScripts->m_olItems.GetNext(pos);
			int iIndex = m_ccbCategory.AddString(pCategory->m_csName);
			m_ccbCategory.SetItemData(iIndex, (DWORD) pCategory);
		}
	}
	
	m_hPaletteIcon = Main->LoadIcon(IDI_PALETTE);
	this->m_cbPalette.SetIcon(m_hPaletteIcon);
	if ( m_pItem != NULL )
	{
		for ( i = 0; i < this->m_ccbEntry.GetCount(); i++ )
		{
			CSObject * pItem = (CSObject *) this->m_ccbEntry.GetItemData(i);
			if ( pItem->m_csValue == m_pItem->m_csValue )
			{
				this->m_ccbEntry.SetCurSel(i);
				this->OnItemEdit();
				break;
			}
		}
	}
	if ( m_wBase != 0 )
	{
		// We started in new mode
		this->OnItemNew();
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CItemEditDlg::OnSelchangeCategory() 
{
	// TODO: Add your control notification handler code here
	CString csCategory;
	m_ccbCategory.GetLBText(m_ccbCategory.GetCurSel(), csCategory);
	if ( (csCategory != ""))
	{
		m_ccbSubsection.ResetContent();
		CCategory * pCategory = (CCategory *) m_ccbCategory.GetItemData(m_ccbCategory.GetCurSel());
		if (pCategory == NULL)
			return;
		if (!pCategory->m_SubsectionList.IsEmpty())
		{
			POSITION pos = pCategory->m_SubsectionList.GetHeadPosition();
			while (pos != NULL)
			{
				CSubsection * pSubsection = (CSubsection *) pCategory->m_SubsectionList.GetNext(pos);
				int iIndex = m_ccbSubsection.AddString(pSubsection->m_csName);
				m_ccbSubsection.SetItemData(iIndex, (DWORD) pSubsection);
			}
		}
		m_ccbSubsection.SetCurSel(0);
	}
	else
	{
		m_ccbSubsection.ResetContent();
		m_ccbSubsection.SetCurSel(-1);
	}
	
}

void CItemEditDlg::EnableControls(bool bEnable)
{
	m_cbRepairable.EnableWindow(bEnable);
	m_cbDyeable.EnableWindow(bEnable);
	m_cbMagical.EnableWindow(bEnable);
	m_ceWeight.EnableWindow(bEnable);
	//m_ccbSubsection.EnableWindow(bEnable);
	m_csBase.EnableWindow(bEnable);
	m_ccbSpell.EnableWindow(bEnable);
	m_ccbSkill.EnableWindow(bEnable);
	m_ceSellValue.EnableWindow(bEnable);
	m_ceSellValueMax.EnableWindow(bEnable);
	m_ceReqStr.EnableWindow(bEnable);
	m_ceName.EnableWindow(bEnable);
	m_ccbItemType.EnableWindow(bEnable);
	m_ceItemID.EnableWindow(bEnable);
	m_ceHPMin.EnableWindow(bEnable);
	m_ceHPMax.EnableWindow(bEnable);
	//m_ceDescription.EnableWindow(bEnable);
	m_ceDamageMin.EnableWindow(bEnable);
	m_ceDamageMax.EnableWindow(bEnable);
	m_ccbColor.EnableWindow(bEnable);
	m_ceCharges.EnableWindow(bEnable);
	//m_ccbCategory.EnableWindow(bEnable);
	m_ceBuyValue.EnableWindow(bEnable);
	m_ceBuyValueMax.EnableWindow(bEnable);
	m_ceArmourMin.EnableWindow(bEnable);
	m_ceArmourMax.EnableWindow(bEnable);
	m_ceArmourBonus.EnableWindow(bEnable);	
}

void CItemEditDlg::OnMagical() 
{
	// TODO: Add your control notification handler code here
	if ((m_cbMagical.GetState() & 0x0003) == 1)
	{
		m_ccbSpell.EnableWindow(true);
		m_ceCharges.EnableWindow(true);
		m_ceArmourBonus.EnableWindow(true);
	}
	else
	{
		m_ccbSpell.EnableWindow(false);
		m_ceCharges.EnableWindow(false);
		m_ceArmourBonus.EnableWindow(false);
	}
}

void CItemEditDlg::OnSelchangeItemtype() 
{
	// TODO: Add your control notification handler code here
	int iSel = m_ccbItemType.GetCurSel();
	int iType = m_ccbItemType.GetItemData(iSel);
	bool bWeapon = false;
	bool bArmour = false;
	if (iType == ITEM_WEAPON_MACE_SMITH ||
		iType == ITEM_WEAPON_MACE_SHARP ||
		iType == ITEM_WEAPON_MACE_STAFF ||
		iType == ITEM_WEAPON_SWORD ||
		iType == ITEM_WEAPON_FENCE ||
		iType == ITEM_WEAPON_BOW)
		bWeapon = true;
	if (iType == ITEM_ARMOR ||
		iType == ITEM_CLOTHING)
		bArmour = true;
	m_ccbSkill.EnableWindow(bWeapon);
	m_ceDamageMin.EnableWindow(bWeapon);
	m_ceDamageMax.EnableWindow(bWeapon);
	m_ceArmourMin.EnableWindow(bArmour);
	m_ceArmourMax.EnableWindow(bArmour);
	m_ceReqStr.EnableWindow(bWeapon | bArmour);
	
}

void CItemEditDlg::InitData(CItem *pItem)
{
	// Clear out the text in all of the windows
	m_ceSellValue.SetWindowText("");
	m_ceSellValueMax.SetWindowText("");
	m_ceBuyValue.SetWindowText("");
	m_ceBuyValueMax.SetWindowText("");
	m_ceWeight.SetWindowText("");
	m_ceHPMin.SetWindowText("");
	m_ceHPMax.SetWindowText("");
	m_ceDamageMin.SetWindowText("");
	m_ceDamageMax.SetWindowText("");
	m_ceArmourMin.SetWindowText("");
	m_ceArmourMax.SetWindowText("");
	m_ceReqStr.SetWindowText("");
	m_ceCharges.SetWindowText("");
	m_ceArmourBonus.SetWindowText("");
	m_ceName.SetWindowText("");
	m_ceItemID.SetWindowText("");
	m_ccbColor.SetWindowText("");
	m_cbDyeable.SetCheck(0);
	m_cbRepairable.SetCheck(0);
	m_cbMagical.SetCheck(0);
	m_ccbSpell.SetCurSel(0);
	m_ccbItemType.SetCurSel(0);
	m_ccbSkill.SetCurSel(-1);
	m_ccbCategory.SetCurSel(-1);
	m_ccbSubsection.SetCurSel(-1);
	m_ceDescription.SetWindowText("");

	if ( m_bNew )
	{
		CString csValue;
		csValue.Format("%04x", m_wBase);
		int iIndex = Main->m_pScripts->m_aItems.Find(csValue);
		if ( iIndex != -1 )
		{
			CItem * pBase = (CItem *) Main->m_pScripts->m_aItems.GetAt(iIndex);
			if ( pBase )
			{
				pItem->Copy(pBase);
				pItem->m_wItemBase = m_wBase;
			}
		}
	}
	m_wBase = 0;

	if ( pItem->m_csDupeItem != "" )
	{
		CString csDupe;
		csDupe.Format("%s", pItem->m_csDupeItem);
		int iIndex = Main->m_pScripts->m_aItems.Find(csDupe);
		if ( iIndex != -1 )
		{
			CItem * pDupe = (CItem *) Main->m_pScripts->m_aItems.GetAt(iIndex);
			if ( pItem->m_csCategory == "<none>" )
				pItem->m_csCategory = pDupe->m_csCategory;
			if ( pItem->m_csSubsection == "<none>" )
				pItem->m_csSubsection = pDupe->m_csSubsection;
			if ( pItem->m_csDescription.Find("<unnamed>") != -1 )
				pItem->m_csDescription = pDupe->m_csDescription;
		}
	}
	if ( pItem->m_csDescription.Find("@") != -1 )
		pItem->m_csDescription.Replace("@", pItem->m_csSubsection);
	CString csVal;
	if (pItem->m_irSellValue.max != 0)
	{
		csVal.Format("%ld", pItem->m_irSellValue.max);
		m_ceSellValueMax.SetWindowText(csVal);
	}
	if (pItem->m_irSellValue.min != 0)
	{
		csVal.Format("%ld", pItem->m_irSellValue.min);
		m_ceSellValue.SetWindowText(csVal);
	}
	if (pItem->m_irBuyValue.max != 0)
	{
		csVal.Format("%ld", pItem->m_irBuyValue.max);
		m_ceBuyValueMax.SetWindowText(csVal);
	}
	if (pItem->m_irBuyValue.min != 0)
	{
		csVal.Format("%ld", pItem->m_irBuyValue.min);
		m_ceBuyValue.SetWindowText(csVal);
	}
	if (pItem->m_fWeight != 0)
	{
		csVal.Format("%f", pItem->m_fWeight);
		m_ceWeight.SetWindowText(csVal);
	}
	if (pItem->m_irHitPoints.min != 0)
	{
		csVal.Format("%ld", pItem->m_irHitPoints.min);
		m_ceHPMin.SetWindowText(csVal);
	}
	if (pItem->m_irHitPoints.max != 0)
	{
		csVal.Format("%ld", pItem->m_irHitPoints.max);
		m_ceHPMax.SetWindowText(csVal);
	}
	if (pItem->m_irDamage.min != 0)
	{
		csVal.Format("%ld", pItem->m_irDamage.min);
		m_ceDamageMin.SetWindowText(csVal);
	}
	if (pItem->m_irDamage.max != 0)
	{
		csVal.Format("%ld", pItem->m_irDamage.max);
		m_ceDamageMax.SetWindowText(csVal);
	}
	if (pItem->m_irArmour.min != 0)
	{
		csVal.Format("%ld", pItem->m_irArmour.min);
		m_ceArmourMin.SetWindowText(csVal);
	}
	if (pItem->m_irArmour.max != 0)
	{
		csVal.Format("%ld", pItem->m_irArmour.max);
		m_ceArmourMax.SetWindowText(csVal);
	}
	if (pItem->m_byReqStr != 0)
	{
		csVal.Format("%ld", pItem->m_byReqStr);
		m_ceReqStr.SetWindowText(csVal);
	}
	if (pItem->m_bySpell != 0)
	{
		// Do something here with the spells
	}
	if (pItem->m_iCharges != 0)
	{
		csVal.Format("%ld", pItem->m_iCharges);
		m_ceCharges.SetWindowText(csVal);
	}
	if (pItem->m_iArmourBonus != 0)
	{
		csVal.Format("%ld", pItem->m_iArmourBonus);
		m_ceArmourBonus.SetWindowText(csVal);
	}
	if (pItem->m_csItemName != "")
		m_ceName.SetWindowText(pItem->m_csItemName);
	if (pItem->m_csSkill != "")
	{
		// Set the skill selelction to this one
	}
	if (pItem->m_wItemBase != 0)
	{
		csVal.Format("%04x", pItem->m_wItemBase);
		m_ceItemID.SetWindowText(csVal);
	}
	if ( this->m_ccbColor.SelectString(-1, pItem->m_csColor) == CB_ERR )
	{
		this->m_ccbColor.SetCurSel(-1);
		this->m_ccbColor.SetWindowText(pItem->m_csColor);
		DrawItem();
	}
	if (pItem->m_bDyeable)
		m_cbDyeable.SetCheck(1);
	if (pItem->m_bRepairable)
		m_cbRepairable.SetCheck(1);
	if (pItem->m_csSkill != "")
		m_ccbSkill.SetCurSel(m_ccbSkill.FindString(-1, pItem->m_csSkill));
	CString csType = ItemTypeName[pItem->m_dwType];
	m_ccbItemType.SetCurSel(m_ccbItemType.FindStringExact(-1, csType));
	bool bWeapon = false;
	bool bArmour = false;
	if (pItem->m_bySpell != 0)
	{
		CString csSpell = SpellNames[pItem->m_bySpell];
		m_ccbSpell.SetCurSel(m_ccbSpell.FindStringExact(-1, csSpell));
	}
	if (pItem->m_csDupeItem != "")
	{
		CDrewskyApp * pApp = (CDrewskyApp *) AfxGetApp();
		CString csDupe;
		csDupe.Format("%s", pItem->m_csDupeItem);
		int iIndex = pApp->m_pScripts->m_aItems.Find(csDupe);
		if ( iIndex != -1 )
		{
			CSObject * pDupe = (CSObject *) pApp->m_pScripts->m_aItems.GetAt(iIndex);
			int iCurIndex = this->m_ccbDupeitem.GetCurSel();
			if (iCurIndex == -1)
			{
				int iIndex = this->m_ccbDupeitem.FindStringExact(-1, pDupe->m_csDescription);
				if (iIndex == -1)
				{
					csVal.Format("%s", pItem->m_csDupeItem);
					int iNewIndex = m_ccbDupeitem.AddString(csVal);
					m_ccbDupeitem.SetCurSel(iNewIndex);
				}
				else
					m_ccbDupeitem.SetCurSel(iIndex);
			}
			if ( !m_cbEdit.IsWindowEnabled() )
				EnableControls(false);
		}
	}
	else
	{
		if ( !m_cbEdit.IsWindowEnabled() )
			EnableControls(true);
		m_ccbDupeitem.SetCurSel(-1);
		if (pItem->m_wAttr & 0x20)
		{
			m_cbMagical.SetCheck(1);
			m_ccbSpell.EnableWindow(!m_cbEdit.IsWindowEnabled());
			m_ceCharges.EnableWindow(!m_cbEdit.IsWindowEnabled());
			m_ceArmourBonus.EnableWindow(!m_cbEdit.IsWindowEnabled());
		}
		else
		{
			m_ccbSpell.EnableWindow(!m_cbEdit.IsWindowEnabled());
			m_ceCharges.EnableWindow(!m_cbEdit.IsWindowEnabled());
			m_ceArmourBonus.EnableWindow(!m_cbEdit.IsWindowEnabled());
		}
		if (pItem->m_dwType == ITEM_WEAPON_MACE_SMITH ||
			pItem->m_dwType == ITEM_WEAPON_MACE_SHARP ||
			pItem->m_dwType == ITEM_WEAPON_MACE_STAFF ||
			pItem->m_dwType == ITEM_WEAPON_SWORD ||
			pItem->m_dwType == ITEM_WEAPON_FENCE ||
			pItem->m_dwType == ITEM_WEAPON_BOW)
		bWeapon = true;
		if (pItem->m_dwType == ITEM_ARMOR ||
			pItem->m_dwType == ITEM_CLOTHING)
			bArmour = true;
		m_ccbSkill.EnableWindow(bWeapon && !m_cbEdit.IsWindowEnabled());
		m_ceDamageMin.EnableWindow(bWeapon && !m_cbEdit.IsWindowEnabled());
		m_ceDamageMax.EnableWindow(bWeapon && !m_cbEdit.IsWindowEnabled());
		m_ceArmourMin.EnableWindow(bArmour && !m_cbEdit.IsWindowEnabled());
		m_ceArmourMax.EnableWindow(bArmour && !m_cbEdit.IsWindowEnabled());
		m_ceReqStr.EnableWindow((bWeapon | bArmour) && !m_cbEdit.IsWindowEnabled());
	}

	if ( (pItem->m_csCategory == "") || (pItem->m_csSubsection == "") || (pItem->m_csDescription == ""))
	{
		CItem * pDupe = NULL;
		CDrewskyApp * pApp = (CDrewskyApp*) AfxGetApp();
		if (pItem->m_csDupeItem != "")
		{
			CString csDupe;
			csDupe.Format("%s", pItem->m_csDupeItem);
			int iIndex = pApp->m_pScripts->m_aItems.Find(csDupe);
			if ( iIndex != -1 )
				pDupe = (CItem *) pApp->m_pScripts->m_aItems.GetAt(iIndex);
		}
		if (pDupe == NULL)
		{
			AfxMessageBox("Category information was somehow lost for this object!", MB_OK | MB_ICONEXCLAMATION);
			m_ccbCategory.SetCurSel(0);
			m_ccbSubsection.SetCurSel(0);
			m_ceDescription.SetWindowText("");
		}
		else
		{
			if (pItem->m_csCategory == "")
				m_ccbCategory.SetCurSel(m_ccbCategory.FindStringExact(-1, pDupe->m_csCategory));
			else
				m_ccbCategory.SetCurSel(m_ccbCategory.FindStringExact(-1, m_pItem->m_csCategory));
			this->OnSelchangeCategory();
			if (pItem->m_csSubsection == "")
				m_ccbSubsection.SetCurSel(m_ccbSubsection.FindStringExact(-1, pDupe->m_csSubsection));
			else
				m_ccbSubsection.SetCurSel(m_ccbSubsection.FindStringExact(-1, m_pItem->m_csSubsection));			
			if (pItem->m_csDescription == "")
				m_ceDescription.SetWindowText(pDupe->m_csDescription);
			else
				m_ceDescription.SetWindowText(m_pItem->m_csDescription);
		}

	}
	else
	{
		m_ccbCategory.SetCurSel(m_ccbCategory.FindStringExact(-1, pItem->m_csCategory));
		this->OnSelchangeCategory();
		m_ccbSubsection.SetCurSel(m_ccbSubsection.FindStringExact(-1, pItem->m_csSubsection));
		m_ceDescription.SetWindowText(pItem->m_csDescription);
	}

	// Fill the triggers.
	CString csTrigs;
	CString crlf;
	crlf.Format("%c%c", 0x0d, 0x0a);
	for ( int i = 0; i < pItem->m_csaTriggers.GetSize(); i++ )
	{
		csTrigs += pItem->m_csaTriggers.GetAt(i);
		csTrigs += crlf;
	}
	this->m_ceTriggers.SetWindowText(csTrigs);

}

void CItemEditDlg::OnSelchangeDupeitem() 
{
	// TODO: Add your control notification handler code here
	int iIndex = this->m_ccbDupeitem.GetCurSel();
	CString csSelection;
	if (iIndex == -1)
	{
		this->m_ccbDupeitem.SetWindowText("__NO_ITEM__");
		csSelection = "__NO_ITEM__";
	}
	else
		this->m_ccbDupeitem.GetLBText(iIndex, csSelection);
	if (csSelection == "__NO_ITEM__")
		this->m_pItem->m_csDupeItem = "";		
	else
	{
		CString csDupeItem;
		this->m_ccbDupeitem.GetLBText(iIndex, csDupeItem);
		this->m_pItem->m_csDupeItem = csDupeItem;
		CDrewskyApp * pApp = (CDrewskyApp *) AfxGetApp();
		CString csDupe;
		csDupe.Format("%s", csDupeItem);
		int iIndex = pApp->m_pScripts->m_aItems.Find(csDupe);
		if ( iIndex != -1 )
		{
			CItem * pDupe = (CItem *) pApp->m_pScripts->m_aItems.GetAt(iIndex);
			if (pDupe != NULL)
				this->m_pItem->Dupe(pDupe);
		}
	}
	this->InitData(this->m_pItem);

}

void CItemEditDlg::OnOK() 
{
	CWaitCursor hourglass;
	if ( !m_iEdits || Main->m_pScripts->SaveItems() )
		CDialog::OnOK();
}

void CItemEditDlg::OnAddcategory() 
{
	CAddValueDialog dlg;
	CCategory * pCategory;
	if (dlg.DoModal() == IDOK)
	{
		if (m_ccbCategory.FindStringExact(0, dlg.m_csValue) != CB_ERR)
		{
			AfxMessageBox("Category already exists", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		else
			pCategory = FindCategory(&Main->m_pScripts->m_olNPCs, dlg.m_csValue);
		int iIndex = m_ccbCategory.AddString(dlg.m_csValue);
		m_ccbCategory.SetItemData(iIndex, (DWORD) pCategory);
		m_ccbCategory.SetCurSel(iIndex);
		this->OnSelchangeCategory();
	}
	return;	
}

void CItemEditDlg::OnAddsubsection() 
{
	CAddValueDialog dlg;
	CSubsection * pSubsection;
	if (dlg.DoModal() == IDOK)
	{
		if (m_ccbSubsection.FindStringExact(0, dlg.m_csValue) != CB_ERR)
		{
			AfxMessageBox("Subsection already exists", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		else
		{
			CCategory * pCategory;
			int iSel = m_ccbCategory.GetCurSel();
			if (iSel == -1)
				return;
			pCategory = (CCategory *) m_ccbCategory.GetItemData(iSel);
			pSubsection = FindSubsection(pCategory, dlg.m_csValue);
		}
		int iIndex = m_ccbSubsection.AddString(dlg.m_csValue);
		m_ccbSubsection.SetItemData(iIndex, (DWORD) pSubsection);
		m_ccbSubsection.SetCurSel(iIndex);
	}
	return;
}

void CItemEditDlg::OnNoindex() 
{
	int iState = m_cbNoIndex.GetCheck();
	if (iState == 0)
	{
		// The button is unchecked
		this->m_ccbCategory.EnableWindow(!m_cbEdit.IsWindowEnabled());
		this->m_ccbSubsection.EnableWindow(!m_cbEdit.IsWindowEnabled());
		this->m_ceDescription.EnableWindow(!m_cbEdit.IsWindowEnabled());
	}
	else
	{
		// The button is checked
		this->m_ccbCategory.EnableWindow(m_cbEdit.IsWindowEnabled());
		this->m_ccbSubsection.EnableWindow(m_cbEdit.IsWindowEnabled());
		this->m_ceDescription.EnableWindow(m_cbEdit.IsWindowEnabled());
	}
}


void CItemEditDlg::OnChangeName() 
{
	CString csText;
	this->m_ceName.GetWindowText(csText);
	this->m_ceDescription.SetWindowText(csText);
}

void CItemEditDlg::OnTrigedit() 
{
	CTriggerEditDlg dlg;
	CTrigger trigger;
	trigger.m_csaEvents.Copy( this->m_pItem->m_csaTriggers );
	dlg.m_pCurrentTrigger = &trigger;
	if ( dlg.DoModal() == IDOK )
	{
		this->m_pItem->m_csaTriggers.Copy( trigger.m_csaEvents );
		this->m_ceTriggers.Clear();
		CString csTrigs;
		CString crlf;
		crlf.Format("%c%c", 0x0d, 0x0a);
		for ( int i = 0; i < m_pItem->m_csaTriggers.GetSize(); i++ )
		{
			csTrigs += m_pItem->m_csaTriggers.GetAt(i);
			csTrigs += crlf;
		}
		this->m_ceTriggers.SetWindowText(csTrigs);
		return;
	}
}

void CItemEditDlg::OnIepalette() 
{
	CColorSelectionDlg dlg;
	if ( dlg.DoModal() == IDOK )
	{
		CString csColor;
		csColor.Format("%05x", dlg.GetColorIndex());
		this->m_ccbColor.SetWindowText(csColor);
		DrawItem();
	}
}

void CItemEditDlg::FillSpells()
{
	CDrewskyApp * pApp = (CDrewskyApp *) AfxGetApp();
	pApp->m_pScripts->LoadTables();
	for ( int i = 1; i < pApp->m_pScripts->m_tables.m_spells.GetSize(); i++ )
	{
		CTObject * pBase = (CTObject *) pApp->m_pScripts->m_tables.m_spells.GetAt(i);
		if ( pBase )
		{
			CTSpellDef spell;
			spell.m_csFilename = pBase->m_csFilename;
			spell.m_csValue = pBase->m_csValue;
			spell.Load();
			int index = this->m_ccbSpell.AddString(spell.m_csName);
			this->m_ccbSkill.SetItemData(index, i);
		}
	}
	this->m_ccbSpell.AddString(" <none> ");
}

void CItemEditDlg::FillColors()
{
	CDrewskyApp * pApp = (CDrewskyApp *) AfxGetApp();
	pApp->m_pScripts->LoadDefs();
	for (int i = 0; i < pApp->m_pScripts->m_aDefs.GetSize(); i++)
	{
		CDef * pDef = (CDef *) pApp->m_pScripts->m_aDefs.GetAt(i);
		if ( pDef && pDef->m_csGroup == "COLORS" )
		{
			int iIndex = this->m_ccbColor.AddString(pDef->m_csValue);
			this->m_ccbColor.SetItemData(iIndex, (DWORD) pDef);
		}
	}
}

void CItemEditDlg::FillDupeItems()
{
	Main->m_pScripts->LoadItems();
	for (int i = 0; i < Main->m_pScripts->m_aItems.GetSize(); i++)
	{
		CSObject * pItem = (CSObject *) Main->m_pScripts->m_aItems.GetAt(i);
		if ( pItem && pItem->m_csDupeItem == "" )
		{
			int index = this->m_ccbDupeitem.AddString(pItem->m_csValue);
			this->m_ccbDupeitem.SetItemData(index, i);
		}
	}
}

void CItemEditDlg::EnableEditWindows(bool bEnable)
{
	this->m_cbAddCategory.EnableWindow(bEnable);
	this->m_cbAddSubsection.EnableWindow(bEnable);
	this->m_cbApply.ShowWindow(bEnable ? SW_SHOW : SW_HIDE);
	this->m_cbCancel.EnableWindow(!bEnable);
	this->m_cbCancelEdit.ShowWindow(bEnable ? SW_SHOW : SW_HIDE);
	this->m_cbDyeable.EnableWindow(bEnable);
	this->m_cbEdit.EnableWindow(!bEnable);
	this->m_cbMagical.EnableWindow(bEnable);
	this->m_cbNew.EnableWindow(!bEnable);
	this->m_cbNoIndex.EnableWindow(bEnable);
	this->m_cbOK.EnableWindow(!bEnable);
	this->m_cbPalette.EnableWindow(bEnable);
	this->m_cbRepairable.EnableWindow(bEnable);
	this->m_cbTrigEdit.EnableWindow(bEnable);
	this->m_ccbCategory.EnableWindow(bEnable);
	this->m_ccbColor.EnableWindow(bEnable);
	this->m_ccbDupeitem.EnableWindow(bEnable);
	this->m_ccbEntry.EnableWindow(!bEnable);
	this->m_ccbItemType.EnableWindow(bEnable);
	this->m_ccbSkill.EnableWindow(bEnable);

	if ( bEnable && m_cbMagical.GetCheck() )
	{
		this->m_ccbSpell.EnableWindow(bEnable);
		this->m_ceCharges.EnableWindow(bEnable);
		this->m_ceArmourBonus.EnableWindow(bEnable);
	}
	else
	{
		this->m_ccbSpell.EnableWindow(false);
		this->m_ceCharges.EnableWindow(false);
		this->m_ceArmourBonus.EnableWindow(false);
	}

	this->m_ccbSubsection.EnableWindow(bEnable);
	this->m_ceArmourMax.EnableWindow(bEnable);
	this->m_ceArmourMin.EnableWindow(bEnable);
	this->m_ceBuyValue.EnableWindow(bEnable);
	this->m_ceBuyValueMax.EnableWindow(bEnable);
	this->m_ceDamageMax.EnableWindow(bEnable);
	this->m_ceDamageMin.EnableWindow(bEnable);
	this->m_ceDescription.EnableWindow(bEnable);
	this->m_ceHPMax.EnableWindow(bEnable);
	this->m_ceHPMin.EnableWindow(bEnable);
	this->m_ceItemID.EnableWindow(bEnable);
	this->m_ceName.EnableWindow(bEnable);
	this->m_ceReqStr.EnableWindow(bEnable);
	this->m_ceSellValue.EnableWindow(bEnable);
	this->m_ceSellValueMax.EnableWindow(bEnable);
	this->m_ceTriggers.EnableWindow(bEnable);
	this->m_ceWeight.EnableWindow(bEnable);
}

void CItemEditDlg::OnSelchangeItementry() 
{
	int iSel = this->m_ccbEntry.GetCurSel();
	if ( iSel == -1 )
		return;
	if ( m_pItem )
		delete m_pItem;
	m_pItem = new CItem;
	CSObject * pBase = (CSObject *) m_ccbEntry.GetItemData(iSel);
	m_pItem->m_csValue = pBase->m_csValue;
	m_pItem->m_csFilename = pBase->m_csFilename;
	m_pItem->Load();
	if ( m_pItem == NULL )
		return;
	InitData(m_pItem);
}

bool CItemEditDlg::ValidateData()
{
	// Make sure all of the data is valid
	int iIndex = this->m_ccbDupeitem.GetCurSel();
	CString csDupeitem;
	if (iIndex != -1)
		this->m_ccbDupeitem.GetLBText(iIndex, csDupeitem);
	else
		csDupeitem = "__NO_ITEM__";
	if (csDupeitem == "__NO_ITEM__")
	{
		// This doesn't have a dupeitem, so we need to check the values
		int iType = this->m_ccbItemType.GetCurSel();
		byte byType =(BYTE) this->m_ccbItemType.GetItemData(iType);
		if (byType == ITEM_WEAPON_MACE_SMITH ||
			byType == ITEM_WEAPON_MACE_SHARP ||
			byType == ITEM_WEAPON_MACE_STAFF ||
			byType == ITEM_WEAPON_SWORD ||
			byType == ITEM_WEAPON_FENCE ||
			byType == ITEM_WEAPON_BOW)
		{
			// It is a weapon...check for weapon attributes
			if (this->m_ccbSkill.GetCurSel() == -1 && !Main->m_bIgnoreWarnings)
			{
				AfxMessageBox("Weapon Types must have an associated weapon skill.", MB_OK | MB_ICONEXCLAMATION);
				return false;
			}
			CString csDamMin, csDamMax;
			this->m_ceDamageMax.GetWindowText(csDamMax);
			this->m_ceDamageMin.GetWindowText(csDamMin);
			int iDamMin, iDamMax;
			iDamMin = atoi(csDamMin);
			iDamMax = atoi(csDamMax);
			if (iDamMin == 0 && iDamMax == 0 && !Main->m_bIgnoreWarnings)
			{
				AfxMessageBox("Your weapon must have damage values.", MB_OK | MB_ICONEXCLAMATION);
				return false;
			}
			if (iDamMin == 0 || iDamMax == 0 && !Main->m_bIgnoreWarnings)
			{
				int result = AfxMessageBox("One of your mininum or maximum damage fields is empty.\nDo you wish for the weapon to always do the same amount of damage?", MB_YESNO | MB_ICONQUESTION);
				if (result == IDNO)
					return false;
				else
				{
					if (iDamMin == 0)
						iDamMin = iDamMax;
					else
						iDamMax = iDamMin;
				}
			}
			if (iDamMax < iDamMin)
			{
				int iTmp = iDamMin;
				iDamMin = iDamMax;
				iDamMax = iTmp;
			}
			csDamMin.Format("%ld", iDamMin);
			csDamMax.Format("%ld", iDamMax);
			this->m_ceDamageMax.SetWindowText(csDamMax);
			this->m_ceDamageMin.SetWindowText(csDamMin);
		}

		if (byType == ITEM_ARMOR)
		{
			// This is armour
			CString csArmMin, csArmMax;
			this->m_ceArmourMax.GetWindowText(csArmMax);
			this->m_ceArmourMin.GetWindowText(csArmMin);
			int iArmMin, iArmMax;
			iArmMin = atoi(csArmMin);
			iArmMax = atoi(csArmMax);
			if (iArmMin == 0 && iArmMax == 0 && !Main->m_bIgnoreWarnings)
			{
				AfxMessageBox("Your armour must have armour values.", MB_OK | MB_ICONEXCLAMATION);
				return false;
			}
			if (iArmMin == 0 || iArmMax == 0)
			{
				// Armour really doesn't need a range, so don't prompt for one
				if (iArmMin == 0)
					iArmMin = iArmMax;
				else
					iArmMax = iArmMin;
			}
			if (iArmMax < iArmMin)
			{
				int iTmp = iArmMin;
				iArmMin = iArmMax;
				iArmMax = iTmp;
			}
			csArmMin.Format("%ld", iArmMin);
			csArmMax.Format("%ld", iArmMax);
			this->m_ceArmourMax.SetWindowText(csArmMax);
			this->m_ceArmourMin.SetWindowText(csArmMin);
		}
		
		// Check to see if the item is magical
		if (this->m_cbMagical.GetCheck())
		{
			// The item is magical...make sure it has magical properties
			int iSpellIndex = this->m_ccbSpell.GetCurSel();
			CString csSpell, csCharges, csArmourBonus;
			this->m_ccbSpell.GetLBText(iSpellIndex, csSpell);
			this->m_ceArmourBonus.GetWindowText(csArmourBonus);
			this->m_ceCharges.GetWindowText(csCharges);
			if (csSpell == "  NONE  " && csArmourBonus == "" && csCharges == "" && !Main->m_bIgnoreWarnings)
			{
				int iResult = AfxMessageBox("You have chosen a magical item, but set no magical properties.\nDo you want the item to be magical?", MB_YESNO | MB_ICONQUESTION);
				if (iResult == IDNO)
					this->m_cbMagical.SetCheck(0);
				else
					return false;
			}
		}

		// Check for normal stuff
		CString csBuyVal, csSellVal;
		this->m_ceBuyValue.GetWindowText(csBuyVal);
		this->m_ceSellValue.GetWindowText(csSellVal);
		int iBuyVal, iSellVal;
		iBuyVal = atoi(csBuyVal);
		iSellVal = atoi(csSellVal);
		if (iBuyVal == 0 && !Main->m_bIgnoreWarnings)
		{
			int iResult = AfxMessageBox("The item has no buy value.\nNo vendor will be able to sell this item.", MB_OKCANCEL | MB_ICONEXCLAMATION);
			if (iResult == IDCANCEL)
				return false;
		}
		if (iSellVal == 0 && !Main->m_bIgnoreWarnings)
		{
			int iResult = AfxMessageBox("The item has no sell value.\nNo vendor will be able to buy this item.", MB_OKCANCEL | MB_ICONEXCLAMATION);
			if (iResult == IDCANCEL)
				return false;
		}
		if (iSellVal > iBuyVal && !Main->m_bIgnoreWarnings)
		{
			int iResult = AfxMessageBox("The sell value is higher than the buy value.\nPlayers can use this as an exploit to make unlimited money.", MB_OKCANCEL | MB_ICONEXCLAMATION);
			if (iResult == IDCANCEL)
				return false;
		}
		CString csWeight;
		this->m_ceWeight.GetWindowText(csWeight);
		if (csWeight.SpanIncluding("0123456789.") != csWeight)
		{
			AfxMessageBox("The value in the weight field is invalid.", MB_OK | MB_ICONEXCLAMATION);
			return false;
		}
		float fWeight = (float) atof(csWeight);
		if (fWeight == 0.0 && !Main->m_bIgnoreWarnings)
		{
			int iResult = AfxMessageBox("The item has no weight.  Players will be able to carry unlimited quantities of this item.", MB_OKCANCEL | MB_ICONEXCLAMATION);
			if (iResult == IDCANCEL)
				return false;
		}
		CString csHPMin, csHPMax;
		this->m_ceHPMax.GetWindowText(csHPMax);
		this->m_ceHPMin.GetWindowText(csHPMin);
		int iHPMin, iHPMax;
		iHPMin = atoi(csHPMin);
		iHPMax = atoi(csHPMax);
		if (iHPMin == 0 && iHPMax == 0 && !Main->m_bIgnoreWarnings)
		{
			int iResult = AfxMessageBox("The Hit Point fields are empty for this item.\nThis will make the item indestructible.", MB_OKCANCEL | MB_ICONEXCLAMATION);
			if (iResult == IDCANCEL)
				return false;
		}
		if (iHPMin == 0 || iHPMax == 0)
		{
			// HP doesn't need a range, so we'll just fill in the blank one
			if (iHPMin = 0)
				iHPMin = iHPMax;
			else
				iHPMax = iHPMin;
		}
		if (iHPMax < iHPMin)
		{
			int iTmp = iHPMin;
			iHPMin = iHPMax;
			iHPMax = iTmp;
		}
		csHPMin.Format("%ld", iHPMin);
		csHPMax.Format("%ld", iHPMax);
		this->m_ceHPMax.SetWindowText(csHPMax);
		this->m_ceHPMin.SetWindowText(csHPMin);
		// hmmm...anything else to check the validity of?

		// Retrieve the data
		CString csVal;
		int iIndex;
		m_pItem->m_bCustom = true;
		m_pItem->m_bDyeable = (this->m_cbDyeable.GetCheck() == 1) ? true : false;
		m_pItem->m_bRepairable = (this->m_cbRepairable.GetCheck() == 1) ? true : false;
		this->m_ceReqStr.GetWindowText(csVal);
		m_pItem->m_byReqStr = (BYTE) atoi(csVal);
		iIndex = this->m_ccbSpell.GetCurSel();
		if (iIndex != -1 && (this->m_cbMagical.GetCheck() == 1))
			m_pItem->m_bySpell = (BYTE) this->m_ccbSpell.GetItemData(iIndex);
		else
			m_pItem->m_bySpell = 0;
		iIndex = this->m_ccbItemType.GetCurSel();
		if (iIndex != -1)
			m_pItem->m_dwType = (DWORD) this->m_ccbItemType.GetItemData(iIndex);
		else
			m_pItem->m_dwType = 0;
		this->m_ccbCategory.GetWindowText(m_pItem->m_csCategory);
		this->m_ceName.GetWindowText(m_pItem->m_csItemName);
		this->m_ceDescription.GetWindowText(m_pItem->m_csDescription);
		this->m_ccbSkill.GetWindowText(m_pItem->m_csSkill);
		this->m_ccbSubsection.GetWindowText(m_pItem->m_csSubsection);
		this->m_ccbColor.GetWindowText(csVal);
		m_pItem->m_csColor = csVal;
		this->m_ceWeight.GetWindowText(csVal);
		m_pItem->m_fWeight = (float) atof(csVal);
		if (this->m_cbMagical.GetCheck())
		{
			this->m_ceArmourBonus.GetWindowText(csVal);
			m_pItem->m_iArmourBonus = atoi(csVal);
		}
		this->m_ceArmourMax.GetWindowText(csVal);
		m_pItem->m_irArmour.max = atoi(csVal);
		this->m_ceArmourMin.GetWindowText(csVal);
		m_pItem->m_irArmour.min = atoi(csVal);
		this->m_ceBuyValue.GetWindowText(csVal);
		m_pItem->m_irBuyValue.min = atoi(csVal);
		this->m_ceBuyValueMax.GetWindowText(csVal);
		m_pItem->m_irBuyValue.max = atoi(csVal);
		if ( m_pItem->m_irBuyValue.max < m_pItem->m_irBuyValue.min )
		{
			int tmp = m_pItem->m_irBuyValue.max;
			m_pItem->m_irBuyValue.max = m_pItem->m_irBuyValue.min;
			m_pItem->m_irBuyValue.min = tmp;
		}
		if (this->m_cbMagical.GetCheck())
		{
			this->m_ceCharges.GetWindowText(csVal);
			m_pItem->m_iCharges = atoi(csVal);
		}
		this->m_ceDamageMax.GetWindowText(csVal);
		m_pItem->m_irDamage.max = atoi(csVal);
		this->m_ceDamageMin.GetWindowText(csVal);
		m_pItem->m_irDamage.min = atoi(csVal);
		this->m_ceHPMax.GetWindowText(csVal);
		m_pItem->m_irHitPoints.max = atoi(csVal);
		this->m_ceHPMin.GetWindowText(csVal);
		m_pItem->m_irHitPoints.min = atoi(csVal);
		this->m_ceSellValue.GetWindowText(csVal);
		m_pItem->m_irSellValue.min = atoi(csVal);
		this->m_ceSellValueMax.GetWindowText(csVal);
		m_pItem->m_irSellValue.max = atoi(csVal);
		if ( m_pItem->m_irSellValue.max < m_pItem->m_irSellValue.min )
		{
			int tmp = m_pItem->m_irSellValue.max;
			m_pItem->m_irSellValue.max = m_pItem->m_irSellValue.min;
			m_pItem->m_irSellValue.min = tmp;
		}
		m_pItem->m_wAttr = ( this->m_cbMagical.GetCheck() == 1 ) ? 0x0020 : 0x0000;
	}
	else
	{
		// This is a dupeitem, so make sure everything is clear except the categories and such
		CString csDupeItem;
		this->m_ccbDupeitem.GetLBText(iIndex, csDupeItem);
		this->m_pItem->m_csDupeItem = csDupeItem;
		CString csCategory, csSubsection, csDescription;
		this->m_ccbCategory.GetWindowText(csCategory);
		this->m_ceDescription.GetWindowText(csDescription);
		this->m_ccbSubsection.GetWindowText(csSubsection);
		int iDupe = Main->m_pScripts->m_aItems.Find(csDupeItem);
		if ( iDupe != -1 )
		{
			CItem * pDupe = (CItem *) Main->m_pScripts->m_aItems.GetAt(iDupe);
			if (csCategory != pDupe->m_csCategory)
				m_pItem->m_csCategory = pDupe->m_csCategory;
			else 
				m_pItem->m_csCategory = "";
			if (csSubsection != pDupe->m_csSubsection)
				m_pItem->m_csSubsection = pDupe->m_csSubsection;
			else
				m_pItem->m_csSubsection = "";
			if (csDescription != pDupe->m_csDescription)
				m_pItem->m_csDescription = pDupe->m_csDescription;
			else
				m_pItem->m_csDescription = "";
			m_pItem->m_bDyeable = false;
			m_pItem->m_bRepairable = false;
			m_pItem->m_byReqStr = 0;
			m_pItem->m_bySpell = 0;
			m_pItem->m_dwType = 0;
			m_pItem->m_csSkill= "";
			m_pItem->m_csColor = "";
			m_pItem->m_fWeight = 0.0;
			m_pItem->m_iArmourBonus = 0;
			m_pItem->m_irArmour.max = 0;
			m_pItem->m_irArmour.min = 0;
			m_pItem->m_irBuyValue.max = 0;
			m_pItem->m_irBuyValue.min = 0;
			m_pItem->m_iCharges = 0;
			m_pItem->m_irDamage.max = 0;
			m_pItem->m_irDamage.min = 0;
			m_pItem->m_irHitPoints.max = 0;
			m_pItem->m_irHitPoints.min = 0;
			m_pItem->m_irSellValue.max = 0;
			m_pItem->m_irSellValue.min = 0;
			m_pItem->m_wAttr = 0;
			m_pItem->m_wItemBase = 0;
		}
	}
	if (m_cbNoIndex.GetCheck() == 1)
		m_pItem->m_bNoIndex = true;
	return true;
}

void CItemEditDlg::OnItemNew() 
{
	m_bNew = true;
	m_pItem = new (CItem);
	if ( !m_wBase )
	{
		int iSel = this->m_ccbEntry.GetCurSel();
		if ( iSel != -1 )
		{
			CItem * pItem = (CItem *) m_ccbEntry.GetItemData(iSel);
			if ( pItem )
			{
				if ( pItem->m_wItemBase )
					m_wBase = pItem->m_wItemBase;
				else
					m_wBase = (WORD) ahextoi(pItem->m_csValue);
			}
		}
	}
	m_pItem->m_wItemBase = m_wBase;
	m_pItem->m_csValue.Format("%04x", Main->m_pScripts->m_wNextItemID);
	EnableEditWindows(true);
	InitData(m_pItem);
}

void CItemEditDlg::OnItemEdit() 
{
	m_bNew = false;
	EnableEditWindows(true);
	InitData(m_pItem);
}

void CItemEditDlg::OnItemApply() 
{
	if ( ! ValidateData() )
		return;
	if ( m_bNew )
	{
		CString csCaption;
		csCaption.Format("%s [%s]", m_pItem->m_csDescription, m_pItem->m_csValue);
		int index = this->m_ccbEntry.AddString(csCaption);
		this->m_ccbEntry.SetItemDataPtr(index, (void *) m_pItem);
		this->m_ccbEntry.SelectString(-1, csCaption);
		Main->m_pScripts->m_aItems.Insert(m_pItem);
		Main->m_pScripts->m_wNextItemID++;
	}
	m_iEdits++;
	EnableEditWindows(false);
}

void CItemEditDlg::OnItemCancel() 
{
	if ( m_bNew )
	{
		if ( m_pItem )
			delete m_pItem;
		m_pItem = NULL;
	}
	m_bNew = false;	
	EnableEditWindows(false);
}

void CItemEditDlg::OnCancel() 
{
	if ( m_iEdits )
	{
		CString csMessage;
		csMessage.Format("You changed %ld items.  Are you sure you want to cancel?", m_iEdits);
		if ( AfxMessageBox(csMessage, MB_YESNO | MB_ICONQUESTION) == IDNO )
			return;
		Main->m_pScripts->ReloadItems();
		Main->m_pScripts->RecategorizeItems();
	}
	if ( m_pItem )
		delete m_pItem;
	CDialog::OnCancel();
}

void CItemEditDlg::DrawItem()
{
	if (!Main->m_dwDrawItems)
		return;
	DWORD dwIdxLookup, dwIdxSize;
	WORD wArtDatasize, wArtTrigger;
	WORD wArtHeight, wArtWidth;
	DWORD dwDStart;
	WORD wLStart [1024];
	WORD wXOffset, wXRun;
	int iCount, iX, iY;
	WORD wColor, wItemColour;
	wItemColour = 0;
	int iWidth, iHeight;

	int iSel = this->m_ccbColor.GetCurSel();
	if ( iSel != -1 )
	{
		CDef * pDef = (CDef *) this->m_ccbColor.GetItemData(iSel);
		if ( pDef )
			wItemColour = (WORD) pDef->Evaluate();
	}
	else
	{
		CString csColour;
		this->m_ccbColor.GetWindowText(csColour);
		wItemColour = (WORD) DefLookup(csColour);
	}

	DWORD dwID;
	dwID = m_pItem->m_wItemBase;
	if ( dwID == 0 )
		dwID = ahextoi(m_pItem->m_csValue);

	HBITMAP hOldBmp = m_csDisplay.GetBitmap();
	if ( hOldBmp )
		DeleteObject(hOldBmp);
	// Create the bitmap for this guy.
	CRect rc;
	m_csDisplay.GetClientRect(&rc);
	iHeight = rc.Height();
	iWidth = rc.Width();

	iHeight -= iHeight % 8;
	iWidth -= iWidth % 8;

	CByteArray bPixels;
	bPixels.SetSize(iWidth * iHeight * 3);
	// Initialize the bits with the stock window color.
	DWORD dwColor = GetSysColor(COLOR_3DFACE);
	BYTE blue = (BYTE) (( dwColor >> 16 ) & 0xFF);
	BYTE green = (BYTE) (( dwColor >> 8 ) & 0xFF);
	BYTE red = (BYTE) (( dwColor ) & 0xFF);
	for ( int x = 0; x < iWidth; x++ )
	{
		for ( int y = 0; y < iHeight; y++ )
		{
			bPixels.SetAt( ( ( (iWidth * y) + x) * 3), blue);
			bPixels.SetAt( ( ( (iWidth * y) + x) * 3) + 1, green);
			bPixels.SetAt( ( ( (iWidth * y) + x) * 3) + 2, red);
		}
	}

	dwIdxLookup = 0;
	dwIdxSize = 0;
	wArtDatasize = 0;
	wArtTrigger = 0;
	wArtHeight = 0;
	wArtWidth = 0;
	CFile cfIdxFile;
	CFile cfArtFile;
	CString csIdxFileName;
	CString csArtFileName;
	csIdxFileName.Format("%sartidx.mul", csUOPath);
	csArtFileName.Format("%sart.mul", csUOPath);
	if (!cfIdxFile.Open(csIdxFileName, CFile::modeRead | CFile::shareDenyNone))
		return;
	if (!cfArtFile.Open(csArtFileName, CFile::modeRead | CFile::shareDenyNone))
	{
		cfIdxFile.Close();
		return;
	}
	cfIdxFile.Seek(0x30000 + (dwID * 12), CFile::begin);
	cfIdxFile.Read(&dwIdxLookup, sizeof(dwIdxLookup));
	if (dwIdxLookup != 0xffffffff)
	{
		cfIdxFile.Read(&dwIdxSize, sizeof(dwIdxSize));
		cfArtFile.Seek(dwIdxLookup, CFile::begin);
		cfArtFile.Read(&wArtDatasize, sizeof(wArtDatasize));
		cfArtFile.Read(&wArtTrigger, sizeof(wArtTrigger));
		if ((wArtDatasize == 0) || (wArtTrigger == 0xffff))
		{
			// hmmm...not sure what Iggy was going to do here.
		}
		else
		{
			cfArtFile.Read(&wArtWidth, sizeof(wArtWidth));
			cfArtFile.Read(&wArtHeight, sizeof(wArtHeight));
			for (iCount = 0; iCount < wArtHeight; iCount++)
				cfArtFile.Read(&wLStart[iCount], sizeof(wLStart[iCount]));
			dwDStart = cfArtFile.GetPosition();	// Was the current position of the art file.
			iX = iY = 0;
			cfArtFile.Seek(dwDStart + wLStart[iY] * 2, CFile::begin);
			int scalefactor;
			if (Main->m_dwScaleItems)
				scalefactor = (wArtHeight / iHeight) + 1;
			else
				scalefactor = 1;
			while (iY < wArtHeight)
			{
				cfArtFile.Read(&wXOffset, sizeof(wXOffset));
				cfArtFile.Read(&wXRun, sizeof(wXRun));
				if ( (wXOffset + wXRun ) >= 2048 )
					break;
				else
				{
					if ( ( wXOffset + wXRun ) != 0)
					{
						iX += wXOffset;
						for (iCount = 0; iCount < wXRun; iCount++)
						{
							cfArtFile.Read(&wColor, sizeof(wColor));
							if ( (iY % scalefactor) == 0)
							{
								// We aren't doing a SetPixel here...we're adding to the bitmap.
								int X, Y;
								X = (iX + iCount) / scalefactor + ((iWidth - wArtWidth / scalefactor) / 2);
								Y =  iY / scalefactor + ((iHeight - wArtHeight / scalefactor) / 2);
								DWORD dwColor = BlendColors(wColor, wItemColour);
								BYTE r, g, b;
								b = (BYTE) ((dwColor >> 16) & 0xFF);
								g = (BYTE) ((dwColor >> 8) & 0xFF);
								r = (BYTE) ((dwColor) & 0xFF);
								bPixels.SetAt((( (iWidth * Y) + X) * 3), b);
								bPixels.SetAt((( (iWidth * Y) + X) * 3) + 1, g);
								bPixels.SetAt((( (iWidth * Y) + X) * 3) + 2, r);
								//pDC->SetPixel((iX + iCount) / scalefactor + ((iWidth - wArtWidth / scalefactor) / 2), iY / scalefactor + ((iHeight - wArtHeight / scalefactor) / 2), wAppliedColor == 0 ? ScaleColor(wColor) : BlendColors(wColor, wAppliedColor));
							}
						}
						iX += wXRun;
					}
					else
					{
						iX = 0;
						iY++;
						cfArtFile.Seek(dwDStart + wLStart[iY] * 2, CFile::begin);
					}
				}
			}
		}
	}

	BITMAPINFO bmi;
	memset( &bmi, 0, sizeof( bmi ));
	bmi.bmiHeader.biSize = sizeof(bmi.bmiHeader);
	bmi.bmiHeader.biHeight = -iHeight;	// - Top down
	bmi.bmiHeader.biWidth = iWidth;
	bmi.bmiHeader.biBitCount = 24;	// 1,4,8,24
	bmi.bmiHeader.biPlanes = 1;
	bmi.bmiHeader.biCompression = BI_RGB;	// Not compressed
	bmi.bmiHeader.biSizeImage = 0;
	bmi.bmiHeader.biXPelsPerMeter= 0;
	bmi.bmiHeader.biYPelsPerMeter= 0;
	bmi.bmiHeader.biClrUsed 	 = 0;
	bmi.bmiHeader.biClrImportant = 0;

	CDC * pDC = m_csDisplay.GetDC();

	HBITMAP hBmp = CreateDIBitmap(pDC->GetSafeHdc(), &(bmi.bmiHeader), CBM_INIT, bPixels.GetData(), &bmi, DIB_RGB_COLORS);
	m_csDisplay.SetBitmap(hBmp);
	m_csDisplay.ReleaseDC(pDC);
}

void CItemEditDlg::OnChangeItemid() 
{
	DrawItem();	
}

void CItemEditDlg::OnEditchangeColorcombo() 
{
	DrawItem();
}

void CItemEditDlg::OnSelchangeColorcombo() 
{
	DrawItem();	
}
