/*
 $Id: itemgentab.cpp,v 1.17 2002/11/13 18:23:08 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// ItemGenTab.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "ItemTweakTab.h"
#include "ItemGenTab.h"
#include "SpawnMessageDlg.h"
#include "FileReadProgress.h"
#include "ItemEditDlg.h"
#include "RemoteConnection.h"
#include "DefEditDlg.h"
#include "TemplateEditDlg.h"
#include "SearchCritDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CItemGenTab property page

IMPLEMENT_DYNCREATE(CItemGenTab, CPropertyPage)

int CItemGenTab::iIDSort = 1;
int CItemGenTab::iNameSort = 1;

CItemGenTab::CItemGenTab() : CPropertyPage(CItemGenTab::IDD)
{
	//{{AFX_DATA_INIT(CItemGenTab)
	//}}AFX_DATA_INIT
	m_iCatSeq = 0;
}

CItemGenTab::~CItemGenTab()
{
	Unload();
}

void CItemGenTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CItemGenTab)
	DDX_Control(pDX, IDC_NUDGEUP, m_cbNudgeUp);
	DDX_Control(pDX, IDC_NUDGEDOWN, m_cbNudgeDown);
	DDX_Control(pDX, IDC_NUDGEAMOUNT, m_ceNudge);
	DDX_Control(pDX, IDC_SPAWNRATE, m_ceSpawnRate);
	DDX_Control(pDX, IDC_LOCKITEM, m_cbLockDown);
	DDX_Control(pDX, IDC_ITEMS, m_clcItems);
	DDX_Control(pDX, IDC_CATEGORY_TREE, m_ctcCategories);
	DDX_Control(pDX, IDC_MINTIME, m_ceMinTime);
	DDX_Control(pDX, IDC_MAXTIME, m_ceMaxTime);
	DDX_Control(pDX, IDC_MAXDIST, m_ceMaxDist);
	DDX_Control(pDX, IDC_AMOUNT, m_ceAmount);
	DDX_Control(pDX, IDC_ZTILE, m_ceZTile);
	DDX_Control(pDX, IDC_ITEMID, m_csItemID);
	DDX_Control(pDX, IDC_DISPLAY, m_Display);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CItemGenTab, CPropertyPage)
	//{{AFX_MSG_MAP(CItemGenTab)
	ON_BN_CLICKED(IDC_FLIP, OnFlip)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_BN_CLICKED(IDC_TILE, OnTile)
	ON_BN_CLICKED(IDC_PLACESPAWN, OnPlacespawn)
	ON_BN_CLICKED(IDC_INITSPAWN, OnInitspawn)
	ON_WM_PAINT()
	ON_NOTIFY(TVN_SELCHANGED, IDC_CATEGORY_TREE, OnSelchangedCategoryTree)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_ITEMS, OnColumnclickItems)
	ON_NOTIFY(NM_CLICK, IDC_ITEMS, OnClickItems)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_ITEMS, OnItemchangedItems)
	ON_NOTIFY(NM_DBLCLK, IDC_ITEMS, OnDblclkItems)
	ON_BN_CLICKED(IDC_FINDITEM, OnFinditem)
	ON_BN_CLICKED(IDC_LOCKITEM, OnLockitem)
	ON_BN_CLICKED(IDC_CREATE, OnCreate)
	ON_NOTIFY(NM_RETURN, IDC_ITEMS, OnReturnItems)
	ON_EN_CHANGE(IDC_MAXDIST, OnChangeSpawnParams)
	ON_BN_CLICKED(IDC_NUKE, OnNuke)
	ON_BN_CLICKED(IDC_NUDGEUP, OnNudgeup)
	ON_EN_CHANGE(IDC_MAXTIME, OnChangeSpawnParams)
	ON_EN_CHANGE(IDC_MINTIME, OnChangeSpawnParams)
	ON_EN_CHANGE(IDC_SPAWNRATE, OnChangeSpawnParams)
	ON_EN_CHANGE(IDC_AMOUNT, OnChangeSpawnParams)
	ON_EN_CHANGE(IDC_NUDGEAMOUNT, OnChangeSpawnParams)
	ON_EN_CHANGE(IDC_ZTILE, OnChangeSpawnParams)
	ON_BN_CLICKED(IDC_NUDGEDOWN, OnNudgedown)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CItemGenTab message handlers

BOOL CItemGenTab::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	CString csValue;
	DWORD dwValue;
	dwValue = Main->GetRegistryDword("LockDownItems", 0);
	this->m_cbLockDown.SetCheck(dwValue);
	csValue = Main->GetRegistryString("ItemSpawnMaxAmount", "1");
	m_ceAmount.SetWindowText(csValue);
	csValue = Main->GetRegistryString("ItemSpawnMaxTime", "240");
	m_ceMaxTime.SetWindowText(csValue);
	csValue = Main->GetRegistryString("ItemSpawnMinTime", "30");
	m_ceMinTime.SetWindowText(csValue);
	csValue = Main->GetRegistryString("ItemSpawnRate", "0");
	m_ceSpawnRate.SetWindowText(csValue);
	csValue = Main->GetRegistryString("ItemSpawnMaxDist", "0");
	m_ceMaxDist.SetWindowText(csValue);
	csValue = Main->GetRegistryString("ItemNudgeAmount", "1");
	m_ceNudge.SetWindowText(csValue);
	csValue = Main->GetRegistryString("ItemTileZ", "1");
	m_ceZTile.SetWindowText(csValue);

	LoadScripts();
	this->m_clcItems.InsertColumn(0, "Item Description", LVCFMT_LEFT, 140, -1);
	this->m_clcItems.InsertColumn(1, "ID", LVCFMT_LEFT, 140, -1);

	WORD wFlags = 0;
	if ( Main->m_dw3DRoomView )
		wFlags |= 0x01;
	if ( Main->m_dwScaleItems )
		wFlags |= 0x02;
	m_Display.SetDrawFlags(wFlags);

	m_iconUp = Main->LoadIcon(IDI_UPARROW);
	m_iconDown = Main->LoadIcon(IDI_DOWNARROW);

	m_cbNudgeDown.SetIcon(m_iconDown);
	m_cbNudgeUp.SetIcon(m_iconUp);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CItemGenTab::OnCreate() 
{
	CString csValue;
	this->m_csItemID.GetWindowText(csValue);
	if ( csValue == "" )
	{
		AfxMessageBox("Selected entry is not an item or a template", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	CString csCmd;
	if (m_cbLockDown.GetCheck() == 0)
		csCmd.Format(".add %s", csValue);
	else
		csCmd.Format(".static %s", csValue);
	SendToUO(csCmd);
}

void CItemGenTab::OnFlip() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".x.flip");
	else
		SendToUO(".xflip");
}

void CItemGenTab::OnRemove() 
{
	SendToUO(".remove");
}

void CItemGenTab::OnTile() 
{
	CString csValue, csID;
	this->m_csItemID.GetWindowText(csID);
	if (csID == "")
	{
		AfxMessageBox("No item is selected.", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	this->m_ceZTile.GetWindowText(csValue);
	if (csValue.SpanIncluding("0123456789-") != csValue)
	{
		AfxMessageBox("Invalid value in the z-level field.", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	if (csValue == "")
		csValue = "0";
	CString csCmd;
	csCmd.Format(".tile %s %s", csValue, csID);
	SendToUO(csCmd);
}

void CItemGenTab::OnPlacespawn() 
{
	SendToUO(".add 01ea7");	// Add a worldgem
}

void CItemGenTab::OnInitspawn() 
{
	CWaitCursor hourglass;
	CString csAmount, csMinTime, csMaxTime, csMaxDist, csID, csSpawnRate;
	this->m_ceAmount.GetWindowText(csAmount);
	this->m_ceMaxDist.GetWindowText(csMaxDist);
	this->m_ceMinTime.GetWindowText(csMinTime);
	this->m_ceMaxTime.GetWindowText(csMaxTime);
	this->m_csItemID.GetWindowText(csID);
	this->m_ceSpawnRate.GetWindowText(csSpawnRate);

	CString csValue;
	this->m_csItemID.GetWindowText(csValue);
	if ( csValue == "" )
	{
		AfxMessageBox("Selected entry is not an item or a template", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	int iSelIndex = this->m_clcItems.GetNextItem(-1, LVNI_SELECTED);
	CSObject * pObject = (CSObject *) this->m_clcItems.GetItemData(iSelIndex);
	if ( pObject )
	{
		if ( pObject->m_bType == TYPE_ITEM )
		{
			CItem item;
			item.CopyBase(pObject);
			item.Load();
			if ( item.m_csDef != "" )
				csValue = item.m_csDef;
		}
		else if ( pObject->m_bType == TYPE_TEMPLATE )
		{
			CTemplate tpl;
			tpl.CopyBase(pObject);
			tpl.Load();
			if ( tpl.m_csDef != "" )
				csValue = tpl.m_csDef;
		}
	}

	int iAmount, iMinTime, iMaxTime, iMaxDist;
	iAmount = atoi(csAmount);
	if (iAmount == 0)
		iAmount = 1;
	iMaxDist = atoi(csMaxDist);
	iMinTime = atoi(csMinTime);
	//if (iMinTime == 0)
	//	iMinTime = 1;
	iMaxTime = atoi(csMaxTime);
	if (iMaxTime <= iMinTime)
		iMaxTime = iMinTime + 1;

	CString csCmd;
	csCmd.Format(".act.type %ld", ITEM_SPAWN_ITEM);
	SendToUO(csCmd);
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	csCmd.Format(".act.amount %ld", iAmount);
	SendToUO(csCmd);
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	csCmd.Format(".act.more %s", csValue);
	SendToUO(csCmd);
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	csCmd.Format(".act.more2 %s", csSpawnRate);
	SendToUO(csCmd);
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	csCmd.Format(".act.morep %ld %ld %ld", iMinTime, iMaxTime, iMaxDist);
	SendToUO(csCmd);
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	csCmd.Format(".act.attr %04x", ATTR_INVIS | ATTR_MAGIC | ATTR_MOVE_NEVER);
	SendToUO(csCmd);
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	SendToUO(".act.timer 1");
	Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(".last");
	//Sleep(SPAWN_MESSAGE_DELAY);
	//SendToUO(KS_ESCAPE);

	if (Main->m_dwSpawnMessage)
	{
		CSpawnMessageDlg mDlg;
		mDlg.Create(IDD_SPAWNMESSAGE_DLG);
		//mDlg.SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
		mDlg.m_csMessage = "Spawn Point Initialized";
		mDlg.UpdateData(false);
		Sleep(3000);
		mDlg.EndDialog(IDOK);
	}
}

void CItemGenTab::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// Do not call CPropertyPage::OnPaint() for painting messages
}


void CItemGenTab::OnSelchangedCategoryTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	this->m_clcItems.SetHotItem(-1);

	HTREEITEM hSelectedItem = NULL;
	HTREEITEM hParentItem = NULL;
	this->m_clcItems.DeleteAllItems();
	this->m_csItemID.SetWindowText("");
	m_Display.SetArtIndex(-1);
	m_Display.SetArtColor(0);

	// Do the bold/nobold thing
	if (pNMTreeView != NULL)
	{
		HTREEITEM hOldItem = pNMTreeView->itemOld.hItem;
		if (hOldItem != NULL)
			this->m_ctcCategories.SetItemState(hOldItem, 0, TVIS_BOLD);
	}

	hSelectedItem = this->m_ctcCategories.GetSelectedItem();
	this->m_ctcCategories.SetItemState(hSelectedItem, TVIS_BOLD, TVIS_BOLD);
	hParentItem = this->m_ctcCategories.GetParentItem(hSelectedItem);

	if (hParentItem != NULL)
	{
		CString csParent = this->m_ctcCategories.GetItemText(hParentItem);
		CString csSelected = this->m_ctcCategories.GetItemText(hSelectedItem);
		CCategory * pCategory = FindCategory(&Main->m_pScripts->m_olItems, csParent);
		if (pCategory == NULL)
			return;
		CSubsection * pSubsection = FindSubsection(pCategory, csSelected);
		if (!pSubsection->m_ItemList.IsEmpty())
		{
			POSITION pos = pSubsection->m_ItemList.GetHeadPosition();
			int iCount = 0;
			while (pos != NULL)
			{
				CSObject * pObject = (CSObject *) pSubsection->m_ItemList.GetNext(pos);
				CItem item;
				item.CopyBase(pObject);
				item.Load();
				this->m_clcItems.InsertItem(iCount, pObject->m_csDescription, 0);
				if ( item.m_csDef != "" )
					this->m_clcItems.SetItemText(iCount, 1, item.m_csDef);
				else
					this->m_clcItems.SetItemText(iCount, 1, pObject->m_csValue);
				this->m_clcItems.SetItemData(iCount, (DWORD)pObject);
				iCount++;
			}
		}
	}

	iNameSort = 1;
	iIDSort = 1;
	this->m_clcItems.SortItems(CompareFunc, 1);		// Sort by ItemID initially
	iNameSort = -1;
}

int CALLBACK CItemGenTab::CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	CSObject * pObject1 = (CSObject *) lParam1;
	CSObject * pObject2 = (CSObject *) lParam2;

	if ( pObject1 && pObject2 )
	{
		if (lParamSort == 0)
		{
			if (iNameSort == 0)
				return (lParam1 < lParam2 ? 1 : -1);
			if (iNameSort == 1)
				return (pObject1->m_csDescription < pObject2->m_csDescription ? -1 : 1);
			if (iNameSort == -1)
				return (pObject1->m_csDescription < pObject2->m_csDescription ? 1 : -1);
		}
		else
		{
			if (iIDSort == 0)
				return (lParam1 < lParam2 ? 1 : -1);
			if (iIDSort == 1)
				return (pObject1->m_csValue < pObject2->m_csValue ? -1 : 1);
			if (iIDSort == -1)
				return (pObject1->m_csValue < pObject2->m_csValue ? 1 : -1);
		}
	}
	return 0;
}

void CItemGenTab::OnColumnclickItems(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	this->m_clcItems.SortItems(CompareFunc, pNMListView->iSubItem);
	if (pNMListView->iSubItem == 0)
	{
		switch(iNameSort)
		{
		case -1:
			iNameSort = 1;
			break;
		case 0:
			iNameSort = 1;
			break;
		case 1:
			iNameSort = -1;
			break;
		}
	}
	if (pNMListView->iSubItem == 1)
	{
		switch(iIDSort)
		{
		case -1:
			iIDSort = 1;
			break;
		case 0:
			iIDSort = 1;
			break;
		case 1:
			iIDSort = -1;
			break;
		}
	}
	*pResult = 0;
}

void CItemGenTab::OnClickItems(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	*pResult = 0;
}

void CItemGenTab::OnItemchangedItems(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	if (pNMListView->uNewState & LVNI_SELECTED)
	{
		// this is the one that has been selected
		int iSelIndex = this->m_clcItems.GetNextItem(-1, LVNI_SELECTED);
		if (iSelIndex == -1)
		{
			this->m_csItemID.SetWindowText("");
			m_Display.SetArtIndex(-1);
			m_Display.SetArtColor(0);
			return;
		}
		this->m_clcItems.SetHotItem(iSelIndex);
		CSObject * pObject = (CSObject *) this->m_clcItems.GetItemData(iSelIndex);
		if ( !pObject )
			return;
		this->m_csItemID.SetWindowText(pObject->m_csValue);
		if ( pObject->m_csFilename == "" )
			return;
		CString csSection;
		CItem item;
		item.CopyBase(pObject);
		item.Load();
		WORD wID;
		if ( ahextoi(item.m_csValue) < 0x4000 && ahextoi(item.m_csValue) != 0 )
			wID = (WORD) ahextoi(item.m_csValue);
		else
			wID = item.m_wItemBase;

		{
			if (Main->m_dwDrawItems)
			{
				WORD wColor = ( WORD ) DefLookup( item.m_csColor );
				m_Display.SetArtIndex(wID);
				m_Display.SetArtColor(wColor);
			}
		}

		return;
	}

	*pResult = 0;
}

void CItemGenTab::FillCategoryTree()
{
	HTREEITEM CategoryParent;
	HTREEITEM SubsectionParent;
	TV_INSERTSTRUCT InsertItem;

	m_ctcCategories.DeleteAllItems();
	if (!Main->m_pScripts->m_olItems.IsEmpty())
	{
		POSITION pos = Main->m_pScripts->m_olItems.GetHeadPosition();
		while (pos != NULL)
		{
			CCategory * pCategory = (CCategory *) Main->m_pScripts->m_olItems.GetNext(pos);
			InsertItem.item.mask = TVIF_TEXT;
			InsertItem.item.pszText = (char *)LPCTSTR(pCategory->m_csName);
			InsertItem.item.cchTextMax = pCategory->m_csName.GetLength();
			InsertItem.hParent = NULL;
			InsertItem.hInsertAfter = TVI_SORT;
			CategoryParent = this->m_ctcCategories.InsertItem(&InsertItem);
			if (!pCategory->m_SubsectionList.IsEmpty())
			{
				POSITION sPos = pCategory->m_SubsectionList.GetHeadPosition();
				while (sPos != NULL)
				{
					CSubsection * pSubsection = (CSubsection *) pCategory->m_SubsectionList.GetNext(sPos);
					InsertItem.item.mask = TVIF_TEXT;
					InsertItem.item.pszText = (char *)LPCTSTR(pSubsection->m_csName);
					InsertItem.item.cchTextMax = pSubsection->m_csName.GetLength();
					InsertItem.hParent = CategoryParent;
					InsertItem.hInsertAfter = TVI_SORT;
					SubsectionParent = this->m_ctcCategories.InsertItem(&InsertItem);
				}
			}
		}
	}
	m_iCatSeq = Main->m_pScripts->m_iICatSeq;
}

void CItemGenTab::SelectTreeItem(CString csParent, CString csChild)
{
	HTREEITEM hParent = m_ctcCategories.GetFirstVisibleItem();
	HTREEITEM hChild;
	
	while (hParent != NULL)
	{
		CString csPText = m_ctcCategories.GetItemText(hParent);
		if (csPText == csParent)
		{
			hChild = m_ctcCategories.GetChildItem(hParent);
			while (hChild != NULL)
			{
				CString csCText = m_ctcCategories.GetItemText(hChild);
				if (csCText == csChild)
				{
					m_ctcCategories.SelectItem(hChild);
					return;
				}
				hChild = m_ctcCategories.GetNextSiblingItem(hChild);
			}
			// Couldn't find the child...
			m_ctcCategories.SelectItem(hParent);
			return;
		}
		hParent = m_ctcCategories.GetNextSiblingItem(hParent);
	}
}

void CItemGenTab::OnDblclkItems(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int iSelIndex = this->m_clcItems.GetNextItem(-1, LVNI_SELECTED);
	if (iSelIndex == -1)
	{
		this->m_csItemID.SetWindowText("");
		m_Display.SetArtIndex(-1);
		m_Display.SetArtColor(0);
		return;
	}
	CSObject * pObject = (CSObject *) this->m_clcItems.GetItemData(iSelIndex);
	if ( !pObject )
		return;

	this->OnCreate();

	*pResult = 0;
}

bool CItemGenTab::IsDef(CString csTest)
{
	if (csTest.SpanIncluding("0123456789abcdefABCDEF") == csTest)
		return false;
	else
		return true;
}

void CItemGenTab::Unload()
{
}

void CItemGenTab::LoadScripts()
{
	FillCategoryTree();
}

void CItemGenTab::OnFinditem() 
{
	CSearchCritDlg dlg;
	if ( dlg.DoModal() != IDOK )
		return;
	Find( dlg.m_csValue, dlg.m_iCrit );
	return;
}

CSObject * CItemGenTab::Find(CString csString, int iCrit, bool bSelect, bool bPrevious)
{
	CSObject * pSelection = NULL;
	if ( csString != "" )
	{
		// this is a new search
		this->m_csSearchValue = csString;
		this->m_iSearchCrit = iCrit;
		this->m_pSearchCategory = NULL;
		this->m_pSearchSubsection = NULL;
		this->m_pSearchItem = NULL;
	}
	POSITION catPos;
	if ( this->m_pSearchCategory )
		catPos = Main->m_pScripts->m_olItems.Find( this->m_pSearchCategory );
	else
	{
		if ( !bPrevious )
			catPos = Main->m_pScripts->m_olItems.GetHeadPosition();
		else
			catPos = Main->m_pScripts->m_olItems.GetTailPosition();
	}
	while ( catPos != NULL )
	{
		CCategory * pCategory;
		if ( !bPrevious )
			pCategory = (CCategory *) Main->m_pScripts->m_olItems.GetNext( catPos );
		else
			pCategory = (CCategory *) Main->m_pScripts->m_olItems.GetPrev( catPos );
		if ( pCategory == NULL )
			break;
		POSITION subPos;
		if ( this->m_pSearchSubsection )
			subPos = pCategory->m_SubsectionList.Find( this->m_pSearchSubsection );
		else
		{
			if ( !bPrevious )
				subPos = pCategory->m_SubsectionList.GetHeadPosition();
			else
				subPos = pCategory->m_SubsectionList.GetTailPosition();
		}
		while ( subPos != NULL )
		{
			CSubsection * pSubsection;
			if ( !bPrevious )
				pSubsection = ( CSubsection *) pCategory->m_SubsectionList.GetNext( subPos );
			else
				pSubsection = ( CSubsection *) pCategory->m_SubsectionList.GetPrev( subPos );
			if ( pSubsection == NULL )
				break;
			POSITION itemPos;
			if ( this->m_pSearchItem )
			{
				itemPos = pSubsection->m_ItemList.Find( this->m_pSearchItem );
				if ( itemPos )
				{
					CSObject * pObject;
					if ( !bPrevious )
						pObject = (CSObject *) pSubsection->m_ItemList.GetNext( itemPos );
					else
						pObject = (CSObject *) pSubsection->m_ItemList.GetPrev( itemPos );
				}
			}
			else
			{
				if ( !bPrevious )
					itemPos = pSubsection->m_ItemList.GetHeadPosition();
				else
					itemPos = pSubsection->m_ItemList.GetTailPosition();
			}
			while ( itemPos != NULL )
			{
				CSObject * pItem;
				if ( !bPrevious )
					pItem = (CSObject *) pSubsection->m_ItemList.GetNext( itemPos );
				else
					pItem = (CSObject *) pSubsection->m_ItemList.GetPrev( itemPos );
				if ( pItem )
				{
					CString csValue, csTest;
					csTest = this->m_csSearchValue;
					csTest.MakeLower();
					switch ( this->m_iSearchCrit )
					{
					case 0:
						// ID
						csValue = pItem->m_csValue;
						csValue.MakeLower();
						if ( csValue.Find( csTest ) != -1 )
							pSelection = (CSObject *) pItem;
						break;
					case 1:
						// Description
						csValue = pItem->m_csDescription;
						csValue.Replace("@", pItem->m_csSubsection);
						csValue.MakeLower();
						if ( csValue.Find( csTest ) != -1 )
							pSelection = (CSObject *) pItem;
						break;
					default:
						break;
					}
				}
				if ( pSelection != NULL )
				{
					if ( bSelect )
					{
						HTREEITEM hRoot = this->m_ctcCategories.GetRootItem();
						HTREEITEM hCat = this->m_ctcCategories.GetNextItem( hRoot, TVGN_NEXT );
						while ( hCat != NULL )
						{
							if ( this->m_ctcCategories.GetItemText( hCat ) == pCategory->m_csName )
							{
								HTREEITEM hSub = this->m_ctcCategories.GetChildItem( hCat );
								while ( hSub != NULL )
								{
									if ( this->m_ctcCategories.GetItemText( hSub ) == pSubsection->m_csName )
									{
										this->m_ctcCategories.SelectItem( hSub );
										for ( int i = 0; i < this->m_clcItems.GetItemCount(); i++ )
										{
											CSObject * pObject = (CSObject *) this->m_clcItems.GetItemData(i);
											if ( pObject == pSelection )
											{
												this->m_clcItems.SetItemState( i, LVIS_SELECTED, LVIS_SELECTED );
												this->m_clcItems.EnsureVisible( i, FALSE );
												this->m_pSearchCategory = pCategory;
												this->m_pSearchItem = pItem;
												this->m_pSearchSubsection = pSubsection;
												return pSelection;
											}
										}
										return pSelection;
									}
									hSub = this->m_ctcCategories.GetNextItem( hSub, TVGN_NEXT );
								}
							}
							hCat = this->m_ctcCategories.GetNextItem( hCat, TVGN_NEXT );
						}
					}
					return pSelection;
				}
			}
			this->m_pSearchItem = NULL;
		}
		this->m_pSearchSubsection = NULL;
	}
	if ( bSelect )
		AfxMessageBox("No matching item was found", MB_OK | MB_ICONINFORMATION);
	return pSelection;
}

BOOL CItemGenTab::PreTranslateMessage(MSG* pMsg) 
{
	if ( pMsg->message == WM_KEYDOWN )
	{
		if ( pMsg->wParam == VK_F3 )
		{
			if ( GetAsyncKeyState(VK_SHIFT) )
				FindPrevious();
			else
				Find();
			return TRUE;
		}
	}
	return CPropertyPage::PreTranslateMessage(pMsg);
}

void CItemGenTab::OnLockitem() 
{
	int iEnabled = this->m_cbLockDown.GetCheck();
	Main->PutRegistryDword("LockDownItems", iEnabled);
}

BOOL CItemGenTab::OnSetActive() 
{
	if ( Main->m_pScripts->m_iICatSeq != m_iCatSeq )
		this->FillCategoryTree();

	if ( csUOPath != "" )
		m_Display.SetMulPath(csUOPath);

	CString csRegKey, csValue;
	csValue = Main->GetRegistryString("MulPath", "" );
	if ( csValue != "" )
		m_Display.SetMulPath(csValue);
	csRegKey.Format("Mul%ld", VERFILE_ART);
	csValue = Main->GetRegistryString(csRegKey, "");
	if ( csValue != "" )
		m_Display.SetCustomMulFile(VERFILE_ART, csValue);
	csRegKey.Format("Mul%ld", VERFILE_ARTIDX);
	csValue = Main->GetRegistryString(csRegKey, "");
	if ( csValue != "" )
		m_Display.SetCustomMulFile(VERFILE_ARTIDX, csValue);

	return CPropertyPage::OnSetActive();
}

void CItemGenTab::OnReturnItems(NMHDR* pNMHDR, LRESULT* pResult) 
{
	this->OnCreate();	
	*pResult = 0;
}

void CItemGenTab::OnChangeSpawnParams() 
{
	UpdateData();
	if ( !this->IsWindowVisible() )
		return;

	CString csAmount, csMinTime, csMaxTime, csRate, csDist, csZHeight, csNudge;

	m_ceAmount.GetWindowText(csAmount);
	m_ceMaxDist.GetWindowText(csDist);
	m_ceMaxTime.GetWindowText(csMaxTime);
	m_ceMinTime.GetWindowText(csMinTime);
	m_ceNudge.GetWindowText(csNudge);
	m_ceSpawnRate.GetWindowText(csRate);
	m_ceZTile.GetWindowText(csZHeight);


	Main->PutRegistryString("ItemSpawnMaxAmount", csAmount);
	Main->PutRegistryString("ItemSpawnMaxTime", csMaxTime);
	Main->PutRegistryString("ItemSpawnMinTime", csMinTime);
	Main->PutRegistryString("ItemSpawnMaxDist", csDist);
	Main->PutRegistryString("ItemSpawnRate", csRate);
	Main->PutRegistryString("ItemNudgeAmount", csNudge);
	Main->PutRegistryString("ItemTileZ", csZHeight);

}

CSObject * CItemGenTab::FindPrevious()
{
	return Find("", 0, true, true);
}

void CItemGenTab::OnNuke() 
{
	SendToUO(".nuke");	
}

void CItemGenTab::OnNudgeup() 
{
	CString csAmount, csMessage;
	this->m_ceNudge.GetWindowText(csAmount);
	csMessage.Format(".nudgeup %s", csAmount);
	SendToUO(csMessage);
}

void CItemGenTab::OnNudgedown() 
{
	CString csAmount, csMessage;
	this->m_ceNudge.GetWindowText(csAmount);
	csMessage.Format(".nudgedown %s", csAmount);
	SendToUO(csMessage);
}
