/*
 $Id: itemtweaktab.cpp,v 1.6 2002/11/17 04:25:27 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// ItemTweakTab.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "ItemTweakTab.h"
#include "ColorSelectionDlg.h"
#include "SpellbookTweakDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CItemTweakTab property page

IMPLEMENT_DYNCREATE(CItemTweakTab, CPropertyPage)

CItemTweakTab::CItemTweakTab() : CPropertyPage(CItemTweakTab::IDD)
{
	//{{AFX_DATA_INIT(CItemTweakTab)
	m_bIdentified = FALSE;
	m_bDecay = FALSE;
	m_bNewbie = FALSE;
	m_bAlwaysMoveable = FALSE;
	m_bNeverMoveable = FALSE;
	m_bMagic = FALSE;
	m_bOwnedByTown = FALSE;
	m_bInvisible = FALSE;
	m_bStatic = FALSE;
	m_bBlessed = FALSE;
	m_bBlessed2 = FALSE;
	m_bCanDecay = FALSE;
	m_bCursed = FALSE;
	m_bCursed2 = FALSE;
	m_bForSale = FALSE;
	m_bStolen = FALSE;
	//}}AFX_DATA_INIT
	m_wColorIndex = 0xFFFF;
}

CItemTweakTab::~CItemTweakTab()
{
}

void CItemTweakTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CItemTweakTab)
	DDX_Control(pDX, IDC_ITPALETTE, m_cbPalette);
	DDX_Control(pDX, IDC_ITSPECTRUM, m_csSpectrum);
	DDX_Control(pDX, IDC_QSVALUE, m_ceQSValue);
	DDX_Control(pDX, IDC_ITEMNAME, m_ceItemName);
	DDX_Control(pDX, IDC_TYPEVALUE, m_csTypeValue);
	DDX_Control(pDX, IDC_TYPES, m_ccItemTypes);
	DDX_Control(pDX, IDC_ATTRVALUE, m_csAttrValue);
	DDX_Check(pDX, IDC_IDENTIFIED, m_bIdentified);
	DDX_Check(pDX, IDC_DECAY, m_bDecay);
	DDX_Check(pDX, IDC_NEWBIE, m_bNewbie);
	DDX_Check(pDX, IDC_ALWAYSMOVEABLE, m_bAlwaysMoveable);
	DDX_Check(pDX, IDC_NEVERMOVEABLE, m_bNeverMoveable);
	DDX_Check(pDX, IDC_MAGIC, m_bMagic);
	DDX_Check(pDX, IDC_OWNEDBYTOWN, m_bOwnedByTown);
	DDX_Check(pDX, IDC_INVISIBLE, m_bInvisible);
	DDX_Check(pDX, IDC_BSTATIC, m_bStatic);
	DDX_Check(pDX, IDC_BBLESSED, m_bBlessed);
	DDX_Check(pDX, IDC_BBLESSED2, m_bBlessed2);
	DDX_Check(pDX, IDC_BCANDECAY, m_bCanDecay);
	DDX_Check(pDX, IDC_BCURSED, m_bCursed);
	DDX_Check(pDX, IDC_BCURSED2, m_bCursed2);
	DDX_Check(pDX, IDC_BFORSALE, m_bForSale);
	DDX_Check(pDX, IDC_BSTOLEN, m_bStolen);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CItemTweakTab, CPropertyPage)
	//{{AFX_MSG_MAP(CItemTweakTab)
	ON_BN_CLICKED(IDC_RESET_ATTR, OnResetAttr)
	ON_BN_CLICKED(IDC_SETATTR, OnSetattr)
	ON_BN_CLICKED(IDC_IDENTIFIED, OnIdentified)
	ON_BN_CLICKED(IDC_DECAY, OnDecay)
	ON_BN_CLICKED(IDC_NEWBIE, OnNewbie)
	ON_BN_CLICKED(IDC_ALWAYSMOVEABLE, OnAlwaysmoveable)
	ON_BN_CLICKED(IDC_NEVERMOVEABLE, OnNevermoveable)
	ON_BN_CLICKED(IDC_MAGIC, OnMagic)
	ON_BN_CLICKED(IDC_OWNEDBYTOWN, OnOwnedbytown)
	ON_BN_CLICKED(IDC_INVISIBLE, OnInvisible)
	ON_BN_CLICKED(IDC_BSTATIC, OnBstatic)
	ON_CBN_SELCHANGE(IDC_TYPES, OnSelchangeTypes)
	ON_BN_CLICKED(IDC_SETTYPE, OnSettype)
	ON_BN_CLICKED(IDC_SETNAME, OnSetname)
	ON_BN_CLICKED(IDC_NUDGEUP, OnNudgeup)
	ON_BN_CLICKED(IDC_NUDGEDOWN, OnNudgedown)
	ON_BN_CLICKED(IDC_QSAMOUNT, OnQsamount)
	ON_BN_CLICKED(IDC_QSCOLOR, OnQscolor)
	ON_BN_CLICKED(IDC_QSMORE, OnQsmore)
	ON_BN_CLICKED(IDC_QSMORE2, OnQsmore2)
	ON_BN_CLICKED(IDC_QSMOREP, OnQsmorep)
	ON_BN_CLICKED(IDC_QSMOREX, OnQsmorex)
	ON_BN_CLICKED(IDC_QSMOREY, OnQsmorey)
	ON_BN_CLICKED(IDC_QSMOREZ, OnQsmorez)
	ON_BN_CLICKED(IDC_QSSET, OnQsset)
	ON_BN_CLICKED(IDC_ITEMCOLOR, OnItemcolor)
	ON_BN_CLICKED(IDC_ITPALETTE, OnItpalette)
	ON_BN_CLICKED(IDC_BCURSED, OnBcursed)
	ON_BN_CLICKED(IDC_BBLESSED, OnBblessed)
	ON_BN_CLICKED(IDC_BBLESSED2, OnBblessed2)
	ON_BN_CLICKED(IDC_BCANDECAY, OnBcandecay)
	ON_BN_CLICKED(IDC_BCURSED2, OnBcursed2)
	ON_BN_CLICKED(IDC_BFORSALE, OnBforsale)
	ON_BN_CLICKED(IDC_BSTOLEN, OnBstolen)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_SPELLBOOK, OnSpellbook)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CItemTweakTab message handlers

void CItemTweakTab::OnResetAttr() 
{
	m_bAlwaysMoveable = FALSE;
	m_bDecay = FALSE;
	m_bIdentified = FALSE;
	m_bInvisible = FALSE;
	m_bMagic = FALSE;
	m_bNeverMoveable = FALSE;
	m_bNewbie = FALSE;
	m_bOwnedByTown = FALSE;
	m_bBlessed = FALSE;
	m_bBlessed2 = FALSE;
	m_bCanDecay = FALSE;
	m_bCursed = FALSE;
	m_bCursed2 = FALSE;
	m_bForSale = FALSE;
	m_bStolen = FALSE;
	m_bStatic = FALSE;
	m_csAttrValue.SetWindowText("00000");
	UpdateData(false);
}

void CItemTweakTab::OnSetattr() 
{
	CString csVal;
	m_csAttrValue.GetWindowText(csVal);
	CString csCmd;
	if ( Main->m_dwCommandVersion )
		csCmd.Format(".set attr=%s", csVal);
	else
		csCmd.Format(".set attr %s", csVal);
	SendToUO(csCmd);
}

void CItemTweakTab::OnIdentified() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bIdentified)
		dwVal |= ATTR_IDENTIFIED;
	else
		dwVal ^= ATTR_IDENTIFIED;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnDecay() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bDecay)
		dwVal |= ATTR_DECAY;
	else
		dwVal ^= ATTR_DECAY;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnNewbie() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bNewbie)
		dwVal |= ATTR_NEWBIE;
	else
		dwVal ^= ATTR_NEWBIE;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnAlwaysmoveable() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bAlwaysMoveable)
		dwVal |= ATTR_MOVE_ALWAYS;
	else
		dwVal ^= ATTR_MOVE_ALWAYS;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnNevermoveable() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bNeverMoveable)
		dwVal |= ATTR_MOVE_NEVER;
	else
		dwVal ^= ATTR_MOVE_NEVER;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnMagic() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bMagic)
		dwVal |= ATTR_MAGIC;
	else
		dwVal ^= ATTR_MAGIC;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnOwnedbytown() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bOwnedByTown)
		dwVal |= ATTR_OWNED;
	else
		dwVal ^= ATTR_OWNED;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnInvisible() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bInvisible)
		dwVal |= ATTR_INVIS;
	else
		dwVal ^= ATTR_INVIS;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnBstatic() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bStatic)
		dwVal |= ATTR_STATIC;
	else
		dwVal ^= ATTR_STATIC;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

BOOL CItemTweakTab::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// Load the Combo Box of Item Types.
	for (int i = 0; i < ITEM_QTY; i++)
		m_ccItemTypes.AddString(ItemTypeName[i]);
	m_ccItemTypes.SetCurSel(0);

	m_hPaletteIcon = AfxGetApp()->LoadIcon(IDI_PALETTE);
	this->m_cbPalette.SetIcon(m_hPaletteIcon);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CItemTweakTab::OnSelchangeTypes() 
{
	int iSelection = m_ccItemTypes.GetCurSel();
	CString csNewValue;
	csNewValue.Format("%d", iSelection);
	m_csTypeValue.SetWindowText(csNewValue);
}

void CItemTweakTab::OnSettype() 
{
	CString csValue;
	m_csTypeValue.GetWindowText(csValue);
	CString csCmd;
	if ( Main->m_dwCommandVersion )
		csCmd.Format(".set type=%s", csValue);
	else
		csCmd.Format(".set type %s", csValue);
	SendToUO(csCmd);
}

void CItemTweakTab::OnSetname() 
{
	CString csValue;
	m_ceItemName.GetWindowText(csValue);
	CString csCmd;
	if ( Main->m_dwCommandVersion )
		csCmd.Format(".set name=\"%s\"", csValue);
	else
		csCmd.Format(".set name %s", csValue);
	SendToUO(csCmd);
}

void CItemTweakTab::OnNudgeup() 
{
	SendToUO(".nudgeup");	
}

void CItemTweakTab::OnNudgedown() 
{
	SendToUO(".nudgedown");
}

void CItemTweakTab::OnQsamount() 
{
	this->m_csQSTag = "amount";	
}

void CItemTweakTab::OnQscolor() 
{
	this->m_csQSTag = "color";
}

void CItemTweakTab::OnQsmore() 
{
	this->m_csQSTag = "more";
}

void CItemTweakTab::OnQsmore2() 
{
	this->m_csQSTag = "more2";	
}

void CItemTweakTab::OnQsmorep() 
{
	this->m_csQSTag = "morep";	
}

void CItemTweakTab::OnQsmorex() 
{
	this->m_csQSTag = "morex";	
}

void CItemTweakTab::OnQsmorey() 
{
	this->m_csQSTag = "morey";	
}

void CItemTweakTab::OnQsmorez() 
{
	this->m_csQSTag = "morez";	
}

void CItemTweakTab::OnQsset() 
{
	CString csValue;
	this->m_ceQSValue.GetWindowText(csValue);
	csValue.TrimLeft();
	csValue.TrimRight();
	CString csCmd;
	if (csValue == "")
		return;
	if (this->m_csQSTag == "")
		return;
	if ( Main->m_dwCommandVersion )
		csCmd.Format(".set %s=%s", this->m_csQSTag, csValue);
	else
		csCmd.Format(".set %s %s", this->m_csQSTag, csValue);
	SendToUO(csCmd);
}

void CItemTweakTab::OnItemcolor() 
{
	if ( m_wColorIndex > 0 && m_wColorIndex < 3000 )
	{
		CString csCommand;
		if ( Main->m_dwCommandVersion )
			csCommand.Format(".set color=%05x", m_wColorIndex);
		else
			csCommand.Format(".set color %05x", m_wColorIndex);
		SendToUO(csCommand);
	}
}

void CItemTweakTab::OnItpalette() 
{
	CColorSelectionDlg dlg;
	if ( dlg.DoModal() == IDOK )
	{
		m_wColorIndex = dlg.GetColorIndex();
		DrawSpectrum(&m_csSpectrum, m_wColorIndex);
	}
	return;	
}

void CItemTweakTab::OnBcursed() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bCursed)
		dwVal |= ATTR_CURSED;
	else
		dwVal ^= ATTR_CURSED;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnBblessed() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bBlessed)
		dwVal |= ATTR_BLESSED;
	else
		dwVal ^= ATTR_BLESSED;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnBblessed2() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bBlessed2)
		dwVal |= ATTR_BLESSED2;
	else
		dwVal ^= ATTR_BLESSED2;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnBcandecay() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bCanDecay)
		dwVal |= ATTR_CAN_DECAY;
	else
		dwVal ^= ATTR_CAN_DECAY;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnBcursed2() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bCursed2)
		dwVal |= ATTR_CURSED2;
	else
		dwVal ^= ATTR_CURSED2;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnBforsale() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bForSale)
		dwVal |= ATTR_FORSALE;
	else
		dwVal ^= ATTR_FORSALE;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnBstolen() 
{
	UpdateData(true);
	CString csCurrentVal;
	m_csAttrValue.GetWindowText(csCurrentVal);
	DWORD dwVal = ahextoi(csCurrentVal);
	if (m_bStolen)
		dwVal |= ATTR_STOLEN;
	else
		dwVal ^= ATTR_STOLEN;
	CString csNewVal;
	csNewVal.Format("%05x", dwVal);
	m_csAttrValue.SetWindowText(csNewVal);
	UpdateData(false);	
}

void CItemTweakTab::OnSpellbook() 
{
	CSpellbookTweakDlg dlg;
	dlg.DoModal();
}
