/*
 $Id: launchertab.cpp,v 1.6 2002/07/19 20:02:01 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// LauncherTab.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "LauncherTab.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifndef MAX_BUFFER
#define MAX_BUFFER 1024
#endif

CString csUOPath;
CString csUOExe;

#ifndef _AXIS
bool ReplaceFiles( CString csNewFile, CString csOldFile )
{
	// Most likely, the old file name doesn't have the path associated with it.
	if (csOldFile.Find(":") == -1 && csOldFile.Find("ini") == -1 )
	{
	}
	// Loop through this a few times
	int i = 0;
	bool bSuccess = false;
	while ( i < 5 && !bSuccess )
	try
	{
		CFileStatus st;
		if ( CFile::GetStatus( csOldFile, st ) )
			CFile::Remove( csOldFile );
		CFile::Rename( csNewFile, csOldFile );
		bSuccess = true;
	}
	catch ( CFileException * e )
	{
		i++;
		if ( i < 5 )
		{
			Sleep( 500 );
			e->Delete();
		}
		else
		{
			CString csMessage;
			char szCause[MAX_BUFFER];
			memset(szCause, 0x00, sizeof(szCause));
			e->GetErrorMessage( &szCause[0], MAX_BUFFER - 1 );
			csMessage.Format("An exception occured while moving files.\n\n%s\n\nThis typically is caused by the Sphere server having the file locked open.\nAxis tries to pause the Sphere server before doing this, but failed.\n", szCause);
			csMessage+= "Make sure Axis is able to connect to the Sphere server with the Remote Console\nor pause the Sphere server manually before attempting a save.\n";
			csMessage+= "\n\nAxis can attempt to rename the existing file, and move in the new file.\nWould you like to try this?";
			e->Delete();
			if ( AfxMessageBox( csMessage, MB_YESNO | MB_ICONQUESTION ) == IDYES )
			{
				CString csBackup;
				CTime ct = CTime::GetCurrentTime();
				csBackup.Format("%s.%s", csOldFile, ct.Format("%Y%m%d%H%M%S"));
				try
				{
					CFile::Rename( csOldFile, csBackup );
					CFile::Rename( csNewFile, csOldFile );
					CString csMessage;
					csMessage.Format("Rename was successful.  Tne backup file is now stored in\n%s\n\nYou may need to manually pause and resync your\nserver for the changes to take effect.", csBackup);
					AfxMessageBox(csMessage, MB_OK | MB_ICONINFORMATION);
					return true;
				}
				catch ( CFileException * e )
				{
					e->Delete();
					AfxMessageBox("Rename failed.", MB_OK | MB_ICONSTOP );
					return false;
				}
			}
			return false;
		}
	}
	return true;
}
#endif

CString Encrypt(CString csValue)
{
	CString csKey = _T("ZuBenELGenuBiZubenElSCheMALiAKam");
	CString csEncrypted = csValue;

	for (int i = 0; i < csValue.GetLength(); i++)
	{
		csKey.SetAt(i, csKey[i] ^ 128);
		csEncrypted.SetAt(i, csValue[i] ^ csKey[i]);
	}
	
	return csEncrypted;
}

CString EncryptUO(CString csValue)
{
	CString csEncrypted = csValue;

	for (int i = 0; i < csValue.GetLength(); i++)
	{
		char cNew = csValue[i];
		cNew += 0x0d;
		if ( cNew > 0x7f )
			cNew -= 0x5f;
		/*
		switch (csValue[i])
		{
		case '!':
			cNew = 0x2e;
			break;
		case '"':
			cNew = 0x2f;
			break;
		case '#':
			cNew = 0x30;
			break;
		case '%':
			cNew = 0x32;
			break;
		case '&':
			cNew = 0x33;
			break;
		case '(':
			cNew = 0x35;
			break;
		case ')':
			cNew = 0x36;
			break;
		case '/':
			cNew = 0x3c;
			break;
		case '0':
			cNew = 0x3d;
			break;
		case '1':
			cNew = 0x3e;
			break;
		case '2':
			cNew = 0x3f;
			break;
		case '3':
			cNew = 0x40;
			break;
		case '4':
			cNew = 0x41;
			break;
		case '5':
			cNew = 0x42;
			break;
		case '6':
			cNew = 0x43;
			break;
		case '7':
			cNew = 0x44;
			break;
		case '8':
			cNew = 0x45;
			break;
		case '9':
			cNew = 0x46;
			break;
		case '=':
			cNew = 0x4a;
			break;
		case 'A':
			cNew = 0x4e;
			break;
		case 'B':
			cNew = 0x4f;
			break;
		case 'C':
			cNew = 0x50;
			break;
		case 'D':
			cNew = 0x51;
			break;
		case '':
			cNew = 0x52;
			break;
		case 'E':
			cNew = 0x52;
			break;
		case 'F':
			cNew = 0x53;
			break;
		case 'G':
			cNew = 0x54;
			break;
		case 'H':
			cNew = 0x55;
			break;
		case 'I':
			cNew = 0x56;
			break;
		case 'J':
			cNew = 0x57;
			break;
		case 'K':
			cNew = 0x58;
			break;
		case 'L':
			cNew = 0x59;
			break;
		case 'M':
			cNew = 0x5a;
			break;
		case 'N':
			cNew = 0x5b;
			break;
		case 'O':
			cNew = 0x5c;
			break;
		case 'P':
			cNew = 0x5d;
			break;
		case 'Q':
			cNew = 0x5e;
			break;
		case 'R':
			cNew = 0x5f;
			break;
		case 'S':
			cNew = 0x60;
			break;
		case 'T':
			cNew = 0x61;
			break;
		case 'U':
			cNew = 0x62;
			break;
		case 'V':
			cNew = 0x63;
			break;
		case 'W':
			cNew = 0x64;
			break;
		case 'X':
			cNew = 0x65;
			break;
		case 'Y':
			cNew = 0x66;
			break;
		case 'Z':
			cNew = 0x67;
			break;
		case 'a':
			cNew = 0x6e;
			break;
		case 'b':
			cNew = 0x6f;
			break;
		case 'c':
			cNew = 0x70;
			break;
		case 'd':
			cNew = 0x71;
			break;
		case 'e':
			cNew = 0x72;
			break;
		case 'f':
			cNew = 0x73;
			break;
		case 'g':
			cNew = 0x74;
			break;
		case 'h':
			cNew = 0x75;
			break;
		case 'i':
			cNew = 0x76;
			break;
		case 'j':
			cNew = 0x77;
			break;
		case 'k':
			cNew = 0x78;
			break;
		case 'l':
			cNew = 0x79;
			break;
		case 'm':
			cNew = 0x7a;
			break;
		case 'n':
			cNew = 0x7b;
			break;
		case 'o':
			cNew = 0x7c;
			break;
		case 'p':
			cNew = 0x7d;
			break;
		case 'q':
			cNew = 0x7e;
			break;
		case 'r':
			cNew = 0x7f;
			break;
		case 's':
			cNew = 0x21;
			break;
		case 't':
			cNew = 0x22;
			break;
		case 'u':
			cNew = 0x23;
			break;
		case 'v':
			cNew = 0x24;
			break;
		case 'w':
			cNew = 0x25;
			break;
		case 'x':
			cNew = 0x26;
			break;
		case 'y':
			cNew = 0x27;
			break;
		case 'z':
			cNew = 0x28;
			break;
		default:
			cNew = 0x20;
		}
		*/
		csEncrypted.SetAt(i, cNew);
	}
	return csEncrypted;
}


/////////////////////////////////////////////////////////////////////////////
// CLauncherTab property page

IMPLEMENT_DYNCREATE(CLauncherTab, CPropertyPage)

CLauncherTab::CLauncherTab() : CPropertyPage(CLauncherTab::IDD)
{
	//{{AFX_DATA_INIT(CLauncherTab)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_bEditContext = false;
}

CLauncherTab::~CLauncherTab()
{
}

void CLauncherTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLauncherTab)
	DDX_Control(pDX, IDC_CLIENTBROWSE, m_cbBrowse);
	DDX_Control(pDX, IDC_ALTCLIENT, m_ceClient);
	DDX_Control(pDX, IDC_EDITACCT, m_cbEdit);
	DDX_Control(pDX, IDC_NEW, m_cbNew);
	DDX_Control(pDX, IDC_LAUNCH, m_cbLaunch);
	DDX_Control(pDX, IDC_DELETE, m_cbDelete);
	DDX_Control(pDX, IDC_DONE, m_cbDone);
	DDX_Control(pDX, IDC_CANCEL, m_cbCancel);
	DDX_Control(pDX, IDC_PORT, m_cePort);
	DDX_Control(pDX, IDC_PASSWORD, m_cePassword);
	DDX_Control(pDX, IDC_NAME, m_ceName);
	DDX_Control(pDX, IDC_IPADDRESS, m_ceIPAddress);
	DDX_Control(pDX, IDC_ACCOUNT_LIST, m_clbAccountList);
	DDX_Control(pDX, IDC_ACCOUNT, m_ceAccount);
	DDX_Control(pDX, IDC_CLIENTLOC, m_csClientLoc);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLauncherTab, CPropertyPage)
	//{{AFX_MSG_MAP(CLauncherTab)
	ON_BN_CLICKED(IDC_NEW, OnNew)
	ON_BN_CLICKED(IDC_DONE, OnDone)
	ON_LBN_SELCHANGE(IDC_ACCOUNT_LIST, OnSelchangeAccountList)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_BN_CLICKED(IDC_LAUNCH, OnLaunch)
	ON_BN_CLICKED(IDC_EDITACCT, OnEditacct)
	ON_BN_CLICKED(IDC_CLIENTBROWSE, OnClientbrowse)
	ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	ON_BN_CLICKED(IDC_CHANGECLIENT, OnChangeclient)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLauncherTab message handlers

BOOL CLauncherTab::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	CString csClientPath;
#ifdef __UOLAUNCHPAD__
	HKEY hUOKey;
	if ( RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Origin Worlds Online\\Ultima Online\\1.0", 0, KEY_ALL_ACCESS, &hUOKey) == ERROR_SUCCESS)
	{
		char szBuffer[MAX_PATH];
		DWORD dwSize = sizeof(szBuffer);
		memset(&szBuffer[0], 0x00, sizeof(szBuffer));
		DWORD dwType = REG_SZ;
		RegQueryValueEx(hUOKey, "ExePath", 0, &dwType, (BYTE *) &szBuffer[0], &dwSize);
		csUOPath = _T(szBuffer);
		if ( csUOPath.ReverseFind('\\') != -1 )
			csUOPath.SetAt(csUOPath.ReverseFind('\\') + 1, 0x00);
		RegCloseKey(hUOKey);
	}
#endif

	if ( csUOExe == "" )
		csUOExe = "client.exe";
	csClientPath.Format("%s%s", csUOPath, csUOExe);
	m_csClientLoc.SetWindowText(csClientPath);

	// Read the existing accounts from the registry
	HKEY hKey;
	LONG lStatus;
	lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Accounts", 0, KEY_ALL_ACCESS, &hKey);
	int iIndex = 0;
	while (lStatus == ERROR_SUCCESS)
	{
		char szBuffer[MAX_PATH];
		DWORD dwSize = sizeof(szBuffer);
		lStatus = RegEnumKeyEx(hKey, iIndex, &szBuffer[0], &dwSize, 0, NULL, NULL, NULL);
		if (lStatus == ERROR_SUCCESS)
		{
			this->m_clbAccountList.AddString(szBuffer);
		}
		iIndex++;
	}


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CLauncherTab::OnNew() 
{
	m_clbAccountList.SetCurSel(-1);
	this->OnSelchangeAccountList();
	m_ceName.EnableWindow(true);
	m_ceAccount.EnableWindow(true);
	m_ceIPAddress.EnableWindow(true);
	m_cePassword.EnableWindow(true);
	m_cePort.EnableWindow(true);
	m_cbCancel.EnableWindow(true);
	m_cbDone.EnableWindow(true);
	m_cbNew.EnableWindow(false);
	m_cbBrowse.EnableWindow(true);
	m_ceClient.EnableWindow(true);
	UpdateData(false);
}

void CLauncherTab::OnCancel() 
{
	this->OnSelchangeAccountList();	// Reset the window contents
	m_ceName.EnableWindow(false);
	m_ceAccount.EnableWindow(false);
	m_ceIPAddress.EnableWindow(false);
	m_cePassword.EnableWindow(false);
	m_cePort.EnableWindow(false);
	m_cbCancel.EnableWindow(false);
	m_cbDone.EnableWindow(false);
	m_cbNew.EnableWindow(true);
	m_cbBrowse.EnableWindow(false);
	m_ceClient.EnableWindow(false);
	m_clbAccountList.EnableWindow(true);
	m_cbEdit.EnableWindow(true);
	m_cbNew.EnableWindow(true);
	m_cbDelete.EnableWindow(true);
	m_cbLaunch.EnableWindow(true);

}

void CLauncherTab::OnDone() 
{
	CString csAccountName, csAccount, csIP, csPassword, csPort, csClient;
	m_ceName.GetWindowText(csAccountName);
	m_ceAccount.GetWindowText(csAccount);
	m_ceIPAddress.GetWindowText(csIP);
	m_cePassword.GetWindowText(csPassword);
	m_cePort.GetWindowText(csPort);
	m_ceClient.GetWindowText(csClient);
	m_clbAccountList.EnableWindow(true);
	m_cbEdit.EnableWindow(true);
	m_cbNew.EnableWindow(true);
	m_cbDelete.EnableWindow(true);
	m_cbLaunch.EnableWindow(true);
	csPassword = Encrypt(csPassword);
	if (!m_bEditContext)
	{
		// Make sure an account with this name doesn't already exist
		if (this->m_clbAccountList.FindStringExact(0, csAccountName) != -1)
		{
			AfxMessageBox("An account with this name already exists.  Please choose another name.", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
	}
	// Save this entry to the registry
	HKEY hKey;
	LONG lStatus;
	DWORD dwDisp;
	CString csKeyName;
	csKeyName.Format("SOFTWARE\\Menasoft\\GM Tools\\Accounts\\%s", csAccountName);
	lStatus = RegCreateKeyEx(HKEY_LOCAL_MACHINE, csKeyName, 0, NULL, REG_OPTION_NON_VOLATILE,	KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
	if (lStatus == ERROR_SUCCESS)
	{
		lStatus = RegSetValueEx(hKey, "Account", 0, REG_SZ, ((BYTE *) csAccount.GetBuffer(csAccount.GetLength())), csAccount.GetLength());
		lStatus+= RegSetValueEx(hKey, "IPAddress", 0, REG_SZ, ((BYTE *) csIP.GetBuffer(csIP.GetLength())), csIP.GetLength());
		lStatus+= RegSetValueEx(hKey, "Password", 0, REG_SZ, ((BYTE *) csPassword.GetBuffer(csPassword.GetLength())), csPassword.GetLength());
		lStatus+= RegSetValueEx(hKey, "Port", 0, REG_SZ, ((BYTE *) csPort.GetBuffer(csPort.GetLength())), csPort.GetLength());
		lStatus+= RegSetValueEx(hKey, "Client", 0, REG_SZ, ((BYTE *) csClient.GetBuffer(csClient.GetLength())), csClient.GetLength());
		RegCloseKey(hKey);
	}
	if (lStatus != ERROR_SUCCESS)
		AfxMessageBox("Error saving this account in the registry.", MB_OK | MB_ICONSTOP);
	if (!m_bEditContext)
		this->m_clbAccountList.AddString(csAccountName);
	m_bEditContext = false;
	// Reset the window
	this->OnSelchangeAccountList();
	m_ceName.EnableWindow(false);
	m_ceAccount.EnableWindow(false);
	m_ceIPAddress.EnableWindow(false);
	m_cePassword.EnableWindow(false);
	m_cePort.EnableWindow(false);
	m_cbCancel.EnableWindow(false);
	m_cbDone.EnableWindow(false);
	m_cbNew.EnableWindow(true);
	m_cbBrowse.EnableWindow(false);
	m_ceClient.EnableWindow(false);
}

void CLauncherTab::OnSelchangeAccountList() 
{
	// Get the current selection
	int iSel = this->m_clbAccountList.GetCurSel();
	if (iSel == -1)
	{
		// Nothing is selected...disable the delete and launch buttons
		this->m_cbDelete.EnableWindow(false);
		this->m_cbLaunch.EnableWindow(false);
		// clear the values in the edit boxes
		m_ceName.SetWindowText("");
		m_ceAccount.SetWindowText("");
		m_ceIPAddress.SetWindowText("");
		m_cePassword.SetWindowText("");
		m_cePort.SetWindowText("");
		m_ceClient.SetWindowText("");
	}
	else
	{
		this->m_cbDelete.EnableWindow(true);
		this->m_cbLaunch.EnableWindow(true);
		this->m_cbEdit.EnableWindow(true);
		// display the attributes for this account as well.
		HKEY hKey;
		LONG lStatus;
		CString csAccountName, csKeyName;
		this->m_clbAccountList.GetText(iSel, csAccountName);
		csKeyName.Format("SOFTWARE\\Menasoft\\GM Tools\\Accounts\\%s", csAccountName);
		lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, csKeyName, 0, KEY_ALL_ACCESS, &hKey);
		if (lStatus == ERROR_SUCCESS)
		{
			this->m_ceName.SetWindowText(csAccountName);
			char szBuffer[MAX_PATH];
			DWORD dwSize = sizeof(szBuffer);
			DWORD dwType;
			lStatus = RegQueryValueEx(hKey, "Account", NULL, &dwType, (BYTE *) &szBuffer[0], &dwSize);
			if (lStatus == ERROR_SUCCESS && dwSize)
				this->m_ceAccount.SetWindowText(szBuffer);
			dwSize = sizeof(szBuffer);
			lStatus = RegQueryValueEx(hKey, "IPAddress", NULL, &dwType, (BYTE *) &szBuffer[0], &dwSize);
			if (lStatus == ERROR_SUCCESS && dwSize)
				this->m_ceIPAddress.SetWindowText(szBuffer);
			dwSize = sizeof(szBuffer);
			lStatus = RegQueryValueEx(hKey, "Password", NULL, &dwType, (BYTE *) &szBuffer[0], &dwSize);
			if (lStatus == ERROR_SUCCESS && dwSize)
			{
				// Need to decrypt the password
				CString csPassword = _T(szBuffer);
				csPassword = Encrypt(csPassword);
				this->m_cePassword.SetWindowText(csPassword);
			}
			dwSize = sizeof(szBuffer);
			lStatus = RegQueryValueEx(hKey, "Port", NULL, &dwType, (BYTE *) &szBuffer[0], &dwSize);
			if (lStatus == ERROR_SUCCESS && dwSize)
				this->m_cePort.SetWindowText(szBuffer);
			dwSize = sizeof(szBuffer);
			lStatus = RegQueryValueEx(hKey, "Client", NULL, &dwType, (BYTE *) &szBuffer[0], &dwSize);
			if (lStatus == ERROR_SUCCESS && dwSize)
				this->m_ceClient.SetWindowText(szBuffer);
			else
				this->m_ceClient.SetWindowText("");
			RegCloseKey(hKey);
		}
	}
}

void CLauncherTab::OnDelete() 
{
	int iSel = this->m_clbAccountList.GetCurSel();
	if (iSel != -1)
	{
		CString csAccountName;
		this->m_clbAccountList.GetText(iSel, csAccountName);
		CString csMessage;
		csMessage.Format("Are you sure you wish to delete the account \"%s\"?", csAccountName);
		if (AfxMessageBox(csMessage, MB_OKCANCEL | MB_ICONQUESTION) == IDOK)
		{
			CString csRegKey;
			csRegKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Accounts\\%s", csAccountName);
			LONG lStatus = RegDeleteKey(HKEY_LOCAL_MACHINE, csRegKey);
			this->m_clbAccountList.DeleteString(iSel);
			this->OnSelchangeAccountList();
		}
	}
}

void CLauncherTab::OnLaunch() 
{
	CString csAccountName, csAccount, csIP, csPort, csPassword;
	m_ceName.GetWindowText(csAccountName);
	m_ceAccount.GetWindowText(csAccount);
	m_cePort.GetWindowText(csPort);
	m_ceIPAddress.GetWindowText(csIP);
	m_cePassword.GetWindowText(csPassword);
	// Write the server IP and port to the login.cfg file
	CString csLoginFile;
	csLoginFile.Format("%slogin.cfg", csUOPath);
	CStdioFile csfLoginFile;
	if (csfLoginFile.Open(csLoginFile, CFile::modeWrite | CFile::modeCreate))
	{
		CString csOutput;
		csOutput.Format("; login.cfg file for the %s server\n", csAccountName);
		csfLoginFile.WriteString(csOutput);
		//csfLoginFile.WriteString("; Created by Axis\n");
		csOutput.Format("LoginServer=%s,%s\n", csIP, csPort);
		csfLoginFile.WriteString(csOutput);
		csfLoginFile.Close();
	}
	else
	{
		AfxMessageBox("Could not open login.cfg file for writing.", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	// Write the Account info to the uo.cfg file
	CString csUOFile;
	csUOFile.Format("%suo.cfg", csUOPath);
	CStdioFile csfUOFile;
	if (csfUOFile.Open(csUOFile, CFile::modeRead | CFile::shareDenyNone))
	{
		CString csTmpFile;
		csTmpFile.Format("%suo.axis", csUOPath);
		CStdioFile csfTmpFile;
		if (csfTmpFile.Open(csTmpFile, CFile::modeWrite | CFile::modeCreate))
		{
			BOOL bStatus = true;
			CString csOutput;
			csOutput.Format("; UO.CFG for the %s server\n", csAccountName);
			csfTmpFile.WriteString(csOutput);
			//csfTmpFile.WriteString("; Created by Axis\n");
			while (bStatus)
			{
				// Read a line
				CString csInput;
				bStatus = csfUOFile.ReadString(csInput);
				if ( !bStatus )
					break;
				if ( (csInput.Find(";") == -1) &&
					(csInput.Find("SavePassword=") == -1) &&
					(csInput.Find("AcctID=") == -1) &&
					(csInput.Find("AcctPassword=") == -1) &&
					(csInput.Find("RememberAcctPW") == -1))
				{
					// Write this one
					csfTmpFile.WriteString(csInput);
					csfTmpFile.WriteString("\n");
				}
			}
			csfTmpFile.WriteString("SavePassword=on\n");
			csOutput.Format("AcctID=%s\n", csAccount);
			csfTmpFile.WriteString(csOutput);
			csOutput.Format("AcctPassword=%s\n", EncryptUO(csPassword));
			csfTmpFile.WriteString(csOutput);
			csfTmpFile.WriteString("RememberAcctPW=on\n");
			csfTmpFile.Close();
			csfUOFile.Close();
			ReplaceFiles(csTmpFile, csUOFile);
		}
		else
		{
			csfUOFile.Close();
			AfxMessageBox("Could not open temporary file for writing.", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
	}
	else
	{
		AfxMessageBox("Could not open uo.cfg file from reading.", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	// Now launch UO
	CString csCmd, csClient;
	this->m_ceClient.GetWindowText(csClient);
	if ( csClient == "" )
		csCmd.Format("%sclient.exe", csUOPath);
	else
		csCmd = csClient;
	//system(csCmd);
	STARTUPINFO start;
	memset( &start, 0x00, sizeof(start) );
	start.cb = sizeof(start);
	PROCESS_INFORMATION procInfo;
	memset( &procInfo, 0x00, sizeof(procInfo) );
	if ( ! CreateProcess( csCmd, NULL, NULL, NULL, FALSE, CREATE_NEW_PROCESS_GROUP, NULL, csUOPath, &start, &procInfo ) )
	{
		DWORD dwError = GetLastError();
	}
}

void CLauncherTab::OnEditacct() 
{
	m_ceAccount.EnableWindow(true);
	m_ceIPAddress.EnableWindow(true);
	m_cePassword.EnableWindow(true);
	m_cePort.EnableWindow(true);
	m_cbCancel.EnableWindow(true);
	m_cbDone.EnableWindow(true);
	m_cbNew.EnableWindow(false);
	m_cbEdit.EnableWindow(false);
	m_cbBrowse.EnableWindow(true);
	m_ceClient.EnableWindow(true);
	m_bEditContext = true;
	m_clbAccountList.EnableWindow(false);
	m_cbEdit.EnableWindow(false);
	m_cbNew.EnableWindow(false);
	m_cbDelete.EnableWindow(false);
	m_cbLaunch.EnableWindow(false);
	UpdateData(false);	
}

void CLauncherTab::OnClientbrowse() 
{
	char szCwd[MAX_PATH];
	memset(&szCwd[0], 0x00, sizeof(szCwd));
	getcwd(szCwd, sizeof(szCwd));
	CFileDialog dlg(TRUE, NULL, NULL, 0, "Executable Files (*.exe)|*.exe||");
	if (dlg.DoModal() == IDOK)
		this->m_ceClient.SetWindowText(dlg.GetPathName());
	chdir(szCwd);
	return;	
}

void CLauncherTab::OnChangeclient() 
{
	// This changes the default client used
	char szCwd[MAX_PATH];
	memset(&szCwd[0], 0x00, sizeof(szCwd));
	getcwd(szCwd, sizeof(szCwd));
	CFileDialog dlg(TRUE, NULL, csUOExe, 0, "Executable Files (*.exe)|*.exe||");

	if ( dlg.DoModal() == IDOK )
	{
		CString csFullPath = dlg.GetPathName();
		csUOExe = dlg.GetFileName();
		csUOPath = csFullPath.Left(csFullPath.GetLength() - csUOExe.GetLength());

		this->m_csClientLoc.SetWindowText(csFullPath);
		LONG lStatus;
		HKEY hKey;
		lStatus = RegOpenKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools", &hKey);
		if ( lStatus == ERROR_SUCCESS )
		{
			lStatus = RegSetValueEx(hKey, "Client Path", 0, REG_SZ, (BYTE *) csUOPath.GetBuffer(csUOPath.GetLength()), csUOPath.GetLength());
			lStatus = RegSetValueEx(hKey, "Client EXE", 0, REG_SZ, (BYTE *) csUOExe.GetBuffer(csUOExe.GetLength()), csUOExe.GetLength());
			RegCloseKey(hKey);
		}
	}
	chdir(szCwd);
}
