/*
 $Id: serverconfigdlg.h,v 1.3 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_SERVERCONFIGDLG_H__3A1709B1_0A15_11D3_871C_00805FD91B8C__INCLUDED_)
#define AFX_SERVERCONFIGDLG_H__3A1709B1_0A15_11D3_871C_00805FD91B8C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ServerConfigDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// ServerConfigDlg dialog

class CServerConfigDlg : public CDialog
{
// Construction
public:
	~CServerConfigDlg();
	CScriptArray m_oWebpages;
	CString m_csURL;
	CString m_csAdminEMail;
	int m_iTimeZone;
	bool SaveConfig();
	void LoadVal(CString csTag, CString csValue);
	CServerConfigDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CServerConfigDlg)
	enum { IDD = IDD_SERVERCONFIG_DLG };
	CButton	m_cbRemoveValue;
	CButton	m_cbAddValue;
	CListCtrl	m_clcValues;
	CTreeCtrl	m_ctcSections;
	CButton	m_cbUseNewSpeech;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CServerConfigDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void EditWebpage(CWebpageDef * pPage);
	void DisplayWebpage(CWebpageDef *pPage);
	BOOL ReadWebpageInfo(CStdioFile &csfInput, CWebpageDef *pPage);
	BOOL ReadServerInfo(CStdioFile &csfFile);
	void WriteTag(CStdioFile *file, CString csTag, CString csLine);
	void RemoveBlockedIP();
	void AddBlockedIP();
	void RemoveServer();
	void AddServer();
	void EditBlockedIPs();
	void EditServers();
	void EditMainOptions();
	CString m_csUOFiles;
	CString m_csScriptFiles;
	CString m_csWorldSave;
	CString m_csLog;
	bool m_bProfile;
	bool m_bVerbose;
	CString m_csGuests;
	CString m_csWebFile2;
	bool m_bSecure;
	bool m_bHearall;
	CString m_csSavePeriod;
	CString m_csMapCacheTime;
	bool m_bRequireReagents;
	CString m_csDungeonLight;
	bool m_bMonsterFight;
	CString m_csSpeechFiles;
	CString m_csDecayTimer;
	CString m_csBankMaxItems;
	CString m_csBankMaxWeight;
	bool m_bWOPPlayer;
	bool m_bWOPStaff;
	CString m_csDeadSocketTime;
	DWORD m_dwDebugFlags;
	bool m_bGuardsInstantKill;
	bool m_bArriveDepartMsg;
	CString m_csCorpsePlayerDecay;
	CString m_csCorpseNPCDecay;
	CString m_csSnoopCriminal;
	bool m_bFreeServer;
	CString m_csClientLinger;
	CString m_csFreezeRestartTime;
	CString m_csWebPageUpdate;
	CString m_csWebFile;
	CString m_csMinCharDeleteTime;
	CString m_csNPCTrainPercent;
	CString m_csClientVersion;
	CString m_csRegisterServer;
	bool m_bCharTags;
	CString m_csVendorMaxSell;
	CString m_csBackupLevels;
	bool m_bSaveBackground;
	bool m_bForceGarbageCollect;
	CString m_csGameMinuteLength;
	bool m_bNoWeather;
	bool m_bEquippedCast;
	bool m_bFlipDroppedItems;
	CString m_csStatCap;
	CString m_csStatAvg;
	bool m_bReagentLossFail;
	bool m_bNTService;
	CString m_csPollServers;
	CString m_csMagicUnlockDoor;
	bool m_bMainLogServer;
	CString m_csMurderMinCount;
	CString m_csMurderDecayTime;
	CString m_csClientsMax;
	CString m_csWebClientListFormat;
	CString m_csWebServerListFormat;
	CString m_csMaxCharsPerAccount;
	DWORD m_dwLogMask;
	CString m_csLightNight;
	CString m_csTrainSkillMax;
	CString m_csMaxComplexity;
	CString m_csPlayerNeutral;
	CString m_csGuardLinger;
	CString m_csCriminalTimer;
	CString m_csHitpointPercentOnRez;
	bool m_bMonsterFear;
	CString m_csAcctFiles;
	bool m_bLootingIsACrime;
	bool m_bResponsibleOwners;
	bool m_bHelpingCriminalsIsACrime;
	bool m_bPlayerGhostSounds;
	bool m_bAutoNewbieKeys;
	CString m_csMaxBaseSkill;
	CString m_csRunningPenalty;
	CString m_csStaminaLossAtWeight;
	
	CStringArray m_csServerName;
	CStringArray m_csServerIP;
	CStringArray m_csServerPort;

	CStringArray m_csaBlockedIPs;

	void DisplayBlockedIPs();
	void DisplayServers();
	void DisplayMainOptions();
	void InitializeSections();
	BOOL ReadBlockedIPs(CStdioFile &csfFile);

	// Generated message map functions
	//{{AFX_MSG(CServerConfigDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnOk();
	afx_msg void OnSelchangedConfigTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnAddvalue();
	afx_msg void OnRemovevalue();
	afx_msg void OnDblclkConfigList(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SERVERCONFIGDLG_H__3A1709B1_0A15_11D3_871C_00805FD91B8C__INCLUDED_)
