/*
 $Id: settingstab.cpp,v 1.26 2002/11/12 03:50:09 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * Modified by Adron 2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// SettingsTab.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "SettingsTab.h"
#include "AboutDlg.h"
#include "ServerConfigDlg.h"
#include "DrewskyPS.h"
#include "RemoteProfileDlg.h"
#include "ScriptEditDlg.h"
#include "ItemScriptEditDlg.h"
#include "AccountDlg.h"
#include "StaticToolDlg.h"
#include "AdditionalSettingsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettingsTab property page

IMPLEMENT_DYNCREATE(CSettingsTab, CPropertyPage)

CSettingsTab::CSettingsTab() : CPropertyPage(CSettingsTab::IDD)
{
	//{{AFX_DATA_INIT(CSettingsTab)
	m_b3DRoomView = FALSE;
	m_bAlwaysOnTop = FALSE;
	m_bDisplayItems = FALSE;
	m_bScalePics = FALSE;
	m_bSpawnMessage = FALSE;
	m_bStartLauncher = FALSE;
	m_bShowRadar = FALSE;
	m_bSysClose = FALSE;
	m_bShowSpawnpoints = FALSE;
	m_bAllowMultiple = FALSE;
	m_dwCommandMode = -1;
	m_bResourcesOnly = FALSE;
	m_pDlgStaticTool = NULL;
	m_pAcctDlg = NULL;
	m_iCommandVersion = 0;
	//}}AFX_DATA_INIT
	m_pDlgStaticTool = 0;
}

CSettingsTab::~CSettingsTab()
{
	if ( m_pDlgStaticTool )
	{
		m_pDlgStaticTool->DestroyWindow();
		delete m_pDlgStaticTool;
	}
	if ( m_pAcctDlg )
	{
		m_pAcctDlg->DestroyWindow();
		delete m_pAcctDlg;
	}
}

void CSettingsTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingsTab)
	DDX_Control(pDX, IDC_LAUNCH_STATIC_TOOL, m_cbStaticLaunch);
	DDX_Control(pDX, IDC_RP_NEW, m_cbRPNew);
	DDX_Control(pDX, IDC_RP_EDIT, m_cbRPEdit);
	DDX_Control(pDX, IDC_RP_DELETE, m_cbRPDelete);
	DDX_Control(pDX, IDC_REMOTEPROFILES, m_clcRmtProfiles);
	DDX_Control(pDX, IDC_ITEM_COLOR, m_csItemColor);
	DDX_Control(pDX, IDC_NPC_COLOR, m_csNpcColor);
	DDX_Control(pDX, IDC_SHOWSPAWNS, m_cbShowSpawnpoints);
	DDX_Control(pDX, IDC_SHOWRADAR, m_cbShowRadar);
	DDX_Control(pDX, IDC_3D_ROOMVIEW, m_cb3DRoomView);
	DDX_Control(pDX, IDC_SCALEPICS, m_cbScalePics);
	DDX_Check(pDX, IDC_3D_ROOMVIEW, m_b3DRoomView);
	DDX_Check(pDX, IDC_ALWAYS_ONTOP, m_bAlwaysOnTop);
	DDX_Check(pDX, IDC_DISPLAY_ITEMS, m_bDisplayItems);
	DDX_Check(pDX, IDC_SCALEPICS, m_bScalePics);
	DDX_Check(pDX, IDC_SPAWN_MESSAGE, m_bSpawnMessage);
	DDX_Check(pDX, IDC_START_LAUNCHER, m_bStartLauncher);
	DDX_Check(pDX, IDC_SHOWRADAR, m_bShowRadar);
	DDX_Check(pDX, IDC_SYSCLOSE, m_bSysClose);
	DDX_Check(pDX, IDC_SHOWSPAWNS, m_bShowSpawnpoints);
	DDX_Check(pDX, IDC_ALLOWMULTIPLE, m_bAllowMultiple);
	DDX_Radio(pDX, IDC_CMDMODE0, m_dwCommandMode);
	DDX_Check(pDX, IDC_RESOURCEONLY, m_bResourcesOnly);
	DDX_Radio(pDX, IDC_SVER0, m_iCommandVersion);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingsTab, CPropertyPage)
	//{{AFX_MSG_MAP(CSettingsTab)
	ON_BN_CLICKED(IDC_CLOSE_CLIENT, OnCloseClient)
	ON_BN_CLICKED(IDC_DISPLAY_ITEMS, OnDisplayItems)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_BN_CLICKED(IDC_SHOWRADAR, OnShowradar)
	ON_BN_CLICKED(IDC_SHOWSPAWNS, OnShowspawns)
	ON_BN_CLICKED(IDC_ABOUTHOG, OnAbouthog)
	ON_BN_CLICKED(IDC_RELOAD_SCRIPTS, OnReloadScripts)
	ON_BN_CLICKED(IDC_ITEM_COLOR, OnItemColor)
	ON_BN_CLICKED(IDC_NPC_COLOR, OnNpcColor)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_RP_NEW, OnRpNew)
	ON_BN_CLICKED(IDC_RP_EDIT, OnRpEdit)
	ON_BN_CLICKED(IDC_RP_DELETE, OnRpDelete)
	ON_LBN_SELCHANGE(IDC_REMOTEPROFILES, OnSelchangeRemoteprofiles)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_SCRIPTEDIT, OnScriptedit)
	ON_BN_CLICKED(IDC_RAWEDIT, OnRawedit)
	ON_BN_CLICKED(IDC_ACCTEDIT, OnAcctedit)
	ON_BN_CLICKED(IDC_DIALOG_COLOR, OnDialogColor)
	ON_BN_CLICKED(IDC_TEXT_COLOR, OnTextColor)
	ON_BN_CLICKED(IDC_3D_ROOMVIEW, On3DRoomView)
	ON_BN_CLICKED(IDC_ALLOWMULTIPLE, OnAllowMultiple)
	ON_BN_CLICKED(IDC_ALWAYS_ONTOP, OnAlwaysOnTop)
	ON_BN_CLICKED(IDC_RESOURCEONLY, OnResourcesOnly)
	ON_BN_CLICKED(IDC_SCALEPICS, OnScalePics)
	ON_BN_CLICKED(IDC_START_LAUNCHER, OnStartLauncher)
	ON_BN_CLICKED(IDC_SYSCLOSE, OnSysClose)
	ON_BN_CLICKED(IDC_SPAWN_MESSAGE, OnSpawnMessage)
	ON_BN_CLICKED(IDC_CMDMODE0, OnCmdMode)
	ON_BN_CLICKED(IDC_LAUNCH_STATIC_TOOL, OnLaunchStaticTool)
	ON_BN_CLICKED(IDC_REFRESHCATEGORIES, OnRefreshcategories)
	ON_BN_CLICKED(IDC_ADDITIONALSETTINGS, OnAdditionalSettings)
	ON_BN_CLICKED(IDC_SVER0, OnSver)
	ON_BN_CLICKED(IDC_SVER1, OnSver)
	ON_BN_CLICKED(IDC_SAVESETTINGS, SaveSettings)
	ON_BN_CLICKED(IDC_CMDMODE1, OnCmdMode)
	ON_BN_CLICKED(IDC_CMDMODE2, OnCmdMode)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsTab message handlers

BOOL CSettingsTab::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	this->m_clcRmtProfiles.AddString("<  NONE  >");
	this->m_clcRmtProfiles.AddString("<  DEFAULT  >");
	// Read the existing local profiles from the registry
	HKEY hKey;
	LONG lStatus;
	lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Local Profiles", 0, KEY_ALL_ACCESS, &hKey);
	int iIndex = 0;
	if ( lStatus == ERROR_SUCCESS )
	{
		while (lStatus == ERROR_SUCCESS)
		{
			char szBuffer[MAX_PATH];
			DWORD dwSize = sizeof(szBuffer);
			lStatus = RegEnumKeyEx(hKey, iIndex, &szBuffer[0], &dwSize, 0, NULL, NULL, NULL);
			if (lStatus == ERROR_SUCCESS)
			{
				CString csProfile;
				csProfile.Format("Local: %s", szBuffer);
				this->m_clcRmtProfiles.AddString(csProfile);
			}
			iIndex++;
		}
		RegCloseKey(hKey);
	}
	// Read the existing remote profiles from the registry
	iIndex = 0;
	lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Remote Profiles", 0, KEY_ALL_ACCESS, &hKey);
	if ( lStatus == ERROR_SUCCESS )
	{
		while (lStatus == ERROR_SUCCESS)
		{
			char szBuffer[MAX_PATH];
			DWORD dwSize = sizeof(szBuffer);
			lStatus = RegEnumKeyEx(hKey, iIndex, &szBuffer[0], &dwSize, 0, NULL, NULL, NULL);
			if (lStatus == ERROR_SUCCESS)
			{
				CString csProfile;
				csProfile.Format("Remote: %s", szBuffer);
				this->m_clcRmtProfiles.AddString(csProfile);
			}
			iIndex++;
		}
		RegCloseKey(hKey);
	}


	RefreshSystemInfo();

	m_bSpawnMessage = (BOOL) Main->m_dwSpawnMessage;
	m_bStartLauncher = (BOOL) Main->m_dwStartLauncher;
	m_bDisplayItems = (BOOL) Main->m_dwDrawItems;
	m_b3DRoomView = (BOOL) Main->m_dw3DRoomView;
	m_bScalePics = (BOOL) Main->m_dwScaleItems;
	m_bAlwaysOnTop = (BOOL) Main->m_dwAlwaysOnTop;
	m_bShowRadar = (BOOL) Main->m_dwShowRadar;
	m_bShowSpawnpoints = (BOOL) Main->m_dwShowSpawnpoints;
	m_bSysClose = (BOOL) Main->m_dwSysClose;
	m_bAllowMultiple = (BOOL) Main->m_dwAllowMultiple;
	m_dwNPCSpawnColor = Main->m_dwNPCSpawnColor;
	m_dwItemSpawnColor = Main->m_dwItemSpawnColor;
	m_dwDialogColor = Main->m_dwDialogColor;
	m_dwTextColor = Main->m_dwTextColor;
	this->m_dwCommandMode = Main->m_dwOldCommands;
	m_bResourcesOnly = Main->m_dwResourcesOnly;
	m_iCommandVersion = Main->m_dwCommandVersion;
	UpdateData(false);
	m_pDlgStaticTool = NULL;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsTab::RefreshSystemInfo()
{
	MEMORYSTATUS mem;
	GlobalMemoryStatus(&mem);
	CString csMemory;
	CString csSwapFile;
	
	csMemory.Format("%ld kB (%ld%% used)", mem.dwTotalPhys/1024, (long) (100 - ((mem.dwAvailPhys * 100)/mem.dwTotalPhys)));
	csSwapFile.Format("%ld kB (%ld%% used)", mem.dwTotalPageFile/1024, 100 - ( (mem.dwAvailPageFile * 100) / mem.dwTotalPageFile));

	OSVERSIONINFO osver;
	osver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osver);
	CString csOS;

	switch( osver.dwPlatformId )
	{
	case VER_PLATFORM_WIN32s:
		csOS = "Windows 3.1";
		break;
	case VER_PLATFORM_WIN32_WINDOWS:
		if ( osver.dwMajorVersion == 4 && osver.dwMinorVersion != 10 )
			csOS = "Windows 95";
		else
			csOS = "Windows 98";
		break;
	case VER_PLATFORM_WIN32_NT:
		csOS = "Windows NT";
		break;
	default:
		csOS = "Undetermined";
		break;
	}

	return;
}

BOOL CSettingsTab::OnSetActive() 
{
	return CPropertyPage::OnSetActive();
}

void CSettingsTab::SaveSettings() 
{
}

void CSettingsTab::OnCloseClient() 
{
	SendToUO(KS_ALT_F4);	
}

void CSettingsTab::OnDisplayItems() 
{
	UpdateData();
	Main->PutRegistryDword("DrawItems", m_bDisplayItems);
	Main->m_dwDrawItems = m_bDisplayItems;
	m_cb3DRoomView.EnableWindow(m_bDisplayItems);
	m_cbScalePics.EnableWindow(m_bDisplayItems);
	return;
}

void CSettingsTab::OnClose() 
{
	CPropertySheet * hParent = (CPropertySheet *)this->GetParent();
	hParent->PressButton(PSBTN_OK);
}

void CSettingsTab::OnShowradar() 
{
	UpdateData();
	Main->PutRegistryDword("ShowRadar", m_bShowRadar);
	Main->m_dwShowRadar = m_bShowRadar;
	this->m_cbShowSpawnpoints.EnableWindow(this->m_bShowRadar);
}

void CSettingsTab::OnShowspawns() 
{
	UpdateData();
	Main->PutRegistryDword("ShowSpawnpoints", m_bShowSpawnpoints);
	Main->m_dwShowSpawnpoints = m_bShowSpawnpoints;
}

void CSettingsTab::OnAbouthog() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

void CSettingsTab::OnReloadScripts() 
{
	this->OnShowWindow(SW_SHOW, SW_PARENTOPENING);
	// Basically what we need to do is call the function in the property sheet
	// that will destroy and recreate the tabs that have scripts associated with them.
	CFileStatus st;
	CDrewskyPS * hParent = (CDrewskyPS *)this->GetParent();
	hParent->ReloadScripts();
	hParent->UpdateTip();
}

void CSettingsTab::OnItemColor() 
{
	CColorDialog colors;
	if ( colors.DoModal() == IDOK )
		m_dwItemSpawnColor = colors.GetColor();
	SendMessage( WM_PAINT );
	Main->PutRegistryDword("ItemSpawnColor", m_dwItemSpawnColor);
	Main->m_dwItemSpawnColor = m_dwItemSpawnColor;
}

void CSettingsTab::OnNpcColor() 
{
	CColorDialog colors;
	if ( colors.DoModal() == IDOK )
		m_dwNPCSpawnColor = colors.GetColor();
	SendMessage( WM_PAINT );
	Main->PutRegistryDword("NPCSpawnColor", m_dwNPCSpawnColor);
	Main->m_dwNPCSpawnColor = m_dwNPCSpawnColor;
}

void CSettingsTab::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CDC * pDC = m_csNpcColor.GetDC();
	CRgn rgn;
	CRect rect;
	m_csNpcColor.GetWindowRect( &rect );
	CBrush * pNewBrush = new (CBrush);
	pNewBrush->CreateSolidBrush( (COLORREF) m_dwNPCSpawnColor );
	CBrush * pOldBrush = pDC->SelectObject(pNewBrush);
	CRect cr;
	m_csNpcColor.GetClientRect(&cr);
	rgn.CreateRectRgnIndirect(cr);
	pDC->SelectClipRgn(&rgn);
	pDC->FillRect(cr, pNewBrush);
	pDC->SelectObject(pOldBrush);
	delete (pNewBrush);
	rgn.DeleteObject();
	m_csNpcColor.ReleaseDC( pDC );

	pDC = m_csItemColor.GetDC();
	m_csItemColor.GetWindowRect( &rect );
	pNewBrush = new (CBrush);
	pNewBrush->CreateSolidBrush( (COLORREF) m_dwItemSpawnColor );
	pOldBrush = pDC->SelectObject(pNewBrush);
	m_csItemColor.GetClientRect(&cr);
	rgn.CreateRectRgnIndirect(cr);
	pDC->SelectClipRgn(&rgn);
	pDC->FillRect(cr, pNewBrush);
	pDC->SelectObject(pOldBrush);
	delete (pNewBrush);
	rgn.DeleteObject();
	m_csItemColor.ReleaseDC( pDC );

}

void CSettingsTab::OnRpNew() 
{
	CRemoteProfileDlg dlg;
	if ( dlg.DoModal() != IDOK )
		return;
	CString csKey, csRmtPwd, csPwd;
	csPwd = Encrypt(dlg.m_csPwd);
	int iTimeout = atoi(dlg.m_csReceiveTimeout);
	int iRemoteSpawns = dlg.m_bRemoteSpawns ? 1 : 0;
	if ( iTimeout < 1000 )
		iTimeout = 1000;
	switch ( dlg.m_iProfile )
	{
	case 0:
		{
			csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Local Profiles\\%s", dlg.m_csName);

			Main->PutRegistryString("Username", dlg.m_csUsername, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Password", csPwd, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("HoGPort", dlg.m_csHogPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("ServerIP", dlg.m_csIP, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Port", dlg.m_csTusPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Root Directory", dlg.m_csBaseDir, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryDword("ReceiveTimeout", (DWORD) iTimeout, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryDword("Read Remote Spawnpoints", (DWORD) iRemoteSpawns, HKEY_LOCAL_MACHINE, csKey);
		}
		break;
	case 1:
		{
			csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Remote Profiles\\%s", dlg.m_csName);

			Main->PutRegistryString("Username", dlg.m_csUsername, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Password", csPwd, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("ServerIP", dlg.m_csIP, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("HoGPort", dlg.m_csHogPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("TUSPort", dlg.m_csTusPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryDword("ReceiveTimeout", (DWORD) iTimeout, HKEY_LOCAL_MACHINE, csKey);
		}
		break;

	}
	CString csProfile;
	csProfile.Format("%s: %s", dlg.m_iProfile == 0 ? "Local" : "Remote", dlg.m_csName);
	this->m_clcRmtProfiles.AddString(csProfile);
	this->m_clcRmtProfiles.SelectString(-1, csProfile);
}

void CSettingsTab::OnRpEdit() 
{
	int iSel = this->m_clcRmtProfiles.GetCurSel();
	if ( iSel == -1 )
		return;
	CRemoteProfileDlg dlg;
	dlg.m_csName = Main->GetProfileString();
	if ( Main->GetProfileType() == PROFILE_REMOTE )
	{
		dlg.m_csHogPort = Main->m_csAxissvrPort;
		dlg.m_csIP = Main->m_csServerIP;
		dlg.m_csPwd = Main->m_csPassword;
		dlg.m_csTusPort = Main->m_csSpherePort;
		dlg.m_csUsername = Main->m_csUserID;
		dlg.m_csReceiveTimeout.Format("%ld", Main->m_iReceiveTimeout);
		dlg.m_iProfile = 1;
	}
	else
	{
		dlg.m_csHogPort = Main->m_csAxissvrPort;
		dlg.m_csIP = Main->m_csServerIP;
		dlg.m_csPwd = Main->m_csPassword;
		dlg.m_csTusPort = Main->m_csSpherePort;
		dlg.m_csUsername = Main->m_csUserID;
		dlg.m_csReceiveTimeout.Format("%ld", Main->m_iReceiveTimeout);
		dlg.m_csBaseDir = Main->m_csRootDirectory;
		dlg.m_bRemoteSpawns = Main->m_dwRemoteSpawns ? true : false;
		dlg.m_iProfile = 0;
	}

	if ( dlg.DoModal() != IDOK )
		return;
	int iRemoteSpawns = dlg.m_bRemoteSpawns ? 1 : 0;
	int iTimeout = atoi(dlg.m_csReceiveTimeout);
	if ( iTimeout < 1000 )
		iTimeout = 1000;

	CString csKey, csRmtPwd, csPwd;
	csPwd = Encrypt(dlg.m_csPwd);

	switch ( dlg.m_iProfile )
	{
	case 0:
		{
			csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Local Profiles\\%s", dlg.m_csName);

			Main->PutRegistryString("Username", dlg.m_csUsername, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Password", csPwd, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("HoGPort", dlg.m_csHogPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("ServerIP", dlg.m_csIP, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Port", dlg.m_csTusPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Root Directory", dlg.m_csBaseDir, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryDword("ReceiveTimeout", (DWORD) iTimeout, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryDword("Read Remote Spawns", (DWORD) iRemoteSpawns, HKEY_LOCAL_MACHINE, csKey);
		}
		break;
	case 1:
		{
			csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Remote Profiles\\%s", dlg.m_csName);

			Main->PutRegistryString("Username", dlg.m_csUsername, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("Password", csPwd, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("ServerIP", dlg.m_csIP, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("HoGPort", dlg.m_csHogPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryString("TUSPort", dlg.m_csTusPort, HKEY_LOCAL_MACHINE, csKey);
			Main->PutRegistryDword("ReceiveTimeout", (DWORD) iTimeout, HKEY_LOCAL_MACHINE, csKey);
		}
		break;
	}

	this->OnSelchangeRemoteprofiles();
}

void CSettingsTab::OnRpDelete() 
{
	int iSel = this->m_clcRmtProfiles.GetCurSel();
	if ( iSel == -1 )
		return;
	CString csKey;
	CString csType;
	switch (Main->GetProfileType() )
	{
	case PROFILE_NONE:
	case PROFILE_DEFAULT:
		AfxMessageBox("This profile cannot be deleted.", MB_OK);
		return;
	case PROFILE_LOCAL:
		csType.Format("Local Profiles");
		break;
	case PROFILE_REMOTE:
		csType.Format("Remote Profiles");
		break;
	}
	csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\%s\\%s", csType, Main->GetProfileString());
	Main->DeleteRegistryKey(csKey);
	this->m_clcRmtProfiles.DeleteString( iSel );
	Main->m_csUserID = "";
	Main->m_csPassword = "";
	Main->m_csSpherePort = "";
	Main->m_csAxissvrPort = "";
	Main->m_csServerIP = "";
	Main->GetProfileString() = "";
	Main->m_iReceiveTimeout = 60000;
	Main->m_dwRemoteSpawns = 0;

}

void CSettingsTab::OnSelchangeRemoteprofiles() 
{
	int iSel = this->m_clcRmtProfiles.GetCurSel();
	// Clear out all of the values
	Main->m_csUserID = "";
	Main->m_csPassword = "";
	Main->m_csSpherePort = "";
	Main->m_csAxissvrPort = "";
	Main->m_csServerIP = "";
	Main->GetProfileString() = "";
	Main->m_iReceiveTimeout = 60000;
	Main->m_csRootDirectory = "";
	Main->m_dwRemoteSpawns = 0;

	this->m_clcRmtProfiles.GetText( iSel, Main->m_csProfile );
	switch ( Main->GetProfileType() )
	{
	case PROFILE_NONE:
	case PROFILE_DEFAULT:
		this->m_cbRPDelete.EnableWindow(FALSE);
		this->m_cbRPEdit.EnableWindow(FALSE);
		break;
	case PROFILE_REMOTE:
		{
			CString csKey;
			csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Remote Profiles\\%s", Main->GetProfileString());
			Main->m_csUserID = Main->GetRegistryString("Username", "", HKEY_LOCAL_MACHINE, csKey);
			Main->m_csPassword = Main->GetRegistryString("Password", "", HKEY_LOCAL_MACHINE, csKey);
			Main->m_csServerIP = Main->GetRegistryString("ServerIP", "", HKEY_LOCAL_MACHINE, csKey);
			Main->m_csAxissvrPort = Main->GetRegistryString("HogPort", "4006", HKEY_LOCAL_MACHINE, csKey);
			Main->m_csSpherePort = Main->GetRegistryString("TusPort", "2593", HKEY_LOCAL_MACHINE, csKey);

			Main->m_iReceiveTimeout = (int) Main->GetRegistryDword("ReceiveTimeout", 60000, HKEY_LOCAL_MACHINE, csKey);
			if ( Main->m_iReceiveTimeout < 1000 )
				Main->m_iReceiveTimeout = 1000;
			Main->m_csPassword = Encrypt(Main->m_csPassword);
		}
		this->m_cbRPDelete.EnableWindow(TRUE);
		this->m_cbRPEdit.EnableWindow(TRUE);
		break;
	case PROFILE_LOCAL:
		{
			CString csKey;
			csKey.Format("SOFTWARE\\Menasoft\\GM Tools\\Local Profiles\\%s", Main->GetProfileString());
			Main->m_csUserID = Main->GetRegistryString("Username", "", HKEY_LOCAL_MACHINE, csKey);
			Main->m_csPassword = Main->GetRegistryString("Password", "", HKEY_LOCAL_MACHINE, csKey);
			Main->m_csServerIP = Main->GetRegistryString("ServerIP", "", HKEY_LOCAL_MACHINE, csKey);
			Main->m_csAxissvrPort = Main->GetRegistryString("HogPort", "4006", HKEY_LOCAL_MACHINE, csKey);
			Main->m_csSpherePort = Main->GetRegistryString("Port", "2593", HKEY_LOCAL_MACHINE, csKey);
			Main->m_csRootDirectory = Main->GetRegistryString("Root Directory", "", HKEY_LOCAL_MACHINE, csKey);
			Main->m_dwRemoteSpawns = Main->GetRegistryDword("Read Remote Spawns", 0, HKEY_LOCAL_MACHINE, csKey);

			Main->m_iReceiveTimeout = (int) Main->GetRegistryDword("ReceiveTimeout", 60000, HKEY_LOCAL_MACHINE, csKey);
			if ( Main->m_iReceiveTimeout < 1000 )
				Main->m_iReceiveTimeout = 1000;
			Main->m_csPassword = Encrypt(Main->m_csPassword);
		}
		this->m_cbRPDelete.EnableWindow(TRUE);
		this->m_cbRPEdit.EnableWindow(TRUE);
		break;
	}
	Main->PutRegistryString("Script Profile", Main->m_csProfile);
}

void CSettingsTab::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CPropertyPage::OnShowWindow(bShow, nStatus);
	
	this->m_clcRmtProfiles.SelectString(-1, Main->m_csProfile);

#ifdef _DEBUG
	this->m_cbStaticLaunch.ShowWindow(SW_SHOW);
#else
	switch ( Main->GetProfileType() )
	{
	case PROFILE_NONE:
	case PROFILE_REMOTE:
		this->m_cbStaticLaunch.ShowWindow(SW_HIDE);
		break;
	case PROFILE_LOCAL:
	case PROFILE_DEFAULT:
		this->m_cbStaticLaunch.ShowWindow(SW_SHOW);
		break;
	}
#endif

	OnSelchangeRemoteprofiles();
}

void CSettingsTab::OnScriptedit() 
{
	CItemScriptEditDlg dlg;
	dlg.DoModal();
}

void CSettingsTab::OnRawedit() 
{
	CScriptEditDlg dlg;
	dlg.DoModal();
}

void CSettingsTab::OnAcctedit() 
{
	if ( m_pAcctDlg && !m_pAcctDlg->IsWindowVisible() )
	{
		m_pAcctDlg->DestroyWindow();
		delete m_pAcctDlg;
		m_pAcctDlg = NULL;
	}
	if ( m_pAcctDlg == NULL )
	{
		m_pAcctDlg = new CAccountDlg;
		m_pAcctDlg->Create(IDD_ACCOUNT_DLG, (CWnd *)this);
	}
	m_pAcctDlg->ShowWindow(SW_SHOW);
}

void CSettingsTab::OnDialogColor() 
{
	CColorDialog colors;
	if ( colors.DoModal() == IDOK )
		m_dwDialogColor = colors.GetColor();
	Invalidate();
	Main->PutRegistryDword("DialogColor", m_dwDialogColor);
	Main->m_dwDialogColor = m_dwDialogColor;
	Main->SetDialogColors();
}

void CSettingsTab::OnTextColor() 
{
	CColorDialog colors;
	if ( colors.DoModal() == IDOK )
		m_dwTextColor = colors.GetColor();
	Invalidate();
	Main->PutRegistryDword("TextColor", m_dwTextColor);
	Main->m_dwTextColor = m_dwTextColor;
	Main->SetDialogColors();
}

void CSettingsTab::On3DRoomView()
{
	UpdateData();
	Main->PutRegistryDword("3DRoomView", m_b3DRoomView);
	Main->m_dw3DRoomView = m_b3DRoomView;
}

void CSettingsTab::OnAllowMultiple()
{
	UpdateData();
	Main->PutRegistryDword("AllowMultipleInstances", m_bAllowMultiple);
	Main->m_dwAllowMultiple = m_bAllowMultiple;
}

void CSettingsTab::OnAlwaysOnTop()
{
	UpdateData();
	Main->PutRegistryDword("AlwaysOnTop", m_bAlwaysOnTop);
	Main->m_dwAlwaysOnTop = m_bAlwaysOnTop;

	CWnd * pParent = this->GetParent();
	pParent->SetWindowPos(Main->m_dwAlwaysOnTop ? &wndTopMost : &wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
}

void CSettingsTab::OnResourcesOnly()
{
	UpdateData();
	Main->PutRegistryDword("ResourcesOnly", m_bResourcesOnly);
	Main->m_dwResourcesOnly = m_bResourcesOnly;
}

void CSettingsTab::OnScalePics()
{
	UpdateData();
	Main->PutRegistryDword("ScaleItems", m_bScalePics);
	Main->m_dwScaleItems = m_bScalePics;
}

void CSettingsTab::OnStartLauncher()
{
	UpdateData();
	Main->PutRegistryDword("StartLauncher", m_bStartLauncher);
	Main->m_dwStartLauncher = m_bStartLauncher;
}

void CSettingsTab::OnSysClose()
{
	UpdateData();
	Main->PutRegistryDword("SysClose", m_bSysClose);
	Main->m_dwSysClose = m_bSysClose;
}

void CSettingsTab::OnSpawnMessage()
{
	UpdateData();
	Main->PutRegistryDword("SpawnMessage", m_bSpawnMessage);
	Main->m_dwSpawnMessage = m_bSpawnMessage;
}

void CSettingsTab::OnCmdMode()
{
	UpdateData();
	Main->PutRegistryDword("UseOldCommands", m_dwCommandMode);
	Main->m_dwOldCommands = m_dwCommandMode;
}

void CSettingsTab::OnLaunchStaticTool() 
{
#ifndef _DEBUG
	if ( Main->GetProfileType() == PROFILE_REMOTE )
	{
		AfxMessageBox("The Static Tool only works when the worldfile is stored locally", MB_OK);
		return;
	}
#endif
	// Make this modeless!!!!
	if ( m_bDeleteStaticTool )
	{
		delete m_pDlgStaticTool;
		m_pDlgStaticTool = NULL;
	}
	if ( m_pDlgStaticTool )
	{
		// Activate it
		m_pDlgStaticTool->ShowWindow(SW_SHOW);
	}
	else
	{
		// Create it
		m_pDlgStaticTool = new CStaticToolDlg;
		m_pDlgStaticTool->Create(IDD_STATICTOOL, this);
		m_pDlgStaticTool->m_pParent = (CWnd *) this;
		m_pDlgStaticTool->ShowWindow(SW_SHOW);
	}

}

void CSettingsTab::OnRefreshcategories() 
{
	// Reload the categories
	Main->m_pScripts->RecategorizeItems();
	Main->m_pScripts->RecategorizeLocations();
	Main->m_pScripts->RecategorizeNPCs();
}

void CSettingsTab::OnAdditionalSettings() 
{
	// Open up the main configuration dialog.
	CAdditionalSettingsDlg dlg;
	dlg.DoModal();
}

void CSettingsTab::OnSver() 
{
	UpdateData();
	Main->PutRegistryDword("CommandVersion", m_iCommandVersion);
	Main->m_dwCommandVersion = m_iCommandVersion;
}	
