/*
 $Id: skilleditdlg.cpp,v 1.3 2002/05/01 03:33:12 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// SkillEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "SkillEditDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSkillEditDlg dialog


CSkillEditDlg::CSkillEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSkillEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSkillEditDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSkillEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSkillEditDlg)
	DDX_Control(pDX, IDC_SKILLNAME, m_ceSkillName);
	DDX_Control(pDX, IDC_SKILL_MIN, m_ceSkillMin);
	DDX_Control(pDX, IDC_SKILL_MAX, m_ceSkillMax);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSkillEditDlg, CDialog)
	//{{AFX_MSG_MAP(CSkillEditDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSkillEditDlg message handlers

BOOL CSkillEditDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	this->m_ceSkillMax.SetWindowText(this->m_csSkillMax);
	this->m_ceSkillMin.SetWindowText(this->m_csSkillMin);
	this->m_ceSkillName.SetWindowText(this->m_csSkillName);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSkillEditDlg::OnOK() 
{
	CWaitCursor hourglass;
	this->m_ceSkillMax.GetWindowText(this->m_csSkillMax);
	this->m_ceSkillMin.GetWindowText(this->m_csSkillMin);

	float fMin = (float) atof(m_csSkillMin);
	float fMax = (float) atof(m_csSkillMax);
	CString csTmp;
	if (m_csSkillMin.Find(".") == -1)
		csTmp.Format("%ld", (int) fMin);
	else
		csTmp.Format("%5.1f", fMin);
	csTmp.TrimLeft();
	csTmp.TrimRight();
	if (csTmp != m_csSkillMin)
	{
		AfxMessageBox("The Minimum Skill Value is invalid", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	if (m_csSkillMax.Find(".") == -1)
		csTmp.Format("%ld", (int) fMax);
	else
		csTmp.Format("%5.1f", fMax);
	csTmp.TrimLeft();
	csTmp.TrimRight();
	if (csTmp != m_csSkillMax)
	{
		AfxMessageBox("The Maximum Skill Value is invalid", MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	CDialog::OnOK();
}
