/*
 $Id: traveltab.h,v 1.9 2002/12/04 18:46:22 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

//{{AFX_INCLUDES()
#include "uomap.h"
//}}AFX_INCLUDES
#if !defined(AFX_TRAVELTAB_H__DFB29CFD_D431_11D2_A613_004F4905E937__INCLUDED_)
#define AFX_TRAVELTAB_H__DFB29CFD_D431_11D2_A613_004F4905E937__INCLUDED_

#include "WorldMapDlg.h"	// Added by ClassView
#include "FileReadProgress.h"
#include "EditGraymapDlg.h"
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// TravelTab.h : header file
//
/////////////////////////////////////////////////////////////////////////////
// CTravelTab dialog

class CTravelTab : public CPropertyPage
{
	DECLARE_DYNCREATE(CTravelTab)

// Construction
public:
	void HitShowWorld() { this->OnWorldmap(); };
	void LoadScripts();
	void Unload();
	CEditGraymapDlg * m_pEditDlg;
	CStringArray m_csaLocalSpawns;
	void GetLocalSpawnpoints(HWND hWnd);
	CStringArray m_csaSpawns;
	int m_iLastLocIndex;
	bool m_bWorldMapVisible;
	bool m_bWorldMapCreated;
	CWorldMapDlg m_dlgWorldMap;
	void SelectTreeItem(CString csParent, CString csChild);
	void FillCategoryTree();
	DWORD m_dwColorMap[65536];
	static int CALLBACK CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	bool m_bSortOrder;
	int m_iLastCustLocIndex;
	CTravelTab();
	~CTravelTab();

// Dialog Data
	//{{AFX_DATA(CTravelTab)
	enum { IDD = IDD_TRAVEL_TAB };
	CEdit	m_ceMapPlane;
	CButton	m_cbEditLoc;
	CButton	m_cbLocalSpawns;
	CButton	m_cbWorldSpawns;
	CStatic	m_csCoords;
	CListCtrl	m_clcLocations;
	CTreeCtrl	m_ctcCategoryTree;
	CButton	m_cbRemoveLoc;
	CUOMap	m_TravelMap;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CTravelTab)
	public:
	virtual BOOL OnSetActive();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	void UpdateSpawnDisplay();
	CSObject * FindPrevious();
	CString m_csSearchValue;
	int m_iSearchCrit;
	CCategory * m_pSearchCategory;
	CSubsection * m_pSearchSubsection;
	CSObject * m_pSearchItem;
	CSObject * Find(CString csString = "", int iCrit = 0, bool bSelect = true, bool bPrevious = false);
	long m_crosshairIndex;
	bool m_bColorsLoaded;
	void Recenter(short x, short y, short z = 256, short m = 256);
	void Recenter();
	int m_iCatSeq;
	// Generated message map functions
	//{{AFX_MSG(CTravelTab)
	virtual BOOL OnInitDialog();
	afx_msg void OnGo();
	afx_msg void OnSend();
	afx_msg void OnAddLoc();
	afx_msg void OnRemoveLoc();
	afx_msg void OnSelchangedCategorytree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClickLocations(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnColumnclickLocations(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnWhere();
	afx_msg void OnItemchangedLocations(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnListspawns();
	afx_msg void OnLocalspawns();
	afx_msg void OnEditgraymap();
	afx_msg void OnReloadspawns();
	afx_msg void OnEditLoc();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMorep();
	afx_msg void OnMouseDownTravelmap(short Button, short Shift, long x, long y);
	afx_msg void OnMouseMoveTravelmap(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTravelmap(short Button, short Shift, long x, long y);
	afx_msg void OnZoomout();
	afx_msg void OnZoomin();
	afx_msg void OnWorldmap();
	afx_msg void OnFind();
	afx_msg void OnChangeMapplane();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	static int iCoordSort;
	static int iLocSort;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRAVELTAB_H__DFB29CFD_D431_11D2_A613_004F4905E937__INCLUDED_)
