/*
 $Id: UOArtCtl.h,v 1.15 2002/11/17 06:43:57 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 2000-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_UOARTCTL_H__8017F402_C6B8_4F3F_B6A5_DB192C01FB65__INCLUDED_)
#define AFX_UOARTCTL_H__8017F402_C6B8_4F3F_B6A5_DB192C01FB65__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <comcat.h>
#include <objsafe.h>

// UOArtCtl.h : Declaration of the CUOArtCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CUOArtCtrl : See UOArtCtl.cpp for implementation.

HRESULT CreateComponentCategory(CATID catid, WCHAR* catDescription);
HRESULT RegisterCLSIDInCategory(REFCLSID clsid, CATID catid);
HRESULT UnRegisterCLSIDInCategory(REFCLSID clsid, CATID catid);


#pragma pack(push, muldata, 1)

struct ArtIdx
{
	DWORD dwLookup;
	DWORD dwSize;
	DWORD dwUnknown;
};

class CHueEntry
{
public:
	WORD wColorTable[32];
	WORD wTableStart;
	WORD wTableEnd;
	CHAR cName[20];
};

class CHueGroup
{
public:
	DWORD dwHeader;
	CHueEntry Hues[8];
};

class CMultiRec
{
public:
	WORD wIndex;
	short x;
	short y;
	short z;
	DWORD dwFlags;
};

class CStaticRec
{
public:
	WORD wIndex;
	BYTE x;
	BYTE y;
	CHAR z;
	WORD wColor;
};

class CCellData
{
public:
	WORD wID;
	CHAR z;
};

class CMapBlock
{
public:
	DWORD dwHeader;
	CCellData cell [64];
};

class CStaticObj : public CStaticRec
{
public:
	DWORD dwBlock;
};

class CDynamicObj : public CStaticRec
{
public:
	DWORD dwBlock;
	WORD wFlags;
};

class CVerdataIdx
{
public:
	DWORD dwID;
	DWORD dwBlock;
	DWORD dwOffset;
	DWORD dwSize;
	DWORD dwCRC;

	CVerdataIdx();                                                                                                                                                                                                                                                                                                                                                                                               
};

WORD anim2idx[][2] = 
{
	0xb, 3,
	0x14, 4,
	0x1c, 5,
	0x26, 8,
	0x28, 9,
	0x2b, 11,
	0x3e, 14,
	0x43, 70,
	0x4a, 18,
	0x4c, 27,
	0x4d, 19,
	0x65, 6,
	0x66, 10,
	0x67, 12,
	0x68, 13,
	0x7a, 0xff,
	0x7b, 64,
	0x7c, 20,
	0x7d, 21,
	0x80, 15,
	0x82, 17,
	0x84, 0x7b,
	0x92, 22,
	0x94, 23,
	0x95, 25,
	0x98, 26,
	0x99, 24,
	0x9a, 28,
	0x9d, 1,
	0xad, 2,
	0xae, 66,
	0xaf, 65,
	0xb0, 16,
	0xb5, 67,
	0xb6, 30,
	0xbb, 0x100,
	0xbc, 0x101,
	0xbd, 31,
	0x2f0, 29,
	0x2f1, 71,
	0x2f2, 72,
	0x2f3, 73,
	0x2f4, 75,
	0x2f5, 76,
	0x2f6, 74,
	0x2fb, 77,
	0x2fc, 32,
	0x2fd, 33,
	0x2fe, 34,
	0x2ff, 35,
	0x300, 36,
	0x301, 37,
	0x302, 38,
	0x303, 39,
	0x304, 40,
	0x305, 41,
	0x306, 42,
	0x307, 43,
	0x308, 44,
	0x309, 45,
	0x30a, 46,
	0x30b, 47,
	0x30c, 48,
	0x30d, 49,
	0x30e, 50,
	0x30f, 51,
	0x310, 52,
	0x311, 53,
	0x313, 55,
	0x314, 56,
	0x315, 57,
	0x317, 0x102,
	0x318, 59,
	0x319, 0x103,
	0x31a, 0x104,
	0x31b, 60,
	0x31c, 61,
	0x31d, 62,
	0x31e, 63,
	0x31f, 0x105,
	0x3e7, 69,
	0xFFFF, 0,
};

WORD anim0map[][2] = 
{
	0x22, 0xe1,
	0x3f, 0xd6,
	0x40, 0xd6,
	0x41, 0xd6,
	0x49, 0x1d,
	0x5D, 0x15,
	0x5e, 0x33,
	0x61, 0xe1,
	0x63, 0xe1,
	0x64, 0xe1,
	0x6b, 0xe,
	0x6c, 0xe,
	0x6d, 0xe,
	0x6e, 0xe,
	0x6f, 0xe,
	0x70, 0xe,
	0x71, 0xe,
	0x72, 0xc8,
	0x73, 0xc8,
	0x74, 0xc8,
	0x75, 0xc8,
	0x76, 0xc8,
	0x77, 0xc8,
	0x78, 0xc8,
	0x79, 0xc8,
	0x81, 0x8,
	0x83, 0xd,
	0x85, 0xca,
	0x86, 0xce,
	0x87, 0x1,
	0x88, 0x55,
	0x89, 0x56,
	0x8a, 0x7,
	0x8b, 0x7,
	0x8f, 0x2a,
	0x90, 0xc8,
	0x91, 0x5f,
	0x93, 0x39,
	0x9b, 0x3,
	0x9e, 0x10,
	0x9f, 0x10,
	0xa1, 0xe,
	0xa2, 0xd,
	0xa3, 0xd,
	0xa5, 0x3a,
	0xa6, 0xe,
	0xA8, 0x10,
	0xAA, 0xdc,
	0xAB, 0xd2,
	0xac, 0x31d,
	0xb4, 0x3b,
	0xb9, 0x190,
	0xba, 0x191,
	0xbe, 0xc8,
	0x316, 0xd,
	0xFFFF, 0,
};



#define VERFILE_MAP0 0x00
#define VERFILE_STAIDX0 0x01
#define VERFILE_STATICS0 0x02
#define VERFILE_ARTIDX 0x03
#define VERFILE_ART 0x04
#define VERFILE_ANIMIDX 0x05
#define VERFILE_ANIM 0x06
#define VERFILE_SOUNDIDX 0x07
#define VERFILE_SOUND 0x08
#define VERFILE_TEXIDX 0x09
#define VERFILE_TEXMAPS 0x0a
#define VERFILE_GUMPIDX 0x0b
#define VERFILE_GUMPART 0x0c
#define VERFILE_MULTIIDX 0x0d
#define VERFILE_MULTI 0x0e
#define VERFILE_SKILLSIDX 0x0f
#define VERFILE_SKILLS 0x10
#define VERFILE_LIGHTIDX 0x11 // ???
#define VERFILE_LIGHT 0x12 // ???
#define VERFILE_TILEDATA	0x1e
#define VERFILE_ANIMDATA 0x1f
#define VERFILE_HUES 0x20
// don't know about these...so we'll assign them numbers for now
#define VERFILE_ANIMINFO 0x21
#define VERFILE_FONTS 0x22
#define VERFILE_RADARCOL 0x23
#define VERFILE_VERDATA 0x24
#define VERFILE_MAP2 0x25
#define VERFILE_STAIDX2 0x26
#define VERFILE_STATICS2 0x27
#define VERFILE_ANIM2 0x28
#define VERFILE_ANIMIDX2 0x29
#define VERFILE_ENDOFTABLE 0x2A

class CItemCache
{
public:
	CItemCache();
	CItemCache(WORD wIndex, CString csVerdataFile, CString csIdxFile, CString csMulFile, CVerdataIdx * pVerdata = NULL);
	~CItemCache();
	BYTE * GetBuffer() { return &m_pBuffer[0]; }
	WORD GetIndex() { return m_wIndex; }
protected:
	WORD m_wIndex;
	BYTE * m_pBuffer;
};

#pragma pack(pop, muldata)


class CUOArtCtrl : public COleControl
{
	DECLARE_DYNCREATE(CUOArtCtrl)

// Constructor
public:
	CUOArtCtrl();
	enum ArtTypes
	{
		ART_ITEM,
		ART_NPC,
		ART_MULTI,
		ART_GUMP,
		ART_LANDSCAPE,
		ART_TEXMAPS,
		ART_CHARTESTS,
		ART_LIGHTS,
		ART_MAPPREVIEW,
		ART_NPC2,
	};

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CUOArtCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	virtual DWORD GetControlFlags();
	virtual void OnAmbientPropertyChange(DISPID dispid);
	//}}AFX_VIRTUAL

// Implementation
protected:
	CString m_csMulPath;
	CStringArray m_saMulPaths;

	CPtrArray m_paStatics;
	CPtrArray m_paDynamics;
	void InitializeMulPaths();
	BYTE m_tiledata [0xFD000];
	void LoadTiledata();
	WORD m_wArtWidth[0x10000];
	WORD m_wArtHeight[0x10000];
	bool m_bArtDataLoaded;
	void LoadArtData();
	void DrawRoomview(CRect bounds, WORD wArtHeight);
	BYTE * LoadCache(WORD wIndex);
	void LoadVerdataIndex();
	DWORD FindVerdata(DWORD dwID, DWORD dwBlock);
	DWORD m_dwVerdataBlocks;
	CPtrList m_cache;
#define F_ROOMVIEW 0x0001
#define F_SCALEITEM 0x0002
#define F_SHOWTERRAIN 0x0010
#define F_SHOWSTATICS 0x0020
#define F_SHOWDYNAMICS 0x0040
#define F_MAP0	0x0100
#define F_MAP2	0x0200
	void ReadRegistry();
	void DrawArt(short sArtType, CRect bounds, DWORD dwArtIndex, short dx, short dy, short dz, WORD wColor = 0, WORD wFlags = 0);
	void LoadHues();
	CPtrArray m_aHueGroups;
	DWORD BlendColors(WORD wBaseColor, WORD wAppliedColor, bool bBlendMode);
	DWORD ScaleColor(WORD wColor);
	WORD m_wAppliedColour;
	CString m_csUOPath;
	CByteArray m_bPixels;
	CRect m_rcSize;
	bool m_bIsValid;
	void SetInvalid();
	short m_sArtType;
	WORD m_wDrawFlags;
	DWORD m_dwArtIndex;
	void RedrawArt(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	~CUOArtCtrl();
	CVerdataIdx * m_pVerdataIdx;
	DWORD m_dwBkColor;

	DECLARE_OLECREATE_EX(CUOArtCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CUOArtCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CUOArtCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CUOArtCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CUOArtCtrl)
		// NOTE - ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CUOArtCtrl)
	long m_xOffset;
	afx_msg void OnXOffsetChanged();
	long m_yOffset;
	afx_msg void OnYOffsetChanged();
	afx_msg short GetArtType();
	afx_msg void SetArtType(short nNewValue);
	afx_msg long GetArtIndex();
	afx_msg void SetArtIndex(long nNewValue);
	afx_msg short GetArtColor();
	afx_msg void SetArtColor(short nNewValue);
	afx_msg short GetDrawFlags();
	afx_msg void SetDrawFlags(short nNewValue);
	afx_msg void SetObject(short type, long index);
	afx_msg void SetOffset(long x, long y);
	afx_msg long yScroll(long offset);
	afx_msg long xScroll(long offset);
	afx_msg void Scroll(long x, long y);
	afx_msg void RemovePreviewItems();
	afx_msg void RemovePreviewItem(short ID, short x, short y, short z, short color);
	afx_msg void RemovePreviewItemAt(long index);
	afx_msg long AddPreviewItem(short ID, short x, short y, short z, short color);
	afx_msg long AddHideStatic(short ID, long Block, short x, short y, short z, short color);
	afx_msg void RemoveHideStatics();
	afx_msg void RemoveHideStaticAt(long index);
	afx_msg void RemoveHideStatic(short ID, long Block, short x, short y, short z, short color);
	afx_msg void RedrawControl();
	afx_msg void SetMulPath(LPCTSTR pszNewPath);
	afx_msg BSTR GetMulPath();
	afx_msg BOOL SetCustomMulFile(short sFileIndex, LPCTSTR pszNewFilePath);
	afx_msg BSTR GetCustomMulPath(short sFileIndex);
	afx_msg long GetBkColor();
	afx_msg void SetBkColor(long nNewValue);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

// Event maps
	//{{AFX_EVENT(CUOArtCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CUOArtCtrl)
	dispidArtType = 3L,
	dispidArtIndex = 4L,
	dispidArtColor = 5L,
	dispidXOffset = 1L,
	dispidYOffset = 2L,
	dispidDrawFlags = 6L,
	dispidSetObject = 7L,
	dispidSetOffset = 8L,
	dispidYScroll = 9L,
	dispidXScroll = 10L,
	dispidScroll = 11L,
	dispidRemovePreviewItems = 12L,
	dispidRemovePreviewItem = 13L,
	dispidRemovePreviewItemAt = 14L,
	dispidAddPreviewItem = 15L,
	dispidAddHideStatic = 16L,
	dispidRemoveHideStatics = 17L,
	dispidRemoveHideStaticAt = 18L,
	dispidRemoveHideStatic = 19L,
	dispidRedrawControl = 20L,
	dispidSetMulPath = 21L,
	dispidGetMulPath = 22L,
	dispidSetCustomMulFile = 23L,
	dispidGetCustomMulPath = 24L,
	dispidBkColor = 25L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_UOARTCTL_H__8017F402_C6B8_4F3F_B6A5_DB192C01FB65__INCLUDED)
