//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: APP_SERVICE_STARTING
//
// MessageText:
//
//  Attempting to start the %1!s! service.
//
#define APP_SERVICE_STARTING             ((DWORD)0x600003E8L)

//
// MessageId: APP_SERVICE_STARTED
//
// MessageText:
//
//  The %1!s! service started successfully.
//
#define APP_SERVICE_STARTED              ((DWORD)0x600003E9L)

//
// MessageId: APP_SERVICE_START_FAILED
//
// MessageText:
//
//  The %1!s! encountered a problem.  ServiceStart() failed. %2!s!.
//
#define APP_SERVICE_START_FAILED         ((DWORD)0xE00003EAL)

//
// MessageId: APP_SERVICE_STOPPING
//
// MessageText:
//
//  Attempting to stop the %1!s!.
//
#define APP_SERVICE_STOPPING             ((DWORD)0x600003EBL)

//
// MessageId: APP_SERVICE_STOPPED
//
// MessageText:
//
//  The %1!s! service stopped successfully.
//
#define APP_SERVICE_STOPPED              ((DWORD)0x600003ECL)

//
// MessageId: APP_SERVICE_TERMINATED
//
// MessageText:
//
//  The %1!s! service terminated abnormally - %2!s!.
//
#define APP_SERVICE_TERMINATED           ((DWORD)0xE00003EDL)

//
// MessageId: APP_SERVICE_SETSTATUS_FAILED
//
// MessageText:
//
//  SetServiceStatus() failed - %1!s!.
//
#define APP_SERVICE_SETSTATUS_FAILED     ((DWORD)0xA00003EEL)

//
// MessageId: APP_SERVICE_CREATEPIPE_FAILED
//
// MessageText:
//
//  The %s service was unable to create named pipe - %1!s!.
//
#define APP_SERVICE_CREATEPIPE_FAILED    ((DWORD)0xE00003EFL)

//
// MessageId: APP_SERVICE_GENERIC_MESSAGE
//
// MessageText:
//
//  %1!s!
//
#define APP_SERVICE_GENERIC_MESSAGE      ((DWORD)0x60000449L)

//
// MessageId: APP_SERVICE_GENERIC_WARNING
//
// MessageText:
//
//  %1!s!
//
#define APP_SERVICE_GENERIC_WARNING      ((DWORD)0xA000044AL)

//
// MessageId: APP_SERVICE_GENERIC_ERROR
//
// MessageText:
//
//  %1!s!
//
#define APP_SERVICE_GENERIC_ERROR        ((DWORD)0xE000044BL)

//
// MessageId: APP_COULD_NOT_CREATE_MUTEX
//
// MessageText:
//
//  The %1!s! service could not create a required Mutex object.  The service cannot continue.
//
#define APP_COULD_NOT_CREATE_MUTEX       ((DWORD)0xE000045BL)

//
// MessageId: APP_GENERIC_MESSAGE
//
// MessageText:
//
//  %1!s!
//
#define APP_GENERIC_MESSAGE              ((DWORD)0x600004ADL)

//
// MessageId: APP_GENERIC_WARNING
//
// MessageText:
//
//  %1!s!
//
#define APP_GENERIC_WARNING              ((DWORD)0xA00004AEL)

//
// MessageId: APP_GENERIC_ERROR
//
// MessageText:
//
//  %1!s!.
//
#define APP_GENERIC_ERROR                ((DWORD)0xE00004AFL)

